; Labyrinth generieren
;---------------------------------------------------------------------------------------

; Vertikal Spiegeln
Procedure vertikal(akt_level.w)

   For i = 1 To groesse(akt_level)/2
      For j = 1 To groesse(akt_level)
      
         save_feld.w = labyrinth(i,j)\feld[akt_level]
         save_lebenspunkte.w = labyrinth(i,j)\lebenspunkte[akt_level]
         save_objekt.w = labyrinth(i,j)\objekt[akt_level]
         save_status.w = labyrinth(i,j)\status[akt_level]
         
         labyrinth(i,j)\feld[akt_level] = labyrinth(groesse(akt_level)+1-i,j)\feld[akt_level]
         labyrinth(i,j)\lebenspunkte[akt_level] = labyrinth(groesse(akt_level)+1-i,j)\lebenspunkte[akt_level]
         labyrinth(i,j)\objekt[akt_level] = labyrinth(groesse(akt_level)+1-i,j)\objekt[akt_level]
         labyrinth(i,j)\status[akt_level] = labyrinth(groesse(akt_level)+1-i,j)\status[akt_level]
         
         labyrinth(groesse(akt_level)+1-i,j)\feld[akt_level] = save_feld
         labyrinth(groesse(akt_level)+1-i,j)\lebenspunkte[akt_level] = save_lebenspunkte
         labyrinth(groesse(akt_level)+1-i,j)\objekt[akt_level] = save_objekt
         labyrinth(groesse(akt_level)+1-i,j)\status[akt_level] = save_status
         
      Next
   Next
   
   For i = 1 To groesse(akt_level)
      For j = 1 To groesse(akt_level)
         If labyrinth(i,j)\feld[akt_level] = #FELD_TELEPORTER
            labyrinth(i,j)\lebenspunkte[akt_level] = groesse(akt_level)+1-labyrinth(i,j)\lebenspunkte[akt_level]
         EndIf
      Next
   Next
   
   ; Raum suchen
   yyy.w = 1
   gef.w = 0
   Repeat
      xxx.w = 0
      Repeat
         If labyrinth(xxx,yyy)\feld[akt_level] = #FELD_FRAGEZEICHEN
            gef = 1
         EndIf
         xxx = xxx + 1
      Until gef = 1 Or xxx > groesse(akt_level)
      yyy = yyy + 1
   Until gef = 1 Or yyy > groesse(akt_level)
   raumx(akt_level)    = xxx-2
      
   eingangx(akt_level) = groesse(akt_level)
   ausgangx(akt_level) = groesse(akt_level)+1-ausgangx(akt_level)
   
EndProcedure

 
 ; Horizontal Spiegeln
Procedure horizontal(akt_level.w)

   For i = 1 To groesse(akt_level)
      For j = 1 To groesse(akt_level)/2
      
         save_feld.w = labyrinth(i,j)\feld[akt_level]
         save_lebenspunkte.w = labyrinth(i,j)\lebenspunkte[akt_level]
         save_objekt.w = labyrinth(i,j)\objekt[akt_level]
         save_status.w = labyrinth(i,j)\status[akt_level]
         
         labyrinth(i,j)\feld[akt_level] = labyrinth(i,groesse(akt_level)+1-j)\feld[akt_level]
         labyrinth(i,j)\lebenspunkte[akt_level] = labyrinth(i,groesse(akt_level)+1-j)\lebenspunkte[akt_level]
         labyrinth(i,j)\objekt[akt_level] = labyrinth(i,groesse(akt_level)+1-j)\objekt[akt_level]
         labyrinth(i,j)\status[akt_level] = labyrinth(i,groesse(akt_level)+1-j)\status[akt_level]
         
         labyrinth(i,groesse(akt_level)+1-j)\feld[akt_level] = save_feld
         labyrinth(i,groesse(akt_level)+1-j)\lebenspunkte[akt_level] = save_lebenspunkte
         labyrinth(i,groesse(akt_level)+1-j)\objekt[akt_level] = save_objekt
         labyrinth(i,groesse(akt_level)+1-j)\status[akt_level] = save_status
         
      Next
   Next
   
   For i = 1 To groesse(akt_level)
      For j = 1 To groesse(akt_level)
         If labyrinth(i,j)\feld[akt_level] = #FELD_TELEPORTER
            labyrinth(i,j)\objekt[akt_level] = groesse(akt_level)+1-labyrinth(i,j)\objekt[akt_level]
         EndIf
      Next
   Next
   
   ; Raum suchen
   yyy.w = 1
   gef.w = 0
   Repeat
      yyy.w = 0
      Repeat
         If labyrinth(xxx,yyy)\feld[akt_level] = #FELD_FRAGEZEICHEN
            gef = 1
         EndIf
         yyy = yyy + 1
      Until gef = 1 Or yyy > groesse(akt_level)
      xxx = xxx + 1
   Until gef = 1 Or xxx > groesse(akt_level)
   raumy(akt_level)    = yyy-2
      
   eingangy(akt_level) = groesse(akt_level)
   ausgangy(akt_level) = groesse(akt_level)+1-ausgangy(akt_level)
 
EndProcedure


 ; Diagonal Spiegeln
Procedure diagonal(akt_level.w)

   j.w = 1
   hugo.w = 1
   Repeat
      i = 1 + hugo
      Repeat
      
         save_feld.w = labyrinth(i,j)\feld[akt_level]
         save_lebenspunkte.w = labyrinth(i,j)\lebenspunkte[akt_level]
         save_objekt.w = labyrinth(i,j)\objekt[akt_level]
         save_status.w = labyrinth(i,j)\status[akt_level]
         
         labyrinth(i,j)\feld[akt_level] = labyrinth(j,i)\feld[akt_level]
         labyrinth(i,j)\lebenspunkte[akt_level] = labyrinth(j,i)\lebenspunkte[akt_level]
         labyrinth(i,j)\objekt[akt_level] = labyrinth(j,i)\objekt[akt_level]
         labyrinth(i,j)\status[akt_level] = labyrinth(j,i)\status[akt_level]
         
         labyrinth(j,i)\feld[akt_level] = save_feld
         labyrinth(j,i)\lebenspunkte[akt_level] = save_lebenspunkte
         labyrinth(j,i)\objekt[akt_level] = save_objekt
         labyrinth(j,i)\status[akt_level] = save_status
         i = i + 1
      Until i > groesse(akt_level)
      hugo = hugo + 1
      j = j + 1
   Until j > groesse(akt_level)
   
   For i = 1 To groesse(akt_level)
      For j = 1 To groesse(akt_level)
         If labyrinth(i,j)\feld[akt_level] = #FELD_TELEPORTER
            save.w = labyrinth(i,j)\lebenspunkte[akt_level]
            labyrinth(i,j)\lebenspunkte[akt_level] = labyrinth(i,j)\objekt[akt_level]
            labyrinth(i,j)\objekt[akt_level] = save
         EndIf
      Next
   Next
   
   ; Raum suchen
   yyy.w = 1
   gef.w = 0
   Repeat
      yyy.w = 0
      Repeat
         If labyrinth(xxx,yyy)\feld[akt_level] = #FELD_FRAGEZEICHEN
            gef = 1
         EndIf
         yyy = yyy + 1
      Until gef = 1 Or yyy > groesse(akt_level)
      xxx = xxx + 1
   Until gef = 1 Or xxx > groesse(akt_level)
   raumx(akt_level)    = xxx-2
   raumy(akt_level)    = yyy-2
      
   save = ausgangy(akt_level)
   ausgangy(akt_level) = ausgangx(akt_level)
   ausgangx(akt_level) = save
 
EndProcedure


Procedure Gang_graben(x.w,y.w,wand.w,hauptgang.w,mit_was.w,level.w)

Shared pos, ganglaenge, laby, groesse, TEST


  ganglaenge = 0
  setlaby(x,y,level,inhalt(level),0,0,0)
  stat = 1
  
  While stat < 3
    richtung=Random(100)

    If y > 1 And ((stat = 1 And richtung < 25) Or stat = 2)
      If labyrinth(x,y-2)\feld[level] = mit_was(level)
        setlaby(x,y-1,level,inhalt(level),0,0,0)
        setlaby(x,y-2,level,inhalt(level),0,0,0)
        ganglaenge=ganglaenge+2
        y=y-2
        stat=0
      EndIf
    EndIf

    If y < groesse(level) - 1 And ((stat = 1 And richtung >= 25 And richtung < 50) Or stat = 2)
      If labyrinth(x,y+2)\feld[level] = mit_was(level)
        setlaby(x,y+1,level,inhalt(level),0,0,0)
        setlaby(x,y+2,level,inhalt(level),0,0,0)
        ganglaenge = ganglaenge + 2
        y = y + 2
        stat = 0
      EndIf
    EndIf

    If x > 1 And ((stat = 1 And richtung >= 50 And richtung < 75) Or stat = 2)
      If labyrinth(x-2,y)\feld[level] = mit_was(level)
        setlaby(x-1,y,level,inhalt(level),0,0,0)
        setlaby(x-2,y,level,inhalt(level),0,0,0)
        ganglaenge = ganglaenge + 2
        x=x-2
        stat=0
      EndIf
    EndIf

    If x < groesse(level) - 1 And ((stat = 1 And richtung >= 75) Or stat = 2)
      If labyrinth(x + 2,y)\feld[level] = mit_was(level)
        setlaby(x + 1,y,level,inhalt(level),0,0,0)
        setlaby(x + 2,y,level,inhalt(level),0,0,0)
        ganglaenge = ganglaenge + 2
        x = x + 2
        stat = 0
      EndIf
    EndIf

    stat = stat + 1
  Wend

  gangende=inhalt(level)
  willi = Random(100)
    If willi < 25
       If Random(100) > 90
          gangende = #FELD_SCHACHT
       Else
          gangende = #FELD_GOLD
       EndIf
    EndIf
    If willi >= 25 And willi < 50
       gangende = #FELD_TRUHE
       If Random(100) > 90
          If Random(100) > 50
             gangende=#FELD_BLAUETRUHE1
          Else
             gangende=#FELD_BLAUETRUHE2
          EndIf
       EndIf
      If Random(100) < 50 And Random(99)<level And level > 9
         gangende=#FELD_MIMIC
      EndIf
    EndIf
    If willi >=50 And willi < 75
       gangende=inhalt(level)
    EndIf
    If willi >= 75
     If Random(100) > 50
        gangende = #FELD_VERBORGENER_SCHATZ
     Else
        gangende = #OBJGRAFIK_PILZE_SCHWARZ+#ANZ_FELDER+#ANZ_MONSTER+Random(#ANZ_PILZE-1)
     EndIf
    EndIf
  If gangende=#FELD_TRUHE And Random(99)<level/3
     gangende=#FELD_GRUENETRUHE1
  EndIf
  
  was.w = 0
  If gangende = #FELD_TRUHE
     was = finden1()
  EndIf
  If gangende = #FELD_GRUENETRUHE1
     was = finden2()
  EndIf
  If gangende = #FELD_BLAUETRUHE1 Or gangende = #FELD_BLAUETRUHE2
     If Random(100) > 50
        was = finden1()
     Else
        was = finden2()
     EndIf
  EndIf
  setlaby(x,y,level,gangende,0,0,was)

  If hauptgang=0
    If x > 1
       If labyrinth(x-2,y)\feld[level] = inhalt(level) And labyrinth(x-1,y)\feld[level] = wand And x > 1
          hugo = Random(100)
          If hugo < 34
             If sonderlevel(level) = 0
                 setlaby(x-1,y,level,#FELD_GEHEIMGANG,0,0,0)
              EndIf
          EndIf
          If hugo >= 34 And hugo < 67
             setlaby(x-1,y,level,inhalt,0,0,0)
          EndIf
          If hugo >= 67
             If sonderlevel(level) <> #SL_SUMPF
                offen.w = 0
                If Random(100) > 85
                   offen = 2
                EndIf
                setlaby(x-1,y,level,#FELD_TUER2,0,0,offen)
             EndIf
          EndIf
       EndIf
    EndIf
    If labyrinth(x+2,y)\feld[level] = inhalt(level) And labyrinth(x+1,y)\feld[level] = wand And x < groesse(level)-2
         hugo = Random(100)
         If hugo < 34
            If sonderlevel(level) = 0
               setlaby(x+1,y,level,#FELD_GEHEIMGANG,0,0,0)
            EndIf
         EndIf
         If hugo >= 34 And hugo < 67
            setlaby(x+1,y,level,inhalt(level),0,0,0)
         EndIf
         If hugo >= 67
            If sonderlevel(level) <> #SL_SUMPF
                offen.w = 0
                If Random(100) > 85
                   offen = 2
                EndIf
               setlaby(x+1,y,level,#FELD_TUER2,0,0,offen)
            EndIf
         EndIf
    EndIf
    If y > 1
    If labyrinth(x,y-2)\feld[level]=inhalt(level) And labyrinth(x,y-1)\feld[level]=wand And y>1
          hugo = Random(100)
          If hugo < 34
             If sonderlevel(level) = 0
                setlaby(x,y-1,level,#FELD_GEHEIMGANG,0,0,0)
             EndIf
          EndIf
          If hugo >= 34 And hugo < 67
             setlaby(x,y-1,level,inhalt(level),0,0,0)
          EndIf
          If hugo >= 67
             If sonderlevel(level) <> #SL_SUMPF
                offen.w = 0
                If Random(100) > 85
                   offen = 2
                EndIf
                setlaby(x,y-1,level,#FELD_TUER2,0,0,offen)
             EndIf
          EndIf
       EndIf
    EndIf
    If labyrinth(x,y+2)\feld[level]=inhalt(level) And labyrinth(x,y+1)\feld[level]=wand And y<groesse(level)-2
         hugo = Random(100)
         If hugo < 34
            setlaby(x,y+1,level,#FELD_GEHEIMGANG,0,0,0)
         EndIf
         If hugo >= 34 And hugo < 67
            setlaby(x,y+1,level,inhalt(level),0,0,0)
         EndIf
         If hugo >= 67
            If sonderlevel(level) <> #SL_SUMPF
                offen.w = 0
                If Random(100) > 85
                   offen = 2
                EndIf
               setlaby(x,y+1,level,#FELD_TUER2,0,0,offen)
            EndIf
         EndIf
    EndIf
  EndIf

  pos = y*groesse(level)+x

EndProcedure

;---------------------------------------------------------------------------------------
; Raum
Procedure setzen (x_length.w, y_length.w, level.w)

Shared TEST

   zaehler.w = 1
   Repeat
      frei = 0
      Repeat
         x.w = Random(groesse(level)-9)
      Until x > 3
      Repeat
         y.w = Random(groesse(level)-9)
      Until y > 3
      x = x / 2
      y = y / 2
      x = x * 2
      y = y * 2
      For i = 1 To x_length
         For j = 1 To y_length
            If labyrinth(i+x,j+y)\feld[level] = #FELD_EINGANG Or labyrinth(i+x,j+y)\feld[level] = #FELD_AUSGANG
               frei = 1
            EndIf
         Next
      Next
      zaehler = zaehler + 1
   Until (x > 0 And y > 0 And frei = 0) Or zaehler > 500
   If zaehler <= 500
      raumx(level) = x
      raumy(level) = y
      For i = 1 To x_length
         For j = 1 To y_length
            setlaby(i+x,j+y,level,#FELD_FRAGEZEICHEN,0,0,0)
         Next
      Next
   EndIf
             
EndProcedure

; ---------------------------------------------------------------------------------------

Procedure monster_setzen(level, welches)

Shared  TEST

   zaehler.w = 1
   Repeat
      x.w=Random(groesse(level)-3)+2
      y.w=Random(groesse(level)-3)+2
      zaehler = zaehler + 1
   Until labyrinth(x,y)\feld[level]=inhalt(level) Or zaehler > 500
   
   If zaehler <= 500
      monstat.w = 0
      If Random(100) > 90 Or levelmod(level) = #LM_ALERTED_MONSTERS
         If Random(100) > 50 And levelmod(level) <> #LM_ALERTED_MONSTERS
            If hat_eigenschaft2(hugo,#ME_SCHLAEFT) = 1
               monstat = #MONSTERSTATUS_SCHLAEFT
            Else
               monstat = #MONSTERSTATUS_ALERT
            EndIf
         Else
            monstat = #MONSTERSTATUS_ALERT
         EndIf
      EndIf
      setlaby(x,y,level,monster(welches)\nr + #ANZ_FELDER,monster(welches)\lebenspunkte,welches,monstat)
   EndIf

EndProcedure

; ---------------------------------------------------------------------------------------

Procedure gen_laby(akt_level.w)

Shared pos, ganglaenge, monster, nr
Shared TEST, anz_spieler, mit_was_normal, inhalt_normal

   groesse(akt_level) = akt_level+10
   
   eingangx(akt_level) = 1
   eingangy(akt_level) = 1
   
   If TEST = 1
      groesse(akt_level) = groesse(akt_level) + 5
   EndIf

    ; Tiles wechseln?
    verg1.f = akt_level / 5
    verg2.f = Int(akt_level / 5)
    If verg1 = verg2
       If Random(5) > 4
          mit_was_normal = #FELD_MAUER
       Else
          mit_was_normal = #FELD_MAUER2 + Random(3)
       EndIf
       If Random(6) > 5
          inhalt_normal = #FELD_LEER
       Else
          inhalt_normal  = #FELD_BODEN1 + Random(4)
       EndIf
    EndIf
    
    mit_was(akt_level) = mit_was_normal
    inhalt(akt_level) = inhalt_normal
    visionen(akt_level) = 1
        
    If levelmod(akt_level) = #LM_GIFTIGER_NEBEL
       inhalt(akt_level) = #FELD_GIFT
    EndIf
    
    ; Eiskaverne
    If sonderlevel(akt_level) = #SL_EISKAVERNE
       mit_was(akt_level) = #FELD_WAND_WEISS
       inhalt(akt_level) = #FELD_SCHNEE
    EndIf
    ; Lavakaverne
    If sonderlevel(akt_level) = #SL_LAVAKAVERNE
       mit_was(akt_level) = #FELD_FEUER2
       inhalt(akt_level) = #FELD_LAVA
    EndIf
    ; Halle Der Toten
    If sonderlevel(akt_level) = #SL_TOTENHALLE
       mit_was(akt_level) = #FELD_GRABSTEIN
    EndIf
    ; Goblin Hoehle
    If sonderlevel(akt_level) = #SL_GOBLINHOEHLE
       mit_was(akt_level) = #FELD_MAUER
       inhalt(akt_level) = #FELD_HOEHLE2_LEER
    EndIf
    ; Diebesnest
    If sonderlevel(akt_level) = #SL_DIEBESNEST
       mit_was(akt_level) = #FELD_MAUER
    EndIf
    ; Zentauerwald
    If sonderlevel(akt_level) = #SL_ZENTAUERWALD
       mit_was(akt_level) = #FELD_BAUM_KLEIN
       inhalt(akt_level) = #FELD_GRAS
    EndIf
    ; Halle der Illusionen
    If sonderlevel(akt_level) = #SL_ILLUSIONEN
       mit_was(akt_level) = #FELD_MOND
       inhalt(akt_level) = #FELD_STERNE2
    EndIf
    ; Spinnenbau
    If sonderlevel(akt_level) = #SL_SPINNENBAU
       mit_was(akt_level) = #FELD_HOEHLE2_MAUER
       inhalt(akt_level) = #FELD_HOEHLE2_LEER
    EndIf
    ; Wueste
    If sonderlevel(akt_level) = #SL_WUESTE
       mit_was(akt_level) = #FELD_SAND_HUEGEL
       inhalt(akt_level) = #FELD_SAND1
    EndIf
    ; Archipel
    If sonderlevel(akt_level) = #SL_ARCHIPEL
       mit_was(akt_level) = #FELD_WASSER
       inhalt(akt_level) = #FELD_WASSER
    EndIf
    ; Sumpf
    If sonderlevel(akt_level) = #SL_SUMPF
       mit_was(akt_level) = #FELD_SUMPF2
       inhalt(akt_level) = #FELD_SUMPF1
    EndIf
    
    
    special.w = 0
    
    ; Wueste!!!
    If sonderlevel(akt_level) = #SL_WUESTE
       special = 1
      ; Ganzes Laby mit Sandhuegel fuellen
      For i = 1 To #MAX_GROESSE
         For j = 1 To #MAX_GROESSE
            setlaby(i,j,akt_level,mit_was(akt_level),0,0,0)
         Next
      Next
      
      ; Palmen setzen
      For i = 1 To groesse(akt_level)/3
         zaehler = 1
         Repeat
            x = Random(groesse(akt_level))
            y = Random(groesse(akt_level))
            zaehler = zaehler + 1
         Until (labyrinth(x,y)\feld[akt_level] = mit_was(akt_level) And labyrinth(x+1,y+1)\feld[akt_level] = mit_was(akt_level) And labyrinth(x+1,y)\feld[akt_level] = mit_was(akt_level) And labyrinth(x,y+1)\feld[akt_level] = mit_was(akt_level)) Or zaehler > 500
         
         If zaehler <= 500
            setlaby(x,y,akt_level,#FELD_PALME1,0,0,0)
            setlaby(x+1,y,akt_level,#FELD_PALME2,0,0,0)
            setlaby(x,y+1,akt_level,#FELD_PALME3,0,0,0)
            setlaby(x+1,y+1,akt_level,#FELD_PALME4,0,0,0)
         EndIf
      Next
      
      ; Ganzes Laby mit Sand fuellen
      For i = 1 To groesse(akt_level)
         For j = 1 To groesse(akt_level)
            If labyrinth(i,j)\feld[akt_level] = mit_was(akt_level)
               Select Random(13)
                  Case 0: setlaby(i,j,akt_level,#FELD_SAND1,0,0,0)
                  Case 1: setlaby(i,j,akt_level,#FELD_SAND1,0,0,0)
                  Case 2: setlaby(i,j,akt_level,#FELD_SAND1,0,0,0)
                  Case 3: setlaby(i,j,akt_level,#FELD_SAND2,0,0,0)
                  Case 4: setlaby(i,j,akt_level,#FELD_SAND2,0,0,0)
                  Case 5: setlaby(i,j,akt_level,#FELD_SAND2,0,0,0)
                  Case 6: setlaby(i,j,akt_level,#FELD_SAND3,0,0,0)
                  Case 7: setlaby(i,j,akt_level,#FELD_SAND3,0,0,0)
                  Case 8: setlaby(i,j,akt_level,#FELD_SAND3,0,0,0)
                  Case 9: setlaby(i,j,akt_level,#FELD_SAND4,0,0,0)
                  Case 10: setlaby(i,j,akt_level,#FELD_SAND4,0,0,0)
                  Case 11: setlaby(i,j,akt_level,#FELD_SAND4,0,0,0)
                  Case 12: setlaby(i,j,akt_level,#FELD_KAKTUS1,0,0,0)
                  Case 13: setlaby(i,j,akt_level,#FELD_KAKTUS2,0,0,0)
               EndSelect
            EndIf
         Next
      Next
      
      ; Place Entry and Exit
      setlaby(1,1,akt_level,#FELD_EINGANG,0,0,0)
      Select Random(2)
         Case 0: ziel_x = groesse(akt_level)
                 ziel_y = groesse(akt_level)
         Case 1: ziel_x = groesse(akt_level)
                 ziel_y = 1
         Case 2: ziel_x = 1
                 ziel_y = groesse(akt_level)
      EndSelect
      If TEST = 0
         setlaby(ziel_x,ziel_y,akt_level,#FELD_AUSGANG,0,0,0)
      EndIf
      ausgangx(akt_level) = ziel_x
      ausgangy(akt_level) = ziel_y
    EndIf
    
   
    
    ; Archipel!!!
    If sonderlevel(akt_level) = #SL_ARCHIPEL
       special = 1
       
       ; Ganzes Laby mit Wasser fuellen
      For i = 1 To #MAX_GROESSE
         For j = 1 To #MAX_GROESSE
            setlaby(i,j,akt_level,mit_was(akt_level),0,0,1)  ; Undurchdringlich!
         Next
      Next
      
      For i = 1 To groesse(akt_level)
         For j = 1 To groesse(akt_level)
            setlaby(i,j,akt_level,mit_was(akt_level),0,0,0)  ; Normales Wasser
         Next
      Next
      
      ; Inseln setzen
      x = 1
      Repeat
         y = 1
         Repeat
            willi.w = Random(2)
            If x = 1 And y = 1 
               willi = 1
            EndIf
            Select(willi)
            Case 0:
               ; Insel Klein
               setlaby(x,y,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+2,y,akt_level,#FELD_INSEL1,0,0,0)
               setlaby(x+3,y,akt_level,#FELD_GRAS,0,0,0)
               setlaby(x+4,y,akt_level,#FELD_INSEL2,0,0,0)
               
               setlaby(x,y+1,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+1,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+2,y+1,akt_level,#FELD_GRAS,0,0,0)
               If Random(100) > 70
                  Select (Random(2))
                     Case 0:
                        setlaby(x+3,y+1,akt_level,#FELD_WIESE_SKELETT,0,0,0)
                     Case 1:
                        setlaby(x+3,y+1,akt_level,#FELD_WIESE_TRUHE,0,0,finden1())
                     Case 2:
                        If Random(100) < 80
                           setlaby(x+3,y+1,akt_level,#FELD_WIESE_GRUENETRUHE1,0,0,finden2())
                        Else
                           setlaby(x+3,y+1,akt_level,#FELD_WIESE_GRUENETRUHE2,0,0,finden2())
                        EndIf
                  EndSelect
               Else
                  setlaby(x+3,y+1,akt_level,#FELD_GRAS,0,0,0)
               EndIf
               setlaby(x+4,y+1,akt_level,#FELD_GRAS,0,0,0)
               
               setlaby(x,y+2,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+2,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+2,y+2,akt_level,#FELD_INSEL3,0,0,0)
               setlaby(x+3,y+2,akt_level,#FELD_GRAS,0,0,0)
               setlaby(x+4,y+2,akt_level,#FELD_INSEL4,0,0,0)
               
               setlaby(x,y+3,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+3,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+2,y+3,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+3,y+3,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+4,y+3,akt_level,#FELD_WASSER,0,0,0)
               
               setlaby(x,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+2,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+3,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+4,y+4,akt_level,#FELD_WASSER,0,0,0)
          Case 1:
               ; Insel Gross
               setlaby(x,y,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y,akt_level,#FELD_INSEL1,0,0,0)
               setlaby(x+2,y,akt_level,#FELD_GRAS,0,0,0)
               setlaby(x+3,y,akt_level,#FELD_GRAS,0,0,0)
               setlaby(x+4,y,akt_level,#FELD_INSEL2,0,0,0)
               
               setlaby(x,y+1,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+1,akt_level,#FELD_GRAS,0,0,0)
               If Random(100) > 70
                  Select (Random(2))
                     Case 0:
                        setlaby(x+2,y+1,akt_level,#FELD_WIESE_SKELETT,0,0,0)
                     Case 1:
                        setlaby(x+2,y+1,akt_level,#FELD_WIESE_TRUHE,0,0,finden1())
                     Case 2:
                        If Random(100) < 80
                           setlaby(x+2,y+1,akt_level,#FELD_WIESE_GRUENETRUHE1,0,0,finden2())
                        Else
                           setlaby(x+2,y+1,akt_level,#FELD_WIESE_GRUENETRUHE2,0,0,finden2())
                        EndIf
                  EndSelect
               Else
                  setlaby(x+2,y+1,akt_level,#FELD_GRAS,0,0,0)
               EndIf
               If Random(100) > 70
                  Select (Random(2))
                     Case 0:
                        setlaby(x+3,y+1,akt_level,#FELD_WIESE_SKELETT,0,0,0)
                     Case 1:
                        setlaby(x+3,y+1,akt_level,#FELD_WIESE_TRUHE,0,0,finden1())
                     Case 2:
                        If Random(100) < 80
                           setlaby(x+3,y+1,akt_level,#FELD_WIESE_GRUENETRUHE1,0,0,finden2())
                        Else
                           setlaby(x+3,y+1,akt_level,#FELD_WIESE_GRUENETRUHE2,0,0,finden2())
                        EndIf
                  EndSelect
               Else
                  setlaby(x+3,y+1,akt_level,#FELD_GRAS,0,0,0)
               EndIf
               setlaby(x+4,y+1,akt_level,#FELD_GRAS,0,0,0)
               
               setlaby(x,y+2,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+2,akt_level,#FELD_GRAS,0,0,0)
               
               If Random(100) > 70
                  Select (Random(2))
                     Case 0:
                        setlaby(x+2,y+2,akt_level,#FELD_WIESE_SKELETT,0,0,0)
                     Case 1:
                        setlaby(x+2,y+2,akt_level,#FELD_WIESE_TRUHE,0,0,finden1())
                     Case 2:
                        If Random(100) < 80
                           setlaby(x+2,y+2,akt_level,#FELD_WIESE_GRUENETRUHE1,0,0,finden2())
                        Else
                           setlaby(x+2,y+2,akt_level,#FELD_WIESE_GRUENETRUHE2,0,0,finden2())
                        EndIf
                  EndSelect
               Else
                  setlaby(x+2,y+2,akt_level,#FELD_GRAS,0,0,0)
               EndIf
               If Random(100) > 70
                  Select (Random(2))
                     Case 0:
                        setlaby(x+3,y+2,akt_level,#FELD_WIESE_SKELETT,0,0,0)
                     Case 1:
                        setlaby(x+3,y+2,akt_level,#FELD_WIESE_TRUHE,0,0,finden1())
                     Case 2:
                        If Random(100) < 80
                           setlaby(x+3,y+2,akt_level,#FELD_WIESE_GRUENETRUHE1,0,0,finden2())
                        Else
                           setlaby(x+3,y+2,akt_level,#FELD_WIESE_GRUENETRUHE2,0,0,finden2())
                        EndIf
                  EndSelect
               Else
                  setlaby(x+3,y+2,akt_level,#FELD_GRAS,0,0,0)
               EndIf
               setlaby(x+4,y+2,akt_level,#FELD_GRAS,0,0,0)
               
               setlaby(x,y+3,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+3,akt_level,#FELD_INSEL3,0,0,0)
               setlaby(x+2,y+3,akt_level,#FELD_GRAS,0,0,0)
               setlaby(x+3,y+3,akt_level,#FELD_GRAS,0,0,0)
               setlaby(x+4,y+3,akt_level,#FELD_INSEL4,0,0,0)
               
               setlaby(x,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+1,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+2,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+3,y+4,akt_level,#FELD_WASSER,0,0,0)
               setlaby(x+4,y+4,akt_level,#FELD_WASSER,0,0,0)
            Case 2: 
               For xx = 0 To 4
                  For yy = 0 To 4
                     setlaby(x+xx,y+yy,akt_level,#FELD_WASSER,0,0,0)
                  Next
               Next
            
            EndSelect
         y = y + 5
         Until y > groesse(akt_level)
      x = x + 5
      Until x > groesse(akt_level)
      
      ; Unterwassertruhen etc setzen
      For i = 1 To akt_level
         counter.w = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            Select (Random(2))
               Case 0: If Random(100) < 80
                          setlaby(x,y,akt_level,#FELD_WASSER_TRUHE,0,0,finden1())
                       Else
                          setlaby(x,y,akt_level,#FELD_WASSER_GRUENE_TRUHE,0,0,finden2())
                       EndIf
               Case 1: setlaby(x,y,akt_level,#FELD_WASSER_SKELETT,0,0,0)
               Case 2: setlaby(x,y,akt_level,#FELD_WASSER_GOLDSACK,0,0,0)
            EndSelect
            
         EndIf
      Next
      
      ; Place Entry and Exit
      setlaby(1,1,akt_level,#FELD_EINGANG,0,0,0)
      Select Random(2)
         Case 0: ziel_x = groesse(akt_level)
                 ziel_y = groesse(akt_level)
         Case 1: ziel_x = groesse(akt_level)
                 ziel_y = 1
         Case 2: ziel_x = 1
                 ziel_y = groesse(akt_level)
      EndSelect
      setlaby(ziel_x,ziel_y,akt_level,#FELD_AUSGANG,0,0,0)
      ausgangx(akt_level) = ziel_x
      ausgangy(akt_level) = ziel_y
    EndIf
    
    If special = 0
      Repeat
         ; Ganzes Laby mit Mauern fuellen
         For i = 1 To #MAX_GROESSE
            For j = 1 To #MAX_GROESSE
               setlaby(i,j,akt_level,mit_was(akt_level),0,0,0)
            Next
         Next
   
         ; Gang graben
         Gang_graben(1,1,1,1,mit_was(akt_level),akt_level)
         ok=1
         If ganglaenge<=groesse(akt_level)*2
            ok=0
         EndIf
         ziel_y=pos/groesse(akt_level)
         ziel_x=pos-ziel_y*groesse(akt_level)
         If ziel_x<groesse(akt_level)/2 And ziel_y<groesse(akt_level)/2
            ok=0
         EndIf
         ; falls Hauptgang zu kurz -> das ganze nochmal
      Until ok=1
   
      ; Nebengaenge graben
      For x=1 To groesse(akt_level)-2 Step 2
         For y=1 To groesse(akt_level)-2 Step 2
         If labyrinth(x,y)\feld[akt_level]=mit_was(akt_level)
            graben=0
   
            If graben=0 And y>1
               If labyrinth(x,y-2)\feld[akt_level] = inhalt(akt_level)
               setlaby(x,y-1,akt_level,inhalt(akt_level),0,0,0)
               graben=1
               EndIf
            EndIf
   
            If graben=0 And x<groesse(akt_level)-2
               If labyrinth(x+2,y)\feld[akt_level] = inhalt(akt_level)
               setlaby(x+1,y,akt_level,inhalt(akt_level),0,0,0)
               graben=1
               EndIf
            EndIf
   
            If graben=0 And y<groesse(akt_level)-2
               If labyrinth(x,y+2)\feld[akt_level] = inhalt(akt_level)
               setlaby(x,y+1,akt_level,inhalt(akt_level),0,0,0)
               graben=1
               EndIf
            EndIf
   
            If graben=0 And x>1
               If labyrinth(x-2,y)\feld[akt_level] = inhalt(akt_level)
               setlaby(x-1,y,akt_level,inhalt(akt_level),0,0,0)
               graben=1
               EndIf
            EndIf
   
            If graben=1
               Gang_graben(x,y,mit_was(akt_level),0,mit_was(akt_level),akt_level)
            EndIf
         EndIf
         Next
      Next
      
      ; Place Entry and Exit
      setlaby(1,1,akt_level,#FELD_EINGANG,0,0,0)
      setlaby(ziel_x,ziel_y,akt_level,#FELD_AUSGANG,0,0,0)
      ausgangx(akt_level) = ziel_x
      ausgangy(akt_level) = ziel_y
    EndIf
    
    ; Kill Wrong zeros
    For i = 1 To #MAX_GROESSE
       For j = 1 To #MAX_GROESSE
          If labyrinth(i,j)\feld[akt_level] = 0
             setlaby(i,j,akt_level,inhalt(akt_level),0,0,0)
          EndIf
       Next
    Next
        
    ; Place Room
    If sonderlevel(akt_level) = 0
      If raeume(akt_level) > 0
         setzen(8,8,akt_level)
      EndIf
    EndIf
 
 
  ; Place Traps
  If akt_level > 2 And sonderlevel(akt_level) = 0
    anzahl_fallen = (groesse(akt_level)/8)*(groesse(akt_level)/8)
    If levelmod(akt_level) = #LM_FIERCE_TRAPS
       anzahl_fallen = anzahl_fallen * 3
    EndIf
    For i=1 To anzahl_fallen
      counter = 1
      Repeat
        x=Random(groesse(akt_level)-3)+2
        y=Random(groesse(akt_level)-3)+2
        counter = counter + 1
      Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500

      If akt_level < 10
         falle = Random(2) + #FELD_SPEERFALLE1
      EndIf
      If akt_level > 9
         falle = Random(8) + #FELD_SPEERFALLE1
      EndIf

      setlaby(x,y,akt_level,falle,0,0,0)
    Next
  EndIf
  
  ; Place Runes
  If akt_level > 2 And sonderlevel(akt_level) = 0
    anzahl_runen.w = Random(akt_level/2)
    If TEST = 1
       anzahl_runen = 5
    EndIf
    For i = 1 To anzahl_runen
      counter = 1
      Repeat
        x=Random(groesse(akt_level)-3)+2
        y=Random(groesse(akt_level)-3)+2
        counter = counter + 1
      Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500

      Select(Random(2))
         Case 0: setlaby(x,y,akt_level,#FELD_RUNE1,0,0,0)
         Case 1: setlaby(x,y,akt_level,#FELD_RUNE2,0,0,0)
         Case 2: setlaby(x,y,akt_level,#FELD_RUNE3,0,0,0)
      EndSelect
    Next
  EndIf

  ; Place Skeletons
  If sonderlevel(akt_level) <> #SL_ARCHIPEL
      For i=1 To akt_level+1
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level]=inhalt(akt_level) Or counter > 500
         willi.w = Random(8)+1
         If Random(100) > 75
            filler.w = 1
         Else
            filler = 0
         EndIf
         Select (willi)
            Case 1: setlaby(x,y,akt_level,#FELD_SKELETT,filler,0,0)
            Case 2: setlaby(x,y,akt_level,#FELD_KNOCHEN1,filler,0,0)
            Case 3: setlaby(x,y,akt_level,#FELD_KNOCHEN2,filler,0,0)
            Case 4: setlaby(x,y,akt_level,#FELD_KNOCHEN3,filler,0,0)
            Case 5: setlaby(x,y,akt_level,#FELD_KNOCHEN4,filler,0,0)
            Case 6: setlaby(x,y,akt_level,#FELD_KNOCHEN5,filler,0,0)
            Case 7: setlaby(x,y,akt_level,#FELD_KNOCHEN6,filler,0,0)
            Case 8: setlaby(x,y,akt_level,#FELD_KNOCHEN7,filler,0,0)
            Case 9: setlaby(x,y,akt_level,#FELD_KNOCHEN8,filler,0,0)
         EndSelect
      Next
  EndIf

  If fluss(akt_level) = 1
     breite = groesse(akt_level)/3
     If Random(1) = 0  ; Vertikal
        If ziel_x > breite + 2
           ; Place River
           anfang = Random(ziel_x - breite) + 1
           For j = 1 To groesse(akt_level)
              For i = 1 To breite
                 If Random(100) < 75
                    setlaby(i+anfang,j,akt_level,#FELD_WASSER,0,0,0)
                 Else
                    setlaby(i+anfang,j,akt_level,#FELD_WASSERMONSTER,0,0,0)
                 EndIf
              Next
           Next
        EndIf
     Else   ; Horizontal
        If ziel_y > breite + 2
           anfang = Random(ziel_y - breite) + 1
           For i = 1 To groesse(akt_level)
              For j = 1 To breite
                 If Random(100) < 90
                    setlaby(i,j+anfang,akt_level,#FELD_WASSER,0,0,0)
                 Else
                    setlaby(i,j+anfang,akt_level,#FELD_WASSERMONSTER,0,0,0)
                 EndIf
              Next
           Next
        EndIf
     EndIf
  EndIf

    ; ggf Koenige setzen!
    ; Goblin Hoehle
    If sonderlevel(akt_level) = #SL_GOBLINHOEHLE
      hugo = 122
      counter = 1
      Repeat
         x=Random(groesse(akt_level)-3)+2
         y=Random(groesse(akt_level)-3)+2
         counter = counter + 1
      Until (labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) And x > groesse(akt_level)/2 And y > groesse(akt_level)/2) Or counter > 500
      If counter <= 500
         setlaby(x,y,akt_level,monster(hugo)\nr + #ANZ_FELDER,monster(hugo)\lebenspunkte,hugo,0)
         goblinkoenig(akt_level) = 1
      EndIf
    EndIf
    
    ; Spinnenbau
    If sonderlevel(akt_level) = #SL_SPINNENBAU
      hugo = 121
      counter = 1
      Repeat
         x=Random(groesse(akt_level)-3)+2
         y=Random(groesse(akt_level)-3)+2
         counter = counter + 1
      Until (labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) And x > groesse(akt_level)/2 And y > groesse(akt_level)/2) Or counter > 500
      If counter <= 500
         setlaby(x,y,akt_level,monster(hugo)\nr + #ANZ_FELDER,monster(hugo)\lebenspunkte,hugo,0)
         spinnenkoenigin(akt_level) = 1
      EndIf
    EndIf
    
    ; Halle der Toten
    If sonderlevel(akt_level) = #SL_TOTENHALLE
      hugo = 123
      counter = 1
      Repeat
         x=Random(groesse(akt_level)-3)+2
         y=Random(groesse(akt_level)-3)+2
         counter = counter + 1
      Until (labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) And x > groesse(akt_level)/2 And y > groesse(akt_level)/2) Or counter > 500
      If counter <= 500
         setlaby(x,y,akt_level,monster(hugo)\nr + #ANZ_FELDER,monster(hugo)\lebenspunkte,hugo,0)
         untotenherr(akt_level) = 1
      EndIf
    EndIf
  
  
    ; Nexus setzen
    If levelmod(akt_level) <> #LM_KEIN_NEXUS
      counter = 1
      Repeat
         x=Random(groesse(akt_level)-3)+2
         y=Random(groesse(akt_level)-3)+2
         counter = counter + 1
      Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
      If counter <= 500
         setlaby(x,y,akt_level,#FELD_NEXUS,anz_spieler*3,0,0)
      EndIf
    EndIf

   
   ; Place Sanktum
   If levelmod(akt_level) <> #LM_KEIN_SANKTUM
      counter = 1
      Repeat
         x=Random(groesse(akt_level)-3)+2
         y=Random(groesse(akt_level)-3)+2
         counter = counter + 1
      Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
      If counter <= 500
         setlaby(x,y,akt_level,#FELD_SANKTUM,anz_spieler*3,1,0)
      EndIf
    EndIf

    ; Place Bowlders
    If sonderlevel(akt_level) <> #SL_ARCHIPEL And sonderlevel(akt_level) <> #SL_SUMPF
         anz_bowlders = Random((akt_level/4)+1)
         If anz_bowlders > 0 And sonderlevel(akt_level) = 0
            For i = 1 To anz_bowlders
               counter = 1
               Repeat
                  x=Random(groesse(akt_level)-3)+2
                  y=Random(groesse(akt_level)-3)+2
                  counter = counter + 1
               Until labyrinth(x,y)\feld[akt_level] = #FELD_MAUER Or counter > 500
               If counter <= 500
                  setlaby(x,y,akt_level,#FELD_FELSBROCKEN,0,0,0)
               EndIf
            Next
         EndIf
    EndIf
    
    ; Place Scrolls
    If sonderlevel(akt_level) = 0
      anz_scrolls.w = Random(akt_level/4)+1
      For i = 1 To anz_scrolls
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            Repeat
               which.w = Random(#ANZ_ZAUBER-1)+1
            Until zauber(which, 1)\dauer <> #UNENDLICH
            setlaby(x, y, akt_level, #ANZ_FELDER+#ANZ_MONSTER+#OBJGRAFIK_SCHRIFTROLLE,which,0,0)
         EndIf
      Next
    EndIf
    
    ; Place Plants
    If sonderlevel(akt_level) = #SL_SUMPF
      ; Pflanzen
      For i = 1 To groesse(akt_level)*groesse(akt_level)/12
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            setlaby(x, y, akt_level, #FELD_PFLANZE,0,0,0)
         EndIf
      Next
      
      ; Gift
      For i = 1 To groesse(akt_level)*groesse(akt_level)/12
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            setlaby(x, y, akt_level, #FELD_GIFTIG,0,0,0)
         EndIf
      Next
    EndIf
    
    ; Place Healing Herbs
    If sonderlevel(akt_level) = 0
      anz_herbs.w = Random(akt_level/2)+1
      For i = 1 To anz_herbs
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            If Random(100) > 80
               setlaby(x, y, akt_level, #ANZ_FELDER+#ANZ_MONSTER+#OBJGRAFIK_CRYSOLIT,0,0,0)
            Else
               setlaby(x, y, akt_level, #ANZ_FELDER+#ANZ_MONSTER+#OBJGRAFIK_KRAEUTER,0,0,0)
            EndIf
         EndIf
      Next
    EndIf
    
    
    ; Place SpiderWebs
    If sonderlevel(akt_level) = 8
      For i = 1 To groesse(akt_level)
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            setlaby(x,y,akt_level,#FELD_NETZ,0,0,0)
         EndIf
      Next
    EndIf
    
    ; Place Hidden Treasure
    If Random(100) > 80 And sonderlevel(akt_level) <> #SL_ARCHIPEL And sonderlevel(akt_level) <> #SL_SUMPF
      counter = 1
      Repeat
         x=Random(groesse(akt_level)-3)+2
         y=Random(groesse(akt_level)-3)+2
         counter = counter + 1
      Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
      If counter <= 500
         was.w = finden2()
         setlaby(x,y,akt_level,#FELD_SKELETT2,0,0,was)
      EndIf
    EndIf

     ; Gitter setzen
      If sonderlevel(akt_level) <> #SL_ARCHIPEL And sonderlevel(akt_level) <> #SL_SUMPF And sonderlevel(akt_level) <> #SL_WUESTE And (akt_level > 5 Or TEST = 1)
        For i = 1 To groesse(akt_level)/10
            counter = 1
            Repeat
               x=Random(groesse(akt_level)-3)+2
               y=Random(groesse(akt_level)-3)+2
               counter = counter + 1
            Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
            If counter <= 500
               setlaby(x,y,akt_level,#FELD_GITTER1,0,0,0)
            EndIf
         Next
      EndIf

      ; Nagelgruben setzen
      If sonderlevel(akt_level) <> #SL_ARCHIPEL And sonderlevel(akt_level) <> #SL_SUMPF And sonderlevel(akt_level) <> #SL_WUESTE And (akt_level > 7)
        For i = 1 To (Random(groesse(akt_level)*2)+1)
            counter = 1
            Repeat
               x=Random(groesse(akt_level)-3)+2
               y=Random(groesse(akt_level)-3)+2
               counter = counter + 1
            Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
            If counter <= 500
               setlaby(x,y,akt_level,#FELD_NAGELGRUBE,0,0,0)
            EndIf
         Next
      EndIf

    ; Wounded Hero
    If level >= 8
      If Random(100) > 95
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            setlaby(x,y,akt_level,#FELD_WOUNDED_HERO1,0,0,0)
         EndIf
      EndIf
    EndIf
    
    
   ; Kleinhaendler
   If Random(100) > 68+akt_level And raeume(akt_level) <> #RAUM_HAENDLER1 And raeume(akt_level) <> #RAUM_HAENDLER2 And raeume(akt_level) <> #RAUM_HAENDLER3 And raeume(akt_level) <> #RAUM_HAENDLER4 And raeume(akt_level) <> #RAUM_HAENDLER5
      counter = 1
      Repeat
         x=Random(groesse(akt_level)-3)+2
         y=Random(groesse(akt_level)-3)+2
         counter = counter + 1
      Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
      If counter <= 500
         kleinhaendler_init(akt_level)
         If Random(100) > 50
            setlaby(x,y,akt_level,#FELD_HAENDLER9,0,0,0)
         Else
            setlaby(x,y,akt_level,#FELD_HAENDLER10,0,0,0)
         EndIf
      EndIf
   EndIf
   
   ; Geheimtueren?
   If levelmod(akt_level) = #LM_GEHEIMTUEREN
      For i = 1 To groesse(akt_level) * groesse(akt_level) / 12
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         If counter <= 500
            setlaby(x,y,akt_level,#FELD_GEHEIMGANG,0,0,0)
         EndIf
      Next
   EndIf
    
    
    ; Place Teleporters
    If (((Random(100) > 40 And akt_level > 3) Or sonderlevel(akt_level) = 7) And sonderlevel(akt_level) <> #SL_ARCHIPEL) Or TEST = 1
      i = 1
      If akt_level > 10 And Random(100) > 50
         i = i + 1
      EndIf
      If akt_level > 20 And Random(100) > 50
         i = i + 1
      EndIf
      If sonderlevel(akt_level) = 7
         i = groesse(akt_level) * groesse(akt_level) / 12
      EndIf
      For j = 1 To i
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         counter2.w = 1
         Repeat
            xx=Random(groesse(akt_level)-3)+2
            yy=Random(groesse(akt_level)-3)+2
            counter2 = counter2 + 1
         Until labyrinth(xx,yy)\feld[akt_level] = inhalt(akt_level) Or counter2 > 500
         If counter <= 500 And counter2 <= 500
            setlaby(x,y,akt_level,#FELD_TELEPORTER,xx,yy,0)
            setlaby(xx,yy,akt_level,#FELD_TELEPORTER,x,y,0)
         EndIf
      Next
    EndIf
    
    ; Cross Level Teleporter
    If Random(100) > 80 And sonderlevel(akt_level) <> #SL_ARCHIPEL And akt_level > 10
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
         counter2.w = 1
         altlevel.w = Random(akt_level-2)+1
         Repeat
            xx=Random(groesse(altlevel)-3)+2
            yy=Random(groesse(altlevel)-3)+2
            counter2 = counter2 + 1
         Until labyrinth(xx,yy)\feld[altlevel] = inhalt(altlevel) Or counter2 > 500
         If counter <= 500 And counter2 <= 500
            setlaby(x,y,akt_level,#FELD_TELEPORTER,xx,yy,altlevel)
            setlaby(xx,yy,altlevel,#FELD_TELEPORTER,x,y,akt_level)
         EndIf
    EndIf
    
    ; Rinnsaale setzen
    If sonderlevel(akt_level) <> #SL_ARCHIPEL And sonderlevel(akt_level) <> #SL_WUESTE And sonderlevel(akt_level) <> #SL_LAVAKAVERNE And sonderlevel(akt_level) <> #SL_ILLUSIONEN
       For i = 1 To groesse(akt_level)/10
          counter = 1
          Repeat
             x=Random(groesse(akt_level)-3)+2
             y=Random(groesse(akt_level)-3)+2
             counter = counter + 1
          Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) Or counter > 500
          If counter <= 500
             setlaby(x,y,akt_level,#FELD_RINNSAAL,0,0,0)
          EndIf
       Next
    EndIf

    
    ; Place Monsters
    ; A Monster on each 12 Fields
    For i = 1 To groesse(akt_level)*groesse(akt_level)/12
       monster_setzen(akt_level,monster_random(akt_level,sonderlevel(akt_level)))
    Next
    If levelmod(akt_level) = #LM_MONSTERS
       For i = 1 To groesse(akt_level)*groesse(akt_level)/12
          monster_setzen(akt_level,monster_random(akt_level,sonderlevel(akt_level)))
       Next
    endif
    
    if test = 1
      For i = 1 To groesse(akt_level)*groesse(akt_level)/12
         
         ;setlaby(x,y,akt_level,#FELD_SCHACHT,xx,yy,0)
         ;monster_setzen(akt_level,131)
      Next
    endif
    
    
    ; Eishalle
    if sonderlevel(akt_level) = #SL_EISKAVERNE
       For i = 1 To groesse(akt_level)*groesse(akt_level)/12
          counter = 1
          Repeat
             x=Random(groesse(akt_level)-3)+2
             y=Random(groesse(akt_level)-3)+2
             counter = counter + 1
          Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) or counter > 500
          if counter <= 500
             setlaby(x,y,akt_level,#FELD_EIS,0,0,0)
          endif
       Next
    endif
    
    
    ; Make sure that there is an exit
    ausgang_vorh = 0
    if test = 0
    For i = 1 To groesse(akt_level)
       For j = 1 To groesse(akt_level)
          If labyrinth(i,j)\feld[akt_level] = #FELD_AUSGANG
             ausgang_vorh = 1
          EndIf
       Next
    Next
    endif
    If ausgang_vorh = 0
       ; zuerst unten rechts probieren
       zaehler = 1
       Repeat
          x=Random(groesse(akt_level)-3)+2
          y=Random(groesse(akt_level)-3)+2
          zaehler = zaehler + 1
       Until (labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) and (labyrinth(x+1,y)\feld[akt_level] = inhalt(akt_level) or labyrinth(x-1,y)\feld[akt_level] = inhalt(akt_level) or labyrinth(x,y+1)\feld[akt_level] = inhalt(akt_level) or labyrinth(x,y-1)\feld[akt_level] = inhalt(akt_level))  and x > (groesse(akt_level) - 6) and y > (groesse(akt_level) - 6)) or zaehler > 500
       ausgangx(akt_level) = x
       ausgangy(akt_level) = y
       ; dann unten links probieren
       if zaehler > 500
         zaehler = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            zaehler = zaehler + 1
         Until (labyrinth(x,y)\feld[akt_level] = inhalt(akt_level)and (labyrinth(x+1,y)\feld[akt_level] = inhalt(akt_level) or labyrinth(x-1,y)\feld[akt_level] = inhalt(akt_level) or labyrinth(x,y+1)\feld[akt_level] = inhalt(akt_level) or labyrinth(x,y-1)\feld[akt_level] = inhalt(akt_level)) and x < 6 and y > (groesse(akt_level) - 6)) or zaehler > 500
          ausgangx(akt_level) = x
          ausgangy(akt_level) = y
       endif
       ; Wenn unmoeglich irgendwo!
       if zaehler > 500
          zaehler = 1
          Repeat
             x=Random(groesse(akt_level)-3)+2
             y=Random(groesse(akt_level)-3)+2
             zaehler = zaehler + 1
          Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) and (labyrinth(x+1,y)\feld[akt_level] = inhalt(akt_level) or labyrinth(x-1,y)\feld[akt_level] = inhalt(akt_level) or labyrinth(x,y+1)\feld[akt_level] = inhalt(akt_level) or labyrinth(x,y-1)\feld[akt_level] = inhalt(akt_level)) or zaehler > 2000
       endif
       if zaehler <= 2000
          setlaby(x,y,akt_level,#FELD_AUSGANG,0,0,0)
          ausgangx(akt_level) = x
          ausgangy(akt_level) = y
       else
          x = groesse(akt_level)-1
          y = groesse(akt_level)-1
          setlaby(x,y,akt_level,#FELD_AUSGANG,0,0,0)
          ausgangx(akt_level) = x
          ausgangy(akt_level) = y
       endif
    EndIf
    
    ; Sicherstellen das Ausgang erreichbar ist
    erreichbar.w = 0
    x = ausgangx(akt_level)
    y = ausgangy(akt_level)
    if x-1 >= 1 and (labyrinth(x-1,y)\feld = inhalt(akt_level) or istmonster(x-1,y) = 1)
       erreichbar = 1
    endif
    if x+1 <= groesse(akt_level) and (labyrinth(x+1,y)\feld = inhalt(akt_level) or istmonster(x+1,y) = 1)
       erreichbar = 1
    endif
    if y-1 >= 1 and (labyrinth(x,y-1)\feld = inhalt(akt_level) or istmonster(x,y-1) = 1)
       erreichbar = 1
    endif
    if y+1 <= groesse(akt_level) and (labyrinth(x,y+1)\feld = inhalt(akt_level) or istmonster(x,y+1) = 1)
       erreichbar = 1
    endif
    if erreichbar = 0
      ; In alle Richtungen graben
      if x-1 >= 1
         if labyrinth(x-1,y)\feld = mit_was(akt_level)
            setlaby(x-1,y,akt_level,inhalt(akt_level),0,0,0)
         endif
      endif
      if x+1 <= groesse(akt_level) 
         if labyrinth(x+1,y)\feld = mit_was(akt_level)
            setlaby(x+1,y,akt_level,inhalt(akt_level),0,0,0)
         endif
      endif
      if y-1 >= 1
         if labyrinth(x,y-1)\feld = mit_was(akt_level)
            setlaby(x,y-1,akt_level,inhalt(akt_level),0,0,0)
         endif
      endif
      if y+1 <= groesse(akt_level) 
         if labyrinth(x,y+1)\feld = mit_was(akt_level)
            setlaby(x,y+1,akt_level,inhalt(akt_level),0,0,0)
         endif
      endif
    endif
    
    ; Blocked exit?
    if levelmod(akt_level) = #LM_BLOCKED_EXIT
         For i = 1 To groesse(akt_level)
            For j = 1 To groesse(akt_level)
               If labyrinth(i,j)\feld[akt_level] = #FELD_AUSGANG
                  ausg_x.w = i
                  ausg_y.w = j
               EndIf
            Next
         Next
         if labyrinth(ausg_x-1,ausg_y)\feld[akt_level] <> #FELD_MAUER
            setlaby(ausg_x-1,ausg_y,akt_level,#FELD_TUER2,0,0,1)
         endif
         if labyrinth(ausg_x+1,ausg_y)\feld[akt_level] <> #FELD_MAUER
            setlaby(ausg_x+1,ausg_y,akt_level,#FELD_TUER2,0,0,1)
         endif
         if labyrinth(ausg_x,ausg_y-1)\feld[akt_level] <> #FELD_MAUER
            setlaby(ausg_x,ausg_y-1,akt_level,#FELD_TUER2,0,0,1)
         endif
         if labyrinth(ausg_x,ausg_y+1)\feld[akt_level] <> #FELD_MAUER
            setlaby(ausg_x,ausg_y+1,akt_level,#FELD_TUER2,0,0,1)
         endif
         counter = 1
         Repeat
            x=Random(groesse(akt_level)-3)+2
            y=Random(groesse(akt_level)-3)+2
            counter = counter + 1
         Until labyrinth(x,y)\feld[akt_level] = inhalt(akt_level) or counter > 2000
         if counter <= 2000
            setlaby(x,y,akt_level,#FELD_SCHALTER1,0,0,0)
         endif
      endif
      
      
    if levelmod(akt_level) = #LM_EXTREME_HOT
       for i = 1 to groesse(akt_level)
          for j = 1 to groesse(akt_level)
             if labyrinth(i,j)\feld[akt_level] = #FELD_LEER
                setlaby(i,j,akt_level,#FELD_FEUER2,0,0,0)
             endif
          next
       next
    endif
    if levelmod(akt_level) = #LM_EXTREME_COLD
       for i = 1 to groesse(akt_level)
          for j = 1 to groesse(akt_level)
             if labyrinth(i,j)\feld[akt_level] = #FELD_LEER
                setlaby(i,j,akt_level,#FELD_EIS,0,0,0)
             endif
          next
       next
    endif
    
    
    if sonderlevel(akt_level) <> #SL_ARCHIPEL and sonderlevel(akt_level) <> #SL_WUESTE
      hugo = random(7)+1
      select(hugo)
         case 1: ; Nichts
         case 2: diagonal(akt_level)
         case 3: vertikal(akt_level)
         case 4: diagonal(akt_level)
                 vertikal(akt_level)
         case 5: horizontal(akt_level)
         case 6: diagonal(akt_level)
                 horizontal(akt_level)
         case 7: vertikal(akt_level)
                 horizontal(akt_level)
         case 8: diagonal(akt_level)
                 vertikal(akt_level)
                 horizontal(akt_level)
      endselect
    endif

EndProcedure

; IDE Options = PureBasic v4.01 (Windows - x86)
; CursorPosition = 1312
; FirstLine = 1279
; Folding = --
; EnableAsm
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger
