; Routinen zum Zeichnen des Hauptschirms


; -------------------------------------------------------------------------------------

Procedure laby_rahmen()
   
   ; Ueberbleibsel des Labyrinths uebermalen
   wohin = ScreenOutput()
   StartDrawing(wohin)
   FrontColor(RGB(0,0,0))
   Box(365,15,51,449) 
   Box(15,365,335,51)
   StopDrawing()

   ; Rahmen zeichnen
   ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
   DisplaySprite(#SPRITE_RAHMEN_OBEN, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
   DisplaySprite(#SPRITE_RAHMEN_LINKS, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
   DisplaySprite(#SPRITE_RAHMEN_UNTEN, 0, 464)
   ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
   DisplaySprite(#SPRITE_RAHMEN_RECHTS, 624, 0)
   
   ClipSprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 0, 640, 17)
   DisplaySprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 350)
   ClipSprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 0, 365, 17)
   DisplaySprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 414)
   
   ClipSprite(#SPRITE_RAHMEN_SCHMAL1, 0, 0, 274, 16)
   DisplaySprite(#SPRITE_RAHMEN_SCHMAL1, 350, 87)
   ClipSprite(#SPRITE_RAHMEN_SCHMAL2, 0, 0, 274, 16)
   DisplaySprite(#SPRITE_RAHMEN_SCHMAL2, 350, 167)
   
   ClipSprite(#SPRITE_RAHMEN_MITTE, 0, 0, 17, 480)
   DisplaySprite(#SPRITE_RAHMEN_MITTE, 350, 0)
   
EndProcedure

; --------------------------------------------------------------------------------------

Procedure show_logo()

   ClipSprite(#SPRITE_TILESET_LOGO, 1, 1, 200, 58)
   DisplayTransparentSprite(#SPRITE_TILESET_LOGO, 400, 25)

EndProcedure

; --------------------------------------------------------------------------------------
; Prozedur Spielervariablen anzeigen

Procedure show_varys()

Shared sprache, akt_spieler, mydelay, flaschen

      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mmouse_rechts  = MouseButton(2)
      
      x = 400
      y = 104
      FrontColor(RGB(0,0,0))
      Box(x,y,160,55)  ; Muell uebermalen
      ; Life Corrigieren
      If spieler(akt_spieler)\Lifepoints > maxlife()
         spieler(akt_spieler)\Lifepoints = maxlife()
      EndIf
      
      ; Zugweite Korrigieren
      If spieler(akt_spieler)\Speed > maxspeed()
         spieler(akt_spieler)\Speed = maxspeed()
      EndIf

      If flaschen = 1
         faktor.f = maxlife() / 32
         pos.w = (spieler(akt_spieler)\Lifepoints / faktor) - 1
         If maxlife() = spieler(akt_spieler)\Lifepoints
            pos2.w = 27 * 32 - 27
         Else
            pos2 = 27 * pos - 27
         EndIf
         ClipSprite(#SPRITE_LEBEN, pos2, 0, 27, 49)
         DisplaySprite(#SPRITE_LEBEN, #POS_FLASCHE_X, #POS_FLASCHE_Y)

         
         faktor = maxmana() / 32
         pos = (spieler(akt_spieler)\Mana / faktor) - 1
         If maxmana() = spieler(akt_spieler)\Mana
            pos2 = 27 * 32 - 27
         Else
            pos2 = 27 * pos - 27
         EndIf
         ClipSprite(#SPRITE_MANA, pos2, 0, 27, 49)
         DisplaySprite(#SPRITE_MANA, #POS_FLASCHE_X+30, #POS_FLASCHE_Y)
         
         wohin = ScreenOutput()
         StartDrawing(wohin)
         DrawingMode(1)
         
         FrontColor(RGB(239,131,44))

         DrawText(x+70,y+15,nachricht_text(77,sprache+1))

         DrawText(x+155,y+15,Str(spieler(akt_spieler)\Speed) + "/" + Str(maxspeed()))
   
         FrontColor(RGB(154,251,120))

         DrawText(x+70,y+30,nachricht_text(525,sprache+1))
 
         DrawText(x+155,y+30,Str(spieler(akt_spieler)\Level))
      Else
         wohin = ScreenOutput()
         StartDrawing(wohin)
         DrawingMode(1)
         

         FrontColor(RGB(247,36,61))
         DrawText(x,y,nachricht_text(55,sprache+1))

         DrawText(x+110,y,Str(spieler(akt_spieler)\Lifepoints) + "/" + Str(maxlife()))
   
         
         FrontColor(RGB(130,125,250))

         DrawText(x,y+15,nachricht_text(59,sprache+1))

         DrawText(x+115,y+15,Str(spieler(akt_spieler)\Mana) + "/" + Str(maxmana()))
         
         FrontColor(RGB(239,131,44))
      
         DrawText(x,y+30,nachricht_text(77,sprache+1))
      
         DrawText(x+115,y+30,Str(spieler(akt_spieler)\Speed) + "/" + Str(maxspeed()))
   
         FrontColor(RGB(154,251,120))
    
         DrawText(x,y+45,nachricht_text(525,sprache+1))
  
         DrawText(x+115,y+45,Str(spieler(akt_spieler)\Level))
      EndIf
      
      StopDrawing()
      
      ; Maennchen anzeigen damit man weiss wer dran ist
      ClipSprite(#SPRITE_TILESET_CHARACTER, 128, spieler(akt_spieler)\maennchen*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 590, 120)

      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)

      ; Aktives Zeug
      x = 400
      y = 174
      FrontColor(RGB(0,0,0))    ; Schwarz
      If spieler(akt_spieler)\schleichen > 0
         y = y + 10
         FrontColor(RGB(150,150,150))  ; Grau
         DrawText(x,y,nachricht_text(78,1+sprache))
      EndIf
      
      StopDrawing()

      For i = 1 To 15
         If aktive(i,akt_spieler)\nr > 0
                
            gibts.w = 0
            For zz = 1 To i-1
               If aktive(i,akt_spieler)\nr = aktive(zz,akt_spieler)\nr
                  gibts = 1
               EndIf
            Next
            
            If gibts = 0
               y = y + 16
               ; Ist Maus hier?
               If mmouse_x >= x And mmouse_x <= x+120 And mmouse_y >= y And mmouse_y <= y+15
                  ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 2*16, 3*16, 16, 16)
                  DisplayTransparentSprite(#SPRITE_TILESET_ENCHANTMENTS, x-20, y)
                  If mmouse_rechts = 1
                     If aktive(i,akt_spieler)\ dauer <> #UNENDLICH
                        aktive(i,akt_spieler)\nr = 0
                        aktive(i,akt_spieler)\staerke = 0
                        Delay(mydelay)
                     EndIf
                  EndIf
               EndIf
               
               ; Icons fuer Enchantments anzeigen
               Select aktive(i,akt_spieler)\nr
                  Case #SPELL_LICHT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 0, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_FLEDERMAUSGESTALT: 
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_WOLFSGESTALT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_VOGELGESTALT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_KATZENGESTALT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_DRACHENGESTALT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_SYPHON:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 143, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_WINTERATEM:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 63, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_FEUERAURA:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 79, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_FALLENSINN:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 95, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_FEUERSCHILD:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 15, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_EISSCHILD:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 0, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_MACHT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 79, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_GLUECKSZAUBER:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 79, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_STAERKEZAUBER:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 0, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_SCHUTZSCHILD:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 63, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_WEISSER_SCHUTZ:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 63, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_MAGIESCHUTZ:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 143, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_SCHUTZ_VOR_GESCHOSSEN:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 111, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_HEXENSICHT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 95, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_FALLEN_SPUEHREN:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 95, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_RUECKENWIND:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 47, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DER_HOFFNUNG:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 127, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DER_EINSAMKEIT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 111, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DES_TODES:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DER_MAGIE:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 143, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DES_LEBENS:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 0, 47, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_FLIEGEN:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 15, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_UEBERS_WASSER_GEHEN:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 127, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DES_KAMPFES:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 15, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_TAEUSCHUNG:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 127, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_UNSICHTBARES_SEHEN:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 63, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_UNSICHTBARKEIT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 47, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_BLITZSCHUTZ:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 111, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_VERSTEINERNSCHUTZ:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 111, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_DOPPELGAENGER:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 143, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_1000_KLINGEN:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 95, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_GEISTERTANZ:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 63, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_UNVERWUNDBARKEIT:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 63, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_GIFTSCHUTZ:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 47, 47, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_WINDMEISTER:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 47, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_HYPNOSE:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 79, 47, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DES_SCHUTZES:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 63, 47, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_SCHOCK:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 111, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_REGENERATION:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 0, 47, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LEBENSBUND:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 111, 47, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DES_SCHLAFES:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 15, 111, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_LIED_DES_SELBSTMORDS:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 31, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_CONCENTRATION:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 31, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  Case #SPELL_PRAEZISION:
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 15, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  EndSelect
                  
                  ; Verzauberungen
                  If aktive(i,akt_spieler)\nr = #SPELL_VERZAUBERE_KREATUR_1 Or aktive(i,akt_spieler)\nr =#SPELL_VERZAUBERE_KREATUR_2 Or aktive(i,akt_spieler)\nr = #SPELL_VERZAUBERE_KREATUR_3 Or aktive(i,akt_spieler)\nr = #SPELL_VERZAUBERE_KREATUR_4
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 0, 15, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  EndIf
                  
                  ; Metamagie
                  If aktive(i,akt_spieler)\nr = #SPELL_TUNNEL Or aktive(i,akt_spieler)\nr = #SPELL_VERLAENGERN2 Or aktive(i,akt_spieler)\nr = #SPELL_SCHNELLZAUBER Or aktive(i,akt_spieler)\nr = #SPELL_BRECHER Or aktive(i,akt_spieler)\nr = #SPELL_PENETRATION Or aktive(i,akt_spieler)\nr = #SPELL_VERDOPPELN
                     ClipSprite(#SPRITE_TILESET_ENCHANTMENTS, 143, 0, 15, 15)
                     DisplaySprite(#SPRITE_TILESET_ENCHANTMENTS, x, y)
                  EndIf
               
               wohin = ScreenOutput()
               StartDrawing(wohin)
               DrawingMode(1)
               FrontColor(RGB(255,255,1))   ; Gelb
               DrawText(x+20,y,zauber(aktive(i,akt_spieler)\nr,akt_spieler)\name[1+sprache])
               
               StopDrawing()
            EndIf ; gibts
         EndIf
      Next

      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)
      
      ; Waffe/Ruestung beschaedigt
      waffe_kaputt.w = 0
      ruestung_kaputt.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\benutzt = 1 And (inventory(i,akt_spieler)\status = 1 Or inventory(i,akt_spieler)\status = 2)
            If gegenstand(inventory(i,akt_spieler)\name)\art = 1
               waffe_kaputt = 1
            EndIf
            If gegenstand(inventory(i,akt_spieler)\name)\art = 6 Or gegenstand(inventory(i,akt_spieler)\name)\art = 7 Or gegenstand(inventory(i,akt_spieler)\name)\art = 8 Or gegenstand(inventory(i,akt_spieler)\name)\art = 9 Or gegenstand(inventory(i,akt_spieler)\name)\art = 11
               ruestung_kaputt = 1
            EndIf
         EndIf
      Next
      If waffe_kaputt > 0
         y = y + 16
         FrontColor(RGB(255,1,1))  ; Rot
         DrawText(x,y,nachricht_text(646,1+sprache))
      EndIf
      If ruestung_kaputt > 0
         y = y + 16

         FrontColor(RGB(255,1,1))  ; Rot
         DrawText(x,y,nachricht_text(647,1+sprache))
      EndIf
      
      ; Close to dying?
      If spieler(akt_spieler)\Lifepoints <= maxlife()/6 Or spieler(akt_spieler)\Lifepoints <= 3
         y = y + 16

         FrontColor(RGB(255,1,1))  ; Rot
         DrawText(x,y,nachricht_text(662,1+sprache))
      Else
         If spieler(akt_spieler)\Lifepoints <= maxlife()/4 Or spieler(akt_spieler)\Lifepoints <= 5
            y = y + 16
            FrontColor(RGB(255,1,1))  ; Rot
            DrawText(x,y,nachricht_text(661,1+sprache))
         EndIf
      EndIf
      
      ; Drunken?
      If spieler(akt_spieler)\betrunken > 0
         y = y + 16
         FrontColor(RGB(1,255,1))  ; Gruen
         DrawText(x,y,nachricht_text(699,1+sprache))
      EndIf
      
      ; Belastung
      If belastung() > 0
         y = y + 16

         FrontColor(RGB(255,1,1))  ; Rot
         DrawText(x,y,nachricht_text(86,1+sprache) + " " + Str(belastung()))
      EndIf

      If spieler(akt_spieler)\gift > 0
         y = y + 16

         FrontColor(RGB(1,255,1))  ; Gruen
         DrawText(x,y,nachricht_text(645,1+sprache) + Str(spieler(akt_spieler)\gift))
      EndIf
      If spieler(akt_spieler)\verhungern > 0
         y = y + 16

         FrontColor(RGB(1,1,255))  ; Blau
            Select spieler(akt_spieler)\verhungern
               Case 1 : DrawText(x,y,nachricht_text(97,sprache+1))
               Case 2 : DrawText(x,y,nachricht_text(98,sprache+1))
               Case 3 : DrawText(x,y,nachricht_text(99,sprache+1))
            EndSelect
      EndIf
      If spieler(akt_spieler)\verdursten > 0
         y = y + 16
         FrontColor(RGB(1,1,255))  ; Blau
            Select spieler(akt_spieler)\verdursten
               Case 1 : DrawText(x,y,nachricht_text(94,sprache+1))
               Case 2 : DrawText(x,y,nachricht_text(95,sprache+1))
               Case 3 : DrawText(x,y,nachricht_text(96,sprache+1))
            EndSelect
      EndIf
      If spieler(akt_spieler)\krankheit > 0
         y = y + 16
         FrontColor(RGB(1,255,1))  ; Gruen
         DrawText(x,y,nachricht_text(825,1+sprache) + " " + Str(spieler(akt_spieler)\krankheit))
      EndIf
      
      If spieler(akt_spieler)\fluch > 0
         y = y + 16

         FrontColor(RGB(150,150,150))  ; Grau

         erkl.w = 0
         If spieler(akt_spieler)\fluch = #FLUCH_NAMENLOS
            DrawText(x,y,nachricht_text(131,sprache+1))
            erkl = 838
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_TIAMAT
            DrawText(x,y,nachricht_text(132,sprache+1))
            erkl = 839
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_HEKATE
            DrawText(x,y,nachricht_text(133,sprache+1))
            erkl = 840
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_ARES
            DrawText(x,y,nachricht_text(134,sprache+1))
            erkl = 841
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_PARALYSE
            DrawText(x,y,nachricht_text(135,sprache+1))
            erkl = 842
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_ARTEMIS
            DrawText(x,y,nachricht_text(136,sprache+1))
            erkl = 843
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_ACHILLES
            DrawText(x,y,nachricht_text(137,sprache+1))
            erkl = 844
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_BLINDHEIT
            DrawText(x,y,nachricht_text(138,sprache+1))
            erkl = 845
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_HEPHAISTOS
            DrawText(x,y,nachricht_text(139,sprache+1))
            erkl = 846
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_HADES
            DrawText(x,y,nachricht_text(140,sprache+1))
            erkl = 847
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_SETH
            DrawText(x,y,nachricht_text(141,sprache+1))
            erkl = 848
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_APOPHIS
            DrawText(x,y,nachricht_text(142,sprache+1))
            erkl = 849
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_DAGDA
            DrawText(x,y,nachricht_text(143,sprache+1))
            erkl = 850
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_NAIADEN
            DrawText(x,y,nachricht_text(144,sprache+1))
            erkl = 851
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_OSIRIS
            DrawText(x,y,nachricht_text(145,sprache+1))
            erkl = 852
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_LEPRECHAUN
            DrawText(x,y,nachricht_text(146,sprache+1))
            erkl = 853
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_MARDUK
            DrawText(x,y,nachricht_text(147,sprache+1))
            erkl = 854
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_ASTARTE
            DrawText(x,y,nachricht_text(148,sprache+1))
            erkl = 855
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DES_POSEIDON
            DrawText(x,y,nachricht_text(149,sprache+1))
            erkl = 856
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_TANIS
            DrawText(x,y,nachricht_text(150,sprache+1))
            erkl = 857
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_ATHENE
            DrawText(x,y,nachricht_text(151,sprache+1))
            erkl = 858
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_DER_MORRIGU
            DrawText(x,y,nachricht_text(152,sprache+1))
            erkl = 859
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN
            DrawText(x,y,nachricht_text(153,sprache+1))
            erkl = 860
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_MAGNETO
            DrawText(x,y,nachricht_text(749,sprache+1))
            erkl = 861
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_GAIA
            DrawText(x,y,nachricht_text(750,sprache+1))
            erkl = 862
         EndIf
         If spieler(akt_spieler)\fluch = #FLUCH_NOSFERATU
            DrawText(x,y,nachricht_text(751,sprache+1))
            erkl = 863
         EndIf

         ; Ist Maus hier?
         If mmouse_x >= x And mmouse_x <= x+120 And mmouse_y >= y And mmouse_y <= y+15 And erkl <> 0

            DrawText(25,#NACHRICHTEN_POSY+20,nachricht_text(erkl,1+sprache))
         EndIf
         
      EndIf

   StopDrawing()

EndProcedure


; --------------------------------------------------------------------------------------
; Prozedur Kreaturenvariablen anzeigen

Procedure show_varys2()

Shared sprache, akt_spieler

   wohin = ScreenOutput()

   StartDrawing(wohin)
      DrawingMode(1)

      x = 400
      y = 104

      FrontColor(RGB(0,0,0))
      Box(400,110,160,55)  ; Muell uebermalen
      FrontColor(RGB(255,255,255))
      FrontColor(RGB(247,36,61))
      DrawText(x,y,nachricht_text(55,sprache+1))

      DrawText(x+110,y,Str(spieler(akt_spieler)\creature_Lifepoints))

      FrontColor(RGB(239,131,44))

      DrawText(x,y+30,nachricht_text(77,sprache+1))

      DrawText(x+115,y+30,Str(spieler(akt_spieler)\creature_Speed) + "/" + Str(creature_speed()))

      FrontColor(RGB(154,251,120))

      DrawText(x,y+45,"Level:")

      DrawText(x+115,y+45,Str(spieler(akt_spieler)\Level))

   StopDrawing()
   
   ; Homunkulus
   If spieler(akt_spieler)\creature_typ = 1 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 9*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
   ; Skelett
   If spieler(akt_spieler)\creature_typ = 2 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 7*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
   ; Todesritter
   If spieler(akt_spieler)\creature_typ = 3 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 12*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
   ; Sternenfee
   If spieler(akt_spieler)\creature_typ = 4 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 13*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 130)
      okay = 1
   EndIf
   ; Tiger
   If spieler(akt_spieler)\creature_typ = 5 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 14*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
   ; Mumie
   If spieler(akt_spieler)\creature_typ = 6 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 11*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
   ; Daemon
   If spieler(akt_spieler)\creature_typ = 7 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 8*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
   ; Engel
   If spieler(akt_spieler)\creature_typ = 8 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 10*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
   ; Drache
   If spieler(akt_spieler)\creature_typ = 9 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 6*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay = 1
   EndIf
  ; Doppelgaenger
   If spieler(akt_spieler)\creature_typ = 10 And okay = 0
      ClipSprite(#SPRITE_TILESET_CHARACTER, 128, spieler(akt_spieler)\maennchen*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 590, 125)
      okay = 1
   EndIf 
   ; Bird
   If spieler(akt_spieler)\creature_typ = 11 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 4*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay =1
   EndIf
   ; Golem
   If spieler(akt_spieler)\creature_typ = 12 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 16*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay =1
   EndIf
   ; Satyr
   If spieler(akt_spieler)\creature_typ = 13 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 17*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay =1
   EndIf
   ; Feuerelementar
   If spieler(akt_spieler)\creature_typ = 14 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 18*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay =1
   EndIf
   ; Wasserelementar
   If spieler(akt_spieler)\creature_typ = 15 And okay = 0
      ClipSprite(#SPRITE_TILESET_MONSTERANIM, 128, 19*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 590, 125)
      okay =1
   EndIf
   ; Gefaehrte
   If spieler(akt_spieler)\creature_typ = 20 And okay = 0
      ClipSprite(#SPRITE_TILESET_CHARACTER, 128, 20*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 590, 125)
      okay = 1
   EndIf

EndProcedure
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 570
; FirstLine = 568
; Folding = -------------
; DisableDebugger
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
