; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


; Lost Labyrinth
; Hauptprogramm
; Version: 2.9.1
;   (c) 2003 - 2007  Markus Doebele (mar_doe@gmx.de)
; letzte Aenderung:
;   02.04.2003 Markus Doebele (mar_doe@gmx.de) Linuxversion (ca. 2 h)
;   17.01.2004 Markus Doebele (mar_doe@gmx.de) Skills auswaehlen begonnen (ca. 12 h!)
;   19.01.2004 Markus Doebele (mar_doe@gmx.de) Skills Menue erweitert (ca. 8 h)
;   21.01.2004 Markus Doebele (mar_doe@gmx.de) Sound hinzugefuegt (ca. 1 h)
;   23.01.2004 Markus Doebele (mar_doe@gmx.de) Hauptschirm erweitert, Highscores, Credits (ca. 10 h)
;   24.01.2004 Markus Doebele (mar_doe@gmx.de) Aufsteigen und Hilfescreen (ca. 8 h)
;   25.01.2004 Markus Doebele (mar_doe@gmx.de) Inventar angefangen (ca. 1 h)
;   27.01.2004 Markus Doebele (mar_doe@gmx.de) Inventar erweitert (ca. 4 h)
;   28.01.2004 Markus Doebele (mar_doe@gmx.de) Spellmenue angefangen, plus Animationen (ca. 4 h)
;   29.01.2004 Markus Doebele (mar_doe@gmx.de) Inventar erweitert, Laby generieren (ca. 8 h)
;   30.01.2004 Markus Doebele (mar_doe@gmx.de) Monster/Skelette/Fallen etc setzen, Kampf (ca. 4 h)
;   31.01.2004 Markus Doebele (mar_doe@gmx.de) Kampf erweitert (ca. 6 h)
;   01.02.2004 Markus Doebele (mar_doe@gmx.de) Highscore (ca. 4 h)
;   02.02.2004 Markus Doebele (mar_doe@gmx.de) Verhungern, Verdursten, Fallen (ca. 4 h)
;   03.02.2004 Markus Doebele (mar_doe@gmx.de) Skills, Nexus, Zauber (ca. 7 h)
;   04.02.2004 Markus Doebele (mar_doe@gmx.de) Zaubern erweitert, L.O.S. (ca. 3 h)
;   05.02.2004 Markus Doebele (mar_doe@gmx.de) Zaubern erweitert, Wirbelwind (ca. 3 h)
;   06.02.2004 Markus Doebele (mar_doe@gmx.de) 11 Raeume (ca. 11 h)
;   07.02.2004 Markus Doebele (mar_doe@gmx.de) Wiedergaenger, Critical Hits, Fallen (ca. 4 h)
;   08.02.2004 Markus Doebele (mar_doe@gmx.de) 12 Zauber, Optionen, Hinterhalte (ca. 5 h)
;   09.02.2004 Markus Doebele (mar_doe@gmx.de) Alle Monster, Lichtdauer, 2 Zauber (ca. 5 h)
;   10.02.2004 Markus Doebele (mar_doe@gmx.de) Waffen, Ruestungen (ca. 3 h)
;   11.02.2004 Markus Doebele (mar_doe@gmx.de) Druiden-, Schwarze-, Feuer- und Erdmagie (ca. 4 h)
;   12.02.2004 Markus Doebele (mar_doe@gmx.de) Wasser-, Sternen, Bardenmagie (ca. 4 h)
;   13.02.2004 Markus Doebele (mar_doe@gmx.de) Luftmagie (ca. 1 h)
;   14.02.2004 Markus Doebele (mar_doe@gmx.de) Fehler behoben (ca. 1 h)
;   15.02.2004 Markus Doebele (mar_doe@gmx.de) Monster Fernkampf (ca. 2 h)
;   16.02.2004 Markus Doebele (mar_doe@gmx.de) Fernkampf erweitert (ca. 3 h)
;   17.02.2004 Markus Doebele (mar_doe@gmx.de) Flueche (ca. 4 h)
;   18.02.2004 Markus Doebele (mar_doe@gmx.de) Runenfallen (ca. 2 h)
;   19.02.2004 Markus Doebele (mar_doe@gmx.de) Windows Version (ca. 4 h)
;   20.02.2004 Markus Doebele (mar_doe@gmx.de) Windows Version (ca. 1 h)
;   22.02.2004 Markus Doebele (mar_doe@gmx.de) Maennchen auswaehlen, Illusionsmagie (ca. 2 h)
;   23.02.2004 Markus Doebele (mar_doe@gmx.de) Characterinfo, Hohe Magie, Fluss, Brunnen, Teleport (ca. 4 h)
;   24.02.2004 Markus Doebele (mar_doe@gmx.de) Hexerei, Schleichen, Bogenschiessen, Warlock (ca. 3 h)
;   25.02.2004 Markus Doebele (mar_doe@gmx.de) 9 neue Zauber, aktive Zauber neu (ca. 5 h)
;   26.02.2004 Markus Doebele (mar_doe@gmx.de) 3 neue Zauber (ca. 1 h)
;   28.02.2004 Markus Doebele (mar_doe@gmx.de) 8 neue Zauber (ca. 3 h)
;   29.02.2004 Markus Doebele (mar_doe@gmx.de) 5 neue zauber, Schriftrollen (ca. 3 h)
;   01.03.2004 Markus Doebele (mar_doe@gmx.de) Traenke, Code cleanup (ca. 5 h)
;   02.03.2004 Markus Doebele (mar_doe@gmx.de) Bugfixing (ca. 2 h)
;   03.03.2004 Markus Doebele (mar_doe@gmx.de) Verborgene Schaetze, Altar, 5 mag. Gegenstaende (ca. 5 h)
;   06.03.2004 Markus Doebele (mar_doe@gmx.de) Bugfixing, Zauberstaebe, Medusahaupt (ca. 3 h)
;   07.03.2004 Markus Doebele (mar_doe@gmx.de) Monstereigenschaften (ca. 1 h)
;   08.03.2004 Markus Doebele (mar_doe@gmx.de) Laufen mit Maus (ca. 1 h)
;   09.03.2004 Markus Doebele (mar_doe@gmx.de) Bugfixing, Windows Version (ca. 4 h)
;   10.03.2004 Markus Doebele (mar_doe@gmx.de) Bugfixing, Ablegen (ca. 1 h)
;   11.03.2004 Markus Doebele (mar_doe@gmx.de) Maussteuerung, Feuerdaemon, Verstaerkung (ca. 5 h)
;   12.03.2004 Markus Doebele (mar_doe@gmx.de) Zweihaender (ca. 1 h)
;   14.03.2004 Markus Doebele (mar_doe@gmx.de) Behinderung durch Ruestung (ca. 1 h)
;   16.03.2004 Markus Doebele (mar_doe@gmx.de) Geheimtueren entdecken, Diebstahl, Skills, Pilze (ca. 6 h)
;   23.03.2004 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 1 h)
;   24.03.2004 Markus Doebele (mar_doe@gmx.de) Buttonfunktionen anzeigen (ca. 2 h)
;   25.03.2004 Markus Doebele (mar_doe@gmx.de) Buttonfunktionen fertig (ca. 1 h)
;   04.04.2004 Markus Doebele (mar_doe@gmx.de) Bugfixing (ca. 1 h)
;   14.04.2004 Markus Doebele (mar_doe@gmx.de) Bugfixing, Optionen mit Maus (ca. 1 h)
;   15.04.2004 Markus Doebele (mar_doe@gmx.de) Multiplayer (ca. 3 h)
;   27.04.2004 Markus Doebele (mar_doe@gmx.de) Multiplayer (ca. 1 h)
;   28.04.2004 Markus Doebele (mar_doe@gmx.de) Multiplayer (ca. 1 h)
;   14.05.2004 Markus Doebele (mar_doe@gmx.de) Multiplayer (ca. 3 h)
;   15.05.2004 Markus Doebele (mar_doe@gmx.de) Multiplayer (ca. 1 h)
;   16.05.2004 Markus Doebele (mar_doe@gmx.de) Zauber auf Tasten, Sprachenfile (ca. 3 h)
;   19.05.2004 Markus Doebele (mar_doe@gmx.de) Sprachenfile, Multiplayer (ca. 4 h)
;   23.05.2004 Markus Doebele (mar_doe@gmx.de) Bugfixing (ca. 1 h)
;   24.05.2004 Markus Doebele (mar_doe@gmx.de) Online Highscore (ca. 1 h)
;   08.08.2005 Markus Doebele (mar_doe@gmx.de) Spanische Version, Neuer Compiler (ca. 5 h)
;   09.08.2005 Markus Doebele (mar_doe@gmx.de) Spanische Version (ca. 8 h)
;   10.08.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   11.08.2005 Markus Doebele (mar_doe@gmx.de) Sonderlevel (ca. 10 h)
;   12.08.2005 Markus Doebele (mar_doe@gmx.de) 6 neue mag Gegenstaende (ca. 4 h)
;   13.08.2005 Markus Doebele (mar_doe@gmx.de) Wassermonster, Hexe (ca. 8 h)
;   14.08.2005 Markus Doebele (mar_doe@gmx.de) Packer integriert, Bilder fuer Sonderlevel (ca. 8 h)
;   15.08.2005 Markus Doebele (mar_doe@gmx.de) Verwandlungszauber, RPM erstellt (ca. 8 h)
;   16.08.2005 Markus Doebele (mar_doe@gmx.de) Verwandlungszauber, RPM verbessert, Restliche Flueche (ca. 10 h)
;   17.08.2005 Markus Doebele (mar_doe@gmx.de) Beschwoerungszauber (ca. 8 h)
;   18.08.2005 Markus Doebele (mar_doe@gmx.de) Beschwoerungszauber, Bugfixes (ca. 6 h)
;   19.08.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 4 h)
;   21.08.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   22.08.2005 Markus Doebele (mar_doe@gmx.de) Zentauerwald, Trainer, Drachenraum, Sonderlevel verbessert (ca. 6 h)
;   23.08.2005 Markus Doebele (mar_doe@gmx.de) 7 neue Magische Gegenstaende (ca. 4 h)
;   24.08.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   25.08.2005 Markus Doebele (mar_doe@gmx.de) Icons fuer Enchantments, 5 neue mag Gegenstaende, Waffen+Ruestungen Neu (ca. 6 h)
;   27.08.2005 Markus Doebele (mar_doe@gmx.de) Waffen+Ruestungen Neu (ca. 2 h)
;   28.08.2005 Markus Doebele (mar_doe@gmx.de) Ablegen, Lavaschatz, Stabteilraum, Steine (ca. 5 h)
;   29.08.2005 Markus Doebele (mar_doe@gmx.de) Spielende, Andere heilen/entgiften, Spitzhacke, Schaufel, Vergrabene Schatztruhe, Highscore erweitert (ca. 6 h)
;   30.08.2005 Markus Doebele (mar_doe@gmx.de) Highscore erweitert, Codecleanup (ca. 3 h)
;   31.08.2005 Markus Doebele (mar_doe@gmx.de) Bugfixing (ca. 2 h)
;   01.09.2005 Markus Doebele (mar_doe@gmx.de) Code Cleanup, Doppelgaenger, Magische Ruestung (ca. 3 h)
;   02.09.2005 Markus Doebele (mar_doe@gmx.de) 11 neue Magische Gegenstaende (ca. 2 h)
;   03.09.2005 Markus Doebele (mar_doe@gmx.de) Laby Kernel Neu (ca. 3 h)
;   04.09.2005 Markus Doebele (mar_doe@gmx.de) Taverne (ca. 4 h)
;   05.09.2005 Markus Doebele (mar_doe@gmx.de) Uralte Hydra, Kampf verbessert (ca. 7 h)
;   08.09.2005 Markus Doebele (mar_doe@gmx.de) Level: Illusionen, Spinnen, Spielgeschwindigkeit, Laden+Speichern (ca. 4 h)
;   10.09.2005 Markus Doebele (mar_doe@gmx.de) 4 neue Splashes, Suchen in Raeumen, Restliche Monstereigenschaften (ca. 5 h)
;   11.09.2005 Markus Doebele (mar_doe@gmx.de) Bugfixing, Andere entfluchen, Steine zerstoeren (ca. 2 h)
;   12.09.2005 Markus Doebele (mar_doe@gmx.de) 38 neue Monster, Skillmenue erweitert (ca. 6 h)
;   13.09.2005 Markus Doebele (mar_doe@gmx.de) 21 neue Skills (ca. 8 h)
;   16.09.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 1 h)
;   17.09.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Orkan , Online Highscore (ca. 4 h)
;   18.09.2005 Markus Doebele (mar_doe@gmx.de) Online Highscore, Monster hinterlassen Schaetze (ca. 3 h)
;   19.09.2005 Markus Doebele (mar_doe@gmx.de) Bewachter Schatzraum, Zauberer, Teich, Pilze neu (ca. 3 h)
;   21.09.2005 Markus Doebele (mar_doe@gmx.de) Mimic, Regeneration (ca. 1 h)
;   25.09.2005 Markus Doebele (mar_doe@gmx.de) Unsichtbarkeit (Monster und Spieler), Monsterkunde verbessert (ca. 3 h)
;   27.09.2005 Markus Doebele (mar_doe@gmx.de) Levelmodifier, Waffenklassen, Wurfwaffen, Geister bannen (ca. 5 h)
;   30.09.2005 Markus Doebele (mar_doe@gmx.de) Load Button Titel, Readme Spells (ca. 1 h)
;   01.10.2005 Markus Doebele (mar_doe@gmx.de) Turn skippen (ca. 2 h)
;   02.10.2005 Markus Doebele (mar_doe@gmx.de) Mystic Attack, leeme, leeme_hechizos, Feuerkreis, Mentalschlag, Neue Effekte (ca. 4 h)
;   03.10.2005 Markus Doebele (mar_doe@gmx.de) Sounds fuer Monster, Vergessene Schmiede, Los fixed, Windows Version, Fullscreen/Fenster (ca. 5 h)
;   04.10.2005 Markus Doebele (mar_doe@gmx.de) Creatures und Teleporter/Eisbloecke, Sternenfee laeuft durch Waende, Drache schlaegt Tueren ein (ca. 2 h)
;   05.10.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 1 h)
;   06.10.2005 Markus Doebele (mar_doe@gmx.de) Kleinigkeiten (ca. 1 h)
;   07.10.2005 Markus Doebele (mar_doe@gmx.de) FAQ, Zauber Effekte - Windows , ReleaseMouse (ca. 3 h)
;   08.10.2005 Markus Doebele (mar_doe@gmx.de) Joystick, Inventory mit Tastatur/Joystick (ca. 3 h)
;   09.10.2005 Markus Doebele (mar_doe@gmx.de) Joystick (ca. 1 h)
;   10.10.2005 Markus Doebele (mar_doe@gmx.de) Joystick, Kochen, Haendler mit Tastatur/Joystick (ca. 4 h)
;   11.10.2005 Markus Doebele (mar_doe@gmx.de) Haendler/Lehrer/Gefaehrten/Wizard/Vergolden/Opfern mit Tastatur/Joystick, Body anzeigen (ca. 6 h)
;   13.10.2005 Markus Doebele (mar_doe@gmx.de) Gegenstaende mit Maus bewegen (ca. 6 h)
;   14.10.2005 Markus Doebele (mar_doe@gmx.de) Gegenstaende mit Maus bewegen (ca. 4 h)
;   15.10.2005 Markus Doebele (mar_doe@gmx.de) Spells: Flameburst, Fireball, Armageddon, Meteor, Levelmodifier: Extremely Cold/Hot, Room of Traps, Skill: Merchant, Items: Flaschengeist, Stack Items, 15 new Potions, 8 neue Zauberstaebe (ca. 9 h)
;   16.10.2005 Markus Doebele (mar_doe@gmx.de) Fackel/Lampeneffekt anzeigen, Stapeln bei Zeug mit Ladungen, Magic Apple verbessert, Spells: Blitzeschutz/Versteinernschutz, 11 Amulette, 3ter Haendler (ca. 4 h)
;   17.10.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Spell: 1000 Klingen (ca. 2 h)
;   18.10.2005 Markus Doebele (mar_doe@gmx.de) Spells: Dance of Ghosts, Invulnerability, Find Nexus/Sanktum, Trank der Unverwundbarkeit, Punkte in Cinfo, Kreaturen Zeug aufnehmen, Schaden vermeiden neu (ca. 5 h)
;   19.10.2005 Markus Doebele (mar_doe@gmx.de) Zaubern/Inventory abbrechen kostet keinen Zug mehr, Steinschleuder, Munition in Bodybild anzeigen (ca. 4 h)
;   20.10.2005 Markus Doebele (mar_doe@gmx.de) Zufaelliger Fluch mit 50% bei Verflucht, 2H Waffenbehandlung neu, 8 neue Knochen, Movecounter, 6 neue Ringe, Ringmeister bekommt einen Ring, Windows Version (ca. 6 h)
;   21.10.2005 Markus Doebele (mar_doe@gmx.de) Animation Turn to stone, Haendler Pilze und Traenke nicht anzeigen, Haendler Beschreibungen von magischen Gegenstaenden anzeigen (ca. 3 h)
;   22.10.2005 Markus Doebele (mar_doe@gmx.de) Spieler in unterschiedlichen Levels (ca. 6 h)
;   23.10.2005 Markus Doebele (mar_doe@gmx.de) Spieler in unterschiedlichen Levels, Spiel endet nach Ebene 150! (ca. 4 h)
;   24.10.2005 Markus Doebele (mar_doe@gmx.de) Top Level angefangen, Schaufel behoben, Haendler berichtigt, Zauberstab Effekte, Schleichen neu, Diagonal verhindern, Karte zerstoeren, Invisibility Bug, Turn to stone, Highscore (ca. 3 h)
;   25.10.2005 Markus Doebele (mar_doe@gmx.de) Neues Design (ca. 4 h)
;   26.10.2005 Markus Doebele (mar_doe@gmx.de) Schnellinventory (ca. 6 h)
;   27.10.2005 Markus Doebele (mar_doe@gmx.de) Schnellinventory, F-Tasten, Farben C-Info Screen+Highscore, Karte scrollen (ca. 6 h)
;   28.10.2005 Markus Doebele (mar_doe@gmx.de) Spieler+Kreaturen in Karte anzeigen, Move Back Buttons, Schriftrollen finden, Unsichtbarkeit geaendert, Suchen auf Friedhof, 11 Gegenstaende, Haendler4 (ca. 5 h)
;   29.10.2005 Markus Doebele (mar_doe@gmx.de) Neue Gegenstaende (ca. 2 h)
;   30.10.2005 Markus Doebele (mar_doe@gmx.de) Stati fuer Monster, Verhexen geaendert, Schleichen geaendert, Spell: Vergiften (ca. 5 h)
;   31.10.2005 Markus Doebele (mar_doe@gmx.de) Monster Regeneration und Vergiftung geaendert, Stati fuer Waffen/Ruestungen, Waffen vergiften, Skills: Giftkenntis, Lahm, Spell: Resurrection (ca. 6 h)
;   01.11.2005 Markus Doebele (mar_doe@gmx.de) Scrolling in Titel, Giftschwert, Sounds fuer Kreaturen, Gold in Rucksack anzeigen, Gold ablegen, Gold stehlen, Alle Raeume 5x5 oder 8x8, Skills: Visionen, Erde spuehren (ca. 7 h)
;   02.11.2005 Markus Doebele (mar_doe@gmx.de) Skill: Schatzjaeger, Scrollore, Zauber: Schlaf (ca. 3 h)
;   03.11.2005 Markus Doebele (mar_doe@gmx.de) Amulett des Durstloeschens, Amulett der Ernaehrung (ca. 1 h)
;   04.11.2005 Markus Doebele (mar_doe@gmx.de) jpg statt bmp, 7 neue Monster, Zauberbeschreibung des Zaubers auf dem die Maus ist, Aktive Zauber beenden, Neuer Sound fuer Blitze, Zauber: Pestilence (ca. 3 h)
;   05.11.2005 Markus Doebele (mar_doe@gmx.de) Heilkraeuter, Einstellungen speichern, Sunken Treasure, Wueste des Vergessens, Alle Raeume 8x8, Haendler Bug (ca. 5 h)
;   06.11.2005 Markus Doebele (mar_doe@gmx.de) Sonderlevel, Levelmodifier bei Spielstart, Inhalt von Truhen am Levelstart festlegen, Teleporter anstatt Treppen, Pilze durch Objekte ersetzt, 5 neue Wassermonster, Archipel der Alten (ca. 6 h)
;   07.11.2005 Markus Doebele (mar_doe@gmx.de) Maennchen in Wasser halb uebermalen, Spinnenkoenigin, Goblinkoenig, Herr der Untoten, 2 neue Spinnen (ca. 2 h)
;   08.11.2005 Markus Doebele (mar_doe@gmx.de) Koenige nur aktueller Level, Fledermaus+Vogelgestalt haben jetzt LP/3, Katze/2 und Drache*3, Katzengestalt+3 gegen Ratten+ befreundet Katzen, Wolfsgestalt Woelfe, Katzengestalt Katzen, Angeln, Spell: Telekinesis, Windows Version (ca. 7 h)
;   09.11.2005 Markus Doebele (mar_doe@gmx.de) Windows Version, Neuer Highscore Upload, Frozen Lightning, Traptoolkit, 6 Weapons, Homepage (ca. 6 h)
;   10.11.2005 Markus Doebele (mar_doe@gmx.de) Release 1.8.1, Homepage (ca. 7 h)
;   11.11.2005 Markus Doebele (mar_doe@gmx.de) Creaturen + Objekte aufnehmen, Online Highscore (ca. 7 h)
;   12.11.2005 Markus Doebele (mar_doe@gmx.de) Neue Homepage online (ca. 3 h)
;   13.11.2005 Markus Doebele (mar_doe@gmx.de) Runes, Online Highscore verbessert, FAQ verbessert (ca. 4 h)
;   14.11.2005 Markus Doebele (mar_doe@gmx.de) Release 1.8.3 (ca. 2 h)
;   15.11.2005 Markus Doebele (mar_doe@gmx.de) Pfeile vergiften, Raum: Thronsaal, Zauber: Vakuum, Giftschutz, Speziallevel: Sumpf der Einsamkeit (ca. 6 h)
;   16.11.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   17.11.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   18.11.2005 Markus Doebele (mar_doe@gmx.de) Animationen fuer Fallen, Wounded Hero (ca. 4 h)
;   20.11.2005 Markus Doebele (mar_doe@gmx.de) Trait Statistik (ca. 3 h)
;   21.11.2005 Markus Doebele (mar_doe@gmx.de) fasm problem behoben, Dart Animation, Kleinhaendler (ca. 4 h)
;   22.11.2005 Markus Doebele (mar_doe@gmx.de) Automapping (ca. 3 h)
;   23.11.2005 Markus Doebele (mar_doe@gmx.de) 2 Zeilen pro Skill, Mailingliste (ca. 7 h)
;   24.11.2005 Markus Doebele (mar_doe@gmx.de) Teleporter+Bewegt, Wasser+Waterskin, Beschreibung fuer Schnellinventory, Fullscreen+Windows, Schnellinventory benutzen/entnutzen, Grafikfehler Skelette (ca. 5 h)
;   25.11.2005 Markus Doebele (mar_doe@gmx.de) Grafikfehler Skelette, Bogen+Unsichtbare, Monsterzauber: Teleport, Neues Design, Neues Bodybild (ca. 6 h)
;   26.11.2005 Markus Doebele (mar_doe@gmx.de) Creatures+versch.Level, Haendler unter Spieler in untersch. Levels (ca. 3 h)
;   27.11.2005 Markus Doebele (mar_doe@gmx.de) Release 1.9.2, Schon gewaehlte Maennchen werden nicht mehr angezeigt, Blaue Truhe, 25 neue Monster, 13 neue Waffen, Haendler 5 (ca. 7 h)
;   28.11.2005 Markus Doebele (mar_doe@gmx.de) Stehlen+Monsterstati, Visionen verbessert, Zauber: Pflanze zerstoeren, 3 neue Monster, Modularisierungen, Plain Settingsfile (ca. 8 h)
;   29.11.2005 Markus Doebele (mar_doe@gmx.de) Silentmode (ca. 2 h)
;   30.11.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Scrollore changed, Kurzsichtig geaendert, Blutmagie geaendert (ca. 8 h)
;   01.12.2005 Markus Doebele (mar_doe@gmx.de) Neuer Untergrund fuer Eislevel, Elfenblut geaendert, Module Tests, Codeoptimierungen, Module Support (ca. 9 h)
;   02.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Feuerkreis->Desintegration, Bogen+Hydra, Release 1.9.5, Show Highscores verbessert, Schmiedekunst, Preise Elder/Ancient (ca. 6 h)
;   03.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Einhorn, Silberner/Goldener Schluessel (ca. 2 h)
;   04.12.2005 Markus Doebele (mar_doe@gmx.de) Erlernte Zauber speichern, Verschiedene Wassermonster (ca. 3 h)
;   05.12.2005 Markus Doebele (mar_doe@gmx.de) Mehrere Savegames, Freie Magie (ca. 4 h)
;   06.12.2005 Markus Doebele (mar_doe@gmx.de) Templates, Haendler erklaert Schriftrollen, Windows Version, Release 2.0.1 (ca. 7 h)
;   07.12.2005 Markus Doebele (mar_doe@gmx.de) Neuer Laby Algorythmus (ca. 2 h)
;   08.12.2005 Markus Doebele (mar_doe@gmx.de) Neuer Laby Algorythmus (ca. 2 h)
;   09.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Monsterzauber: Dispel (ca. 3 h)
;   10.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Freie Magie geaendert (ca. 2 h)
;   11.12.2005 Markus Doebele (mar_doe@gmx.de) Highscore nach Punkten/Zeit sortieren, Labyrinth spiegeln, Lichtests (ca. 6 h)
;   12.12.2005 Markus Doebele (mar_doe@gmx.de) Diagonal spiegeln, Release 2.0.3 (ca. 3 h)
;   13.12.2005 Markus Doebele (mar_doe@gmx.de) Weight, Zauber: Mit Tieren reden, Energie der Steine (ca. 4 h)
;   14.12.2005 Markus Doebele (mar_doe@gmx.de) Magischer Bogen, Levelmod : Alarmierte Monster, Crysolit, Zauber: Wegblasen, Bugfixes: Verlaengern, Syphon (ca. 4 h)
;   15.12.2005 Markus Doebele (mar_doe@gmx.de) Punkte in C-Info, F-Tasten+Guertel, Identifizierte Traenke/Schriftrollen, Chancen in C-Info, Bugfixes, Umherschauen geaendert (ca. 5 h)
;   16.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes: Staerkeberechnung, Zauber: Blenden (ca. 3 h)
;   17.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes: Haendler+Id.Schriftrollen (ca. 2 h)
;   18.12.2005 Markus Doebele (mar_doe@gmx.de) Qualitäten für Gegenstände, Bugfixes: Freemagic Crash, Release 2.0.5 (ca. 3 h)
;   19.12.2005 Markus Doebele (mar_doe@gmx.de) Delay3, min/max schaden neu, Entdeckte Fallen +30% ausweichen, Naga Pfeile, Fehler: Kreaturen+Automap (ca. 3 h)
;   20.12.2005 Markus Doebele (mar_doe@gmx.de) Naga Pfeile, Alchemie neu, Monsterlore, 2 Seite C-Info (ca. 5 h)
;   21.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes, Alle Ruestungen beschädigen (ca. 3 h)
;   22.12.2005 Markus Doebele (mar_doe@gmx.de) Kritische geändert, Gott der Geheimnisse geändert, Flecke aus Monster ausgelagert, Lore durch Aktionen, Haendler+Qualitaeten (ca. 6 h)
;   23.12.2005 Markus Doebele (mar_doe@gmx.de) Haendler bug (ca. 2 h)
;   27.12.2005 Markus Doebele (mar_doe@gmx.de) Wassermonster+Bogen, Kreaturen+Hydra (ca. 5 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Skill Menue berarbeitet (ca. 5 h)
;   28.12.2005 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 4 h)
;   29.12.2005 Markus Doebele (mar_doe@gmx.de) Neue Monster, 5 neue Zauber, Release 2.1.3 (ca. 6 h)
;   30.12.2005 Rasmus Klette  (rasmus.klette@freenet.de) Berechnung des Menues mit Anzahl Skills, "Alle Skills" Button, Diamanten Tiles verbessert, 3 Neue Buttons, Skill Save Menue Save, (ca. 8 h)
;              Markus Doebele (mar_doe@gmx.de) 3 neue Zauber, Homepage verbessert (ca. 5 h)
;   31.12.2005 Rasmus Klette  (rasmus.klette@freenet.de) Sprachauswahl im Titel speichern (ca. 1 h)
;   01.01.2006 Markus Doebele (mar_doe@gmx.de) Neue Zauber: Vogel beschw, Gift neutralisieren (ca. 2 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Schadenswerte zentriert, Bugfixes: Flimmern am Rundenende und beim Betreten von neuen Raeumen
;   02.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 3 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Neue Zentrale Stringeingabe (ca. 2 h)
;   03.01.2006 Markus Doebele (mar_doe@gmx.de) Buttons fuer Hoch/Runter neu, 9 Neue Animationen, Monster huepfen (ca. 7 h)
;              Rasmus Klette (rasmus.klette@freenet.de) Neue Delay Methode (ca. 7 h)
;   04.01.2006 Markus Doebele (mar_doe@gmx.de) Waffenstatus in Mainscreen, Bugfixes, Release 2.2.0 (ca. 5 h)
;              Rasmus Klette (rasmus.klette@freenet.de) Neue Zentrale Stringeingabe (ca. 5 h)
;   05.01.2006 Markus Doebele (mar_doe@gmx.de) Bird everywhere, LM: Illusionary walls, Zauber: Todeswolke, Verdorren (ca. 4 h)
;   06.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.2.1 (ca. 2 h)
;   07.01.2006 Markus Doebele (mar_doe@gmx.de) Beschw. Gegenst. aufloesen (ca. 2 h)
;   11.01.2006 Markus Doebele (mar_doe@gmx.de) Englische Schreibfehler, Index FAQ, Release 2.2.2, schleuder (ca. 4 h)
;   13.01.2006 Markus Doebele (mar_doe@gmx.de) Regulationen, Fernkampf+Zuruecklassen, Tiles wechseln (ca. 5 h)
;   14.01.2006 Markus Doebele (mar_doe@gmx.de) Nachrichtenschirm, Monster huepfen bei Kreatur, Neue Runenfalle, Highscore Verifikation, Spanische Schreibfehler (ca. 10 h)
;   15.01.2006 Markus Doebele (mar_doe@gmx.de) Release 2.3.0 (ca. 2 h)
;   16.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Icons fuer Schulen (ca. 5 h)
;   17.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.3.1 (ca. 2 h)
;   19.01.2006 Markus Doebele (mar_doe@gmx.de) Doppelklick, Zauber: Insektenschwarm, Sekundaere Faehigkeiten (ca. 6 h)
;   20.01.2006 Markus Doebele (mar_doe@gmx.de) 7 neue Gegenstaende, Bugfixes, Release 2.3.2 (ca. 4 h)
;   21.01.2006 Markus Doebele (mar_doe@gmx.de) Inventory ueberarbeitet, Bogen und Kritische (ca. 5 h)
;   22.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.3.3 (ca. 3 h)
;   23.01.2006 Markus Doebele (mar_doe@gmx.de) Strukturen verbessert, Metamagie, Zauber: Tunnel (ca. 6 h)
;   24.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 1 h)
;   25.01.2006 Markus Doebele (mar_doe@gmx.de) Zauber: Schnellzauber, Verlaengern2, Neuer Button für Automapping, Alkoholische Getränke (ca. 4 h)
;   26.01.2006 Markus Doebele (mar_doe@gmx.de) Rinnsaale, Klicking, Spieler Huepfen, Release 2.3.4 (ca. 6 h)
;   27.01.2006 Markus Doebele (mar_doe@gmx.de) Neuigkeiten als db (ca. 2 h)
;   28.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Animationen Geschwindigkeit, Release 2.3.5 (ca. 2 h)
;   29.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   30.01.2006 Markus Doebele (mar_doe@gmx.de) Farben fuer Nachrichten (ca. 3 h)
;   31.01.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.4.0 (ca. 3 h)
;   01.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, FAQ Raeume, FAQ Sonderlevel, FAQ Monsterfaehigkeiten, 14 neue Charakteranimationen, 2te Auswahlseite (ca. 6 h)
;   02.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   03.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.4.1 (ca. 2 h)
;   04.02.2006 Markus Doebele (mar_doe@gmx.de) Blinking cursor, Zauberweben, Admin Seite fuer Neuigkeiten, Beschworene Kreatures aufstehen, Magieresistenz neu (ca. 8 h)
;   05.02.2006 Markus Doebele (mar_doe@gmx.de) Explodierende Monster, Durchschlagende Pfeile, Weaponcraft und Spezialpfeile, Kampfstile, Interaktion mit Objekten neu (ca. 10 h)
;   06.02.2006 Markus Doebele (mar_doe@gmx.de) Release 2.4.2, Bugfixes (ca. 3 h)
;   07.02.2006 Markus Doebele (mar_doe@gmx.de) In_Rucksack, FAQ Unterschiede New/Classic Laby, 2 neue Raeume (ca. 4 h)
;   08.02.2006 Markus Doebele (mar_doe@gmx.de) Traenke mischen, Opfer Schirm verbessert (ca. 3 h)
;   09.02.2006 Markus Doebele (mar_doe@gmx.de) Release 2.4.3, Monstersense, Scharfschuetze (ca. 2 h)
;   10.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Lichtradius (ca. 4 h)
;   11.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   12.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.4.4 (ca. 2 h)
;   13.02.2006 Markus Doebele (mar_doe@gmx.de) Ghosthunter, Immune normal damage, Spawning, Special successes (ca. 4 h)
;   14.02.2006 Markus Doebele (mar_doe@gmx.de) Release 2.5.0 + 2.5.1, Bugfixes (ca. 6 h)
;   15.02.2006 Markus Doebele (mar_doe@gmx.de) Tiles verbessert, Schmiede geaendert (ca. 2 h)
;   17.02.2006 Markus Doebele (mar_doe@gmx.de) Feuer+Wasserelementar, Licht+Kreaturen (ca. 5 h)
;   18.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.5.2 (ca. 2 h)
;   19.02.2006 Markus Doebele (mar_doe@gmx.de) Tests mehrere Raeume pro Ebene (ca. 6 h)
;   20.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   21.02.2006 Markus Doebele (mar_doe@gmx.de) Titelbild/Spieleranzahl mit Tastatur und Joystick (ca. 4 h)
;   22.02.2006 Markus Doebele (mar_doe@gmx.de) Skills mit Tastatur und Joystick (ca. 6 h)
;   24.02.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 3 h)
;   26.02.2006 Markus Doebele (mar_doe@gmx.de) Credits mit Tastatur, Namen eingeben mit Joystick, Bild fuer Gefaengnis, Orkdorf, New light radius and earthsense (ca. 8 h)
;   27.02.2006 Markus Doebele (mar_doe@gmx.de) Release 2.5.3 (ca. 1 h)
;   28.02.2006 Markus Doebele (mar_doe@gmx.de) Hexenhaus (ca. 2 h)
;   04.03.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes: Findentexte, Text Daemon, Zittern Teleport (windows), cursor (windows), Sternenfee und Aussenwaende, Matrix und windows (ca. 4 h)
;   08.03.2006 Markus Doebele (mar_doe@gmx.de) Joystick verbessert (ca. 5 h)
;   11.03.2006 Markus Doebele (mar_doe@gmx.de) Center Button fuer Karten, Honig (ca. 3 h)
;   13.03.2006 Markus Doebele (mar_doe@gmx.de) Explosionen neu (ca. 3 h)
;   16.03.2006 Markus Doebele (mar_doe@gmx.de) Unerreichbarer Ausgang, Neue Animationen (ca. 4 h)
;   17.03.2006 Markus Doebele (mar_doe@gmx.de) Neue Animationen (ca. 4 h)
;   19.03.2006 Markus Doebele (mar_doe@gmx.de) Grafikfehler behoben, Release 2.6.0 (ca. 2 h)
;   21.03.2006 Markus Doebele (mar_doe@gmx.de) Joystick/Tastatur und Select item Screen, Beschreibung Pilze beim Zerstoeren, Zeit/Datum fuer Savegames, Native Magie (ca. 4 h)
;   22.03.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 2 h)
;   24.03.2006 Markus Doebele (mar_doe@gmx.de) Blocked Exit fixed, Bugfixes (ca. 2 h)
;   26.03.2006 Markus Doebele (mar_doe@gmx.de) Pfeile und explodierende Monster (ca. 4 h)
;   31.03.2006 Markus Doebele (mar_doe@gmx.de) Bogen mit Knopf 5, Wasser/Feuerelementar überqueren Wasser/Feuer, Zauber: Lied des Schlafes/Selbstmords (ca. 4 h)
;   01.04.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, Release 2.6.2 (ca. 2 h)
;   02.04.2006 Markus Doebele (mar_doe@gmx.de) Summoner (ca. 2 h)
;   03.04.2006 Markus Doebele (mar_doe@gmx.de) Icon fuer Summoner, Kreatur heilen, Umschauen erklaert auch Felder (ca. 7 h)
;   06.04.2006 Markus Doebele (mar_doe@gmx.de) Kreaturen verzaubern (ca. 2 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Room Editor Gestarted (ca. 6 h)
;   07.04.2006 Rasmus Klette  (rasmus.klette@freenet.de) key_sting verbessert, Editor erweitert (ca. 6 h)
;   08.04.2006 Markus Doebele (mar_doe@gmx.de) Kreaturen verzaubern, Release 2.6.2 (ca. 2 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Room Editor: Cleanups, Grafisches Interface, Speichern mit Dateinamen (ca. 4 h)
;   09.04.2006 Markus Doebele (mar_doe@gmx.de) Freie Magie nur neue Zauber anzeigen, Magische Helme (ca. 3 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Room Editor: Speicherart komprimiert (ca. 2 h)
;   10.04.2006 Markus Doebele (mar_doe@gmx.de) Hinterhalt aufstehen wie Skelett, 3 neue Levelmods (ca. 4 h)
;   12.04.2006 Markus Doebele (mar_doe@gmx.de) Flaschen fuer Lebens/Manapunkte (ca. 4 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Room Editor: Monster und Objekte setzbar gemacht (ca. 2 h)
;   13.04.2006 Markus Doebele (mar_doe@gmx.de) Flaschen fuer Lebens/Manapunkte (ca. 2 h)
;   17.04.2006 Markus Doebele (mar_doe@gmx.de) Readmes anzeigen, Release 2.6.4 (ca. 3 h)
;   18.04.2006 Markus Doebele (mar_doe@gmx.de) Staemmig, Krankheiten, Schieben (ca. 4 h)
;   23.04.2006 Markus Doebele (mar_doe@gmx.de) Fallgitter (ca. 2 h)
;   26.04.2006 Markus Doebele (mar_doe@gmx.de) Nagelgruben (ca. 2 h)
;   28.04.2006 Markus Doebele (mar_doe@gmx.de) Immun gegen Wind, 6 neue Monster (ca. 2 h)
;   09.05.2006 Markus Doebele (mar_doe@gmx.de) Wahrlicht durch Waende (ca. 2 h)
;   25.05.2006 Markus Doebele (mar_doe@gmx.de) Kleine Grafikfehler (ca. 1 h)
;   30.05.2006 Markus Doebele (mar_doe@gmx.de) Skills erklaeren in C-Info Screen (ca. 1 h)
;   31.05.2006 Markus Doebele (mar_doe@gmx.de) Flueche erklaeren in Hauptscreen (ca. 2 h)
;   01.06.2006 Rasmus Klette  (rasmus.klette@freenet.de) Ausloten fuer das neue Raumsystem (ca. 3 h)
;   02.06.2006 Markus Doebele (mar_doe@gmx.de) Zeitberechnung Online Highscore, Release 2.7.1, Zauber: Chaos, Transmigration, Konzentration, Praezision (ca. 8 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Neues Raumsystem im Editor (ca. 6 h)
;   03.06.2006 Rasmus Klette  (rasmus.klette@freenet.de) Neues Raumsystem im Spiel (ca. 6 h)
;   04.06.2006 Rasmus Klette  (rasmus.klette@freenet.de) Neues Raumsystem ohne Bild und HG, Anfaenge der Raum Scriptsprache (ca. 5 h)
;   05.06.2006 Rasmus Klette  (rasmus.klette@freenet.de) Raumsystem voll implementiert, Laden aus slroom automatisch (ca. 5 h)
;   06.06.2006 Markus Doebele (mar_doe@gmx.de) Stundenglas, Broomstick (ca. 3 h)
;              Rasmus Klette  (rasmus.klette@freenet.de) Wiedereinbau des neuen String und Nummer Eingabesystems in LL (ca. 3 h)
;   14.06.2006 Markus Doebele (mar_doe@gmx.de) Bugfix: Unaufmerksam (ca. 1 h)
;   17.06.2006 Markus Doebele (mar_doe@gmx.de) Aenderungen Rasmus einfuegen (ca. 1 h)
;   14.07.2006 Markus Doebele (mar_doe@gmx.de) Undurchdringliche Waende richtig darstellen, Neue Option Raumtest (ca. 1 h)
;   01.08.2006 Markus Doebele (mar_doe@gmx.de) Fehler beheben (ca. 1 h)
;   05.08.2006 Markus Doebele (mar_doe@gmx.de) Neue Homepage (ca. 2 h)
;   06.08.2006 Markus Doebele (mar_doe@gmx.de) Neue Homepage online stellen (ca. 2 h)
;   17.08.2006 Markus Doebele (mar_doe@gmx.de) Code von Rasmus einfuegen (ca. 2 h)
;   18.08.2006 Markus Doebele (mar_doe@gmx.de) Bugfixing, Release 2.7.3 (ca. 5 h)
;   11.09.2006 Markus Doebele (mar_doe@gmx.de) Bugfixing (ca. 1 h)
;   17.09.2006 Markus Doebele (mar_doe@gmx.de) Fingerfertigkeit, Secondary skills (ca. 2 h)
;   18.09.2006 Markus Doebele (mar_doe@gmx.de) Weak arm, weak fingers, disfigured (ca. 1 h)
;   19.09.2006 Markus Doebele (mar_doe@gmx.de) Arbeiten fuer Freigabe nach Ubuntu (ca. 1 h)
;   21.09.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 1 h)
;   22.09.2006 Markus Doebele (mar_doe@gmx.de) Neuer Downloadbereich mit Versionen (ca. 1 h)
;   23.09.2006 Markus Doebele (mar_doe@gmx.de) Kalligrafie Set (ca. 1 h)
;   24.09.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes (ca. 1 h)
;   25.09.2006 Markus Doebele (mar_doe@gmx.de) Bugfixes, cross level teleporter (ca. 2 h)
;   26.09.2006 Markus Doebele (mar_doe@gmx.de) Lichtmatrix anderer Spieler (ca. 2 h)
;   25.12.2006 Peter Eismann (icesoft@freenet.de) Update to PB4.02 (Windows)
;   13.01.2007 Roger Roesch (feedback@10a.rshost.de) Bugs durch Portierung gefixt, Credits Screen erweitert (ca. 4 h)
;   13.01.2007 Roger Roesch (feedback@10a.rshost.de) Bugs durch Portierung gefixt (ca 1 h)
;   26.01.2007 Markus Doebele (mar_doe@gmx.de) Bugtracker (ca. 2 h)
;   27.01.2007 Roger Roesch (feedback@10a.rshost.de) Neue Fehlerprozedur (ca. 4 h)
;              Markus Doebele (mar_doe@gmx.de) Neues Forum phpBB3 (ca. 2 h)
;   28.01.2007 Markus Doebele (mar_doe@gmx.de) Grafikfehler (ca. 2 h)
;   29.01.2007 Peter Eismann (icesoft@freenet.de) Help screen verbessert (ca. 2 h)
;   01.02.2007 Roger Roesch (feedback@10a.rshost.de) Deutsche Umlaute (ca. 5 h)
;   02.02.2007 Roger Roesch (feedback@10a.rshost.de) Deutsche Umlaute (ca. 5 h)
;   03.02.2007 Markus Doebele (mar_doe@gmx.de) Crosslevel Teleporter Bug (ca. 1 h)
;   04.02.2007 Roger Roesch (feedback@10a.rshost.de) Skill Menue erweiterungen (ca. 1 h)
;   05.02.2007 Roger Roesch (feedback@10a.rshost.de) Skill Menue erweiterungen (ca. 3 h)
;   07.02.2007 Peter Eismann (icesoft@freenet.de) Bitmapfonts are usable! ;-) (ca. 10 h)
;   08.02.2007 Roger Roesch (feedback@10a.rshost.de) Skill Menue Erweiterungen (ca. 4 h)
;   08.02.2007 Peter Eismann (icesoft@freenet.de) BMP -> PNG/JPEG (ca. 4 h)
;   09.02.2007 Roger Roesch (feedback@10a.rshost.de) Titelscreen Erweiterungen (ca. 3 h)
;   09.02.2007 Peter Eismann (icesoft@freenet.de) Titelscreen Erweiterungen (ca. 3 h)
;   10.02.2007 Peter Eismann (icesoft@freenet.de) Hilfescreen erweitert (ca. 5 h)
;   13.02.2007 Peter Eismann (icesoft@freenet.de) Hilfescreen erweitert (ca. 5 h)
;   17.02.2007 Markus Doebele (mar_doe@gmx.de) New skill: monkey grip (ca. 1 h)
;   18.02.2007 Markus Doebele (mar_doe@gmx.de) New skill: Awareness (ca. 1 h)
;   19.02.2007 Markus Doebele (mar_doe@gmx.de) Bugfixing (Peters bugs) (ca. 1 h)
;   20.02.2007 Markus Doebele (mar_doe@gmx.de) Release 2.8.2 (ca. 1 h)
;   03.03.2007 Markus Doebele (mar_doe@gmx.de) Buttons+Projektile aus Items ausgelagert (ca. 1 h)
;   09.03.2007 Markus Doebele (mar_doe@gmx.de) Neue Bilder von Wizball (ca. 2 h)
;   10.03.2007 Markus Doebele (mar_doe@gmx.de) Alle Fonts in ein File, Kleine Fehler (ca. 3 h)
;   10.03.2007 Markus Doebele (mar_doe@gmx.de) Neue Spellschool Icons, Projektile (ca. 1 h)
;   07.04.2007 Markus Doebele (mar_doe@gmx.de) Neues interface, Kleinigkeiten (ca. 5 h)
;   08.04.2007 Markus Doebele (mar_doe@gmx.de) Release 2.8.3 (ca. 1 h)
;   18.04.2007 Markus Doebele (mar_doe@gmx.de) Replaced some items with better versions from jorgen (ca. 1 h)
;   28.04.2007 Markus Doebele (mar_doe@gmx.de) Buttons for selecting figures and up/down in map screen have been invisible (ca. 1 h)
;   30.04.2007 Markus Doebele (mar_doe@gmx.de) Bugfixes, New borders, Release 2.8.4 (ca. 1 h)
;   01.05.2007 Markus Doebele (mar_doe@gmx.de) Maps center button (ca. 1 h)
;   05.05.2007 Markus Doebele (mar_doe@gmx.de) Monster wakeup (ca. 1 h)
;   08.05.2007 Markus Doebele (mar_doe@gmx.de) Magical hammers (ca. 1 h)
;   14.05.2007 Markus Doebele (mar_doe@gmx.de) Small code improvements (ca. 1 h)
;   28.05.2007 Markus Doebele (mar_doe@gmx.de) Skill delete button, Batform can move through portculis, translations (ca. 3 h)
;   06.07.2007 Markus Doebele (mar_doe@gmx.de) Pickup with mouse, Enter Textstring Bug, scroll spellist with mouse (ca. 5 h)
;   07.07.2007 Markus Doebele (mar_doe@gmx.de) Release 2.9.0, Merchant and mouse (ca. 2 h)
;   08.07.2007 Markus Doebele (mar_doe@gmx.de) Spells and special letters (ca. 1 h)

; Markus: 1103 h
; Rasmus:   75 h
; Peter:    33 h
; Roger:    30 h



; All constants
XIncludeFile "constants.pbi"

; All structures
XIncludeFile "structures.pbi"

; All variables 
XIncludeFile "variables.pbi"

; Common variables
Global gb_CallFromTitleScreen = 0
test.b = 0         ; Testrun ? (0=no 1=yes)
win_mode.w = 1     ; 1 = Fullscreen, 2 = Fenster
nr_of_saves.w = 0
flaschen.w = 1     ; display Mana/Life graphically?
released.w = 1
roomtest.w = 0
itemmenue_aktiv.w = 0
joystick_used.w = 0
no_mouse.w = 0
knopf5.w = 0
mit_was_normal.w = #FELD_MAUER
inhalt_normal.w =  #FELD_LEER
bewegen.w = 0
aktuell.w = 0
akt_spieler.b = 1
anz_levels.w = 0
x_r.w              ; Attackfield
y_r.w              ; Attackfield
frame.b = 0        ; Animationsframe des Charakters
framestep.b = 0    ; Verzoegerung der Animation des Charakters
xmod.b = 0         ; Richtungsaenderung des Charakters in X-Richtung
ymod.b = 0         ; Richtungsaenderung des Charakters in Y-Richtung
messages.s = ""    ; Nachrichten des Messagefensters
sprache.b = 0      ; 0 ist Englisch, 1 ist Deutsch, 2 ist Spanisch
mmouse_x.w
mmouse_y.w
mmouse_links.w
mmouse_rechts.w
zw_bild.b = 0      ; Splash Bilder
benutzen.b         ; Fuer Inventarmenue
pos.b              ; Fuer laby_gen
ganglaenge.w       ; Fuer laby_gen
sprite_x.w
sprite_y.w
spell_x.w
spell_y.w
blocked.w
nr.w
angreifen.w = 1
nach_kampf.b = 0
punkte.w = 0
feld.w
bewegt.b = 0
anz_spieler.b = 1
von_ferne.b = 0
mydelay.w = 600    ; Messages
mydelay2.w = 0     ; Scrolling
mydelay3.w = 30    ; Mouserefresh
mydelay4.w = 0     ; Animationen
autopickup.w = 1
keydelay = 15    ; typing delay: first letter
keydelay2 = 3    ; typing delay: hold Key
selectdelay = 150
schutz_min.w = 0
schutz_max.w = 0
behinderung.w = 0
anfangszeit.s = " "
skills_menu.w = 1
maennchen_menu.w = 1
cinfo_menu.w = 1
zeit.s
altezeit.s
mauszauber.b
mauszauber2.b
letzter_eintrag.b = 0
anz_zauber.w = 0
akt_option.b = 1
myname.s
do_it.w = 0      ; From Inventory (right)
do_it2.w = 0     ; From Body (left)
do_it3.w = 0     ; To Quickinventory (left)
do_it4.w = 0     ; From Quickinventory (right)
sound.w = 1
music.w = 1
modules.w = 0
klicking.w = 1
punkte.w = 7
ADCount.l = 1    ; Auto delay: Unspezifische Delays Durchzaehler
ADMax.l = 10
abbrechen.w = 0
room_cursprite_nr.l = -1
room_curtext_nr.l = -1
room_curtext.s = ""
no_room_intro.l = 0
monsterauge.w = 0
over_item.w = 0
warten.w = 0

; -------------------------------------------------------------------------

; Arrays
Global Dim haendler_objekte.w (40,#MAX_EBENEN)
Global Dim haendler_schriftrolle.w (40,#MAX_EBENEN)
Global Dim haendler_staerke.w (40,#MAX_EBENEN)
Global Dim spieler.character_data(#ANZ_SPIELER)
Global Dim nachricht_text.s (1000,#ANZ_SPRACHEN)
Global Dim xsprites(20)
Global Dim ysprites(20)
Global Dim fsprites(20)
Global Dim rsprites(20)
Global Dim optionenliste.s(130)
Global Dim schnellzauber.s (10,#ANZ_SPIELER)
Global Dim schnellzauber2.s (8,#ANZ_SPIELER)
Global Dim savenames.s (10)
Global Dim savedatum.s (10)
Global Dim ADDelay.l (ADMax + 10)
Global Dim ADDelayMax.l (ADMax + 10)
Global Dim matrix.w (12,12)
Global Dim matrix2.w (12,12)
Global Dim summoning.w(#ANZ_ZAUBER)
Global Dim slraum_name.s(#MAX_SLROOMDIR)
Global NewList Fehler.s()

; -------------------------------------------------------------------------
Declare DrawBitmapFont(s.l, x.l, y.l, w.l, h.l, t.s)
Declare DrawToolTip(s.l, x.l, y.l, w.l, h.l, t.s)
Declare LogError(beschreibung.s,typ=0)
Declare aus()
Declare Fenster(typ=0)
Declare ich_trage(was.w)
Declare entdecken()
Declare ausweichen()
Declare naechster()
Declare gen_laby(akt_level.w)
Declare hat_eigenschaft(labyx.w,labyy.w,eigensch.w)
Declare nachricht(text.w, farbe.w)
Declare nachricht3(text1.w,anz.w,text2.w)
Declare.s nachricht4(welche.w)
Declare gold_anzahl()
Declare habich(nr.w)
Declare monsterkunde()
Declare laby_screen()
Declare laby_screen2()
Declare draw_screen(x_offset.b, y_offset.b)
Declare draw_screen2(x_offset.b, y_offset.b)
Declare draw_screen3(x_offset.b, y_offset.b)
Declare draw_screen4(x_offset.b, y_offset.b)
Declare draw_screen5(x_offset.b, y_offset.b)
Declare draw_screen6(x_offset.b, y_offset.b)
Declare draw_screen7(x_offset.b, y_offset.b)
Declare draw_character(face.b, frame.b, offset.w)
Declare feld_waehlen()
Declare laby_rahmen()
Declare show_logo()
Declare show_varys()
Declare show_buttons()
Declare tot()
Declare draw_tile(nr.w, x.w, y.w, offset_x.b, offset_y.b)
Declare cast_it()
Declare trinken(welchen.s)
Declare eintragen(nr.w,staerke.w,dauer.w,source.w)
Declare pilz_essen(welchen.s)
Declare sonderlevel_text(nr.w)
Declare hater(nr.w,xx)
Declare maxlife()
Declare staerke()
Declare reflexe()
Declare luck()
Declare draw_creature(frame.b,offset.w)
Declare los()
Declare show_varys2()
Declare levelmodtext(welcher.w)
Declare attack_spell(aussehen.w)
Declare monsterschaden(egal.w)
Declare load(name.s)
Declare save(name.s)
Declare loading_screen()
Declare saving_screen()
Declare show_buttons2()
Declare creature_schaden(wieviel.w)
Declare haendler()
Declare haendler_init1(level.w)
Declare haendler_init2(level.w)
Declare haendler_init3(level.w)
Declare haendler_init4(level.w)
Declare haendler_init5(level.w)
Declare ende()
Declare show_schnellinventory()
Declare itemtest()
Declare hinterhalt(welches.w)
Declare fullscreen()
Declare finden1()
Declare finden2()
Declare truhe(x.w, y.w)
Declare gold(x.w, y.w)
Declare objekt(x.w, y.w)
Declare fernangriff_monster(aussehen.w)
Declare kleinhaendler_init(level.w)
Declare beschreiben(feld.w,x.w,y.w)
Declare select_inventory(nachricht.w)
Declare zauber_rahmen()
Declare show_sight()
Declare power(spell.w)
Declare save_settings()
Declare.s keyboard_string(text.s,typ.b)
Declare autoDelay(ADInput.l,ADWhat.b ,ADDelayMaxInput.l)
Declare doubleClick(main.b)
Declare show_old_messages()
Declare zaubern()
Declare restaurieren()
Declare restaurieren2()
Declare autopickup()
Declare in_rucksack(was.w, anzahl.w)
Declare screen1(i.w)
Declare screen2()
Declare blockiert(x.w,y.w)
Declare feuerschaden(schaden.w)
Declare liste_leeren()
Declare zauber_nehmen(i.w)
Declare bubblesort()
Declare count_slrooms()
Declare credit(nummer,text.s,Abstand=280)
Declare hilfe()

; -------------------------------------------------------------------------
XIncludeFile "font.pbi"               ; Bitmap fonts functions
XIncludeFile "roomscript.pbi"         ; Zum Oeffnen und Scripten der Raeume
XIncludeFile "sonstige.pbi"           ; Routinen die sonst nirgends reinpassen
XIncludeFile "interaction.pbi"        ; Mouse, Keybord, Joystik events
XIncludeFile "nachrichten.pbi"        ; Alle Nachrichten in allen Sprachen
XIncludeFile "hauptscreen.pbi"        ; Routinen zum Zeichnen des Hauptschirms
XIncludeFile "skills.pbi"             ; Screen zum auswaehlen der Eigenschaften
XIncludeFile "highscore_upload.pbi"   ; Highscores uploaden
XIncludeFile "skills_data.pbi"        ; Skills initialisieren
XIncludeFile "highscore.pbi"          ; Highscores anzeigen
XIncludeFile "credits.pbi"            ; Credits anzeigen
XIncludeFile "optionen.pbi"           ; Zum Spiel verlassen
XIncludeFile "titel.pbi"              ; Startscreen
XIncludeFile "haendler.pbi"           ; Klein/Grosshaendler
XIncludeFile "personen.pbi"           ; Wen man so im Laby treffen kann
XIncludeFile "teleporter.pbi"         ; Eingang + Ausgang sehen manchmal anders aus
XIncludeFile "buttons.pbi"            ; Routinen fuer alle Buttons
XIncludeFile "schnellinventory2.pbi"  ; Quickaccess Inventory
XIncludeFile "monsterkunde.pbi"       ; Monsterinfo ausgeben
XIncludeFile "monster_random.pbi"     ; Zufaelliges Monster fuer Sonderlevels ermitteln
XIncludeFile "procs_graphics.pbi"     ; Prozeduren fuer die Grafik
XIncludeFile "genlaby.pbi"            ; Labyrinth generieren
XIncludeFile "maennchen.pbi"          ; Routine fuer Spielfigur
XIncludeFile "cinfo.pbi"              ; Characterinformationen anzeigen
XIncludeFile "flueche.pbi"            ; Routinen fuer Flueche
XIncludeFile "aufsteigen.pbi"         ; Aufsteigen
XIncludeFile "inventory.pbi"          ; Inventory
XIncludeFile "pick_inventory.pbi"     ; Routinen die Items aus Rucksack auswaehlen
XIncludeFile "init_gegenstaende.pbi"  ; Gegenstaende initialisieren
XIncludeFile "hilfe.pbi"              ; Hilfe
XIncludeFile "sterben.pbi"            ; Sterben
XIncludeFile "load_sounds.pbi"        ; Gepackte Sounds laden
XIncludeFile "load_graphics.pbi"      ; Gepackte Grafiken laden
XIncludeFile "monsterdaten.pbi"       ; Monster initialisieren
XIncludeFile "kampf.pbi"              ; Kaempfen
XIncludeFile "sonderlevel.pbi"        ; Titelbilder fuer Sonderlevel
XIncludeFile "advance.pbi"            ; Vor und Nachteile durch Skills
XIncludeFile "raeume.pbi"             ; Alle Raeume
XIncludeFile "zaubern.pbi"            ; Zaubern
XIncludeFile "fallen.pbi"             ; Routinen fuer alle Fallen
XIncludeFile "spell_init.pbi"         ; Zauber initialisieren
XIncludeFile "fernkampf.pbi"          ; Monster Fernkampf
XIncludeFile "bogen.pbi"              ; Spieler Fernkampf
XIncludeFile "finden1.pbi"            ; Normale Gegenstaende
XIncludeFile "finden2.pbi"            ; Magische gegenstaende
XIncludeFile "stehlen.pbi"
XIncludeFile "traenke.pbi"            ; Potions
XIncludeFile "pilze.pbi"              ; Mushrooms
XIncludeFile "spieler.pbi"            ; Anzahl Spieler
XIncludeFile "ende.pbi"               ; Spielende durch Stab des letzten Buendnisses
XIncludeFile "sonderfeld.pbi"         ; Sonderfelder nach Bewegung behandeln
XIncludeFile "vor_bewegung.pbi"       ; Sonderfelder vor Bewegung behandeln
XIncludeFile "creature_bewegen.pbi"   ; Beschworene creaturen behandeln
XIncludeFile "nach_zug.pbi"           ; Character Zug fertig
XIncludeFile "zwischenbild.pbi"       ; Button angeklickt?
XIncludeFile "itemtest.pbi"           ; Gegenstaende benutzen
XIncludeFile "old_messages.pbi"       ; Letzte 25 Nachrichten anzeigen

; OnError (Windows)
CompilerSelect #PB_Compiler_OS
CompilerCase #PB_OS_Windows
OnErrorGosub(@Fehlerverarbeitung())
CompilerEndSelect

yplus = 12
yplus2 = 10
akt_zauber_offset = 14
akt_zauber_offset2 = 13
anzz = 26
anz_slraeume.l = count_slrooms()
CreateDirectory(#ROOMDIR)
CreateDirectory(#SLROOMDIR)

; --------------------------------------------------------------------------------------
; Screen oeffnen

If InitSprite() =0
EndIf

load_settings()

If win_mode=2
  windowsfenster=1
EndIf

CompilerSelect #PB_Compiler_OS
CompilerCase #PB_OS_Windows
If win_mode = 1
  If OpenScreen(640,480,16,"Lost Labyrinth") = 0
  EndIf
  screenopen=1
Else
  hugo = OpenWindow(0, 0, 0, 640, 480, "Lost Labyrinth (Press ESC to release the mouse)",#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered)
  If OpenWindowedScreen(hugo, 0, 0, 640, 480, 1, 0, 0) = 0
  EndIf
  screenopen=2
EndIf
CompilerCase #PB_OS_Linux
If win_mode = 1
  If OpenScreen(640,480,16,"Lost Labyrinth") = 0
  EndIf
  screenopen=1
Else
  If OpenWindowedScreen(0, 0, 0, 640, 480, 1, 0, 0) = 0
  EndIf
  screenopen=1
  SDL_WM_SetCaption_("Lost Labyrinth - Press Escape to release the mouse", "")
EndIf
CompilerEndSelect

If sound = 1 Or music = 1
  If InitSound() = 0
  EndIf

  CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
  If InitModule() = 0
    modules = 0
  Else
    modules = 1
  EndIf
  CompilerCase #PB_OS_Linux
  CompilerEndSelect

  load_sounds()
EndIf

load_graphics()

ClipSprite(0, spieler(akt_spieler)\face*32*2+frame*32, 0, 32, 32)
DisplayTransparentSprite(0, 5*32, 5*32); Variablen setzen
SetFrameRate(60)


If InitKeyboard() = 0
EndIf

If no_mouse = 0
  result = InitMouse()
EndIf

; Highscores initialisieren
init_highscores()

; Highscores einlesen
read_highscores()

again:

zw_bild = 0
nr_of_saves = 0

; Labyrinth initialisieren
For i = 1 To #MAX_EBENEN
  raeume(i)      = 0
  raumx(i)       = 0
  raumy(i)       = 0
  ausgangx(i)    = 0
  ausgangy(i)    = 0
  sonderlevel(i) = 0
  levelmod(i)    = 0
  groesse(i)     = 0
  inhalt(i)      = 0
  mit_was(i)     = 0
  visionen(i)    = 0
Next


mit_was_normal = #FELD_MAUER
inhalt_normal =  #FELD_LEER

; Charaktere initialisieren
For i = 1 To #ANZ_SPIELER
  spieler(i)\Status = 1
  spieler(i)\Level = 1
  spieler(i)\MaxLevel = 1
  spieler(i)\Maennchen = 2
  spieler(i)\Lifepoints = 12
  spieler(i)\MaxLifepoints = 12
  spieler(i)\LifeGain = 3
  spieler(i)\Mana = 3
  spieler(i)\MaxMana = 3
  spieler(i)\ManaGain = 3
  spieler(i)\Attack = 1
  spieler(i)\Dexterity = 1
  spieler(i)\Strength = 1
  spieler(i)\MaxSpeed = 7
  spieler(i)\Speed = 7
  spieler(i)\Perception = 1
  spieler(i)\Luck_score = 1
  spieler(i)\Power_score = 1
  spieler(i)\Circle = 0
  spieler(i)\magieresistenz = 0
  spieler(i)\spellweaving = 1
  spieler(i)\style = 0
  spieler(i)\light = 1
  spieler(i)\hunger = 0
  spieler(i)\durst = 0
  spieler(i)\betrunken = 0
  spieler(i)\mks = 0
  spieler(i)\schleichen = 0
  spieler(i)\fluch = 0
  spieler(i)\fluchdauer = 0
  spieler(i)\krankheit = 0
  spieler(i)\krankheitdauer = 0
  spieler(i)\gift = 0
  spieler(i)\giftdauer = 0
  spieler(i)\verhungern = 0
  spieler(i)\verdursten = 0
  spieler(i)\weisheit = 0
  spieler(i)\lifepointgegenstand  = 0
  spieler(i)\managegenstand  = 0
  spieler(i)\staerkegegenstand = 0
  spieler(i)\zugweitegegenstand = 0
  spieler(i)\dexteritygegenstand = 0
  spieler(i)\gluecksgegenstand = 0
  spieler(i)\bogentreffergegenstand = 0
  spieler(i)\bogenschadengegenstand = 0
  spieler(i)\powergegenstand = 0
  spieler(i)\perceptiongegenstand = 0
  spieler(i)\attackgegenstand = 0
  spieler(i)\stealthgegenstand = 0
  spieler(i)\damagegegenstand = 0
  spieler(i)\lichtgegenstand = 0
  spieler(i)\diebstahlgegenstand = 0
  spieler(i)\goblinlehre = 0
  spieler(i)\spinnenlehre = 0
  spieler(i)\untotenlehre = 0
  spieler(i)\pflanzenlehre = 0
  spieler(i)\tierkunde = 0
  spieler(i)\fallenlehre = 0
  spieler(i)\giftlehre = 0
  spieler(i)\pos_zaubermenue = 0
  spieler(i)\dumm = 0
  spieler(i)\face = 2
  spieler(i)\hinterhalt = 0
  spieler(i)\portal = 1
  spieler(i)\teleport = 1
  spieler(i)\nexus = 1
  spieler(i)\stehlen = 2
  spieler(i)\armageddon = 1
  spieler(i)\pestilence = 1
  spieler(i)\drachenform = 1
  spieler(i)\macht = 1
  spieler(i)\magic_apple = 2
  spieler(i)\refresh = 2
  spieler(i)\heal = 3
  spieler(i)\schriftrolle = 0
  spieler(i)\zauberbuch = 0
  spieler(i)\kessel = 0
  spieler(i)\udjat_ben = 1
  spieler(i)\akt_zauber = 1
  spieler(i)\schule = ""
  spieler(i)\udjat_ben = 1
  spieler(i)\character_x = 1
  spieler(i)\character_y = 1
  spieler(i)\lehrer = 3
  spieler(i)\stabteile = 0
  spieler(i)\moves = 0
  spieler(i)\anker_x = 0
  spieler(i)\anker_y = 0
  spieler(i)\anker_level = 0
  spieler(i)\old_pos_x = spieler(i)\character_x
  spieler(i)\old_pos_y = spieler(i)\character_y
  spieler(i)\old_lp = spieler(i)\lifepoints
  spieler(i)\old_max_lp = spieler(i)\maxlifepoints
  spieler(i)\old_mp = spieler(i)\mana
  spieler(i)\old_max_mp = spieler(i)\maxmana
  For k = 1 To #ANZ_SPRACHEN-1
    spieler(i)\sterbegrund[k] = " "
  Next
  spieler(i)\creature_typ = 0
  spieler(i)\creature_Attack = 0
  spieler(i)\creature_LifePoints = 0
  spieler(i)\creature_Speed = 0
  spieler(i)\creature_MaxSpeed = 0
  spieler(i)\creature_x = 0
  spieler(i)\creature_y = 0
  spieler(i)\creature_heading = 0
Next

; Clear active spells
For j = 1 To #ANZ_SPIELER
  For i = 1 To 15
    aktive (i,j)\nr = 0
    aktive (i,j)\dauer = 0
  Next
Next

; Clear quick spells
For j = 1 To 10
  For i = 1 To #ANZ_SPIELER
    schnellzauber(j,i) = ""
  Next
Next
For j = 1 To 8
  For i = 1 To #ANZ_SPIELER
    schnellzauber2(j,i) = ""
  Next
Next

; Clear inventory
For j = 1 To #ANZ_SPIELER
  For i = 1 To #MAX_RUCKSACK
    inventory(i,j)\name = 0
    inventory(i,j)\art = 0
    inventory(i,j)\status = 0
    inventory(i,j)\benutzt = 0
    inventory(i,j)\anzahl = 0
    inventory(i,j)\attri1 = 0
    inventory(i,j)\attri2 = 0
    inventory(i,j)\attri3 = 0
    inventory(i,j)\attri4 = 0
    inventory(i,j)\attri5 = 0
  Next
Next

For i = 1 To #MAX_EBENEN
  spinnenkoenigin(i) = 0
Next
For i = 1 To #MAX_EBENEN
  goblinkoenig(i) = 0
Next
For i = 1 To #MAX_EBENEN
  untotenherr(i) = 0
Next

For i = 1 To #ANZ_ZAUBER
  summoning(i) = 0
Next

init_creatures()

anfangszeit.s = FormatDate("%yyyy%mm%dd%hh%ii%ss", Date())

init_spells()
init_traenke()
init_pilze()

; Titelmusic ab
If modules = 1 And music = 1
  CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
  PlayModule(#MOD_ARCHONS)
  CompilerCase #PB_OS_Linux
  CompilerEndSelect
EndIf

; Titelscreen anzeigen
title()

; Anzahl Spieler festlegen
select_spieler()

For akt_spieler = 1 To anz_spieler
  maennchen_auswaehlen()
  init_skills()
  punkte = 14
  select_skills()
  advancements()
  spieler(akt_spieler)\verifikation = ""
  For i = 1 To 30
    spieler(akt_spieler)\verifikation = spieler(akt_spieler)\verifikation + Str(Random(9))
  Next
  Delay(my_delay)
Next

; Titlemusic off
If modules = 1 And music = 1
  CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
  StopModule(-1)
  CompilerCase #PB_OS_Linux
  CompilerEndSelect
EndIf

; Wegen Kundschafter/Lahm/Staemmig neu berechnen
For akt_spieler = 1 To anz_spieler
  spieler(akt_spieler)\speed = maxspeed()
  spieler(akt_spieler)\Lifepoints = maxlife()
Next

; Init Trader
For i = 1 To 40
  For j = 1 To #MAX_EBENEN
    haendler_objekte(i,j) = 0
    haendler_schriftrolle(i,j) = 0
    haendler_staerke(i,j) = 0
  Next
Next

; Init Labyrinth
For akt_level.w = 1 To #MAX_EBENEN

  ; Init Automap
  For i = 1 To #MAX_GROESSE
    For j = 1 To #MAX_GROESSE
      automap(i,j) \feld[akt_level] = 0
    Next
  Next

  ; Levelmodifier?
  levelmod(akt_level) = 0
  If akt_level > 25 And Random(100) > 90
    levelmod(akt_level) = Random(#ANZ_LEVELMODS-1)+1
  EndIf

  ; Special level?
  sonderlevel(akt_level) = 0
  If akt_level > 10 And Random(100) > 80 And levelmod(akt_level) = 0
    sonderlevel(akt_level) = Random(#ANZ_SONDERLEVEL-1)+1
  EndIf

  ; River?
  fluss(akt_level) = 0
  If akt_level >= 10 And Random(3) = 0 And sonderlevel(akt_level) = 0
    fluss(akt_level) = 1
  EndIf

  ; Room?
  raeume(akt_level) = 0
  If (akt_level > 3 And fluss(akt_level) = 0 And sonderlevel(akt_level) = 0) Or test = 1
    Repeat
      gesetzt.w = 1
      If roomtest = 0
        raeume(akt_level) = Random(#ANZ_RAEUME+anz_slraeume -1)+1
      Else
        raeume(akt_level) = Random(anz_slraeume -1)+1+#ANZ_RAEUME
      EndIf
      If test = 1
        raeume(akt_level) = #RAUM_SEE
      EndIf
      If raeume(akt_level) = #RAUM_HYDRA And akt_level < 10
        gesetzt = 0
      EndIf
      If raeume(akt_level) = #RAUM_MONSTERFALLE And akt_level < 6
        gesetzt = 0
      EndIf
      If raeume(akt_level) = #RAUM_FEUERDAEMON And akt_level < 7
        gesetzt = 0
      EndIf
    Until gesetzt = 1
    If raeume(akt_level) = #RAUM_HAENDLER1
      haendler_init1(akt_level)
    EndIf
    If raeume(akt_level) = #RAUM_HAENDLER2
      haendler_init2(akt_level)
    EndIf
    If raeume(akt_level) = #RAUM_HAENDLER3
      haendler_init3(akt_level)
    EndIf
    If raeume(akt_level) = #RAUM_HAENDLER4
      haendler_init4(akt_level)
    EndIf
    If raeume(akt_level) = #RAUM_HAENDLER5
      haendler_init5(akt_level)
    EndIf
  EndIf
Next

level = 1
gen_laby(level)

For i = 1 To anz_spieler
  spieler(i)\character_x = eingangx(level)
  spieler(i)\character_y = eingangy(level)
Next

geladen:

For j = 1 To #ANZ_SPIELER
  For i = 1 To 25
    old_messages(i,j)\farbe     = 0
    old_messages(i,j)\nachricht = " "
  Next
Next

; erstes Zeichnen des Hauptbildschirms
FlipBuffers()
laby_screen()


; Hintergrundmusik ab
If modules = 1 And music = 1
  CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
  PlayModule(#MOD_BALLADA)
  CompilerCase #PB_OS_Linux
  CompilerEndSelect
EndIf


; Mainloop

akt_spieler = 1

Repeat
  Fenster()

  If spieler(akt_spieler)\creature_speed > 0
    ; First move creature
    creature_bewegen()

    ; then the character
  Else

    ; Movement
    xmod = 0
    ymod = 0
    ExamineKeyboard()
    jax.w = 0
    jay.w = 0
    If joystick_used = 1
      ExamineJoystick()
      jax = JoystickAxisX()
      jay = JoystickAxisY()
      jb1 = JoystickButton(1)
    EndIf
    If no_mouse = 0
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mmouse_links  = MouseButton(1)
    EndIf

    If KeyboardPushed(#PB_Key_Right) Or jax = 1
      okay = 1
      spieler(akt_spieler)\face = 1
      xmod = 1
      ymod = 0
    EndIf
    If KeyboardPushed(#PB_Key_Left) Or jax = -1
      okay = 1
      spieler(akt_spieler)\face = 3
      xmod = -1
      ymod = 0
    EndIf
    If KeyboardPushed(#PB_Key_Up) Or jay = -1
      okay = 1
      spieler(akt_spieler)\face = 0
      xmod = 0
      ymod = -1
    EndIf
    If KeyboardPushed(#PB_Key_Down) Or jay = 1
      okay = 1
      spieler(akt_spieler)\face = 2
      xmod = 0
      ymod = 1
    EndIf

    If no_mouse = 0
      If mmouse_links = 1
        If mmouse_x > 160 And mmouse_x < 192 And mmouse_y >= 160 And mmouse_y <= 192
           autopickup()
        ; Right
	ElseIf mmouse_x > 176 And mmouse_x < 352 And mmouse_y >= 160 And mmouse_y <= 192
          okay = 1
          spieler(akt_spieler)\face = 1
          xmod = 1
          ymod = 0
         ; Left
        ElseIf mmouse_x < 176 And mmouse_y >= 160 And mmouse_y <= 192
          okay = 1
          spieler(akt_spieler)\face = 3
          xmod = -1
          ymod = 0
         ; Down 
        ElseIf mmouse_y > 176 And mmouse_y < 352 And mmouse_x >= 160 And mmouse_x <= 192
          okay = 1
          spieler(akt_spieler)\face = 2
          xmod = 0
          ymod = 1
         ; Up
        ElseIf mmouse_y < 176 And mmouse_x >= 160 And mmouse_x <= 192
          okay = 1
          spieler(akt_spieler)\face = 0
          xmod = 0
          ymod = -1
        EndIf
      EndIf
    EndIf

    aktion = 0

    ; Test new field before movement
    If xmod <> 0 Or ymod <> 0
      vor_bewegung()
    EndIf
    ; Do we still move?
    If xmod <> 0 Or ymod <> 0
      bewegt = 1
    Else
      bewegt = 0
    EndIf

    spielerwechsel = 0
    schongemalt = 0

    ; Do we move ?
    If xmod <> 0 Or ymod <> 0
      spieler(akt_spieler)\Speed = spieler(akt_spieler)\Speed - 1

      For i = 4 To 32 Step 4
        framestep = framestep + 1
        If framestep > 3
          framestep = 0
          If frame = 0
            frame = 1
          Else
            frame = 0
          EndIf
        EndIf

        screen1(i)

        If no_mouse = 0
          result = ExamineMouse()
          mmouse_x = MouseX()
          mmouse_y = MouseY()
          mmouse_links  = MouseButton(1)
          mmouse_rechts = MouseButton(2)

          ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
          DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
        EndIf

        FlipBuffers()
        Delay(mydelay2)
      Next
      schongemalt = 1
      spieler(akt_spieler)\character_x = spieler(akt_spieler)\character_x + xmod
      spieler(akt_spieler)\character_y = spieler(akt_spieler)\character_y + ymod

      ; Aktualisiere Automap
      automap(spieler(akt_spieler)\character_x, spieler(akt_spieler)\character_y)\feld[spieler(akt_spieler)\level] = 1
      automap(spieler(akt_spieler)\character_x+1, spieler(akt_spieler)\character_y)\feld[spieler(akt_spieler)\level] = 1
      If spieler(akt_spieler)\character_x > 1
        automap(spieler(akt_spieler)\character_x-1, spieler(akt_spieler)\character_y)\feld[spieler(akt_spieler)\level] = 1
        If spieler(akt_spieler)\character_y > 1
          automap(spieler(akt_spieler)\character_x-1, spieler(akt_spieler)\character_y-1)\feld[spieler(akt_spieler)\level] = 1
        EndIf
        automap(spieler(akt_spieler)\character_x-1, spieler(akt_spieler)\character_y+1)\feld[spieler(akt_spieler)\level] = 1
      EndIf
      automap(spieler(akt_spieler)\character_x, spieler(akt_spieler)\character_y+1)\feld[spieler(akt_spieler)\level] = 1
      automap(spieler(akt_spieler)\character_x+1, spieler(akt_spieler)\character_y+1)\feld[spieler(akt_spieler)\level] = 1
      If spieler(akt_spieler)\character_y > 1
        automap(spieler(akt_spieler)\character_x, spieler(akt_spieler)\character_y-1)\feld[spieler(akt_spieler)\level] = 1
        automap(spieler(akt_spieler)\character_x+1, spieler(akt_spieler)\character_y-1)\feld[spieler(akt_spieler)\level] = 1
      EndIf

    EndIf

    schnelltasten()
    zwischenbild()
    ftasten()

    ; Auto-Toggle
    If (KeyboardPushed(#PB_Key_Space) Or jb1 <> 0) And autopickup = 0
      autopickup()
    EndIf

    If schongemalt = 0
      screen2()

      If no_mouse = 0
        result = ExamineMouse()
        mmouse_x = MouseX()
        mmouse_y = MouseY()
        mmouse_links  = MouseButton(1)
        mmouse_rechts = MouseButton(2)
        over_item = 0
        If mmouse_x > 160 And mmouse_x < 192 And mmouse_y >= 160 And mmouse_y <= 192
         ; over an item?
         testfeld.w = labyrinth(spieler(akt_spieler)\character_x, spieler(akt_spieler)\character_y)\feld[spieler(akt_spieler)\level]
         if (testfeld >= #FELD_BAUM3 And testfeld <= #FELD_BAUM6) or testfeld > (#ANZ_FELDER + #ANZ_MONSTER) or testfeld = #FELD_GRUENETRUHE2 or testfeld = #FELD_WIESE_GRUENETRUHE2 or testfeld = #FELD_BLAUETRUHE2 or testfeld = #FELD_WASSER_TRUHE or testfeld = #FELD_WASSER_GRUENE_TRUHE or testfeld = #FELD_GOLD or testfeld = #FELD_STABTEIL or testfeld = #FELD_SANKTUM or testfeld = #FELD_HAENDLER1 or testfeld = #FELD_HAENDLER2 or testfeld = #FELD_HAENDLER3 or testfeld = #FELD_HAENDLER4_4 or testfeld = #FELD_HAENDLER9 or testfeld = #FELD_HAENDLER10 or testfeld = #FELD_LEHRER1 or testfeld = #FELD_LEHRER2 or testfeld = #FELD_LEHRER3 or testfeld = #FELD_LEHRER4 or testfeld = #FELD_LEHRER5 or testfeld = #FELD_LEHRER6 or testfeld = #FELD_LEHRER7 or testfeld = #FELD_LEHRER8 or testfeld = #FELD_LEHRER9 or testfeld = #FELD_LEHRER10 or testfeld = #FELD_WOUNDED_HERO1 or testfeld = #FELD_WOUNDED_HERO2 or testfeld = #FELD_TRUHE or testfeld = #FELD_WIESE_TRUHE or testfeld = #FELD_NEXUS or testfeld = #FELD_BRUNNEN or testfeld = #FELD_AMBOSS or testfeld = #FELD_SCHALTER1 or testfeld = #FELD_EINGANG or testfeld = #FELD_AUSGANG or testfeld = #FELD_RINNSAAL
            over_item = 1
         EndIf
        endif
        if over_item = 0
            ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
        else
            ClipSprite(#SPRITE_TILESET_ITEMS, 13*32, 25*32, 32, 32)
        endif
        DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
      EndIf

      FlipBuffers()
    EndIf

    laby_screen2()
    falle()
    sonderfeld()

    If spieler(akt_spieler)\Speed < 1 Or aktion = 1
      spielerwechsel = 1
      nach_zauber:
      laby_screen2()
      nach_zug()

      If spieler(akt_spieler)\creature_speed > 0
        laby_screen3()
      Else
        laby_screen()
      EndIf

    EndIf

    If anz_spieler > 1
      ; Are there other players?
      weitere = 0
      For i = 1 To anz_spieler
        If spieler(i)\status = 1
          weitere = weitere + 1
        EndIf
      Next

      If (spielerwechsel = 1 Or aktion = 1) And weitere > 1
        nachricht(192,#COLOR_WEISS)
        naechster()
      EndIf
    EndIf

  EndIf  ; Kreatur bewegen?


Until EventID = #PB_Event_CloseWindow
aus()

; Programmende

;- Buglist
;----------------------------
;-1.


; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 350
; IDE Options = PureBasic v4.01 (Windows - x86)
; CursorPosition = 672
; FirstLine = 616
; Folding = -
; EnableOnError
; UseIcon = laby.ico
; Executable = laby_2.8.3.exe
; DisableDebugger