; Optionen
; -------------------------------------------------------------------------------

Procedure save_settings()

Shared mydelay, mydelay2, mydelay3, joystick_used, anz_spieler, win_mode, sprache, sound, music
Shared klicking, mydelay4, autopickup, knopf5, no_mouse, flaschen, roomtest

   If CreateFile(0, "./settings.txt")
      WriteStringN(0,"# Lost Labyrinth Settings File")
      If sprache = 0
         WriteStringN(0,"language = english   # english, german, spanish")
      EndIf
      If sprache = 1
         WriteStringN(0,"language = german   # english, german, spanish")
      EndIf
      If sprache = 2
         WriteStringN(0,"language = spanish   # english, german, spanish")
      EndIf
      WriteStringN(0,"mydelay  = " + RSet(Str(mydelay),5)  + "   # Messages    (5 Digits!)")
      WriteStringN(0,"mydelay2 = " + RSet(Str(mydelay2),5) + "   # Scrolling   (5 Digits!)")
      WriteStringN(0,"mydelay3 = " + RSet(Str(mydelay3),5) + "   # Mouserefesh (5 Digits!)")
      WriteStringN(0,"mydelay4 = " + RSet(Str(mydelay4),5) + "   # Animationen (5 Digits!)")
      If joystick_used = 0
         WriteStringN(0,"joystick = no   # yes, no")
      EndIf
      If joystick_used = 1
         WriteStringN(0,"joystick = yes   # yes, no")
      EndIf
      If joystick_only = 0
         WriteStringN(0,"no_mouse = no   # yes, no")
      EndIf
      If joystick_only = 1
         WriteStringN(0,"no_mouse = yes   # yes, no")
      EndIf
      If win_mode = 1
         WriteStringN(0,"windowed = no   # yes, no")
      EndIf
      If win_mode = 2
         WriteStringN(0,"windowed = yes    # yes, no")
      EndIf
      If sound = 1
         WriteStringN(0,"sound = yes   # yes, no")
      EndIf
      If sound = 0
         WriteStringN(0,"sound = no    # yes, no")
      EndIf
      If music = 1
         WriteStringN(0,"music = yes   # yes, no")
      EndIf
      If music = 0
         WriteStringN(0,"music = no    # yes, no")
      EndIf
      If klicking = 1
         WriteStringN(0,"klicking = yes   # yes, no")
      EndIf
      If klicking = 0
         WriteStringN(0,"klicking = no    # yes, no")
      EndIf
      If autopickup = 1
         WriteStringN(0,"auto-toggle = yes   # yes, no")
      EndIf
      If autopickup = 0
         WriteStringN(0,"auto-toggle = no    # yes, no")
      EndIf
      If knopf5 = 1
         WriteStringN(0,"button5 = yes   # yes, no")
      EndIf
      If knopf5 = 0
         WriteStringN(0,"button5 = no    # yes, no")
      EndIf
      If flaschen = 1
         WriteStringN(0,"jars = yes   # yes, no")
      EndIf
      If flaschen = 0
         WriteStringN(0,"jars = no    # yes, no")
      EndIf
      If roomtest = 1
         WriteStringN(0,"roomtest = yes   # yes, no")
      EndIf
      If roomtest = 0
         WriteStringN(0,"roomtest = no    # yes, no")
      EndIf
      CloseFile(0)
      
      ProcedureReturn 1
   Else
   
      ProcedureReturn 0
   EndIf

EndProcedure

; -------------------------------------------------------------------------------

Procedure load_settings()

Shared mydelay, mydelay2, joystick_used, anz_spieler, win_mode, sprache, sound, music
Shared klicking, mydelay3, mydelay4, autopickup, knopf5, no_mouse, flaschen, roomtest

   If ReadFile(0, "./settings.txt")
      zw.s = ReadString(0)   ; Titelzeile ignorieren
      zw   = ReadString(0)   ; Sprache
      If Mid(zw,12, 7) = "english"
         sprache = 0
      EndIf
      If Mid(zw,12, 6) = "german"
         sprache = 1
      EndIf
      If Mid(zw,12, 7) = "spanish"
         sprache = 2
      EndIf
      zw   = ReadString(0)  ; Mydelay
      zw2.s          = Mid(zw,12, 5)
      mydelay        = Val(zw2)
      zw   = ReadString(0)  ; Mydelay2
      zw2.s          = Mid(zw,12, 5)
      mydelay2       = Val(zw2)
      zw   = ReadString(0)  ; Mydelay3
      zw2.s          = Mid(zw,12, 5)
      mydelay3       = Val(zw2)
      zw   = ReadString(0)  ; Mydelay4
      zw2.s          = Mid(zw,12, 5)
      mydelay4       = Val(zw2)
      zw   = ReadString(0)  ; Joystick
      If Mid(zw,12, 2) = "no"
         joystick_used = 0
      EndIf
      If Mid(zw,12, 3) = "yes"
         joystick_used = 1
      EndIf
      zw   = ReadString(0)  ; Keine Maus?
      If Mid(zw,12, 2) = "no"
         no_mouse = 0
      EndIf
      If Mid(zw,12, 3) = "yes"
         no_mouse = 1
      EndIf
      zw   = ReadString(0)  ; Winmode
      If Mid(zw,12, 2) = "no"
         win_mode = 1
      EndIf
      If Mid(zw,12, 3) = "yes"
         win_mode = 2
      EndIf
      zw   = ReadString(0)  ; Sound
      If Mid(zw,9, 3) = "yes"
         sound = 1
      EndIf
      If Mid(zw,9, 2) = "no"
         sound = 0
      EndIf
      zw   = ReadString(0)  ; Musik
      If Mid(zw,9, 3) = "yes"
         music = 1
      EndIf
      If Mid(zw,9, 2) = "no"
         music = 0
      EndIf
      zw   = ReadString(0)  ; Klicking
      If Mid(zw,12, 3) = "yes"
         klicking = 1
      EndIf
      If Mid(zw,12, 2) = "no"
         klicking = 0
      EndIf
      zw   = ReadString(0)  ; Autopickup
      If Mid(zw,15, 3) = "yes"
         autopickup = 1
      EndIf
      If Mid(zw,15, 2) = "no"
         autopickup = 0
      EndIf
      zw   = ReadString(0)  ; Knopf 5
      If Mid(zw,11, 3) = "yes"
         knopf5 = 1
      EndIf
      If Mid(zw,11, 2) = "no"
         knopf5 = 0
      EndIf
      zw   = ReadString(0)  ; Flaschen
      If Mid(zw,8, 3) = "yes"
         flaschen = 1
      EndIf
      If Mid(zw,8, 2) = "no"
         flaschen = 0
      EndIf
      zw   = ReadString(0)  ; Raeume testen?
      If Mid(zw,12, 3) = "yes"
         roomtest = 1
      EndIf
      If Mid(zw,12, 2) = "no"
         roomtest = 0
      EndIf
      CloseFile(0)
      If joystick_used = 1
         If InitJoystick() = 0
         EndIf
      EndIf
   EndIf

EndProcedure

; -------------------------------------------------------------------------------

Procedure fullscreen()

Shared win_mode
 
CompilerSelect #PB_Compiler_OS
   CompilerCase #PB_OS_Windows       
      If win_mode = 1
         win_mode = 2
      Else
         win_mode = 1
     EndIf
     save_settings()
     nachricht(519,#COLOR_WEISS)      
     nachricht(520,#COLOR_WEISS)
      
   CompilerCase #PB_OS_Linux
      If win_mode = 2
         win_mode = 1
         If OpenScreen(640,480,16,"Lost Labyrinth") = 0
         EndIf
   ;;;      SDL_WM_SetCaption_("Lost Labyrinth - Press Escape to release the mouse", "")
      Else
         win_mode = 2
         If OpenWindowedScreen(WindowID, 0, 0, 640, 480, 0, 0, 0) = 0
         EndIf
     EndIf
CompilerEndSelect

EndProcedure

; -------------------------------------------------------------------------------


Procedure gamespeed()

Shared mydelay, mydelay2, mydelay4, sprache, no_mouse

gewaehlt_message.w = 0
gewaehlt_scrolling.w = 0
Repeat
   Fenster()
   ClearScreen(RGB(0,0,0))

   wohin = ScreenOutput()
   StartDrawing(wohin)
      DrawingMode(1)
      FrontColor(RGB(255,255,1))  ; Gelb
      DrawText(195,25,nachricht_text(664,1+sprache))
      
      xxx.w = 195
      yyy.w = 100
      DrawText(xxx,yyy,nachricht_text(665,1+sprache))
      
      xx.w = 195
      yy.w = 200
      DrawText(xx,yy,"Scrolling")
      
      xxxx.w = 195
      yyyy.w = 300
      DrawText(xxxx,yyyy,nachricht_text(702,1+sprache))
   StopDrawing()

   ; Rahmen zeichnen
   ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
   DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
   DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
   DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 463)
   ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
   DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 623, 0)

   ; Maus darstellen
   If no_mouse = 0
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mmouse_links  = MouseButton(1)
      mmouse_rechts = MouseButton(2)
   EndIf

   ; Messages
   yyy = yyy + 25
   For y = 1 To 9
      If mmouse_x > 50 + y * 50 And mmouse_x < 100 + y * 50  And mmouse_y > yyy And mmouse_y < yyy + 50
         wohin = ScreenOutput()
         StartDrawing(wohin)
            FrontColor(RGB(100,100,100)) ; Grau
            Box(50 + y * 50, yyy,50,50)
            DrawingMode(1)
            FrontColor(RGB(255,255,255))
            If y = mydelay / 200
               FrontColor(RGB(1,1,255))
            EndIf
            DrawText(75 + y * 50, 17+yyy,Str(10-y))
         StopDrawing()
         If mmouse_links = 1
            gewaehlt_message = y
         EndIf
      Else
         wohin = ScreenOutput()
         StartDrawing(wohin)
            FrontColor(RGB(255,255,255))
            DrawingMode(1)
            If y = mydelay / 200
               FrontColor(RGB(1,1,255))
            EndIf
            DrawText(75 + y * 50, 17+yyy,Str(10-y))
         StopDrawing()
      EndIf
   Next
   
   ; Scrolling
   yy = yy + 25
   For y = 1 To 5
      If mmouse_x > 50 + y * 50 And mmouse_x < 100 + y * 50  And mmouse_y > yy And mmouse_y < yy + 50
         wohin = ScreenOutput()
         StartDrawing(wohin)
            FrontColor(RGB(100,100,100)) ; Grau
            Box(50 + y * 50, yy,50,50)
            DrawingMode(1)
            FrontColor(RGB(255,255,255))
            If y = mydelay2 / 10 + 1
               FrontColor(RGB(1,1,255))
            EndIf
            DrawText(75 + y * 50, 17+yy,Str(6-y))
         StopDrawing()
         If mmouse_links = 1
            gewaehlt_scrolling = y
         EndIf
      Else
         wohin = ScreenOutput()
         StartDrawing(wohin)
            FrontColor(RGB(255,255,255))
            DrawingMode(1)
            If y = mydelay2 / 10 + 1
               FrontColor(RGB(1,1,255))
            EndIf
            DrawText(75 + y * 50, 17+yy,Str(6-y))
         StopDrawing()
      EndIf
   Next
   
   ; Animationen
   yyyy = yyyy + 25
   For y = 1 To 4
      If mmouse_x > 50 + y * 50 And mmouse_x < 100 + y * 50  And mmouse_y > yyyy And mmouse_y < yyyy + 50
         wohin = ScreenOutput()
         StartDrawing(wohin)
            FrontColor(RGB(100,100,100)) ; Grau
            Box(50 + y * 50, yyyy,50,50)
            DrawingMode(1)
            FrontColor(RGB(255,255,255))
            If 4-y = mydelay4
               FrontColor(RGB(1,1,255))
            EndIf
            DrawText(75 + y * 50, 17+yyyy,Str(4-(y-1)))
         StopDrawing()
         If mmouse_links = 1
            gewaehlt_animationen = y
         EndIf
      Else
         wohin = ScreenOutput()
         StartDrawing(wohin)
            FrontColor(RGB(255,255,255))
            DrawingMode(1)
            If 4-y = mydelay4
               FrontColor(RGB(1,1,255))
            EndIf
            DrawText(75 + y * 50, 17+yyyy,Str(4-(y-1)))
         StopDrawing()
      EndIf
   Next

   ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
   DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
   FlipBuffers()

   Delay(50)

Until gewaehlt_message > 0 Or gewaehlt_scrolling > 0 Or gewaehlt_animationen > 0 Or mmouse_rechts = 1

If gewaehlt_message > 0
   mydelay = gewaehlt_message * 200
EndIf
If gewaehlt_scrolling > 0
   mydelay2 = (gewaehlt_scrolling-1) * 10
EndIf
If gewaehlt_animationen > 0
   mydelay4 = 4 - gewaehlt_animationen
EndIf

Delay(mydelay)

EndProcedure

; -------------------------------------------------------------------------------

Procedure load(name.s)

Shared anz_spieler, anfangszeit, sprache, anz_levels, modules, silent, test

   If ReadFile(0, "./" + name)
      version.s    = ReadString(0)
      nr_of_saves  = ReadWord(0)
      If version <> #LASTCHANGE And test = 0
         nachricht(320,#COLOR_ROT)
      Else
         anz_spieler     = ReadWord(0)
         sprache         = ReadWord(0)
         anfangszeit     = ReadString(0)
         anz_levels      = ReadWord(0)
         
         For j = 1 To 20
            pilz(j)\nr = ReadWord(0)
            For k = 1 To #ANZ_SPRACHEN
               pilz(j)\wirkung[k] = ReadString(0)
            Next
         Next
         
         For j = 0 To #ANZ_TRAENKE-1
            For k = 1 To #ANZ_SPRACHEN
               gegenstand(#OBJGRAFIK_TRANK1 + j)\name[k] = ReadString(0)
            Next
            gegenstand(#OBJGRAFIK_TRANK1 + j)\art = ReadWord(0)
            gegenstand(#OBJGRAFIK_TRANK1 + j)\einkauf = ReadWord(0)
            gegenstand(#OBJGRAFIK_TRANK1 + j)\verkauf = ReadWord(0)
         Next
         
         For j = 0 To #ANZ_PILZE-1
            For k = 1 To #ANZ_SPRACHEN
               gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\name[k] = ReadString(0)
            Next
            gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\art = ReadWord(0)
            gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\einkauf = ReadWord(0)
            gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\verkauf = ReadWord(0)
         Next
         
         For j = 1 To #ANZ_TRAENKE
            mischen(j)\trank1 = ReadWord(0)
            mischen(j)\trank2 = ReadWord(0)
            mischen(j)\trank3 = ReadWord(0)
         Next
         
         For j = 1 To #MAX_GROESSE
            For k = 1 To #MAX_GROESSE
               For y = 1 To anz_levels
                  labyrinth (j,k)\feld[y] = ReadWord(0)
               Next
               For y = 1 To anz_levels
                  labyrinth (j,k)\lebenspunkte[y] = ReadWord(0)
               Next
               For y = 1 To anz_levels
                  labyrinth (j,k)\objekt[y] = ReadWord(0)
               Next
               For y = 1 To anz_levels
                  labyrinth (j,k)\status[y] = ReadWord(0)
               Next
               For y = 1 To anz_levels
                  automap (j,k)\feld[y] = ReadWord(0)
               Next
            Next
         Next
         
         For j = 1 To #MAX_EBENEN
            raeume(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            raumx(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            raumy(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            ausgangx(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            ausgangy(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            eingangx(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            eingangy(j) = ReadWord(0)
         Next
         
         For j = 1 To #MAX_EBENEN
            sonderlevel(j) = ReadWord(0)
         Next
         
         For j = 1 To #MAX_EBENEN
            levelmod(j) = ReadWord(0)
         Next
         
         ; Groesse initialisieren! Zeigt an ob Level schon erschaffen!
         For j = 1 To #MAX_EBENEN
            groesse(j) = 0
         Next
         
         For j = 1 To anz_levels
            groesse(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            inhalt(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            mit_was(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            visionen(j) = ReadWord(0)
         Next
         
         For j = 1 To #MAX_EBENEN
            fluss(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            spinnenkoenigin(j) = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            goblinkoenig(j)    = ReadWord(0)
         Next
         
         For j = 1 To anz_levels
            untotenherr(j)     = ReadWord(0)
         Next
         
         For j = 1 To 40
            For k = 1 To anz_levels
               haendler_objekte(j,k) = ReadWord(0)
               haendler_schriftrolle(j,k) = ReadWord(0)
               haendler_staerke(j,k) = ReadWord(0)
            Next
         Next
         
         For i = 1 To anz_spieler
            spieler(i)\Status = ReadWord(0)
            spieler(i)\verifikation = ReadString(0)
            spieler(i)\Level = ReadWord(0)
            spieler(i)\MaxLevel = ReadWord(0)
            spieler(i)\Maennchen = ReadWord(0)
            spieler(i)\Lifepoints = ReadWord(0)
            spieler(i)\MaxLifepoints = ReadWord(0)
            spieler(i)\LifeGain = ReadWord(0)
            spieler(i)\Mana = ReadWord(0)
            spieler(i)\MaxMana = ReadWord(0)
            spieler(i)\ManaGain = ReadWord(0)
            spieler(i)\Attack = ReadWord(0)
            spieler(i)\Dexterity = ReadWord(0)
            spieler(i)\Strength = ReadWord(0)
            spieler(i)\MaxSpeed = ReadWord(0)
            spieler(i)\Speed = ReadWord(0)
            spieler(i)\Perception = ReadWord(0)
            spieler(i)\Luck_score = ReadWord(0)
            spieler(i)\Power_score = ReadWord(0)
            spieler(i)\Circle = ReadWord(0)
            spieler(i)\magieresistenz = ReadWord(0)
            spieler(i)\spellweaving = ReadWord(0)
            spieler(i)\style = ReadWord(0)
            spieler(i)\light = ReadWord(0)
            spieler(i)\Hunger = ReadWord(0)
            spieler(i)\Durst = ReadWord(0)
            spieler(i)\betrunken = ReadWord(0)
            spieler(i)\weisheit = ReadWord(0)
            spieler(i)\schleichen = ReadWord(0)
            spieler(i)\mks = ReadWord(0)
            spieler(i)\fluch = ReadWord(0)
            spieler(i)\fluchdauer = ReadWord(0)
            spieler(i)\krankheit = ReadWord(0)
            spieler(i)\krankheitdauer = ReadWord(0)
            spieler(i)\gift = ReadWord(0)
            spieler(i)\giftdauer = ReadWord(0)
            spieler(i)\verhungern = ReadWord(0)
            spieler(i)\verdursten = ReadWord(0)
            spieler(i)\lifepointgegenstand = ReadWord(0)
            spieler(i)\managegenstand = ReadWord(0)
            spieler(i)\staerkegegenstand = ReadWord(0)
            spieler(i)\zugweitegegenstand = ReadWord(0)
            spieler(i)\dexteritygegenstand = ReadWord(0)
            spieler(i)\gluecksgegenstand = ReadWord(0)
            spieler(i)\bogentreffergegenstand = ReadWord(0)
            spieler(i)\bogenschadengegenstand = ReadWord(0)
            spieler(i)\powergegenstand = ReadWord(0)
            spieler(i)\perceptiongegenstand = ReadWord(0)
            spieler(i)\attackgegenstand = ReadWord(0)
            spieler(i)\stealthgegenstand = ReadWord(0)
            spieler(i)\damagegegenstand = ReadWord(0)
            spieler(i)\lichtgegenstand = ReadWord(0)
            spieler(i)\diebstahlgegenstand = ReadWord(0)
            spieler(i)\goblinlehre = ReadWord(0)
            spieler(i)\spinnenlehre = ReadWord(0)
            spieler(i)\untotenlehre = ReadWord(0)
            spieler(i)\pflanzenlehre = ReadWord(0)
            spieler(i)\tierkunde = ReadWord(0)
            spieler(i)\fallenlehre = ReadWord(0)
            spieler(i)\giftlehre = ReadWord(0)
            spieler(i)\pos_zaubermenue = ReadWord(0)
            spieler(i)\dumm = ReadWord(0)
            spieler(i)\face = ReadWord(0)
            spieler(i)\hinterhalt = ReadWord(0)
            spieler(i)\portal = ReadWord(0)
            spieler(i)\teleport = ReadWord(0)
            spieler(i)\nexus = ReadWord(0)
            spieler(i)\stehlen = ReadWord(0)
            spieler(i)\schriftrolle = ReadWord(0)
            spieler(i)\zauberbuch = ReadWord(0)
            spieler(i)\kessel = ReadWord(0)
            spieler(i)\armageddon = ReadWord(0)
            spieler(i)\pestilence = ReadWord(0)
            spieler(i)\drachenform = ReadWord(0)
            spieler(i)\macht = ReadWord(0)
            spieler(i)\heal = ReadWord(0)
            spieler(i)\udjat_ben = ReadWord(0)
            spieler(i)\akt_zauber = ReadWord(0)
            spieler(i)\schule = ReadString(0)
            spieler(i)\lehrer = ReadWord(0)
            spieler(i)\stabteile = ReadWord(0)
            spieler(i)\moves = ReadWord(0)
            spieler(i)\anker_x = ReadWord(0)
            spieler(i)\anker_y = ReadWord(0)
            spieler(i)\anker_level = ReadWord(0)
            spieler(i)\old_pos_x = ReadWord(0)
            spieler(i)\old_pos_y = ReadWord(0)
            spieler(i)\old_lp = ReadWord(0)
            spieler(i)\old_max_lp = ReadWord(0)
            spieler(i)\old_mp = ReadWord(0)
            spieler(i)\old_max_mp = ReadWord(0)
            For k = 1 To #ANZ_SPRACHEN
               spieler(i)\sterbegrund[k] = ReadString(0)
            Next
            spieler(i)\character_x = ReadWord(0)
            spieler(i)\character_y = ReadWord(0)
            spieler(i)\creature_typ = ReadWord(0)
            spieler(i)\creature_LifePoints = ReadWord(0)
            spieler(i)\creature_Attack = ReadWord(0)
            spieler(i)\creature_schaden_min = ReadWord(0)
            spieler(i)\creature_schaden_max = ReadWord(0)
            spieler(i)\creature_Speed = ReadWord(0)
            spieler(i)\creature_MaxSpeed = ReadWord(0)
            spieler(i)\creature_x = ReadWord(0)
            spieler(i)\creature_y = ReadWord(0)
            spieler(i)\creature_heading = ReadWord(0)
            
            For j = 1 To 15
               aktive(j,i)\nr = ReadWord(0)
               aktive(j,i)\staerke = ReadWord(0)
               aktive(j,i)\dauer = ReadWord(0)
               aktive(j,i)\source = ReadWord(0)
            Next
            
            For j = 1 To #ANZ_SKILLS
               For k = 1 To #ANZ_SPRACHEN
                  skills(j,i)\name[k] = ReadString(0)
               Next
               skills(j,i)\nummer = ReadWord(0)
               skills(j,i)\kosten = ReadWord(0)
               skills(j,i)\gruppe = ReadWord(0)
               For k = 1 To #ANZ_SPRACHEN
                  skills(j,i)\beschreibung_1[k] = ReadString(0)
                  skills(j,i)\beschreibung_2[k] = ReadString(0)
               Next
               skills(j,i)\gewaehlt = ReadWord(0)
               skills(j,i)\gelocked = ReadWord(0)
            Next
            
            For j = 1 To 50
               inventory(j,i)\name = ReadWord(0)
               inventory(j,i)\art = ReadWord(0)
               inventory(j,i)\benutzt = ReadWord(0)
               inventory(j,i)\anzahl = ReadWord(0)
               inventory(j,i)\status = ReadWord(0)
               inventory(j,i)\attri1 = ReadWord(0)
               inventory(j,i)\attri2 = ReadWord(0)
               inventory(j,i)\attri3 = ReadWord(0)
               inventory(j,i)\attri4 = ReadWord(0)
               inventory(j,i)\attri5 = ReadWord(0)
            Next
            
            For j = 1 To 150
               For k = 1 To #ANZ_SPRACHEN
                  zauber(j,i)\name[k] = ReadString(0)
               Next
               zauber(j,i)\level = ReadWord(0)
               zauber(j,i)\kosten = ReadWord(0)
               zauber(j,i)\dauer = ReadWord(0)
               zauber(j,i)\chance = ReadWord(0)
               zauber(j,i)\anhaltend = ReadWord(0)
               zauber(j,i)\erlernt = ReadWord(0)
               zauber(j,i)\art = ReadString(0)
               For k = 1 To #ANZ_SPRACHEN
                  zauber(j,i)\besch_1[k] = ReadString(0)
                  zauber(j,i)\besch_2[k] = ReadString(0)
               Next
            Next
            
            For j = 1 To 10
               schnellzauber(j,i) = ReadString(0)
            Next
            
            For j = 1 To 8
               schnellzauber2(j,i) = ReadString(0)
            Next
            
         Next ; anz_spieler
         
         nachricht(299,#COLOR_WEISS)
         CloseFile(0)

        ; Titelmusic aus
        If modules = 1 And silent = 0
            StopModule()
        EndIf

         Goto geladen
      EndIf  ; version okay?
   Else
      nachricht(406,#COLOR_ROT)
   EndIf  ; File vorhanden?

EndProcedure
; -------------------------------------------------------------------------------

Procedure save(name.s)

Shared anz_spieler, anfangszeit, sprache, groesse
Shared anz_levels, nr_of_saves

   If CreateFile(0, "./" + name)
      WriteStringN(0,#LASTCHANGE)
      nr_of_saves = nr_of_saves + 1
      WriteWord(0,nr_of_saves)
      WriteWord(0,anz_spieler)
      WriteWord(0,sprache)
      WriteStringN(0,anfangszeit)
      anz_levels = 0
      For j = 1 To #MAX_EBENEN
         If groesse(j) > 0
            anz_levels = anz_levels + 1
         EndIf
      Next
      WriteWord(0,anz_levels)
      
      For j = 1 To 20
         WriteWord(0,pilz(j)\nr)
         For k = 1 To #ANZ_SPRACHEN
            WriteStringN(0,pilz(j)\wirkung[k])
         Next
      Next
      
      For j = 0 To #ANZ_TRAENKE-1
         For k = 1 To #ANZ_SPRACHEN
            WriteStringN(0,gegenstand(#OBJGRAFIK_TRANK1 + j)\name[k])
         Next
         WriteWord(0,gegenstand(#OBJGRAFIK_TRANK1 + j)\art)
         WriteWord(0,gegenstand(#OBJGRAFIK_TRANK1 + j)\einkauf)
         WriteWord(0,gegenstand(#OBJGRAFIK_TRANK1 + j)\verkauf)
      Next
      
      For j = 0 To #ANZ_PILZE-1
         For k = 1 To #ANZ_SPRACHEN
            WriteStringN(0,gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\name[k])
         Next
         WriteWord(0,gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\art)
         WriteWord(0,gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\einkauf)
         WriteWord(0,gegenstand(#OBJGRAFIK_PILZE_SCHWARZ + j)\verkauf)
      Next
      
      For j = 1 To #ANZ_TRAENKE
         WriteWord(0,mischen(j)\trank1)
         WriteWord(0,mischen(j)\trank2)
         WriteWord(0,mischen(j)\trank3)
      Next
      
      For j = 1 To #MAX_GROESSE
         For k = 1 To #MAX_GROESSE
            For y = 1 To anz_levels
               WriteWord(0,labyrinth (j,k)\feld[y])
            Next
            For y = 1 To anz_levels
               WriteWord(0,labyrinth (j,k)\lebenspunkte[y])
            Next
            For y = 1 To anz_levels
               WriteWord(0,labyrinth (j,k)\objekt[y])
            Next
            For y = 1 To anz_levels
               WriteWord(0,labyrinth (j,k)\status[y])
            Next
            For y = 1 To anz_levels
               WriteWord(0,automap (j,k)\feld[y])
            Next
         Next
      Next
         
      For j = 1 To #MAX_EBENEN
            WriteWord(0,raeume(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,raumx(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,raumy(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,ausgangx(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,ausgangy(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,eingangx(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,eingangy(j))
         Next
         
         For j = 1 To #MAX_EBENEN
            WriteWord(0,sonderlevel(j))
         Next
         
         For j = 1 To #MAX_EBENEN
            WriteWord(0,levelmod(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,groesse(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,inhalt(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,mit_was(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,visionen(j))
         Next
         
         For j = 1 To #MAX_EBENEN
            WriteWord(0,fluss(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,spinnenkoenigin(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,goblinkoenig(j))
         Next
         
         For j = 1 To anz_levels
            WriteWord(0,untotenherr(j))
         Next
         
         For j = 1 To 40
            For k = 1 To anz_levels
               WriteWord(0,haendler_objekte(j,k))
               WriteWord(0,haendler_schriftrolle(j,k))
               WriteWord(0,haendler_staerke(j,k))
            Next
         Next
      
      For i = 1 To anz_spieler
         WriteWord(0,spieler(i)\Status)
         WriteStringN(0,spieler(i)\verifikation)
         WriteWord(0,spieler(i)\Level)
         WriteWord(0,spieler(i)\MaxLevel)
         WriteWord(0,spieler(i)\Maennchen)
         WriteWord(0,spieler(i)\Lifepoints)
         WriteWord(0,spieler(i)\MaxLifepoints)
         WriteWord(0,spieler(i)\LifeGain)
         WriteWord(0,spieler(i)\Mana)
         WriteWord(0,spieler(i)\MaxMana)
         WriteWord(0,spieler(i)\ManaGain)
         WriteWord(0,spieler(i)\Attack)
         WriteWord(0,spieler(i)\Dexterity)
         WriteWord(0,spieler(i)\Strength)
         WriteWord(0,spieler(i)\MaxSpeed)
         WriteWord(0,spieler(i)\Speed)
         WriteWord(0,spieler(i)\Perception)
         WriteWord(0,spieler(i)\Luck_score)
         WriteWord(0,spieler(i)\Power_score)
         WriteWord(0,spieler(i)\Circle)
         WriteWord(0,spieler(i)\magieresistenz)
         WriteWord(0,spieler(i)\spellweaving)
         WriteWord(0,spieler(i)\style)
         WriteWord(0,spieler(i)\light)
         WriteWord(0,spieler(i)\Hunger)
         WriteWord(0,spieler(i)\Durst)
         WriteWord(0,spieler(i)\betrunken)
         WriteWord(0,spieler(i)\weisheit)
         WriteWord(0,spieler(i)\schleichen)
         WriteWord(0,spieler(i)\mks)
         WriteWord(0,spieler(i)\fluch)
         WriteWord(0,spieler(i)\fluchdauer)
         WriteWord(0,spieler(i)\krankheit)
         WriteWord(0,spieler(i)\krankheitdauer)
         WriteWord(0,spieler(i)\gift)
         WriteWord(0,spieler(i)\giftdauer)
         WriteWord(0,spieler(i)\verhungern)
         WriteWord(0,spieler(i)\verdursten)
         WriteWord(0,spieler(i)\lifepointgegenstand)
         WriteWord(0,spieler(i)\managegenstand)
         WriteWord(0,spieler(i)\staerkegegenstand)
         WriteWord(0,spieler(i)\zugweitegegenstand)
         WriteWord(0,spieler(i)\dexteritygegenstand)
         WriteWord(0,spieler(i)\gluecksgegenstand)
         WriteWord(0,spieler(i)\bogentreffergegenstand)
         WriteWord(0,spieler(i)\bogenschadengegenstand)
         WriteWord(0,spieler(i)\powergegenstand)
         WriteWord(0,spieler(i)\perceptiongegenstand)
         WriteWord(0,spieler(i)\attackgegenstand)
         WriteWord(0,spieler(i)\stealthgegenstand)
         WriteWord(0,spieler(i)\damagegegenstand)
         WriteWord(0,spieler(i)\lichtgegenstand)
         WriteWord(0,spieler(i)\diebstahlgegenstand)
         WriteWord(0,spieler(i)\goblinlehre)
         WriteWord(0,spieler(i)\spinnenlehre)
         WriteWord(0,spieler(i)\untotenlehre)
         WriteWord(0,spieler(i)\pflanzenlehre)
         WriteWord(0,spieler(i)\tierkunde)
         WriteWord(0,spieler(i)\fallenlehre)
         WriteWord(0,spieler(i)\giftlehre)
         WriteWord(0,spieler(i)\pos_zaubermenue)
         WriteWord(0,spieler(i)\dumm)
         WriteWord(0,spieler(i)\face)
         WriteWord(0,spieler(i)\hinterhalt)
         WriteWord(0,spieler(i)\portal)
         WriteWord(0,spieler(i)\teleport)
         WriteWord(0,spieler(i)\nexus)
         WriteWord(0,spieler(i)\stehlen)
         WriteWord(0,spieler(i)\schriftrolle)
         WriteWord(0,spieler(i)\zauberbuch)
         WriteWord(0,spieler(i)\kessel)
         WriteWord(0,spieler(i)\armageddon)
         WriteWord(0,spieler(i)\pestilence)
         WriteWord(0,spieler(i)\drachenform)
         WriteWord(0,spieler(i)\macht)
         WriteWord(0,spieler(i)\heal)
         WriteWord(0,spieler(i)\udjat_ben)
         WriteWord(0,spieler(i)\akt_zauber)
         WriteStringN(0,spieler(i)\schule)
         WriteWord(0,spieler(i)\lehrer)
         WriteWord(0,spieler(i)\stabteile)
         WriteWord(0,spieler(i)\moves)
         WriteWord(0,spieler(i)\anker_x)
         WriteWord(0,spieler(i)\anker_y)
         WriteWord(0,spieler(i)\anker_level)
         WriteWord(0,spieler(i)\old_pos_x)
         WriteWord(0,spieler(i)\old_pos_y)
         WriteWord(0,spieler(i)\old_lp)
         WriteWord(0,spieler(i)\old_max_lp)
         WriteWord(0,spieler(i)\old_mp)
         WriteWord(0,spieler(i)\old_max_mp)
         For k = 1 To #ANZ_SPRACHEN
            WriteStringN(0,spieler(i)\sterbegrund[k])
         Next
         WriteWord(0,spieler(i)\character_x)
         WriteWord(0,spieler(i)\character_y)
         WriteWord(0,spieler(i)\creature_typ)
         WriteWord(0,spieler(i)\creature_LifePoints)
         WriteWord(0,spieler(i)\creature_Attack)
         WriteWord(0,spieler(i)\creature_schaden_min)
         WriteWord(0,spieler(i)\creature_schaden_max)
         WriteWord(0,spieler(i)\creature_Speed)
         WriteWord(0,spieler(i)\creature_MaxSpeed)
         WriteWord(0,spieler(i)\creature_x)
         WriteWord(0,spieler(i)\creature_y)
         WriteWord(0,spieler(i)\creature_heading)
         
         For j = 1 To 15
            WriteWord(0,aktive(j,i)\nr)
            WriteWord(0,aktive(j,i)\staerke)
            WriteWord(0,aktive(j,i)\dauer)
            WriteWord(0,aktive(j,i)\source)
         Next
         
         For j = 1 To #ANZ_SKILLS
            For k = 1 To #ANZ_SPRACHEN
               WriteStringN(0,skills(j,i)\name[k])
            Next
            WriteWord(0,skills(j,i)\nummer)
            WriteWord(0,skills(j,i)\kosten)
            WriteWord(0,skills(j,i)\gruppe)
            For k = 1 To #ANZ_SPRACHEN
               WriteStringN(0,skills(j,i)\beschreibung_1[k])
               WriteStringN(0,skills(j,i)\beschreibung_2[k])
            Next
            WriteWord(0,skills(j,i)\gewaehlt)
            WriteWord(0,skills(j,i)\gelocked)
         Next
         
         For j = 1 To 50
            WriteWord(0,inventory(j,i)\name)
            WriteWord(0,inventory(j,i)\art)
            WriteWord(0,inventory(j,i)\benutzt)
            WriteWord(0,inventory(j,i)\anzahl)
            WriteWord(0,inventory(j,i)\status)
            WriteWord(0,inventory(j,i)\attri1)
            WriteWord(0,inventory(j,i)\attri2)
            WriteWord(0,inventory(j,i)\attri3)
            WriteWord(0,inventory(j,i)\attri4)
            WriteWord(0,inventory(j,i)\attri5)
         Next
         
         For j = 1 To 150
            For k = 1 To #ANZ_SPRACHEN
               WriteStringN(0,zauber(j,i)\name[k])
            Next
            WriteWord(0,zauber(j,i)\level)
            WriteWord(0,zauber(j,i)\kosten)
            WriteWord(0,zauber(j,i)\dauer)
            WriteWord(0,zauber(j,i)\chance)
            WriteWord(0,zauber(j,i)\anhaltend)
            WriteWord(0,zauber(j,i)\erlernt)
            WriteStringN(0,zauber(j,i)\art)
            For k = 1 To #ANZ_SPRACHEN
               WriteStringN(0,zauber(j,i)\besch_1[k])
               WriteStringN(0,zauber(j,i)\besch_2[k])
            Next
         Next
         
         For j = 1 To 10
            WriteStringN(0,schnellzauber(j,i))
         Next
         
         For j = 1 To 8
            WriteStringN(0,schnellzauber2(j,i))
         Next
         
      Next ; anz_spieler
      CloseFile(0)
   Else
      nachricht(407,#COLOR_ROT)
   EndIf
   
   nachricht(298,#COLOR_WEISS)

EndProcedure

; -------------------------------------------------------------------------------

Procedure loading_screen()

Shared akt_spieler, sprache, joystick_used, no_mouse
    
raus.w = 0
load.w = 0

If ReadFile(0, "./savenames.sav")
   For i = 1 To 10
      savenames(i) = ReadString(0)
      savedatum(i)     = ReadString(0)
   Next
   CloseFile(0)
EndIf

Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))
      
      ; Rahmen zeichnen
      ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 463)
      ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 623, 0)

      yy = 65
      
      wohin = ScreenOutput()
      StartDrawing(wohin)
         DrawingMode(1)
         FrontColor(RGB(255,255,255))  ; Weiss
         DrawText(190,yy,nachricht_text(570,1+sprache))
         yy = yy + 15
         DrawText(190,yy,nachricht_text(569,1+sprache))
         
         jax.w = 0
         jay.w = 0
         jb1.w = 0
         If joystick_used = 1
            ExamineJoystick()
            jay = JoystickAxisY()
            jb1 = JoystickButton(1)
         EndIf
         
         ExamineKeyboard()
         If KeyboardPushed(#PB_Key_Up) Or jay = -1
            sel = sel - 1
            If sel < 1
               sel = 1
            EndIf
         EndIf
         If KeyboardPushed(#PB_Key_Down) Or jay = 1
            sel = sel + 1
            If sel > 10
               sel = 10
            EndIf
         EndIf

         If no_mouse = 0
            result = ExamineMouse()
            mmouse_x = MouseX()
            mmouse_y = MouseY()
            mmouse_links  = MouseButton(1)
            mmouse_rechts = MouseButton(2)
         EndIf
         
         
         For willi = 1 To 10
            If mmouse_x > 40 And mmouse_x < 600 And mmouse_y > 100+willi*20 And mmouse_y < 120+willi*20
               FrontColor(RGB(150,150,150))
               Box(40,100+willi*20,400,20)
               If sel = 1
                  FrontColor(RGB(1,1,255))  ; Blau
               Else
                  FrontColor(RGB(255,255,255))  ; Weiss
               EndIf
               DrawText(40, 100+willi*20,Str(willi))
               If mmouse_links = 1
                  raus = 1
                  load = willi
               EndIf
            Else
               If sel = willi
                  FrontColor(RGB(1,1,255))  ; Blau
                  If KeyboardPushed(#PB_Key_Return) Or jb1 <> 0
                     raus = 1
                     load = willi
                  EndIf
               Else
                  FrontColor(RGB(255,255,255))  ; Weiss
               EndIf
               DrawText(40, 100+willi*20,Str(willi))
            EndIf
            
            FrontColor(RGB(255,255,255))  ; Weiss
            DrawText(150, 100+willi*20,savenames(willi))
            If savedatum(willi) <> ""
               akt_datum.s = FormatDate("%dd.%mm.%yyyy %hh:%ii",ParseDate("%yyyy%mm%dd%hh%ii%ss",savedatum(willi)))
               DrawText(450, 100+willi*20,akt_datum)
            EndIf
         Next
         
      StopDrawing()
      
      ; Maus darstellen
      If no_mouse = 0
         ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
      EndIf
      FlipBuffers()
      Delay(50)
   Until mmouse_rechts = 1 Or raus = 1 Or KeyboardPushed(#PB_Key_Escape)
   
   If load > 0
      load("laby" + Str(load) + ".sav")
   EndIf

EndProcedure

; -------------------------------------------------------------------------------

Procedure saving_screen()

Shared akt_spieler, sprache, joystick_used, no_mouse
    
raus.w = 0
save.w = 0

If ReadFile(0, "./savenames.sav")
   For i = 1 To 10
      savenames(i) = ReadString(0)
      savedatum(i)     = ReadString(0)
   Next
   CloseFile(0)
EndIf

Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))
      
      ; Rahmen zeichnen
      ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 463)
      ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 623, 0)

      yy = 65
      
      wohin = ScreenOutput()
      StartDrawing(wohin)
         DrawingMode(1)
         FrontColor(RGB(255,255,255))  ; Weiss
         DrawText(190,yy,nachricht_text(568,1+sprache))
         yy = yy + 15
         DrawText(190,yy,nachricht_text(569,1+sprache))
      StopDrawing()
         
         jax.w = 0
         jay.w = 0
         jb1.w = 0
         If joystick_used = 1
            ExamineJoystick()
            jay = JoystickAxisY()
            jb1 = JoystickButton(1)
         EndIf
         
         ExamineKeyboard()
         If KeyboardPushed(#PB_Key_Up) Or jay = -1
            sel = sel - 1
            If sel < 1
               sel = 1
            EndIf
         EndIf
         If KeyboardPushed(#PB_Key_Down) Or jay = 1
            sel = sel + 1
            If sel > 10
               sel = 10
            EndIf
         EndIf

         If no_mouse = 0
            result = ExamineMouse()
            mmouse_x = MouseX()
            mmouse_y = MouseY()
            mmouse_links  = MouseButton(1)
            mmouse_rechts = MouseButton(2)
         EndIf
         
         wohin = ScreenOutput()
         StartDrawing(wohin)
         DrawingMode(1)
         FrontColor(RGB(255,255,255))  ; Weiss
         
         For willi = 1 To 10
            If mmouse_x > 40 And mmouse_x < 600 And mmouse_y > 100+willi*20 And mmouse_y < 120+willi*20
               FrontColor(RGB(150,150,150))
               Box(40,100+willi*20,400,20)
               If sel = 1
                  FrontColor(RGB(1,1,255))  ; Blau
               Else
                  FrontColor(RGB(255,255,255))  ; Weiss
               EndIf
   
               DrawText(40, 100+willi*20,Str(willi))
               If mmouse_links = 1
                  raus = 1
                  save = willi
               EndIf
            Else
               If sel = willi
                  FrontColor(RGB(1,1,255))  ; Blau
                  If KeyboardPushed(#PB_Key_Return) Or jb1 <> 0
                     raus = 1
                     save = willi
                  EndIf
               Else
                  FrontColor(RGB(255,255,255))  ; Weiss
               EndIf
               DrawText(40, 100+willi*20,Str(willi))              
            EndIf
            
            FrontColor(RGB(255,255,255))  ; Weiss
            DrawText(150, 100+willi*20,savenames(willi))
            If savedatum(willi) <> ""
               
               akt_datum.s = FormatDate("%dd.%mm.%yyyy %hh:%ii",ParseDate("%yyyy%mm%dd%hh%ii%ss",savedatum(willi)))
               DrawText(450, 100+willi*20,akt_datum)
            EndIf
         Next
         
         StopDrawing()
      
      ; Maus darstellen
      If no_mouse = 0
         ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
      EndIf
      FlipBuffers()
      Delay(50)
   Until mmouse_rechts = 1 Or raus = 1 Or KeyboardPushed(#PB_Key_Escape)
   
   If save > 0
      myname.s = savenames(save)
      Repeat
         Fenster()
         ClearScreen(RGB(0,0,0))

         yy = 65
   
         ; Rahmen zeichnen
         ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
         DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
         ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
         DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
         ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
         DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 463)
         ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
         DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 623, 0)
         
         wohin = ScreenOutput()
         StartDrawing(wohin)
         DrawingMode(1)
         
         FrontColor(RGB(255,255,255))  ; Weiss
         DrawText(190,yy,nachricht_text(568,1+sprache))
         yy = yy + 15
         DrawText(190,yy,nachricht_text(569,1+sprache))
         
        StopDrawing()

         For willi = 1 To 10
            If willi = save
               FrontColor(RGB(150,150,150))  ; Weiss
               Box(40,100+save*20,550,20)
            EndIf
           wohin = ScreenOutput()
          StartDrawing(wohin)
           DrawingMode(1)
           FrontColor(RGB(255,255,255))  ; Weiss
            FrontColor(RGB(255,255,255))  ; Weiss
            DrawText(40, 100+willi*20,Str(willi))
            StopDrawing()
         Next
      
         ; Name einlesen
         wohin = ScreenOutput()
         StartDrawing(wohin)
           DrawingMode(1)
           FrontColor(RGB(255,255,255))  ; Weiss
           DrawText(100, 100+save*20,nachricht_text(571,1+sprache))
           DrawText(200,100+save*20,myname)
         StopDrawing()

         ; Maus darstellen
         If no_mouse = 0
            result = ExamineMouse()
            mmouse_x  = MouseX()
            mmouse_y  = MouseY()
            mmouse_links  = MouseButton(1)
            mmouse_rechts = MouseButton(2)
            ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
            DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
            mouse_x_old = mmouse_x
            mouse_y_old = mmouse_y
         EndIf
         
         If joystick_used = 1
            jax.w = 0
            jay.w = 0
            jb2.w = 0
            ExamineJoystick()
            jax = JoystickAxisX()
            jay = JoystickAxisY()
            jb2 = JoystickButton(2)
         EndIf

         myname = keyboard_string(myname,0)

         
         If Len(myname) > 25
            myname = Mid(myname,1,25)
         EndIf
         
         ; Cursor darstellen
         warten = warten + 1
         If warten < 3
            ; anzeigen
            wohin = ScreenOutput()
            StartDrawing(wohin)
            DrawingMode(1)
            FrontColor(RGB(255,255,255))  ; Weiss
            Line(200+TextWidth(myname), 102+save*20, 0, 15)
            Line(200+1+TextWidth(myname), 102+save*20, 0, 15)
            StopDrawing()
         EndIf
         If warten > 4
            warten = 0
         EndIf
         
         FlipBuffers()
         Delay(1)
      Until ((KeyboardPushed(#PB_Key_Return) Or jb2 = 1) And myname <> "") Or KeyboardPushed(#PB_Key_Escape) Or mmouse_rechts = 1
      
      If myname <> ""
         savenames(save) = myname
         savedatum(save) = FormatDate("%yyyy%mm%dd%hh%ii%ss", Date())
         If CreateFile(0, "./savenames.sav")
            For egon = 1 To 10
               WriteStringN(0,savenames(egon))
               WriteStringN(0,savedatum(egon))
            Next
            CloseFile(0)
         EndIf
         save("laby" + Str(save) + ".sav")
      EndIf
   EndIf

EndProcedure

; -------------------------------------------------------------------------------

Procedure optionen_rahmen()

Shared sprache, optionenliste, akt_option, anzz, yplus, yplus2, mauszauber

   ; Ueberbleibsel des Labyrinths uebermalen
   wohin = ScreenOutput()
   StartDrawing(wohin)
   FrontColor(RGB(0,0,0))
   Box(365,15,260,449) 
   Box(15,365,335,51)
   StopDrawing()

   ; Rahmen zeichnen
   ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
   DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
   DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
   DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 464)
   ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
   DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 624, 0)

   ClipSprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 0, 640, 17)
   DisplaySprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 350)
   ClipSprite(#SPRITE_RAHMEN_MITTE, 0, 0, 17, 480)
   DisplaySprite(#SPRITE_RAHMEN_MITTE, 350, 0)

   wohin = ScreenOutput()
   StartDrawing(wohin)
   DrawingMode(1)

   FrontColor(RGB(255,255,255))  ; Weiss
   DrawText(440, 19,nachricht_text(76,1+sprache))

   ; In der Mitte wird ausgewaehlt
   FrontColor(RGB(150,150,150))
   Box(365,200+yplus2,260,yplus)

   ; Optionen darstellen
   FrontColor(RGB(255,255,255))
   x = 400
   y = 52

   For i = 1 To anzz-3
      FrontColor(RGB(255,255,255))  ; Weiss
      If i = mauszauber
         FrontColor(RGB(1,1,255))  ; Blau
      EndIf
      DrawText(x,y,optionenliste(i + akt_option))
      y = y + yplus
   Next

   StopDrawing()


EndProcedure

; ------------------------------------------------------------------------------------------
; Optionenmenue

Procedure optionen()

Shared sprache, optionenliste, akt_spieler, frame, akt_option, akt_zauber_offset2, yplus, anzz
Shared mauszauber, character_x, character_y, joystick_used, sound, music, klicking, autopickup
Shared selectdelay, modules, mydelay, knopf5, no_mouse, flaschen

   For i = 1 To 30
      optionenliste(i) = ""
   Next

   If sprache = 0
      optionenliste(akt_zauber_offset2+1)  = "Abort game"
      optionenliste(akt_zauber_offset2+2)  = "Quit program"
      optionenliste(akt_zauber_offset2+3)  = "Gamespeed"
      optionenliste(akt_zauber_offset2+4)  = "Save Settings"
      optionenliste(akt_zauber_offset2+5)  = "Fullscreen/Windowed"
      optionenliste(akt_zauber_offset2+6)  = "Enable Joystick"
      optionenliste(akt_zauber_offset2+7)  = "Enable No mouse"
      optionenliste(akt_zauber_offset2+8)  = "Disable No mouse"
      optionenliste(akt_zauber_offset2+9)  = "Auto-Toggle : Off"
      optionenliste(akt_zauber_offset2+10) = "Auto-Toggle : On"
      optionenliste(akt_zauber_offset2+11) = "Sounds : Off"
      optionenliste(akt_zauber_offset2+12) = "Sounds : On"
      optionenliste(akt_zauber_offset2+13) = "Music : Off"
      optionenliste(akt_zauber_offset2+14) = "Music : On"
      optionenliste(akt_zauber_offset2+15) = "Klicking : Off"
      optionenliste(akt_zauber_offset2+16) = "Klicking : On"
      optionenliste(akt_zauber_offset2+17) = "Bow = Button 5 : Off"
      optionenliste(akt_zauber_offset2+18) = "Bow = Button 5 : On"
      optionenliste(akt_zauber_offset2+19) = "Jars : Off"
      optionenliste(akt_zauber_offset2+20) = "Jars : On"
      optionenliste(akt_zauber_offset2+21) = "Load"
      optionenliste(akt_zauber_offset2+22) = "Save"
      optionenliste(akt_zauber_offset2+23) = "Cancel"
   EndIf
   If sprache = 1
      optionenliste(akt_zauber_offset2+1)  = "Spiel abbrechen"
      optionenliste(akt_zauber_offset2+2)  = "Programm beenden"
      optionenliste(akt_zauber_offset2+3)  = "Spielgeschwindigkeit"
      optionenliste(akt_zauber_offset2+4)  = "Einstellungen speichern"
      optionenliste(akt_zauber_offset2+5)  = "Vollbild/Fenster"
      optionenliste(akt_zauber_offset2+6)  = "Joystick einschalten"
      optionenliste(akt_zauber_offset2+7)  = "Keine Maus einschalten"
      optionenliste(akt_zauber_offset2+8)  = "Keine Maus ausschalten"
      optionenliste(akt_zauber_offset2+9)  = "Auto-Toggle : Aus"
      optionenliste(akt_zauber_offset2+10) = "Auto-Toggle : An"
      optionenliste(akt_zauber_offset2+11) = "Sound : Aus"
      optionenliste(akt_zauber_offset2+12) = "Sound : An"
      optionenliste(akt_zauber_offset2+13) = "Musik : Aus"
      optionenliste(akt_zauber_offset2+14) = "Musik : An"
      optionenliste(akt_zauber_offset2+15) = "Klicken : Aus"
      optionenliste(akt_zauber_offset2+16) = "Klicken : An"
      optionenliste(akt_zauber_offset2+17) = "Bogen = Knopf 5 : Aus"
      optionenliste(akt_zauber_offset2+18) = "Bogen = Knopf 5 : An"
      optionenliste(akt_zauber_offset2+19) = "Flaschen : Aus"
      optionenliste(akt_zauber_offset2+20) = "Flaschen : An"
      optionenliste(akt_zauber_offset2+21) = "Laden"
      optionenliste(akt_zauber_offset2+22) = "Speichern"
      optionenliste(akt_zauber_offset2+23) = "Abbrechen"
   EndIf
   If sprache = 2
      optionenliste(akt_zauber_offset2+1)  = "Terminar Juego"
      optionenliste(akt_zauber_offset2+2)  = "Salir del Programa"
      optionenliste(akt_zauber_offset2+3)  = "Velocidad del Juego"
      optionenliste(akt_zauber_offset2+4)  = "Guardar Configuracion"
      optionenliste(akt_zauber_offset2+5)  = "Fullscreen/Ventana"
      optionenliste(akt_zauber_offset2+6)  = "Activar Joystick"
      optionenliste(akt_zauber_offset2+7)  = "Activar No raton"
      optionenliste(akt_zauber_offset2+8)  = "Desactivar No raton"
      optionenliste(akt_zauber_offset2+9)  = "Auto-Usar: No"
      optionenliste(akt_zauber_offset2+10)  = "Auto-Usar : Si"
      optionenliste(akt_zauber_offset2+11)  = "Sonidos : No"
      optionenliste(akt_zauber_offset2+12) = "Sonidos : Si"
      optionenliste(akt_zauber_offset2+13) = "Musica : No"
      optionenliste(akt_zauber_offset2+14) = "Musica : Si"
      optionenliste(akt_zauber_offset2+15) = "Klickear : No"
      optionenliste(akt_zauber_offset2+16) = "Klickear : Si"
      optionenliste(akt_zauber_offset2+17) = "Arco = Buton 5 : No"
      optionenliste(akt_zauber_offset2+18) = "Arco = Buton 5 : Si"
      optionenliste(akt_zauber_offset2+19) = "Botellas : No"
      optionenliste(akt_zauber_offset2+20) = "Botellas : Si"
      optionenliste(akt_zauber_offset2+21) = "Cargar"
      optionenliste(akt_zauber_offset2+22) = "Guardar"
      optionenliste(akt_zauber_offset2+23) = "Cancelar"
   EndIf

   akt_option = 12


   Repeat
        Fenster()
        screen2()
        optionen_rahmen()

        If joystick_used = 1
            jax.w = 0
            jay.w = 0
            jb1.w = 0
            ExamineJoystick()
            jax = JoystickAxisX()
            jay = JoystickAxisY()
            jb1 = JoystickButton(1)
         EndIf

        If no_mouse = 0
            result = ExamineMouse()
            mmouse_x = MouseX()
            mmouse_y = MouseY()
            mouse_links   = MouseButton(1)
            mouse_rechts  = MouseButton(2)
      
            ; Maus darstellen
            ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
            DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
        EndIf

        FlipBuffers()

           
        ADDelayMax(1) = selectdelay  
        If KeyboardPushed(#PB_Key_Down) Or jay > 0
           If autoDelay(1,#AD_WORK, -2)
              autoDelay(1,#AD_SETNEW, -2)
              If akt_option < 22
                  akt_option = akt_option + 1
              EndIf
           EndIf
        
        ElseIf KeyboardPushed(#PB_Key_Up) Or jay < 0
           If autoDelay(1,#AD_WORK, -2)
              autoDelay(1,#AD_SETNEW, -2)
              If akt_option > 0
                  akt_option = akt_option - 1
              EndIf
            EndIf
        Else
          autoDelay(1,#AD_SETZERO, -2)
        EndIf

        ExamineKeyboard()

        ; Mit Maus gewaehlt ?
        mauszauber = 0
        y = 52
        aktuell = 1
        If mmouse_x > 365 And mmouse_x < 610
           For i = 1 To anzz
              If mmouse_y >= y And mmouse_y <= y + yplus
                 mauszauber = aktuell
              EndIf
              y = y + yplus
              aktuell = aktuell + 1
           Next
        EndIf

        raushier = 0
        If mouse_links = 1 And mauszauber > 0
           raushier = 1
        EndIf

   Until raushier = 1 Or mouse_rechts = 1 Or KeyboardPushed(#PB_Key_Return) Or jb1 = 1
   autoDelay(-1,#AD_DELTEMP,-2)

   ; Tastatur?
   If KeyboardPushed(#PB_Key_Return) Or jb1 = 1
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Spiel abbrechen" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Abort game" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Terminar Juego"
         Goto again
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Programm beenden" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Quit program" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Salir del Programa"
         Aus()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Spielgeschwindigkeit" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Gamespeed" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Velocidad del Juego"
         Delay(mydelay)
         gamespeed()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Einstellungen speichern" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Save Settings" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Guardar Configuracion"
         
         If save_settings()
            nachricht(486,#COLOR_WEISS)
         Else
            nachricht(487,#COLOR_ROT)
         EndIf
      EndIf
   

      If optionenliste(akt_option + akt_zauber_offset2+1) = "Vollbild/Fenster" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Fullscreen/Windowed" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Fullscreen/Ventana"
         fullscreen()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Joystick einschalten" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Enable Joystick" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Activar Joystick"
         joystick_used = 1
         If InitJoystick() = 0
         EndIf
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Keine Maus einschalten" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Enable No mouse" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Activar No raton"
         no_mouse = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Keine Maus ausschalten" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Disable No mouse" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Desactivar No raton"
         no_mouse = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Auto-Toggle : On" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Auto-Toggle : An" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Auto-Usar : Si"
         autopickup = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Auto-Toggle : Off" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Auto-Toggle : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Auto-Usar : No"
         autopickup = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Sounds : Off" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Sound : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Sonidos : No"
         sound = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Sounds : On" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Sound : Ein" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Sonidos : Si"
         sound = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Music : Off" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Musik : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Musica : No"
         music = 0         
         ; Hintergrundmusic aus
         If modules = 1
           StopModule()
         EndIf
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Music : On" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Musik : Ein" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Musica : Si"
         music = 1
         ; Hintergrundmusik ab
         If modules = 1
           PlayModule(#MOD_BALLADA)
         EndIf
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Klicking : Off" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Klicken : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Klickear : No"
         klicking = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Klicking : On" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Klicken : Ein" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Klickear : Si"
         klicking = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Laden" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Load" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Cargar"
         Delay(500)
         loading_screen()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Speichern" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Save" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Guardar"
         Delay(500)
         saving_screen()
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Bow = Button 5 : Off" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Bogen = Knopf 5 : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Arco = Buton 5 : No"
         knopf5 = 0
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Bow = Button 5 : On" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Bogen = Knopf 5 : An" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Arco = Buton 5 : Si"
         knopf5 = 1
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Jars : Off" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Flaschen : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Botellas : No"
         flaschen = 0
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1) = "Jars : On" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Flaschen : An" Or optionenliste(akt_option + akt_zauber_offset2+1) = "Botellas : Si"
         flaschen = 1
      EndIf
   EndIf

   ; Maus?
   If raushier = 1
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Spiel abbrechen" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Abort game" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Terminar Juego"
         Goto again
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Programm beenden" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Quit program" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Salir del Programa"
         CloseScreen()
         Aus()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Spielgeschwindigkeit" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Gamespeed" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Velocidad del Juego"
         Delay(mydelay)
         gamespeed()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Einstellungen speichern" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Save Settings" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Guardar Configuracion"
         
         If save_settings()
            nachricht(486,#COLOR_WEISS)
         Else
            nachricht(487,#COLOR_ROT)
         EndIf
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Vollbild/Fenster" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Fullscreen/Windowed" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Fullscreen/Ventana"
         fullscreen()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Joystick einschalten" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Enable Joystick" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Activar Joystick"
         no_mouse = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Keine Maus einschalten" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Enable No mouse" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Activar No raton"
         no_mouse = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Keine Maus ausschalten" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Disable No mouse" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Desactivar No Raton"
         joystick_only = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Auto-Toggle : Off" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Auto-Toggle : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Auto-Usar : No"
         autopickup = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Auto-Toggle : On" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Auto-Toggle : An" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Auto-Usar : Si"
         autopickup = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Sounds : Off" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Sound : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Sonidos : No"
         sound = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Sounds : On" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Sound : Ein" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Sonidos : Si"
         sound = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Music : Off" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Musik : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Musica : No"
         music = 0
         ; Hintergrundmusik aus
         If modules = 1
            CompilerSelect #PB_Compiler_OS
               CompilerCase #PB_OS_Windows 
                  StopModule()
               CompilerCase #PB_OS_Linux
            CompilerEndSelect
         EndIf
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Music : On" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Musik : Ein" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Musica : Si"
         music = 1
         ; Hintergrundmusik ab
         If modules = 1
           PlayModule(#MOD_BALLADA)
         EndIf
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Klicking : Off" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Klicken : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Klickear : No"
         klicking = 0
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Klicking : On" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Klicken : Ein" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Klickear : Si"
         klicking = 1
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Laden" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Load" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Cargar"
         Delay(500)
         loading_screen()
      EndIf
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Speichern" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Save" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Guardar"
         Delay(500)
         saving_screen()
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Bow = Button 5 : Off" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Bogen = Knopf 5 : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Arco = Buton 5 : No"
         knopf5 = 0
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Bow = Button 5 : On" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Bogen = Knopf 5 : An" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Arco = Buton 5 : Si"
         knopf5 = 1
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Jars : Off" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Flaschen : Aus" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Botellas : No"
         flaschen = 0
      EndIf
      
      If optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Jars : On" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Flaschen : An" Or optionenliste(akt_option + akt_zauber_offset2+1 + mauszauber - 14) = "Botellas : Si"
         flaschen = 1
      EndIf
   EndIf


EndProcedure

Procedure optionen2()

  Shared sprache, optionenliste, akt_spieler, frame, akt_option, akt_zauber_offset2, yplus, anzz
  Shared mauszauber, character_x, character_y, joystick_used, sound, music, klicking, autopickup
  Shared selectdelay, modules, mydelay, knopf5, no_mouse, flaschen

  ClearScreen(0)
  Repeat
    FlipBuffers()
    ClearScreen(0)
    fenster()
    ; Maus abfragen
    If no_mouse = 0
      result = ExamineMouse()
      mouse_x = MouseX()
      mouse_y = MouseY()
      mouse_linksold=mouse_links
      mouse_links  = MouseButton(1)
      If mouse_linksold=1 And mouse_links=0
        mouse_released=1
      Else
        mouse_released=0
      EndIf
      mouse_rechtsold=mouse_rechts
      mouse_rechts = MouseButton(2)
      If mouse_rechtsold=1 And mouse_rechts=0
        mouse_rechts_released=1
      Else
        mouse_rechts_released=0
      EndIf
    EndIf
    ; Tasten abfragen
    ;{
    ExamineKeyboard()
    If left_delay<1
      key_left=KeyboardPushed(#PB_Key_Left)
      If key_left And left_delay=0
        left_delay=10
      ElseIf key_left
        left_delay=40
      Else
        left_delay=-1
      EndIf
    Else
      left_delay-1
    EndIf

    If right_delay<1
      key_right=KeyboardPushed(#PB_Key_Right)
      If key_right And right_delay=0
        right_delay=10
      ElseIf key_right
        right_delay=40
      Else
        right_delay=-1
      EndIf
    Else
      right_delay-1
    EndIf

    If up_delay<1
      key_up=KeyboardPushed(#PB_Key_Up)
      If key_up And up_delay=0
        up_delay=10
      ElseIf key_up
        up_delay=40
      Else
        up_delay=-1
      EndIf
    Else
      up_delay-1
    EndIf

    If down_delay<1
      key_down=KeyboardPushed(#PB_Key_Down)
      If key_down And down_delay=0
        down_delay=10
      ElseIf key_down
        down_delay=40
      Else
        down_delay=-1
      EndIf
    Else
      down_delay-1
    EndIf

    ;}


    ; Rahmen zeichnen
    ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
    DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
    ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
    DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
    ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
    DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 464)
    ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
    DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 624, 0)
    ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 607, 17)
    DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 17, 400)

    StartDrawing(ScreenOutput())
    DrawingMode(1)
    If key_left
      DrawText(30,30,"Left",$00ffff)
    EndIf
    If key_right
      DrawText(30,30,"right",$00ffff)
    EndIf
    If key_up
      DrawText(30,30,"up",$00ffff)
    EndIf
    If key_down
      DrawText(30,30,"down",$00ffff)
    EndIf
    StopDrawing()

    If mouse_rechts_released
      quit=1
    ElseIf KeyboardReleased(#PB_Key_Space)
      quit=1
    EndIf

    key_left=0 : key_right=0 : key_up=0 : key_down=0
  Until quit

EndProcedure

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1852
; FirstLine = 1849
; Folding = ---
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger