Procedure screen1(i.w)

Shared akt_spieler, xmod, ymod, frame

   ClearScreen(RGB(0,0,0))
   draw_screen(xmod*i*(-1) , ymod*i*(-1))  ; Alles ausser Mauern + Schaetze + Monster
   okay.w = 0
   
   ; before
   If skills(#CE_ERDE_SPUEHREN,akt_spieler)\gewaehlt = 0
      draw_screen3(xmod*i*(-1) , ymod*i*(-1)) ; Wall
   EndIf
   If skills(#CE_SCHATZJAEGER,akt_spieler)\gewaehlt = 0
      draw_screen4(xmod*i*(-1) , ymod*i*(-1)) ; Treasure
   EndIf
   If skills(#CE_MONSTER_SPUEHREN,akt_spieler)\gewaehlt = 0
      draw_screen7(xmod*i*(-1) , ymod*i*(-1)) ; Monster
   EndIf
   
   show_sight()
      
   ; after
   If skills(#CE_ERDE_SPUEHREN,akt_spieler)\gewaehlt = 1
      draw_screen3(xmod*i*(-1) , ymod*i*(-1)) ; Wall
   EndIf
   If skills(#CE_SCHATZJAEGER,akt_spieler)\gewaehlt = 1
      draw_screen4(xmod*i*(-1) , ymod*i*(-1)) ; Treasure
   EndIf
   If skills(#CE_MONSTER_SPUEHREN,akt_spieler)\gewaehlt = 1
      draw_screen7(xmod*i*(-1) , ymod*i*(-1)) ; Monster
   EndIf
   
   draw_character(spieler(akt_spieler)\face, frame,0)
   laby_rahmen()
   show_logo()
   show_varys()
   show_buttons()
   show_schnellinventory()

EndProcedure


Procedure screen2()

Shared akt_spieler, xmod, ymod, frame

   ClearScreen(RGB(0,0,0))
   okay.w = 0
   draw_screen(0,0)  ; Alles ausser Mauern + Schaetze + Monster
   
   ; vorher
   If skills(#CE_ERDE_SPUEHREN,akt_spieler)\gewaehlt = 0
      draw_screen3(0,0) ; Mauern
   EndIf
   If skills(#CE_SCHATZJAEGER,akt_spieler)\gewaehlt = 0
      draw_screen4(0,0) ; Schaetze
   EndIf
   If skills(#CE_MONSTER_SPUEHREN,akt_spieler)\gewaehlt = 0
      draw_screen7(0,0) ; Monster
   EndIf
   
   show_sight()
      
   ; nachher
   If skills(#CE_ERDE_SPUEHREN,akt_spieler)\gewaehlt = 1
      draw_screen3(0,0) ; Mauern
   EndIf
   If skills(#CE_SCHATZJAEGER,akt_spieler)\gewaehlt = 1
      draw_screen4(0,0) ; Schaetze
   EndIf
   If skills(#CE_MONSTER_SPUEHREN,akt_spieler)\gewaehlt = 1
      draw_screen7(0,0) ; Monster
   EndIf
   
   draw_character(spieler(akt_spieler)\face, frame,0)
   laby_rahmen()
   show_logo()
   show_varys()
   show_buttons()
   show_schnellinventory()

EndProcedure


; Prozedur zum Zeichnen eines einzelnen Tile (fuer Karten)
Procedure draw_small_tile(nr.w, x.w, y.w, offset_x.b, offset_y.b)

; Bei Erde spueren nur Mauern. Bei Karte Mauern/Ausgang/Eingang. Bei Sternensicht alles ausser Objekte.
; Bei Sanktum/Nexus spuehren nur Mauern und diese Felder

   Shared sprite_x, sprite_y, schriftrolle, karten_typ, akt_spieler

   zw.w
   
  ; Hidden Treasure etc anders darstellen
   If nr = #FELD_VERBORGENER_SCHATZ Or (nr >= #FELD_SPEERFALLE1 And nr <= #FELD_SPEERFALLE1+8)
      nr = inhalt(spieler(akt_spieler)\level)
   EndIf
   If nr = #FELD_GEHEIMGANG
      nr = mit_was(spieler(akt_spieler)\level)
   EndIf
  
  If  nr = #FELD_AUSGANG And karten_typ = 5
     sprite_x.w = #FELD_AUSGANG
     sprite_y.w = 0
     ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, sprite_x*16, sprite_y*16, 16, 16)
     DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)
  EndIf

  ; Teleporter statt Treppen?
  XIncludeFile ("teleporter.pbi")
  
   sprite_x.w = nr
   sprite_y.w = 0
   If sprite_x > 10
      Repeat
         sprite_y = sprite_y + 1
         sprite_x = sprite_x - 10
      Until sprite_x < 11
   EndIf
   If sprite_x = 10
      sprite_x = 0
      sprite_y = sprite_y + 1
   EndIf

   ; Nur Mauern anzeigen
   If nr = #FELD_MAUER 
     ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, sprite_x*16, sprite_y*16, 16, 16)
     DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)
  EndIf
  ; Normale Felder
  If nr <= #ANZ_FELDER And (karten_typ = 2 Or schriftrolle = 1)   
     ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, sprite_x*16, sprite_y*16, 16, 16)
     DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)
  EndIf
  ; Monster
  If (karten_typ = 2 And nr > #ANZ_FELDER And nr <= #ANZ_FELDER+#ANZ_MONSTER) 
      zw = nr - #ANZ_FELDER
      sprite_x.w = zw
      sprite_y.w = 0
      If sprite_x > 10
         Repeat
            sprite_y = sprite_y + 1
            sprite_x = sprite_x - 10
         Until sprite_x < 11
      EndIf
      
      ; Erst Gang
      ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, 64, 0, 16, 16)
      DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)  
      
      ; Dann Monster
      akt_monster.w = 0
      For i = 1 To #ANZ_MONSTER
         If monster(i)\nr = nr - #ANZ_FELDER
            akt_monster = i
         EndIf
      Next
      ; Unsichtbar?
      If hat_eigenschaft2(akt_monster,#ME_UNSICHTBAR) = 0
         ClipSprite(#SPRITE_TILESET_SMALLMONSTER, sprite_x*16-16, sprite_y*16, 16, 16)
         DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTER, x*16+offset_x, y*16+offset_y)  
      EndIf
  EndIf
  If  nr = #FELD_NEXUS And karten_typ = 3
     sprite_x.w = #FELD_NEXUS
     sprite_y.w = 0
     ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, sprite_x*16, sprite_y*16, 16, 16)
     DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)
  EndIf
  If  nr = #FELD_SANKTUM And karten_typ = 4
     sprite_x.w = #FELD_SANKTUM
     sprite_y.w = 0
     ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, sprite_x*16, sprite_y*16, 16, 16)
     DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)
  EndIf


EndProcedure

; ---------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Charakters
Procedure draw_character(face.b, frame.b, offset.w)
  Shared spieler, akt_spieler
  uebermalen.w = 0
  
  If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, face*32*2+frame*32, 1*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
    uebermalen = 1
  ElseIf habich(#SPELL_FLEDERMAUSGESTALT)
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, face*32*2+frame*32, 5*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ;    uebermalen = 1
  ElseIf habich(#SPELL_WOLFSGESTALT)
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, face*32*2+frame*32, 3*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
    uebermalen = 1
  ElseIf habich(#SPELL_VOGELGESTALT)
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, face*32*2+frame*32, 4*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ;   uebermalen = 1
  ElseIf habich(#SPELL_KATZENGESTALT) 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, face*32*2+frame*32, 2*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
    uebermalen = 1
  ElseIf habich(#SPELL_DRACHENGESTALT)
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, face*32*2+frame*32, 6*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
    uebermalen = 1
  Else  ; Normales aussehen
    ClipSprite(#SPRITE_TILESET_CHARACTER, face*32*2+frame*32, spieler(akt_spieler)\maennchen*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 5*32, 5*32+offset)
    uebermalen = 1
  EndIf
  
  If uebermalen = 1
      testfeld.w = labyrinth(spieler(akt_spieler)\character_x, spieler(akt_spieler)\character_y)\feld[spieler(akt_spieler)\level]
      If testfeld = #FELD_WASSER Or testfeld = #FELD_WASSER_TRUHE Or testfeld = #FELD_WASSER_SKELETT Or testfeld = #FELD_WASSER_GOLDSACK Or testfeld = #FELD_WASSER_GRUENE_TRUHE
         ClipSprite(#SPRITE_TILESET_LABYRINTH, 6*32, 7*32, 32, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_LABYRINTH, 5*32, 5*32+offset)
      EndIf
  EndIf
EndProcedure


; ---------------------------------------------------------------------------------------

; Prozedur zum Zeichnen der Kreatur
Procedure draw_creature(frame.b, offset.w)
  Shared spieler, akt_spieler
  
  ; Homunkulus
  If spieler(akt_spieler)\creature_typ = 1 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 9*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Skelett
  ElseIf spieler(akt_spieler)\creature_typ = 2 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 7*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Todesritter
  ElseIf spieler(akt_spieler)\creature_typ = 3 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 12*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Sternenfee
  ElseIf spieler(akt_spieler)\creature_typ = 4 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 13*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Tiger
  ElseIf spieler(akt_spieler)\creature_typ = 5
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 14*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Mumie
  ElseIf spieler(akt_spieler)\creature_typ = 6 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 11*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Daemon
  ElseIf spieler(akt_spieler)\creature_typ = 7 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 8*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Engel
  ElseIf spieler(akt_spieler)\creature_typ = 8 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 10*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Drache
  ElseIf spieler(akt_spieler)\creature_typ = 9 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 6*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Doppelgaenger
  ElseIf spieler(akt_spieler)\creature_typ = 10 
    ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(akt_spieler)\creature_heading*32*2+frame*32, spieler(akt_spieler)\maennchen*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 5*32, 5*32+offset)
  ; Bird
  ElseIf spieler(akt_spieler)\creature_typ = 11 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 4*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Golem
  ElseIf spieler(akt_spieler)\creature_typ = 12 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 16*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Satyr
  ElseIf spieler(akt_spieler)\creature_typ = 13
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 17*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Feuerelementar
  ElseIf spieler(akt_spieler)\creature_typ = 14
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 18*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Wasserelementar
  ElseIf spieler(akt_spieler)\creature_typ = 15 
    ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(akt_spieler)\creature_heading*32*2+frame*32, 19*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, 5*32, 5*32+offset)
  ; Gefaehrte
  ElseIf spieler(akt_spieler)\creature_typ = 20 
    ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(akt_spieler)\creature_heading*32*2+frame*32, 20*32-32, 32, 32)
    DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 5*32, 5*32+offset)
  EndIf
EndProcedure

; --------------------------------------------------------------------------------------

Procedure draw_monster(x.w, y.w, nr.w, offset_x.w, offset_y.w)

Shared akt_spieler

   zw.w = nr
   zw = zw - #ANZ_FELDER
   sprite_x.w = zw
   sprite_y.w = 0
   If sprite_x > 10
      Repeat
         sprite_y = sprite_y + 1
         sprite_x = sprite_x - 10
      Until sprite_x < 11
   EndIf

   ClipSprite(#SPRITE_TILESET_MONSTER, sprite_x*32-32, sprite_y*32, 32, 32)  ; Dann Monster
   DisplayTransparentSprite(#SPRITE_TILESET_MONSTER, x*32+offset_x, y*32+offset_y)
   
   testfeld.w = labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\status[spieler(akt_spieler)\Level]
   If testfeld = #MONSTERSTATUS_ALERT
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 0, 0, 8, 9)  ; Alert
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld = #MONSTERSTATUS_SCHLAEFT
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 8, 0, 8, 9)  ; Sleeping
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld = #MONSTERSTATUS_FREUND
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 16, 0, 8, 9)  ; Friend
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld >= #MONSTERSTATUS_VERGIFTET And testfeld < #MONSTERSTATUS_BLIND
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 24, 0, 8, 9)  ; Poisoned
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld >= #MONSTERSTATUS_BLIND And testfeld < #MONSTERSTATUS_SCHWARM
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 32, 0, 8, 9)  ; Blind
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld >= #MONSTERSTATUS_SCHWARM
      ClipSprite(#SPRITE_TILESET_FX, 0, 14*32, 32, 32)  ; Swarmed
      DisplayTransparentSprite(#SPRITE_TILESET_FX, x*32+offset_x, y*32+offset_y)
   EndIf
      
EndProcedure


; Fuer Kreaturen
Procedure draw_monster2(x.w, y.w, nr.w, offset_x.w, offset_y.w)

Shared akt_spieler

   zw.w = nr
   zw = zw - #ANZ_FELDER
   sprite_x.w = zw
   sprite_y.w = 0
   If sprite_x > 10
      Repeat
         sprite_y = sprite_y + 1
         sprite_x = sprite_x - 10
      Until sprite_x < 11
   EndIf

   ClipSprite(#SPRITE_TILESET_MONSTER, sprite_x*32-32, sprite_y*32, 32, 32)  ; Then Monster
   DisplayTransparentSprite(#SPRITE_TILESET_MONSTER, x*32+offset_x, y*32+offset_y)
   
   testfeld.w = labyrinth(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y)\status[spieler(akt_spieler)\Level]
   If testfeld = #MONSTERSTATUS_ALERT
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 0, 0, 8, 9)  ; Alert
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld = #MONSTERSTATUS_SCHLAEFT
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 8, 0, 8, 9)  ; Sleeping
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld = #MONSTERSTATUS_FREUND
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 16, 0, 8, 9)  ; Friend
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld >= #MONSTERSTATUS_VERGIFTET And testfeld < #MONSTERSTATUS_BLIND
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 24, 0, 8, 9)  ; Poisoned
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld >= #MONSTERSTATUS_BLIND And testfeld < #MONSTERSTATUS_SCHWARM
      ClipSprite(#SPRITE_TILESET_MONSTERSTATUS, 32, 0, 8, 9)  ; Blind
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTERSTATUS, x*32+offset_x+23, y*32+offset_y)
   ElseIf testfeld >= #MONSTERSTATUS_SCHWARM
      ClipSprite(#SPRITE_TILESET_FX, 0, 14*32, 32, 32)  ; Swarmed
      DisplayTransparentSprite(#SPRITE_TILESET_FX, x*32+offset_x, y*32+offset_y)
   EndIf
      
EndProcedure


; Prozedur zum Zeichnen eines einzelnen Tile
Procedure draw_tile(nr.w, x.w, y.w, offset_x.b, offset_y.b)

Shared akt_spieler, test

zw.w
     inhalt_x.w = inhalt(spieler(akt_spieler)\level)
     inhalt_y.w = 0
     If inhalt_x > 10
        Repeat
           inhalt_y = inhalt_y + 1
           inhalt_x = inhalt_x - 10
        Until inhalt_x < 11
     EndIf
     If inhalt_x = 10
        inhalt_x = 0
        inhalt_y = inhalt_y + 1
     EndIf
     
  ; Hidden Treasure etc anders darstellen
   If nr = #FELD_VERBORGENER_SCHATZ Or (nr >= #FELD_SPEERFALLE1 And nr <= #FELD_SPEERFALLE1+8)
      nr = inhalt(spieler(akt_spieler)\level)
   EndIf
   If nr = #FELD_GEHEIMGANG
      nr = mit_was(spieler(akt_spieler)\level)
   EndIf

  ; Teleporter instead of stairs?
  XIncludeFile ("teleporter.pbi")
     
  ; Normal field
  If nr <= #ANZ_FELDER
     
     ; Background first 
     ClipSprite(#SPRITE_TILESET_LABYRINTH, inhalt_x*32, inhalt_y*32, 32, 32)
     DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
     
     sprite_x.w = nr
     sprite_y.w = 0
     If sprite_x > 10
        Repeat
           sprite_y = sprite_y + 1
           sprite_x = sprite_x - 10
        Until sprite_x < 11
     EndIf
     If sprite_x = 10
        sprite_x = 0
        sprite_y = sprite_y + 1
     EndIf
     ClipSprite(#SPRITE_TILESET_LABYRINTH, sprite_x*32, sprite_y*32, 32, 32)
     DisplayTransparentSprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
  EndIf
  
   If nr = #FELD_GOLD
     ; First Content
     ClipSprite(#SPRITE_TILESET_LABYRINTH, inhalt_x*32, inhalt_y*32, 32, 32)
     DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
     ; Then goldbag
     ClipSprite(#SPRITE_TILESET_LABYRINTH, 288, 0, 32, 32)
     DisplayTransparentSprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
  EndIf
  
  If nr > #ANZ_FELDER And nr <= #ANZ_FELDER+#ANZ_MONSTER   ; Monster
      akt_monster.w = 0
      For i = 1 To #ANZ_MONSTER
         If monster(i)\nr = nr - #ANZ_FELDER
            akt_monster = i
         EndIf
      Next
      ; Watermonster?
      If hat_eigenschaft2(akt_monster,#ME_WASSER) = 1
         ; Water
         ClipSprite(#SPRITE_TILESET_LABYRINTH, 64, 224, 32, 32)
         DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
      Else 
         ; Inhalt
         ClipSprite(#SPRITE_TILESET_LABYRINTH, inhalt_x*32, inhalt_y*32, 32, 32)
         DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
      EndIf
      ; Invisible?
      If habich(#SPELL_UNSICHTBARES_SEHEN) > 0 Or habich(#SPELL_GEISTERTANZ)
         akt_monster = 0
      EndIf
      If akt_monster > 0 And hat_eigenschaft2(akt_monster,#ME_UNSICHTBAR) = 1
         ; Nichts anzeigen!
      Else
         draw_monster(x, y, nr, offset_x, offset_y)
      EndIf
  EndIf
  
  If nr > #ANZ_FELDER+#ANZ_MONSTER  ; Object
     ClipSprite(#SPRITE_TILESET_LABYRINTH, inhalt_x*32, inhalt_y*32, 32, 32)  ; Content
     DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
     
     ; Pilze nicht mit Unaufmerksam
     If skills(#CE_UNAUFMERKSAM, akt_spieler)\gewaehlt = 1 And nr >= #ANZ_FELDER+#ANZ_MONSTER+#OBJGRAFIK_PILZE_SCHWARZ And nr <= #ANZ_FELDER+#ANZ_MONSTER+#OBJGRAFIK_PILZE_SCHWARZ+#ANZ_PILZE
         ; nichts
     Else
         ; Item zeichnen
         sprite_x.w = nr - (#ANZ_FELDER+#ANZ_MONSTER)
         sprite_y.w = 0
         If sprite_x > 16
            Repeat
               sprite_y = sprite_y + 1
               sprite_x = sprite_x - 16
            Until sprite_x < 17
         EndIf
         
         ClipSprite(#SPRITE_TILESET_ITEMS, sprite_x * 32-32, sprite_y * 32, 32, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, x*32+offset_x, y*32+offset_y)
     EndIf
  EndIf


EndProcedure

; --------------------------------------------------------------------------------------
; Spieler
Procedure kopiere_matrix()

Shared akt_spieler
   
   ; In neuen Bereich kopieren 
   For y = -1 To 11
      For x = -1 To 11
         If spieler(akt_spieler)\character_x-5+x > 0 And spieler(akt_spieler)\character_y-5+y > 0
            If blockiert(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y) = 0
               matrix(x+1,y+1) = #CLOSED
            Else
               matrix(x+1,y+1) = #OPEN
            EndIf
         EndIf
      Next
   Next

EndProcedure

; Kreaturen
Procedure kopiere_matrix2()

Shared akt_spieler
   
   ; In neuen Bereich kopieren 
   For y = -1 To 11
      For x = -1 To 11
         If spieler(akt_spieler)\creature_x-5+x > 0 And spieler(akt_spieler)\creature_y-5+y > 0
            If blockiert(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y) = 0
               matrix(x+1,y+1) = #CLOSED
            Else
               matrix(x+1,y+1) = #OPEN
            EndIf
         EndIf
      Next
   Next

EndProcedure


Procedure erstelle_matrix(wer.w)

Shared akt_spieler, xmod, ymod

  If sonderlevel(spieler(akt_spieler)\level) = #SL_WUESTE Or sonderlevel(spieler(akt_spieler)\level) = #SL_ZENTAUERWALD Or sonderlevel(spieler(akt_spieler)\level) = #SL_SUMPF Or habich(#SPELL_LICHT) = #UNENDLICH
      For x.b = 1 To 12
         For y.b = 1 To 12
            matrix(x,y) = 1
         Next
      Next
  Else
   For x.b = 1 To 12
      For y.b = 1 To 12
         matrix(x,y) = #OPEN
      Next
   Next
   
   If wer = 1
      radius.w = radius()
      kopiere_matrix()
   Else
      radius.w = radius2()
      kopiere_matrix2()
   EndIf
      
   ; Startfeld setzen
   matrix(6,6) = 1
   
   For i = 1 To radius
      For x = 6 - radius To 6 + radius
         For y = 6 - radius To 6 + radius
            If x > 0 And y > 0
               If matrix(x,y) = #CLOSED
                  If matrix(x-1,y) < #CLOSED And x-1 > 0
                     matrix(x,y) = matrix(x-1,y) + 1
                  EndIf
                  If matrix(x+1,y) < #CLOSED And x+1 <= 12
                     matrix(x,y) = matrix(x+1,y) + 1
                  EndIf
                  If matrix(x,y-1) < #CLOSED And y-1 > 0
                     matrix(x,y) = matrix(x,y-1) + 1
                  EndIf
                  If matrix(x,y+1) < #CLOSED And y+1 <= 12
                     matrix(x,y) = matrix(x,y+1) + 1
                  EndIf
               EndIf
            EndIf
         Next
      Next
   Next
   
      ; Alles was Verbindung zum Licht hat einschalten
      For x = 1 To 12
         For y = 1 To 12
            matrix2(x,y) = 0   
         Next
      Next
      
      For x = 1 To 12
         For y = 1 To 12
            einschalten.w = 0
            If x-1 > 0
               If matrix(x-1,y) <= radius
                  einschalten = 1
               EndIf
            EndIf
            If x+1 <= 12
               If matrix(x+1,y) <= radius
                  einschalten = 1
               EndIf
            EndIf
            If y-1 > 0
               If matrix(x,y-1) <= radius
                  einschalten = 1
               EndIf
            EndIf
            If y+1 <= 12
               If matrix(x,y+1) <= radius
                  einschalten = 1
               EndIf
            EndIf
            
            If matrix(x+1,y+1) <= radius
               einschalten = 1
            EndIf
            
            If x-1 > 0
               If matrix(x-1,y+1) <= radius
                  einschalten = 1
               EndIf
            EndIf
            
            If y-1 > 0
               If matrix(x+1,y-1) <= radius
                  einschalten = 1
               EndIf
            EndIf
            
            If x-1 > 0 And y-1 > 0
               If matrix(x-1,y-1) <= radius
                  einschalten = 1
               EndIf
            EndIf
            
            If einschalten = 1
               matrix2(x,y) = 1
            EndIf
         Next
      Next
      
      For x = 1 To 12
         For y = 1 To 12
            If matrix2(x,y) = 1
               matrix(x,y) = radius
            EndIf   
         Next
      Next
      
      For x = -1 To 11
         For y = -1 To 11
            If spieler(akt_spieler)\character_x-5+x > 0 And spieler(akt_spieler)\character_y-5+y > 0 
               testfeld.w = labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level]
               If skills(#CE_ERDE_SPUEHREN, akt_spieler)\gewaehlt = 1
                  If testfeld = #FELD_MAUER Or testfeld = #FELD_GEHEIMGANG
                      matrix(x+1,y+1) = radius
                  EndIf
               EndIf 
            
               If skills(#CE_SCHATZJAEGER, akt_spieler)\gewaehlt = 1
                  If testfeld = #FELD_GOLD Or testfeld = #FELD_GRUENETRUHE1 Or testfeld = #FELD_GRUENETRUHE2 Or testfeld = #FELD_VERBORGENER_SCHATZ Or testfeld = #FELD_TRUHE Or testfeld = #FELD_SKELETT2 Or testfeld = #FELD_VERBORGENER_SCHATZ2
                      matrix(x+1,y+1) = radius
                  EndIf
               EndIf 
            
               If skills(#CE_MONSTER_SPUEHREN, akt_spieler)\gewaehlt = 1
                  If istmonster(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y) = 1
                      matrix(x+1,y+1) = radius
                  EndIf
               EndIf 
            EndIf
         Next
      Next
      
   EndIf ; outdoor level?

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms
; Alles ausser Kisten, Gold, Mauern und Monsters
Procedure draw_screen(x_offset.b, y_offset.b)

Shared akt_spieler, frame, anz_spieler
 
  erstelle_matrix(1)
  radius.w = radius()
  
  For y = -1 To 11
    For x = -1 To 11
      If spieler(akt_spieler)\character_x-5+x > 0 And spieler(akt_spieler)\character_y-5+y > 0 And matrix(x+1,y+1) <= radius
         testfeld.w = labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level]
         If testfeld <> #FELD_MAUER And testfeld <> #FELD_GEHEIMGANG And testfeld <> #FELD_GOLD And testfeld <> #FELD_GRUENETRUHE1 And testfeld <> #FELD_GRUENETRUHE2 And testfeld <>  #FELD_VERBORGENER_SCHATZ And testfeld <> #FELD_TRUHE And testfeld <> #FELD_SKELETT2 And testfeld <> #FELD_VERBORGENER_SCHATZ2 And (testfeld <= #ANZ_FELDER Or testfeld > #ANZ_FELDER+#ANZ_MONSTER)
         
            draw_tile(labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)
         EndIf

         ; Charactere darstellen
         For xx = 1 To anz_spieler
            If xx <> akt_spieler
               If spieler(akt_spieler)\character_x-5+x = spieler(xx)\character_x And spieler(akt_spieler)\character_y-5+y = spieler(xx)\character_y
                  If spieler(xx)\Status = 1 And spieler(xx)\Level = spieler(akt_spieler)\Level
                     
                     okay = 0
                     uebermalen = 0
                     If spieler(xx)\fluch = #FLUCH_CHICKEN And okay = 0
                        uebermalen = 1
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 1*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     If hater(#SPELL_FLEDERMAUSGESTALT,xx) And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 5*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     If hater(#SPELL_WOLFSGESTALT,xx) And okay = 0
                        uebermalen = 1
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 3*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     If hater(#SPELL_VOGELGESTALT,xx) And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 4*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     If hater(#SPELL_KATZENGESTALT,xx) And okay = 0
                        uebermalen = 1
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 2*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     If hater(#SPELL_DRACHENGESTALT,xx) And okay = 0
                        uebermalen = 1
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 6*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     
                     ; Normales aussehen
                     If okay = 0
                        uebermalen = 1
                        ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(xx)\face*32*2, spieler(xx)\maennchen*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, x*32+x_offset, y*32+y_offset)
                     EndIf
                     
                     If uebermalen = 1
                        testfeld.w = labyrinth(spieler(xx)\character_x, spieler(xx)\character_y)\feld[spieler(akt_spieler)\level]
                        If testfeld = #FELD_WASSER Or testfeld = #FELD_WASSER_TRUHE Or testfeld = #FELD_WASSER_SKELETT Or testfeld = #FELD_WASSER_GOLDSACK Or testfeld = #FELD_WASSER_GRUENE_TRUHE
                           ClipSprite(#SPRITE_TILESET_LABYRINTH, 6*32, 7*32, 32, 32)
                           DisplayTransparentSprite(#SPRITE_TILESET_LABYRINTH, x*32+x_offset, y*32+y_offset)
                        EndIf
                     EndIf
                     
                  EndIf
               EndIf
            EndIf
         Next
         
         ; Display Creatures
         For xx = 1 To anz_spieler
            If spieler(xx)\creature_typ > 0
               If spieler(akt_spieler)\character_x-5+x = spieler(xx)\creature_x And spieler(akt_spieler)\character_y-5+y = spieler(xx)\creature_y
                  okay = 0
                  If spieler(xx)\Status = 1 And spieler(xx)\Level = spieler(akt_spieler)\Level
                     ; Homunkulus
                     If spieler(xx)\creature_typ = 1 And okay = 0 
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 9*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Skelett
                     If spieler(xx)\creature_typ = 2 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 7*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Todesritter
                     If spieler(xx)\creature_typ = 3 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 12*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Sternenfee
                     If spieler(xx)\creature_typ = 4 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 13*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Tiger
                     If spieler(xx)\creature_typ = 5 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 14*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Mumie
                     If spieler(xx)\creature_typ = 6 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 11*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Daemon
                     If spieler(xx)\creature_typ = 7 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 8*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Engel
                     If spieler(xx)\creature_typ = 8 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 10*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Drache
                     If spieler(xx)\creature_typ = 9 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 6*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Doppelgaenger
                     If spieler(xx)\creature_typ = 10 And okay = 0
                        ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(xx)\creature_heading*32*2, spieler(xx)\maennchen*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Bird
                     If spieler(xx)\creature_typ = 11 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 4*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Golem
                     If spieler(xx)\creature_typ = 12 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 16*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Satyr
                     If spieler(xx)\creature_typ = 13 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 17*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Feuerelementar
                     If spieler(xx)\creature_typ = 14 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 18*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Wasserelementar
                     If spieler(xx)\creature_typ = 15 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 19*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Gefaehrte
                     If spieler(xx)\creature_typ = 20 And okay = 0
                        ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(xx)\creature_heading*32*2, 20*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                  EndIf ; Gleicher Level?
               EndIf
            EndIf
         Next
      EndIf
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms für Kreaturen
Procedure draw_screen2(x_offset.b, y_offset.b)

  Shared akt_spieler, frame, anz_spieler
  
  erstelle_matrix(2)
  radius.w = radius2()
  
  For y.b = -1 To 11
    For x.b = -1 To 11
      If spieler(akt_spieler)\creature_x-5+x > 0 And spieler(akt_spieler)\creature_y-5+y > 0 And matrix(x+1,y+1) <= radius
         testfeld.w = labyrinth(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y)\feld[spieler(akt_spieler)\Level]
         If testfeld <> #FELD_MAUER And testfeld <> #FELD_GEHEIMGANG And testfeld <> #FELD_GOLD And testfeld <> #FELD_GRUENETRUHE1 And testfeld <> #FELD_GRUENETRUHE2 And testfeld <>  #FELD_VERBORGENER_SCHATZ And testfeld <> #FELD_TRUHE And testfeld <> #FELD_SKELETT2 And testfeld <> #FELD_VERBORGENER_SCHATZ2
            draw_tile(labyrinth(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)
         EndIf
         
         ; Charactere darstellen
         For xx = 1 To anz_spieler
            If spieler(akt_spieler)\creature_x-5+x = spieler(xx)\character_x And spieler(akt_spieler)\creature_y-5+y = spieler(xx)\character_y
               If spieler(xx)\Status = 1 And spieler(xx)\Level = spieler(akt_spieler)\Level
                  
                  okay = 0
                  uebermalen = 0
                  If spieler(xx)\fluch = #FLUCH_CHICKEN And okay = 0
                     uebermalen = 1
                     ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 1*32-32, 32, 32)
                     DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                     okay = 1
                  EndIf
                  If hater(#SPELL_FLEDERMAUSGESTALT,xx) And okay = 0
                     ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 5*32-32, 32, 32)
                     DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                     okay = 1
                  EndIf
                  If hater(#SPELL_WOLFSGESTALT,xx) And okay = 0
                     uebermalen = 1
                     ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 3*32-32, 32, 32)
                     DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                     okay = 1
                  EndIf
                  If hater(#SPELL_VOGELGESTALT,xx) And okay = 0
                     ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 4*32-32, 32, 32)
                     DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                     okay = 1
                  EndIf
                  If hater(#SPELL_KATZENGESTALT,xx) And okay = 0
                     uebermalen = 1
                     ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 2*32-32, 32, 32)
                     DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                     okay = 1
                  EndIf
                  If hater(#SPELL_DRACHENGESTALT,xx) And okay = 0
                     uebermalen = 1
                     ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\face*32*2, 6*32-32, 32, 32)
                     DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                     okay = 1
                  EndIf
                  
                  ; Normales aussehen
                  If okay = 0
                     uebermalen = 1
                     ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(xx)\face*32*2, spieler(xx)\maennchen*32-32, 32, 32)
                     DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, x*32+x_offset, y*32+y_offset)
                  EndIf
                  
                  If uebermalen = 1
                     testfeld.w = labyrinth(spieler(xx)\character_x, spieler(xx)\character_y)\feld[spieler(akt_spieler)\level]
                     If testfeld = #FELD_WASSER Or testfeld = #FELD_WASSER_TRUHE Or testfeld = #FELD_WASSER_SKELETT Or testfeld = #FELD_WASSER_GOLDSACK Or testfeld = #FELD_WASSER_GRUENE_TRUHE
                        ClipSprite(#SPRITE_TILESET_LABYRINTH, 6*32, 7*32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_LABYRINTH, x*32+x_offset, y*32+y_offset)
                     EndIf
                  EndIf
                  
               EndIf
            EndIf
         Next
         
         ; Creaturen darstellen
         For xx = 1 To anz_spieler
            If spieler(xx)\creature_typ > 0 And akt_spieler <> xx
               If spieler(akt_spieler)\creature_x-5+x = spieler(xx)\creature_x And spieler(akt_spieler)\creature_y-5+y = spieler(xx)\creature_y
                  If spieler(xx)\Status = 1 And spieler(xx)\Level = spieler(akt_spieler)\Level
                     
                     okay = 0
                     ; Homunkulus
                     If spieler(xx)\creature_typ = 1 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 9*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Skelett
                     If spieler(xx)\creature_typ = 2 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 7*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Todesritter
                     If spieler(xx)\creature_typ = 3 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 12*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Sternenfee
                     If spieler(xx)\creature_typ = 4 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 13*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Tiger
                     If spieler(xx)\creature_typ = 5 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 14*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Mumie
                     If spieler(xx)\creature_typ = 6 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 11*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Daemon
                     If spieler(xx)\creature_typ = 7 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 8*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Engel
                     If spieler(xx)\creature_typ = 8 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 10*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Drache
                     If spieler(xx)\creature_typ = 9 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 6*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Doppelgaenger
                     If spieler(xx)\creature_typ = 10 And okay = 0
                        ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(xx)\creature_heading*32*2, spieler(xx)\maennchen*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Bird
                     If spieler(xx)\creature_typ = 11 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 4*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Golem
                     If spieler(xx)\creature_typ = 12 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 16*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Satyr
                     If spieler(xx)\creature_typ = 13 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 17*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Fireelemental
                     If spieler(xx)\creature_typ = 14 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 18*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Waterelemental
                     If spieler(xx)\creature_typ = 15 And okay = 0
                        ClipSprite(#SPRITE_TILESET_MONSTERANIM, spieler(xx)\creature_heading*32*2, 19*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_MONSTERANIM, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                     ; Gefaehrte
                     If spieler(xx)\creature_typ = 20 And okay = 0
                        ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(xx)\creature_heading*32*2, 20*32-32, 32, 32)
                        DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, x*32+x_offset, y*32+y_offset)
                        okay = 1
                     EndIf
                  EndIf  
               EndIf
            EndIf
         Next
      EndIf
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms
; Nur Mauern
Procedure draw_screen3(x_offset.b, y_offset.b)

  Shared akt_spieler, frame
  
  radius.w = radius()
   
  For y.b = -1 To 11
    For x.b = -1 To 11 
      If matrix(x+1,y+1) <= radius
         If spieler(akt_spieler)\character_x-5+x < 1 Or spieler(akt_spieler)\character_y-5+y < 1
            draw_tile(mit_was(spieler(akt_spieler)\level), x, y, x_offset, y_offset)   ; Mauer
         Else
            testfeld.w = labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level]
            If testfeld = mit_was(spieler(akt_spieler)\level) Or testfeld = #FELD_GEHEIMGANG
               draw_tile(labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)
            EndIf
         EndIf
      EndIf
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms
; Nur Schaetze
Procedure draw_screen4(x_offset.b, y_offset.b)

  Shared akt_spieler, frame
  
  radius.w = radius()
  
  For y.b = -1 To 11
    For x.b = -1 To 11
       If spieler(akt_spieler)\character_x-5+x > 0 And spieler(akt_spieler)\character_y-5+y > 0 And matrix(x+1,y+1) <= radius
          testfeld.w = labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level]
            If testfeld = #FELD_GOLD Or testfeld = #FELD_GRUENETRUHE1 Or testfeld = #FELD_GRUENETRUHE2 Or testfeld = #FELD_TRUHE Or testfeld = #FELD_VERBORGENER_SCHATZ Or testfeld = #FELD_SKELETT2 Or testfeld = #FELD_VERBORGENER_SCHATZ2
               If testfeld = #FELD_VERBORGENER_SCHATZ And skills(#CE_SCHATZJAEGER,akt_spieler)\gewaehlt = 1
                  setlaby(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y,spieler(akt_spieler)\level,#FELD_VERBORGENER_SCHATZ2,0,0,0)
               EndIf
               draw_tile(labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)
            EndIf
       EndIf
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms
; Fuer Kreaturen
; Nur Mauern
Procedure draw_screen5(x_offset.b, y_offset.b)

Shared akt_spieler, frame
  
  radius.w = radius2()
  
  For y.b = -1 To 11
    For x.b = -1 To 11
      If matrix(x+1,y+1) <= radius
         If spieler(akt_spieler)\creature_x-5+x < 1 Or spieler(akt_spieler)\creature_y-5+y < 1
            draw_tile(mit_was(spieler(akt_spieler)\level), x, y, x_offset, y_offset)   ; Mauer
         Else
            testfeld.w = labyrinth(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y)\feld[spieler(akt_spieler)\Level]
            If testfeld = mit_was(spieler(akt_spieler)\level) Or testfeld = #FELD_GEHEIMGANG
               draw_tile(labyrinth(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)
            EndIf
         EndIf
      EndIf
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms
; Fuer Kreaturen
; Nur Schaetze
Procedure draw_screen6(x_offset.b, y_offset.b)

  Shared akt_spieler, frame
  
  radius.w = radius2()
  
  For y.b = -1 To 11
    For x.b = -1 To 11
       If spieler(akt_spieler)\creature_x-5+x > 0 And spieler(akt_spieler)\creature_y-5+y > 0 And matrix(x+1,y+1) <= radius
          testfeld.w = labyrinth(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y)\feld[spieler(akt_spieler)\Level]
            If testfeld = #FELD_GOLD Or testfeld = #FELD_GRUENETRUHE1 Or testfeld = #FELD_GRUENETRUHE2 Or testfeld = #FELD_TRUHE Or testfeld = #FELD_VERBORGENER_SCHATZ Or testfeld = #FELD_SKELETT2 Or testfeld = #FELD_VERBORGENER_SCHATZ2
               draw_tile(labyrinth(spieler(akt_spieler)\creature_x-5+x, spieler(akt_spieler)\creature_y-5+y)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)
            EndIf
       EndIf
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms
; Nur Monster
Procedure draw_screen7(x_offset.b, y_offset.b)

  Shared akt_spieler, frame
  
  radius.w = radius()
  
  For y.b = -1 To 11
    For x.b = -1 To 11
       If spieler(akt_spieler)\character_x-5+x > 0 And spieler(akt_spieler)\character_y-5+y > 0 And matrix(x+1,y+1) <= radius
          testfeld.w = labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level]
            If testfeld > #ANZ_FELDER And testfeld <= #ANZ_FELDER+#ANZ_MONSTER
               draw_tile(labyrinth(spieler(akt_spieler)\character_x-5+x, spieler(akt_spieler)\character_y-5+y)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)
            EndIf
       EndIf
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen von Karten

Procedure karte(x_offset.b, y_offset.b)

Shared akt_spieler, joystick_used, anz_spieler, mydelay3

x_akt.w = 0
y_akt.w = 0
offset.w = 10
 
   Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))

      For y.b=-1 To 20
         For x.b=-1 To 20
            If spieler(akt_spieler)\character_x-offset+x + x_akt < 1 Or spieler(akt_spieler)\character_y-offset+y + y_akt < 1
               draw_small_tile(mit_was(spieler(akt_spieler)\Level), x, y, x_offset, y_offset)
            Else
               draw_small_tile(labyrinth(spieler(akt_spieler)\character_x-offset+x + x_akt, spieler(akt_spieler)\character_y-offset+y + y_akt)\feld[spieler(akt_spieler)\Level], x, y, x_offset, y_offset)     
               ; Charactere darstellen
               For xx = 1 To anz_spieler
                  If spieler(akt_spieler)\character_x-offset+x + x_akt = spieler(xx)\character_x And spieler(akt_spieler)\character_y-offset+y + y_akt = spieler(xx)\character_y
                     If spieler(xx)\Status = 1 And spieler(xx)\level = spieler(akt_spieler)\level    
                        If spieler(xx)\fluch = #FLUCH_CHICKEN 
                           ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 1*16-16, 16, 16)
                           DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                        ElseIf hater(#SPELL_FLEDERMAUSGESTALT,xx) 
                           ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 5*16-16, 16, 16)
                           DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                        ElseIf hater(#SPELL_WOLFSGESTALT,xx) 
                           ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 3*16-16, 16, 16)
                           DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                        ElseIf hater(#SPELL_VOGELGESTALT,xx)
                           ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 4*16-16, 16, 16)
                           DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                        ElseIf hater(#SPELL_KATZENGESTALT,xx) 
                           ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 2*16-16, 16, 16)
                           DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                        ElseIf hater(#SPELL_DRACHENGESTALT,xx) 
                           ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 6*16-16, 16, 16)
                           DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                        ; Normales aussehen
                        Else
                           ClipSprite(#SPRITE_TILESET_SMALLCHARA, spieler(xx)\face*16*2, spieler(xx)\maennchen*16-16, 16, 16)
                           DisplayTransparentSprite(#SPRITE_TILESET_SMALLCHARA, x*16+x_offset, y*16+y_offset)
                        EndIf                       
                     EndIf
                  EndIf
               Next
               
               ; Kreaturen darstellen
               For xx = 1 To anz_spieler
                  If spieler(xx)\creature_typ > 0
                     If spieler(akt_spieler)\character_x-offset+x + x_akt = spieler(xx)\creature_x And spieler(akt_spieler)\character_y-offset+y + y_akt = spieler(xx)\creature_y                    
                        If spieler(xx)\level = spieler(akt_spieler)\level And spieler(xx)\status = 1
                           ; Homunkulus
                           If spieler(xx)\creature_typ = 1
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 9*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Skelett
                           ElseIf spieler(xx)\creature_typ = 2 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 7*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Todesritter
                           ElseIf spieler(xx)\creature_typ = 3 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 12*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Sternenfee
                           ElseIf spieler(xx)\creature_typ = 4 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 13*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Tiger
                           ElseIf spieler(xx)\creature_typ = 5 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 14*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Mumie
                           ElseIf spieler(xx)\creature_typ = 6 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 11*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Daemon
                           ElseIf spieler(xx)\creature_typ = 7
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 8*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Engel
                           ElseIf spieler(xx)\creature_typ = 8 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 10*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Drache
                           ElseIf spieler(xx)\creature_typ = 9 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 6*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Doppelgaenger
                           ElseIf spieler(xx)\creature_typ = 10 
                              ClipSprite(#SPRITE_TILESET_SMALLCHARA, spieler(xx)\creature_heading*16*2, spieler(xx)\maennchen*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLCHARA, x*16+x_offset, y*16+y_offset)
                           ; Bird
                           ElseIf spieler(xx)\creature_typ = 11 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 4*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Golem
                           ElseIf spieler(xx)\creature_typ = 12 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 16*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Feuerelementar
                           ElseIf spieler(xx)\creature_typ = 14
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 18*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Wasserelementar
                           ElseIf spieler(xx)\creature_typ = 15 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 19*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Satyr
                           ElseIf spieler(xx)\creature_typ = 13 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 17*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ; Gefaehrte
                           ElseIf spieler(xx)\creature_typ = 20
                              ClipSprite(#SPRITE_TILESET_SMALLCHARA, spieler(xx)\creature_heading*16*2, 20*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLCHARA, x*16+x_offset, y*16+y_offset)
                           EndIf             
                        EndIf                     
                     EndIf
                  EndIf
               Next             
            EndIf
         Next
      Next
      
      laby_rahmen()
      show_logo()
      show_varys()
      show_buttons()
      
      ExamineKeyboard()
      jax.w = 0
      jay.w = 0
      If joystick_used = 1
         ExamineJoystick()
         jax = JoystickAxisX()
         jay = JoystickAxisY()
      EndIf
      
      If KeyboardPushed(#PB_Key_Right) Or jax = 1
         x_akt = x_akt + 1
         If x_akt > groesse(spieler(akt_spieler)\level)
            x_akt = groesse(spieler(akt_spieler)\level)
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Left) Or jax = -1
         x_akt = x_akt - 1
         If spieler(akt_spieler)\character_x-offset+ x + x_akt < 1
            x_akt = 0
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Up) Or jay = -1
         y_akt = y_akt - 1
         If spieler(akt_spieler)\character_y-offset+ y + y_akt < 1
            y_akt = 0
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Down) Or jay = 1
         y_akt = y_akt + 1
         If y_akt > groesse(spieler(akt_spieler)\level)
            y_akt = groesse(spieler(akt_spieler)\level)
         EndIf
      EndIf

      result = ExamineMouse()
      mouse_x = MouseX()
      mouse_y = MouseY()
      mouse_links = 0
      mouse_rechts = 0
      mouse_links  = MouseButton(1)
      mouse_rechts = MouseButton(2)
      
      
      ; Links
      If mouse_x >= #POS_BUTTON_LINKS_X And mouse_x <= #POS_BUTTON_LINKS_X+32 And mouse_y >= #POS_BUTTON_LINKS_Y And mouse_y <= #POS_BUTTON_LINKS_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 3*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LINKS_X, #POS_BUTTON_LINKS_Y)
         If mouse_links = 1
            x_akt = x_akt - 1
            If spieler(akt_spieler)\character_x-offset+ x + x_akt < 1
               x_akt = 0
            EndIf
         EndIf 
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 1*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LINKS_X, #POS_BUTTON_LINKS_Y)
      EndIf
      
      ; Rechts
      If mouse_x >= #POS_BUTTON_RECHTS_X And mouse_x <= #POS_BUTTON_RECHTS_X + 32 And mouse_y >= #POS_BUTTON_RECHTS_Y And mouse_y <= #POS_BUTTON_RECHTS_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 63, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RECHTS_X, #POS_BUTTON_RECHTS_Y)
         If mouse_links = 1
            x_akt = x_akt + 1
            If x_akt > groesse(spieler(akt_spieler)\level)
               x_akt = groesse(spieler(akt_spieler)\level)
            EndIf
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 0*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RECHTS_X, #POS_BUTTON_RECHTS_Y)
      EndIf
      
      ; Oben
      If mouse_x >= #POS_BUTTON_HOCH_X And mouse_x <= #POS_BUTTON_HOCH_X + 32 And mouse_y >= #POS_BUTTON_HOCH_Y And mouse_y <= #POS_BUTTON_HOCH_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 6*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_HOCH_X, #POS_BUTTON_HOCH_Y)
         If mouse_links = 1
            y_akt = y_akt - 1
            If spieler(akt_spieler)\character_y-offset+ y + y_akt < 1
               y_akt = 0
            EndIf
         EndIf 
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 4*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_HOCH_X, #POS_BUTTON_HOCH_Y)
      EndIf
      
      ; Unten
      If mouse_x > #POS_BUTTON_RUNTER_X And mouse_x < #POS_BUTTON_RUNTER_X + 32 And mouse_y > #POS_BUTTON_RUNTER_Y And mouse_y < #POS_BUTTON_RUNTER_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 7*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RUNTER_X, #POS_BUTTON_RUNTER_Y)
         If mouse_links = 1
            y_akt = y_akt + 1
            If y_akt > groesse(spieler(akt_spieler)\level)
               y_akt = groesse(spieler(akt_spieler)\level)
            EndIf
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 5*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RUNTER_X, #POS_BUTTON_RUNTER_Y)
      EndIf
      
      ; Center
      If mouse_x > #POS_BUTTON_CENTER_X And mouse_x < #POS_BUTTON_CENTER_X + 32 And mouse_y > #POS_BUTTON_CENTER_Y And mouse_y < #POS_BUTTON_CENTER_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 1*32, 1*32, 29, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_CENTER_X, #POS_BUTTON_CENTER_Y)
         If mouse_links = 1
            x_akt = 0
            y_akt = 0
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 0*32, 1*32, 29, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_CENTER_X, #POS_BUTTON_CENTER_Y)
      EndIf
      
      
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mouse_x, mouse_y)
     FlipBuffers()
     Delay(mydelay3)
   Until mouse_rechts = 1

EndProcedure

; --------------------------------------------------------------------------------------
; Prozedur zum Zeichnen von Karten

Procedure show_automap()

Shared akt_spieler, joystick_used, anz_spieler, karten_typ, mydelay3

x_akt.w = 0
y_akt.w = 0
offset.w = 10
karten_typ = 2
map_level.w = spieler(akt_spieler)\Level
 
   Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))

      For y.b=-1 To 20
         For x.b=-1 To 20
            If spieler(akt_spieler)\character_x-offset+x + x_akt < 1 Or spieler(akt_spieler)\character_y-offset+y + y_akt < 1
               draw_small_tile(mit_was(map_level), x, y, x_offset, y_offset)
            Else
               If automap(spieler(akt_spieler)\character_x-offset+x + x_akt, spieler(akt_spieler)\character_y-offset+y + y_akt)\feld[map_level] = 1
               
                  draw_small_tile(labyrinth(spieler(akt_spieler)\character_x-offset+x + x_akt, spieler(akt_spieler)\character_y-offset+y + y_akt)\feld[map_level], x, y, x_offset, y_offset)
                  
                  
                  ; Charactere darstellen
                  For xx = 1 To anz_spieler
                     If spieler(akt_spieler)\character_x-offset+x + x_akt = spieler(xx)\character_x And spieler(akt_spieler)\character_y-offset+y + y_akt = spieler(xx)\character_y
                        If spieler(xx)\Status = 1 And spieler(xx)\level = map_level                     
                           If spieler(xx)\fluch = #FLUCH_CHICKEN 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 1*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ElseIf hater(#SPELL_FLEDERMAUSGESTALT,xx) 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 5*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ElseIf hater(#SPELL_WOLFSGESTALT,xx)
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 3*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ElseIf hater(#SPELL_VOGELGESTALT,xx) 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 4*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ElseIf hater(#SPELL_KATZENGESTALT,xx) 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 2*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                           ElseIf hater(#SPELL_DRACHENGESTALT,xx) 
                              ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\face*16*2, 6*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset) 
                           ; Normales aussehen
                           Else
                              ClipSprite(#SPRITE_TILESET_SMALLCHARA, spieler(xx)\face*16*2, spieler(xx)\maennchen*16-16, 16, 16)
                              DisplayTransparentSprite(#SPRITE_TILESET_SMALLCHARA, x*16+x_offset, y*16+y_offset)
                           EndIf
                           
                        EndIf
                     EndIf
                  Next
                  
                  ; Creaturen darstellen
                  For xx = 1 To anz_spieler
                     If spieler(xx)\creature_typ > 0
                        If spieler(akt_spieler)\character_x-offset+x + x_akt = spieler(xx)\creature_x And spieler(akt_spieler)\character_y-offset+y + y_akt = spieler(xx)\creature_y
                              
                           If spieler(xx)\level = map_level And spieler(xx)\Status = 1
                              ; Homunkulus
                              If spieler(xx)\creature_typ = 1 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 9*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Skelett
                              ElseIf spieler(xx)\creature_typ = 2 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 7*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Todesritter
                              ElseIf spieler(xx)\creature_typ = 3 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 12*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Sternenfee
                              ElseIf spieler(xx)\creature_typ = 4
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 13*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Tiger
                              ElseIf spieler(xx)\creature_typ = 5 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 14*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Mumie
                              ElseIf spieler(xx)\creature_typ = 6 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 11*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Daemon
                              ElseIf spieler(xx)\creature_typ = 7 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 8*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Engel
                              ElseIf spieler(xx)\creature_typ = 8 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 10*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Drache
                              ElseIf spieler(xx)\creature_typ = 9
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 6*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Doppelgaenger
                              ElseIf spieler(xx)\creature_typ = 10 
                                 ClipSprite(#SPRITE_TILESET_SMALLCHARA, spieler(xx)\creature_heading*16*2, spieler(xx)\maennchen*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLCHARA, x*16+x_offset, y*16+y_offset)
                              ; Bird
                              ElseIf spieler(xx)\creature_typ = 11 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 4*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Golem
                              ElseIf spieler(xx)\creature_typ = 12 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 16*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Satyr
                              ElseIf spieler(xx)\creature_typ = 13 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 17*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Feuerelementar
                              ElseIf spieler(xx)\creature_typ = 13 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 18*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Wasserelementar
                              ElseIf spieler(xx)\creature_typ = 13 
                                 ClipSprite(#SPRITE_TILESET_SMALLMONSTERANIM, spieler(xx)\creature_heading*16*2, 19*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLMONSTERANIM, x*16+x_offset, y*16+y_offset)
                              ; Gefaehrte
                              ElseIf spieler(xx)\creature_typ = 20 
                                 ClipSprite(#SPRITE_TILESET_SMALLCHARA, spieler(xx)\creature_heading*16*2, 20*16-16, 16, 16)
                                 DisplayTransparentSprite(#SPRITE_TILESET_SMALLCHARA, x*16+x_offset, y*16+y_offset)
                                 okay = 1
                              EndIf
                           EndIf                 
                        EndIf
                     EndIf
                  Next
               EndIf ; Auf automap?
            EndIf
         Next
      Next
      
      laby_rahmen()
      show_logo()
      show_varys()
      show_buttons()
      
      ExamineKeyboard()
      jax.w = 0
      jay.w = 0
      If joystick_used = 1
         ExamineJoystick()
         jax = JoystickAxisX()
         jay = JoystickAxisY()
      EndIf
      
      If KeyboardPushed(#PB_Key_Right) Or jax = 1
         x_akt = x_akt + 1
         If x_akt > groesse(map_level)
            x_akt = groesse(map_level)
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Left) Or jax = -1
         x_akt = x_akt - 1
         If spieler(akt_spieler)\character_x-offset+ x + x_akt < 1
            x_akt = 0
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Up) Or jay = -1
         y_akt = y_akt - 1
         If spieler(akt_spieler)\character_y-offset+ y + y_akt < 1
            y_akt = 0
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Down) Or jay = 1
         y_akt = y_akt + 1
         If y_akt > groesse(map_level)
            y_akt = groesse(map_level)
         EndIf
      EndIf

      result = ExamineMouse()
      mouse_x = MouseX()
      mouse_y = MouseY()
      mouse_links = 0
      mouse_rechts = 0
      mouse_links  = MouseButton(1)
      mouse_rechts = MouseButton(2)
      
      
      ; Links
      If mouse_x >= #POS_BUTTON_LINKS_X And mouse_x <= #POS_BUTTON_LINKS_X+32 And mouse_y >= #POS_BUTTON_LINKS_Y And mouse_y <= #POS_BUTTON_LINKS_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 3*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LINKS_X, #POS_BUTTON_LINKS_Y)
         If mouse_links = 1
            x_akt = x_akt - 1
            If spieler(akt_spieler)\character_x-offset+ x + x_akt < 1
               x_akt = 0
            EndIf
         EndIf 
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 1*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LINKS_X, #POS_BUTTON_LINKS_Y)
      EndIf
      
      ; Rechts
      If mouse_x >= #POS_BUTTON_RECHTS_X And mouse_x <= #POS_BUTTON_RECHTS_X + 32 And mouse_y >= #POS_BUTTON_RECHTS_Y And mouse_y <= #POS_BUTTON_RECHTS_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 63, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RECHTS_X, #POS_BUTTON_RECHTS_Y)
         If mouse_links = 1
            x_akt = x_akt + 1
            If x_akt > groesse(map_level)
               x_akt = groesse(map_level)
            EndIf
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 0*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RECHTS_X, #POS_BUTTON_RECHTS_Y)
      EndIf
      
      ; Oben
      If mouse_x >= #POS_BUTTON_HOCH_X And mouse_x <= #POS_BUTTON_HOCH_X + 32 And mouse_y >= #POS_BUTTON_HOCH_Y And mouse_y <= #POS_BUTTON_HOCH_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 6*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_HOCH_X, #POS_BUTTON_HOCH_Y)
         If mouse_links = 1
            y_akt = y_akt - 1
            If spieler(akt_spieler)\character_y-offset+ y + y_akt < 1
               y_akt = 0
            EndIf
         EndIf 
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 4*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_HOCH_X, #POS_BUTTON_HOCH_Y)
      EndIf
      
      ; Unten
      If mouse_x > #POS_BUTTON_RUNTER_X And mouse_x < #POS_BUTTON_RUNTER_X + 32 And mouse_y > #POS_BUTTON_RUNTER_Y And mouse_y < #POS_BUTTON_RUNTER_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 7*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RUNTER_X, #POS_BUTTON_RUNTER_Y)
         If mouse_links = 1
            y_akt = y_akt + 1
            If y_akt > groesse(map_level)
               y_akt = groesse(map_level)
            EndIf
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 5*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_RUNTER_X, #POS_BUTTON_RUNTER_Y)
      EndIf
      
      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)
         FrontColor(RGB(255,255,255))
         DrawText(#POS_BUTTON_LEV_HOCH_X-10,#POS_BUTTON_LEV_HOCH_Y-17,"Lv." + Str(map_level))
      StopDrawing()
      
      ; Level Hoch
      If mouse_x >= #POS_BUTTON_LEV_HOCH_X And mouse_x <= #POS_BUTTON_LEV_HOCH_X + 32 And mouse_y >= #POS_BUTTON_LEV_HOCH_Y And mouse_y <= #POS_BUTTON_LEV_HOCH_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 6*32, 0, 32, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LEV_HOCH_X, #POS_BUTTON_LEV_HOCH_Y)
         If mouse_links = 1
             If map_level > 1
                map_level = map_level - 1
             EndIf
         EndIf 
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 4*32, 0, 32, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LEV_HOCH_X, #POS_BUTTON_LEV_HOCH_Y)
      EndIf
      
      ; Level Runter
      If mouse_x > #POS_BUTTON_LEV_RUNTER_X And mouse_x < #POS_BUTTON_LEV_RUNTER_X + 32 And mouse_y > #POS_BUTTON_LEV_RUNTER_Y And mouse_y < #POS_BUTTON_LEV_RUNTER_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 7*32, 0, 32, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LEV_RUNTER_X, #POS_BUTTON_LEV_RUNTER_Y)
         If mouse_links = 1
             If map_level < spieler(akt_spieler)\maxlevel
                map_level = map_level + 1
             EndIf
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 5*32, 0, 32, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_LEV_RUNTER_X, #POS_BUTTON_LEV_RUNTER_Y)
      EndIf
      
      ; Center
      If mouse_x > #POS_BUTTON_CENTER_X And mouse_x < #POS_BUTTON_CENTER_X + 32 And mouse_y > #POS_BUTTON_CENTER_Y And mouse_y < #POS_BUTTON_CENTER_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 1*32, 1*32, 29, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_CENTER_X, #POS_BUTTON_CENTER_Y)
         If mouse_links = 1
            x_akt = 0
            y_akt = 0
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 0*32, 1*32, 29, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_CENTER_X, #POS_BUTTON_CENTER_Y)
      EndIf
      
      
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mouse_x, mouse_y)
     FlipBuffers()
     Delay(mydelay3)
   Until mouse_rechts = 1

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum kompletten Zeichnen des Hauptbildschirms (inkl. Charakter, FlipBuffer etc.)
Procedure draw_screen_total()

  Shared spieler, akt_spieler, frame
  
  ClearScreen(RGB(0, 0, 0))
  draw_screen(0 , 0)
  draw_character(spieler(akt_spieler)\face, frame,0)
  result = ExamineMouse()
  mouse_x = MouseX()
  mouse_y = MouseY()
  mouse_links = 0
  mouse_rechts = 0
  mouse_links  = MouseButton(1)
  mouse_rechts = MouseButton(2)
  ok_button = 0
  ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
  DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mouse_x, mouse_y)
  FlipBuffers()

EndProcedure
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1307
; FirstLine = 1305
; Folding = -------------------------------------------
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger