; die Strukturen

;-Das Labyrinth
Structure laby
   feld.w             [#MAX_EBENEN+1]
   lebenspunkte.w     [#MAX_EBENEN+1]
   objekt.w           [#MAX_EBENEN+1]
   status.w           [#MAX_EBENEN+1]
EndStructure
Global Dim labyrinth.laby(#MAX_GROESSE+1,#MAX_GROESSE+1)

;-Eine Ebene fuer Labykreation
Structure laby2
   feld.w
   lebenspunkte.w
   objekt.w 
   status.w
EndStructure
Global Dim labyrinth2.laby2(#MAX_GROESSE+1,#MAX_GROESSE+1)

Global Dim raeume.w          (#MAX_EBENEN+1)
Global Dim raumx.w           (#MAX_EBENEN+1)
Global Dim raumy.w           (#MAX_EBENEN+1)
Global Dim eingangx.w        (#MAX_EBENEN+1)
Global Dim eingangy.w        (#MAX_EBENEN+1)
Global Dim ausgangx.w        (#MAX_EBENEN+1)
Global Dim ausgangy.w        (#MAX_EBENEN+1)
Global Dim sonderlevel.w     (#MAX_EBENEN+1)
Global Dim levelmod.w        (#MAX_EBENEN+1)
Global Dim groesse.w         (#MAX_EBENEN+1)
Global Dim inhalt.w          (#MAX_EBENEN+1)   ; Gang
Global Dim mit_was.w         (#MAX_EBENEN+1)   ; Wand
Global Dim visionen.w        (#MAX_EBENEN+1)
Global Dim fluss.w           (#MAX_EBENEN+1)
Global Dim spinnenkoenigin.w (#MAX_EBENEN+1)
Global Dim goblinkoenig.w    (#MAX_EBENEN+1)
Global Dim untotenherr.w     (#MAX_EBENEN+1)


;-Automap
Structure carta
   feld.w             [#MAX_EBENEN+1]
EndStructure
Global Dim automap.carta(#MAX_GROESSE+1,#MAX_GROESSE+1)


;-Struktur fuer den Charakter
Structure character_data

  Status.b       ; 1=Aktiv,2=Inaktiv,3=dead
  verifikation.s
  Level.w
  MaxLevel.w
  Maennchen.w
  Lifepoints.w
  MaxLifepoints.w
  LifeGain.w
  Mana.w
  MaxMana.w
  ManaGain.w
  Attack.w
  Dexterity.w
  Strength.w
  MaxSpeed.w
  Speed.w
  Perception.w
  Luck_score.w
  Power_score.w
  Circle.w
  magieresistenz.w
  spellweaving.w
  style.w
  light.w
  Hunger.w
  Durst.w
  weisheit.w
  schleichen.w
  mks.w
  fluch.w
  fluchdauer.w
  krankheit.w
  krankheitdauer.w
  gift.w
  giftdauer.w
  verhungern.w
  verdursten.w
  betrunken.w
  lifepointgegenstand.w
  managegenstand.w
  staerkegegenstand.w
  zugweitegegenstand.w
  dexteritygegenstand.w
  gluecksgegenstand.w
  bogentreffergegenstand.w
  bogenschadengegenstand.w
  powergegenstand.w
  perceptiongegenstand.w
  attackgegenstand.w
  stealthgegenstand.w
  damagegegenstand.w
  lichtgegenstand.w
  diebstahlgegenstand.w
  goblinlehre.w
  spinnenlehre.w
  untotenlehre.w
  pflanzenlehre.w
  tierkunde.w
  fallenlehre.w
  giftlehre.w
  pos_zaubermenue.w
  dumm.w
  face.w
  hinterhalt.w
  portal.w
  teleport.w
  nexus.w
  stehlen.w
  schriftrolle.w
  zauberbuch.w
  kessel.w
  udjat_ben.w
  armageddon.w 
  pestilence.w
  drachenform.w
  macht.w
  magic_apple.w
  refresh.w
  heal.w
  akt_zauber.w
  schule.s
  lehrer.w
  stabteile.w
  moves.w
  anker_x.w
  anker_y.w
  anker_level.w
  old_pos_x.w
  old_pos_y.w
  old_lp.w
  old_max_lp.w
  old_mp.w
  old_max_mp.w
  sterbegrund.s [#ANZ_SPRACHEN+1]
  character_x.w
  character_y.w
  creature_typ.b
  creature_LifePoints.w
  creature_Attack.w
  creature_schaden_min.w
  creature_schaden_max.w
  creature_Speed.w
  creature_MaxSpeed.w
  creature_x.w
  creature_y.w
  creature_heading.w

EndStructure

; -------------------------------------
;-Struktur fuer aktive Zauber

Structure az
   nr.w
   staerke.w
   dauer.w
   source.w
EndStructure

Global Dim aktive.az(15+1,#ANZ_SPIELER)

; -------------------------------------

;-Struktur fuer Skills

Structure skill
   name.s [#ANZ_SPRACHEN+1]
   nummer.w
   kosten.w
   beschreibung_1.s [#ANZ_SPRACHEN+1]
   beschreibung_2.s [#ANZ_SPRACHEN+1]
   gruppe.w
   gewaehlt.w
   gelocked.w
EndStructure

Global Dim skills.skill(#ANZ_SKILLS+1,#ANZ_SPIELER)

; --------------------------------------

;-Struktur fuer sich ausschliessende Skills

Structure LOCK
   name.w
   locked.w
EndStructure

Global Dim unmoeglich.lock(#ANZ_UNMOEGLICH+1)

; -----------------------------------------

;-Struktur fuer Highscores

Structure egal
   version.s
   name.s
   level.w
   gold.w
   mks.w
   punkte.w
   maennchen.w
   MaxLifepoints.w 
   MaxMana.w
   Attack.w
   Dexterity.w
   Strength.w
   MaxSpeed.w
   Perception.w
   Luck_score.w
   Power_score.w
   Circle.w
   anfangszeit.s
   endezeit.s
   stabteile.w
   moves.w
   sterbegrund.s [#ANZ_SPRACHEN+1]
   skills.w [30+1]
EndStructure

Global Dim hscores.egal(30+1)

; ------------------------------------------

;-Struktur fuer Inventory

Structure inv
   name.w
   art.w
   benutzt.w
   anzahl.w
   status.w
   attri1.w
   attri2.w
   attri3.w
   attri4.w
   attri5.w
EndStructure

Global Dim inventory.inv(#MAX_RUCKSACK+1,#ANZ_SPIELER)

; -----------------------------------------

;-Struktur fuer Gegenstaende

Structure gs
   name.s [#ANZ_SPRACHEN+1]
   info.s [#ANZ_SPRACHEN+1]
   art.w
   klasse.w
   magisch.w
   qualitaet.w
   einkauf.w
   verkauf.w
   gewicht.w
   attri1.w
   attri2.w
   attri3.w
   attri4.w
EndStructure

Global Dim gegenstand.gs (#ANZ_GEGENSTAENDE+1)

; -----------------------------------------

;-Struktur fuer Zauber

Structure spell
   name.s [#ANZ_SPRACHEN+1]
   level.w
   kosten.w
   dauer.w
   chance.w
   anhaltend.w
   erlernt.w
   art.s
   besch_1.s [#ANZ_SPRACHEN+1]
   besch_2.s [#ANZ_SPRACHEN+1]
EndStructure

Global Dim zauber.spell(200,#ANZ_SPIELER)

; ------------------------------------------------------

;-Struktur fuer Mischen

Structure misch
   trank1.w
   trank2.w
   trank3.w
EndStructure

Global Dim mischen.misch(#ANZ_TRAENKE)

; -----------------------------------------

;-Struktur fuer Monster

Structure monsterstruct
   name.s [#ANZ_SPRACHEN+1]
   nr.w
   art.b
   lebenspunkte.w
   angriff.b
   abwehr.b
   staerke.b
   ruestung.b
   zauberkraft.b
   zauber.b
   reichweite.b
   minlevel.w
   sound.w
   eigenschaft1.b
   eigenschaft2.b
   eigenschaft3.b
   eigenschaft4.b
   eigenschaft5.b
   eigenschaft6.b
   eigenschaft7.b
   eigenschaft8.b
   eigenschaft9.b
   eigenschaft10.b
EndStructure

Global Dim monster.monsterstruct(#ANZ_MONSTER+1)

; ------------------------------------------------------

;-Struktur fuer Pilze

Structure pi
   nr.w
   wirkung.s [#ANZ_SPRACHEN+1]
EndStructure

Global Dim pilz.pi(20+1)

; ------------------------------------------------------

;-Struktur fuer Zauberliste

Structure zl
   name.s [#ANZ_SPRACHEN+1]
EndStructure

Global Dim zauberliste.zl(500)

; ------------------------------------------------------

;-Struktur fuer Nachrichten

Structure mes
   farbe.w
   nachricht.s
EndStructure

Global Dim old_messages.mes (25,#ANZ_SPIELER)

; ------------------------------------------------------

;-Struktur fuer Kreaturen

Structure kriatura
   creature_LifePoints.w
   creature_Attack.w
   creature_schaden_min.w
   creature_schaden_max.w
   creature_MaxSpeed.w
EndStructure

Global Dim creature.kriatura (#ANZ_KREATUREN)

; ------------------------------------------------------

;-Struktur fuer Fehler
CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows   
Structure Fehler
Zeile.l
Datei.s
EndStructure

Global NewList Error.Fehler()
Declare Fehlerverarbeitung()
OnErrorGosub(@Fehlerverarbeitung())
CompilerEndSelect

; ------------------------------------------------------

;-Linked List fr Sprachen
Structure sprache
id.l
Buttonpos.l
EndStructure

Global Dim sprache.sprache(2)

;Englisch
sprache(0)\buttonpos=34

;Deutsch
sprache(1)\buttonpos=68

;Spanisch
sprache(2)\buttonpos=612


; IDE Options = PureBasic v4.01 (Windows - x86)
; CursorPosition = 412
; FirstLine = 362
; Folding = -
; EnableAsm
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger