; Traenke

; ----------------------------------------------------------------

; Traenke mischen
Procedure init_traenke()

shared gegenstand
   zw_geg.gs

   for i = 1 to 100
      von = #OBJGRAFIK_TRANK1 + random(#ANZ_TRAENKE-1)
      nach = #OBJGRAFIK_TRANK1 + random(#ANZ_TRAENKE-1)
      
      for k = 1 to #ANZ_SPRACHEN
         zw_geg \name[k]  = gegenstand(von)\name[k]
      next
      zw_geg \art     = gegenstand(von)\art
      zw_geg \einkauf = gegenstand(von)\einkauf
      zw_geg \verkauf = gegenstand(von)\verkauf
      
      for k = 1 to #ANZ_SPRACHEN
         gegenstand(von)\name[k]  = gegenstand(nach)\name[k]
      next
      gegenstand(von)\art     = gegenstand(nach)\art
      gegenstand(von)\einkauf = gegenstand(nach)\einkauf
      gegenstand(von)\verkauf = gegenstand(nach)\verkauf
      
      for k = 1 to #ANZ_SPRACHEN
         gegenstand(nach)\name[k]  = zw_geg \name[k]
      next
      gegenstand(nach)\art     = zw_geg \art
      gegenstand(nach)\einkauf = zw_geg \einkauf
      gegenstand(nach)\verkauf = zw_geg \verkauf
   next
   
   for i = 1 to #ANZ_TRAENKE
      mischen(i)\trank1 = #OBJGRAFIK_TRANK1 + i - 1
      mischen(i)\trank2 = #OBJGRAFIK_TRANK1 + i - 1
      if random(100) > 90
         mischen(i)\trank3 = #UNENDLICH
      else
         mischen(i)\trank3 = random(#ANZ_TRAENKE-1) + #OBJGRAFIK_TRANK1
      endif
   next
   
   for i = 1 to 100
      pos1.w = random(#ANZ_TRAENKE-1)+1
      pos2.w = random(#ANZ_TRAENKE-1)+1
      trank.w = mischen(pos1)\trank2
      mischen(pos1)\trank2 = mischen(pos2)\trank2
      mischen(pos2)\trank2 = trank
   next

EndProcedure

; ----------------------------------------------------------------

Procedure trinken(welchen.s)

shared spieler, akt_spieler, sprache, schriftrolle, akt_zauber, akt_zauber_offset

   spieler(akt_spieler)\durst = 0
   select(welchen)
      case "Wirkungslos":
         nachricht(38,#COLOR_GRUEN)
      case "Schwacher Heiltrank":
         spieler(akt_spieler)\Lifepoints = spieler(akt_spieler)\Lifepoints + random(10)+3
         if spieler(akt_spieler)\Lifepoints > spieler(akt_spieler)\Maxlifepoints
            spieler(akt_spieler)\Lifepoints = spieler(akt_spieler)\Maxlifepoints
         endif
         nachricht(46,#COLOR_GRUEN)
      case "Starker Heiltrank":
         spieler(akt_spieler)\Lifepoints = maxlife()
         nachricht(47,#COLOR_GRUEN)
      case "Schwaches Gift":
         ; Giftschutz ?
         If habich(#SPELL_GIFTSCHUTZ) > 0
            nachricht(256,#COLOR_GRUEN)
         else
            spieler(akt_spieler)\gift = 1
            spieler(akt_spieler)\giftdauer = random(10)+1
            nachricht(40,#COLOR_GRUEN)
         endif
      case "Starkes Gift":
         ; Giftschutz ?
         If habich(#SPELL_GIFTSCHUTZ) > 0
            nachricht(256,#COLOR_GRUEN)
         else
            spieler(akt_spieler)\gift = 2
            spieler(akt_spieler)\giftdauer = random(15)+1
            nachricht(40,#COLOR_GRUEN)
         endif
      case "Trank der Helden":
         aufsteigen(2)
      case "Trank der Gtter":
         for i = 1 to 3
            aufsteigen(2)
         next
      case "Strketrank":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Strkezauber"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Schwchetrank":
         nachricht(41,#COLOR_GRUEN)
      case "Paralysetrank":
         spieler(akt_spieler)\fluch = #FLUCH_PARALYSE
         spieler(akt_spieler)\fluchdauer = random(15)+1
         nachricht(42,#COLOR_GRUEN)
      case "Trank des Fiegens":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Fliegen"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Trank des Schutzes": 
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Schutzzauber"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Schwacher Manatrank":
         spieler(akt_spieler)\Mana = spieler(akt_spieler)\Mana + random(10)+3
         if spieler(akt_spieler)\Mana > maxmana()
            spieler(akt_spieler)\Mana = maxmana()
         endif
         nachricht(43,#COLOR_GRUEN)
      case "Starker Manatrank":
         spieler(akt_spieler)\Mana = maxmana()
         nachricht(43,#COLOR_GRUEN)
      case "Gegengift":
         spieler(akt_spieler)\Gift = 0
         spieler(akt_spieler)\GiftDauer = 0
         nachricht(222,#COLOR_GRUEN)
      case "Klteschutz":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Eisschild"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Hitzeschutz":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Feuerschild"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Magieleere":
         spieler(akt_spieler)\Mana = 0
         nachricht(222,#COLOR_GRUEN)
      case "Unsichtbarkeit":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Unsichtbarkeit"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Macht":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Macht"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Fallen sphren":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Fallen sphren"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Winteratem":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Winteratem"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Flammenaura":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Flammenaura"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Fledermausgestalt":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Fledermausgestalt"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Wolfsgestalt":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Wolfsgestalt"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Vogelgestalt":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Vogelgestalt"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Katzengestalt":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Katzengestalt"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Drachengestalt":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Drachengestalt"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "bers Wasser gehen":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "bers Wasser gehen"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Schutz vor Geschossen":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Schutz vor Geschossen"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Unsichtbares sehen":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Unsichtbares sehen"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Magieschutz":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Magieschutz"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Hexensicht":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Hexensicht"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Unverwundbarkeit":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Unverwundbarkeit"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
         
      case "Giftschutz":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Giftschutz"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Selbsthypnose":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Selbsthypnose"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Regeneration":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Regeneration"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      case "Lebensbund":
         zauberliste(akt_zauber+akt_zauber_offset)\name[2] = "Lebensbund"
         schriftrolle = 1
         cast_it()
         schriftrolle = 0
      default:
         nachricht(38,#COLOR_GRUEN)
   endselect

EndProcedure

; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger
