; Alle Routinen fuer die Zauber

Procedure get_creature(typ.w)

Shared akt_spieler, spell_x, spell_y

   spieler(akt_spieler)\creature_typ = typ
   spieler(akt_spieler)\creature_LifePoints = creature(typ)\creature_LifePoints
   spieler(akt_spieler)\creature_Attack = creature(typ)\creature_Attack
   spieler(akt_spieler)\creature_schaden_min = creature(typ)\creature_schaden_min
   spieler(akt_spieler)\creature_schaden_max = creature(typ)\creature_schaden_max
   spieler(akt_spieler)\creature_Speed = creature_speed()
   spieler(akt_spieler)\creature_MaxSpeed = creature(typ)\creature_MaxSpeed
   spieler(akt_spieler)\creature_x = spieler(akt_spieler)\character_x + spell_x
   spieler(akt_spieler)\creature_y = spieler(akt_spieler)\character_y + spell_y
   spieler(akt_spieler)\creature_heading = 2

EndProcedure


Procedure init_creatures()

   ; Homunkulus
   creature(1)\creature_LifePoints = 5
   creature(1)\creature_Attack = 20
   creature(1)\creature_schaden_min = 1
   creature(1)\creature_schaden_max = 2
   creature(1)\creature_MaxSpeed = 10

   ; Skelett
   creature(2)\creature_LifePoints = 10
   creature(2)\creature_Attack = 40
   creature(2)\creature_schaden_min = 1
   creature(2)\creature_schaden_max = 4
   creature(2)\creature_MaxSpeed = 4

   ; Todesritter
   creature(3)\creature_LifePoints = 20
   creature(3)\creature_Attack = 70
   creature(3)\creature_schaden_min = 1
   creature(3)\creature_schaden_max = 10
   creature(3)\creature_MaxSpeed = 5

   ; Sternenfee
   creature(4)\creature_LifePoints = 10
   creature(4)\creature_Attack = 40
   creature(4)\creature_schaden_min = 1
   creature(4)\creature_schaden_max = 2
   creature(4)\creature_MaxSpeed = 15

   ; Tiger
   creature(5)\creature_LifePoints = 25
   creature(5)\creature_Attack = 70
   creature(5)\creature_schaden_min = 2
   creature(5)\creature_schaden_max = 10
   creature(5)\creature_MaxSpeed = 7

   ; Mumie
   creature(6)\creature_LifePoints = 50
   creature(6)\creature_Attack = 60
   creature(6)\creature_schaden_min = 2
   creature(6)\creature_schaden_max = 15
   creature(6)\creature_MaxSpeed = 4

   ; Daemon
   creature(7)\creature_LifePoints = 70
   creature(7)\creature_Attack = 80
   creature(7)\creature_schaden_min = 3
   creature(7)\creature_schaden_max = 20
   creature(7)\creature_MaxSpeed = 8

   ; Engel
   creature(8)\creature_LifePoints = 70
   creature(8)\creature_Attack = 80
   creature(8)\creature_schaden_min = 3
   creature(8)\creature_schaden_max = 20
   creature(8)\creature_MaxSpeed = 8

   ; Drache
   creature(9)\creature_LifePoints = 100
   creature(9)\creature_Attack = 80
   creature(9)\creature_schaden_min = 4
   creature(9)\creature_schaden_max = 25
   creature(9)\creature_MaxSpeed = 5

   ; Doppelganger
   creature(10)\creature_LifePoints = 0
   creature(10)\creature_Attack = 60
   creature(10)\creature_schaden_min = 2
   creature(10)\creature_schaden_max = 10
   creature(10)\creature_MaxSpeed = 0

   ; Vogel
   creature(11)\creature_LifePoints = 5
   creature(11)\creature_Attack = 20
   creature(11)\creature_schaden_min = 1
   creature(11)\creature_schaden_max = 2
   creature(11)\creature_MaxSpeed = 12

   ; Golem
   creature(12)\creature_LifePoints = 100
   creature(12)\creature_Attack = 60
   creature(12)\creature_schaden_min = 2
   creature(12)\creature_schaden_max = 10
   creature(12)\creature_MaxSpeed = 4

   ; Satyr
   creature(13)\creature_LifePoints = 20
   creature(13)\creature_Attack = 60
   creature(13)\creature_schaden_min = 2
   creature(13)\creature_schaden_max = 8
   creature(13)\creature_MaxSpeed = 6

   ; Feuerelementar
   creature(14)\creature_LifePoints = 24
   creature(14)\creature_Attack = 60
   creature(14)\creature_schaden_min = 2
   creature(14)\creature_schaden_max = 14
   creature(14)\creature_MaxSpeed = 5

   ; Wasserelementar
   creature(15)\creature_LifePoints = 24
   creature(15)\creature_Attack = 60
   creature(15)\creature_schaden_min = 2
   creature(15)\creature_schaden_max = 14
   creature(15)\creature_MaxSpeed = 5

EndProcedure


Procedure special_success(spell.w)

   akt_power.w = power(spell)
   ; Special success?
   If Random(1000) <= 5
      akt_power = akt_power * 2
      nachricht(737,#COLOR_BLAU)
   EndIf
   
   ProcedureReturn akt_power
   
EndProcedure


Procedure zauberkosten(spell.w)

Shared akt_spieler

   kosten.w = zauber(spell,akt_spieler)\kosten + (spieler(akt_spieler)\spellweaving - 1)
   
   ProcedureReturn kosten

EndProcedure


Procedure immune(gegen.w)

Shared akt_spieler, spell_x, spell_y
   
   If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,gegen) = 0 Or habich(#SPELL_PENETRATION) > 0
      res.w = 0
   Else
      res = 1
   EndIf
   
   ProcedureReturn res

EndProcedure


Procedure dispelled()

Shared akt_spieler, spell_x, spell_y

   disp.w = 0
   If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,#ME_DISPEL) = 1 And Random(100) > 50 And habich(#SPELL_PENETRATION) = 0
      disp = 1
   EndIf
   
   ProcedureReturn disp

EndProcedure


Procedure zug_verlieren()

Shared aktion, akt_spieler

   If habich(#SPELL_SCHNELLZAUBER) = 0
      aktion = 1
   Else
      ; Metamagic ausschalten
      For i = 1 To 15
         If aktive(i,akt_spieler)\dauer = #META_MAGIC
            aktive(i,akt_spieler)\dauer = 0
            aktive(i,akt_spieler)\nr = 0
            aktive(i,akt_spieler)\staerke = 0
         EndIf
      Next
   EndIf

EndProcedure


Procedure mana_verlieren(spell.w)

Shared akt_spieler, schriftrolle

   If schriftrolle = 0
      kosten.w = zauberkosten(spell)
      If habich(#SPELL_SYPHON) > 0
         kosten = kosten / 2
         If kosten <= 1
            kosten = 1
         EndIf
      EndIf
      spieler(akt_spieler)\Mana = spieler(akt_spieler)\Mana - kosten
   EndIf

EndProcedure


Procedure hydra_zauber(schaden.w)

Shared akt_spieler, spell_x, spell_y

   If labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\feld[spieler(akt_spieler)\level] >=#FELD_HYDRA1 And labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\feld[spieler(akt_spieler)\level] <= #FELD_HYDRA12
   
      If schaden > min(max(spieler(akt_spieler)\level/2+1,6),15)
         ; Ein Kopf weniger
         labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level] = labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level] - 1
         nachricht(287,#COLOR_ROT)
         nachricht3(289,labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level],290)
         If labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level] < 1
            setlaby(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+4,raumy(spieler(akt_spieler)\level)+3,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+5,raumy(spieler(akt_spieler)\level)+3,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+6,raumy(spieler(akt_spieler)\level)+3,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+4,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+4,raumy(spieler(akt_spieler)\level)+4,spieler(akt_spieler)\level,#FELD_GOLD,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+5,raumy(spieler(akt_spieler)\level)+4,spieler(akt_spieler)\level,#FELD_GOLD,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+6,raumy(spieler(akt_spieler)\level)+4,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+5,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+4,raumy(spieler(akt_spieler)\level)+5,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+5,raumy(spieler(akt_spieler)\level)+5,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
            setlaby(raumx(spieler(akt_spieler)\level)+6,raumy(spieler(akt_spieler)\level)+5,spieler(akt_spieler)\level,#FELD_HOEHLE2_LEER,0,0,0)
         EndIf
      Else
         ; New Heads!
         neue_koepfe = Random(1)+1
         labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level] = labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level] + neue_koepfe
         If labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level] > 9
            labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level] = 9
         EndIf
         nachricht3(289,labyrinth(raumx(spieler(akt_spieler)\level)+3,raumy(spieler(akt_spieler)\level)+3)\lebenspunkte[spieler(akt_spieler)\level],290)
      EndIf
   EndIf

EndProcedure

; -----------------------------------------------------------------------------

Procedure schnelltasten()

Shared zauberliste, schnellzauber, akt_spieler, akt_zauber, akt_zauber_offset, joystick_used

   ; Zauber Schnelltasten
   If KeyboardPushed(#PB_Key_1) And schnellzauber(1,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(1,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_2) And schnellzauber(2,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(2,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_3) And schnellzauber(3,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(3,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_4) And schnellzauber(4,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(4,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_5) And schnellzauber(5,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(5,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_6) And schnellzauber(6,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(6,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_7) And schnellzauber(7,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(7,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_8) And schnellzauber(8,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(8,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_9) And schnellzauber(9,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(9,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   If KeyboardPushed(#PB_Key_0) And schnellzauber(10,akt_spieler) <> ""
      zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber(10,akt_spieler)
      cast_it()
      laby_screen()
      Goto nach_zauber
   EndIf
   
   ; Joystick Buttons
   If joystick_used = 1
      For xx.b = 1 To 8
         If JoystickButton(xx+4) And schnellzauber2(xx,akt_spieler) <> ""
            zauberliste(akt_zauber+akt_zauber_offset)\name[2] = schnellzauber2(xx,akt_spieler)
            cast_it()
            laby_screen()
            Goto nach_zauber
         EndIf
      Next
   EndIf

EndProcedure

; -----------------------------------------------------------------------------

Procedure eisschaden(schaden.w)

Shared akt_spieler, spell_x, spell_y, mydelay, inhalt

   testfeld.w = labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\feld[spieler(akt_spieler)\Level]
   If spieler(akt_spieler)\character_x + spell_x > 0 And spieler(akt_spieler)\character_y + spell_y > 0
      If testfeld > #ANZ_FELDER And testfeld <= #ANZ_FELDER+#ANZ_MONSTER  ; Monster ?
         If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,#ME_DISPEL) = 1 And Random(100) > 50 And habich(#SPELL_PENETRATION) = 0
            nachricht(312,#COLOR_BLAU)
         Else
            ; Eisfest ?
            If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,#ME_EISFEST) = 0 Or habich(#SPELL_PENETRATION) > 0
               monsterschaden(schaden)
            Else
               nachricht(267,#COLOR_ROT)
            EndIf
         EndIf
      EndIf
      ; Feuer?
      If testfeld = #FELD_FEUER1 Or testfeld = #FELD_FEUER2 Or testfeld = #FELD_FEUER3
         If schaden > 3
            Sound(#SOUND_SPLASH)
            setlaby(spieler(akt_spieler)\character_x+spell_x,spieler(akt_spieler)\character_y+spell_y,spieler(akt_spieler)\level,inhalt(spieler(akt_spieler)\level),0,0,0)
            Delay(mydelay)
            laby_screen()
         EndIf
      EndIf
   EndIf
EndProcedure

; -----------------------------------------------------------------------------

Procedure feuerschaden(schaden.w)

Shared akt_spieler, spell_x, spell_y, mydelay, inhalt

   testfeld.w = labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\feld[spieler(akt_spieler)\Level]
   If spieler(akt_spieler)\character_x + spell_x > 0 And spieler(akt_spieler)\character_y + spell_y > 0
      If istmonster(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1
         If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,#ME_DISPEL) = 1 And Random(100) > 50 And habich(#SPELL_PENETRATION) = 0
            nachricht(312,#COLOR_BLAU)
         Else
            If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,#ME_BRENNT) = 1
               schaden = schaden * 2
            EndIf
            ; Feuerfest ?
            If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,#ME_FEUERFEST) = 0 Or habich(#SPELL_PENETRATION) > 0
               monsterschaden(schaden)
            Else
               nachricht(265,#COLOR_ROT)
            EndIf
         EndIf
      EndIf
      If testfeld = #FELD_EIS     ; Eisblock
         If schaden > 3
            Sound(#SOUND_GLASS)
            setlaby(spieler(akt_spieler)\character_x+spell_x,spieler(akt_spieler)\character_y+spell_y,spieler(akt_spieler)\level,inhalt(spieler(akt_spieler)\level),0,0,0)
            Delay(mydelay)
            laby_screen()
         EndIf
      EndIf
   EndIf
EndProcedure

; -----------------------------------------------------------------------------

Procedure eintragen(nr.w, staerke.w, dauer.w, source.w)

Shared akt_spieler

   ; Alle gleichen Spells rauswerfen
   For i = 1 To 15
      If aktive(i,akt_spieler)\nr = nr And aktive(i,akt_spieler)\source = source
         aktive(i,akt_spieler)\nr = 0
         aktive(i,akt_spieler)\staerke = 0
         aktive(i,akt_spieler)\dauer = 0
      EndIf
   Next
   
   ; Alle anderen Shapechangers rauswerfen
   If nr >= #SPELL_FLEDERMAUSGESTALT And nr <= #SPELL_DRACHENGESTALT
      For i = 1 To 15
         If aktive(i,akt_spieler)\nr = #SPELL_FLEDERMAUSGESTALT Or aktive(i,akt_spieler)\nr = #SPELL_WOLFSGESTALT Or aktive(i,akt_spieler)\nr = #SPELL_VOGELGESTALT Or aktive(i,akt_spieler)\nr = #SPELL_KATZENGESTALT Or aktive(i,akt_spieler)\nr = #SPELL_DRACHENGESTALT
            aktive(i,akt_spieler)\nr = 0
            aktive(i,akt_spieler)\staerke = 0
            aktive(i,akt_spieler)\dauer = 0
         EndIf
      Next
   EndIf
   
   ; Alle anderen Kreatur Verzauberungen rauswerfen
   If nr >= #SPELL_VERZAUBERE_KREATUR_1 And nr <= #SPELL_VERZAUBERE_KREATUR_4
      For i = 1 To 15
         If aktive(i,akt_spieler)\nr = #SPELL_VERZAUBERE_KREATUR_1 Or aktive(i,akt_spieler)\nr = #SPELL_VERZAUBERE_KREATUR_2 Or aktive(i,akt_spieler)\nr = #SPELL_VERZAUBERE_KREATUR_3 Or aktive(i,akt_spieler)\nr = #SPELL_VERZAUBERE_KREATUR_4
            aktive(i,akt_spieler)\nr = 0
            aktive(i,akt_spieler)\staerke = 0
            aktive(i,akt_spieler)\dauer = 0
         EndIf
      Next
   EndIf

   i = 1
   pos = 0
   Repeat
      If aktive(i,akt_spieler)\nr = 0
         pos = i
      EndIf
      i = i + 1
   Until i > 15 Or pos > 0

   If i <= 15
      aktive(pos,akt_spieler)\nr = nr
      aktive(pos,akt_spieler)\staerke = staerke
      
      If dauer = #META_MAGIC
         aktive(pos,akt_spieler)\dauer = #META_MAGIC
      Else
         If dauer <> #UNENDLICH
            If habich(#SPELL_VERLAENGERN2) > 0
               dauer = dauer * 2
            EndIf
         
            If skills(#CE_BESTAENDIGKEIT,akt_spieler)\gewaehlt = 1
               dauer = dauer * 2
            EndIf
            
            If skills(#CE_KURZE_MAGIE,akt_spieler)\gewaehlt = 1
               dauer = dauer / 2
            EndIf
            
            If spieler(akt_spieler)\fluch = #FLUCH_DER_TANIS
               dauer = dauer / 2
            EndIf
         EndIf
         
         aktive(pos,akt_spieler)\dauer = dauer
         aktive(pos,akt_spieler)\source = source
      EndIf
   EndIf

EndProcedure

; -----------------------------------------------------------------------------

Procedure habich(nr.w)

Shared aktive, akt_spieler

   habich = 0
   gef = 0
   For i = 1 To 15
      If aktive(i,akt_spieler)\nr = nr
         habich = aktive(i,akt_spieler)\staerke
         gef = 1
      EndIf
   Next
   If habich = 0 And gef = 1   ; Zauber ohne staerke als 1 melden!
      habich = 1
   EndIf

   ProcedureReturn = habich


EndProcedure

; -----------------------------------------------------------------------------

Procedure hater(nr.w,xx)

Shared aktive

   hater = 0
   For i = 1 To 15
      If aktive(i,xx)\nr = nr
         hater = 1
      EndIf
   Next

   ProcedureReturn = hater


EndProcedure

; -----------------------------------------------------------------------------

Procedure sog()

Shared spell_x, spell_y

      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)
      For j = 1 To 5
         For i = 1 To 4
            laby_screen2()
            If i = 1
               ClipSprite(#SPRITE_TILESET_ANIMATIONEN, 80, 40, 39, 39)
            EndIf
            If i = 2
               ClipSprite(#SPRITE_TILESET_ANIMATIONEN, 120, 40, 39, 39)
            EndIf
            If i = 3
               ClipSprite(#SPRITE_TILESET_ANIMATIONEN, 1, 80, 39, 39)
            EndIf
            If i = 4
               ClipSprite(#SPRITE_TILESET_ANIMATIONEN, 40, 80, 39, 39)
            EndIf
            DisplayTransparentSprite(#SPRITE_TILESET_ANIMATIONEN, 156+spell_x*32, 156+spell_y*32)
            FlipBuffers()
            Delay(90)
         Next
      Next
      StopDrawing()

EndProcedure

; --------------------------------------------------------------

Procedure Spraygrafik(radius,dauer)

  z=6*32-15
  For i=1 To dauer
    laby_screen2()
    For j=0 To 360 Step 10
      r=Random(1) : g=Random(1) : b=Random(1)
      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)
      FrontColor (RGB(r*255,g*255,b*255))
      Line (z,z,z+Sin(j)*radius,z+Cos(j)*radius)
      StopDrawing()
    Next
    FlipBuffers()
    Delay (100)
  Next

EndProcedure

; -------------------------------------------------------------------------

Procedure Sternchen(x.w,y.w,stern.w)

Shared akt_spieler, frame

  For i=1 To 20
    xsprites(i)=0:ysprites(i)=0:fsprites(i)=-i-1:rsprites(i)=1
  Next
  For j=1 To 30
    laby_screen2()
    For i=1 To 20
      fsprites(i)=fsprites(i)+rsprites(i)
      If fsprites(i)>=4
         rsprites(i)=-1
      EndIf
      If fsprites(i)=-1
         xsprites(i)=Random(32):ysprites(i)=Random(32):rsprites(i)=1
      EndIf
      If fsprites(i)>=0
        ClipSprite(#SPRITE_TILESET_STARS, fsprites(i)+stern*5, stern*9-9, 9, 9)
        DisplayTransparentSprite(#SPRITE_TILESET_STARS,x+xsprites(i)-5,y+ysprites(i)-5)
      EndIf
    Next
    FlipBuffers()
    Delay(50)
  Next

EndProcedure

; -------------------------------------------------------------------------

Procedure Sternchen2(x.w,y.w,stern.w)

Shared akt_spieler, frame

  For i=1 To 20
    xsprites(i)=0:ysprites(i)=0:fsprites(i)=-i-1:rsprites(i)=1
  Next
  For j=1 To 30
    laby_screen3()
    For i=1 To 20
      fsprites(i)=fsprites(i)+rsprites(i)
      If fsprites(i)>=4
         rsprites(i)=-1
      EndIf
      If fsprites(i)=-1
         xsprites(i)=Random(32):ysprites(i)=Random(32):rsprites(i)=1
      EndIf
      If fsprites(i)>=0
        ClipSprite(#SPRITE_TILESET_STARS, fsprites(i)+stern*5, stern*9-9, 9, 9)
        DisplayTransparentSprite(#SPRITE_TILESET_STARS,x+xsprites(i)-5,y+ysprites(i)-5)
      EndIf
    Next
    FlipBuffers()
    Delay(50)
  Next

EndProcedure

;---------------------------------------------------------------------------------------

Procedure faechergrafik()

  a=1
  s=5
  While 32*6>a*s
    laby_screen2()
    For i=1 To a
      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)
      FrontColor(RGB(255,255,255))
      LineXY (32*6-15-i*s,32*6-15-i*s,32*6-15+i*s,32*6-15-i*s)
      LineXY (32*6-15+i*s,32*6-15-i*s,32*6-15+i*s,32*6-15+i*s)
      LineXY (32*6-15+i*s,32*6-15+i*s,32*6-15-i*s,32*6-15+i*s)
      LineXY (32*6-15-i*s,32*6-15+i*s,32*6-15-i*s,32*6-15-i*s)
      StopDrawing()
    Next
    FlipBuffers()
    Delay (25)
    a=a+1
  Wend

EndProcedure

; -------------------------------------------------------------------------------

Procedure versteinern()

Shared spell_x, spell_y
   
    wohin = ScreenOutput()
    StartDrawing(wohin)
       DrawingMode(1)
       FrontColor(RGB(255,255,255))
       For akt_zeile = 32 To 1 Step -1
          Line(160+spell_x*32, 160+akt_zeile+spell_y*32, 32, 0)
          FlipBuffers()
          Delay(20)
       Next
    StopDrawing()
    

EndProcedure

; -------------------------------------------------------------------------------

Procedure todesblick()

Shared spell_x, spell_y
   
    wohin = ScreenOutput()
    StartDrawing(wohin)
       DrawingMode(1)
       FrontColor(RGB(0,0,0))
       For akt_zeile = 32 To 1 Step -1
          Line(160+spell_x*32, 160+akt_zeile+spell_y*32, 32, 0)
          FlipBuffers()
          Delay(20)
       Next
    StopDrawing()
    

EndProcedure

; -------------------------------------------------------------------------------

Procedure wr_txt(what,nr1,nr2,x,y)

Shared sprache, zauberliste

   If nr1 = 0 And nr2 = 0
   DrawText(x,y,zauberliste(what)\name[1+sprache])
   EndIf
   
   If nr1 > 0 And nr2 = 0
  DrawText(x,y,zauberliste(what)\name[1+sprache] + " (" + Str(nr1) + ")")
   EndIf
   
   If nr1 = 0 And nr2 > 0
     DrawText(x,y,zauberliste(what)\name[1+sprache] + " (B" + Str(nr2) + ")")
   EndIf
   
   If nr1 > 0 And nr2 > 0
  DrawText(x,y,zauberliste(what)\name[1+sprache] + " (" + Str(nr1) + ")" + " (B" + Str(nr2) + ")")
   EndIf

EndProcedure

; -------------------------------------------------------------------------------

Procedure liste_leeren()

   For i.w = 1 To #ANZ_ZAUBER
      For j.w = 1 To #ANZ_SPRACHEN
         zauberliste(i)\name[j] = ""
      Next
   Next
   
EndProcedure

; -------------------------------------------------------------------------------

Procedure zauber_nehmen(i.w)

Shared akt_spieler

      nehmen.w = 0
      If zauber(i,akt_spieler)\level <= spieler(akt_spieler)\circle
         If (summoning(i) = 1 Or zauber(i,akt_spieler)\art = "beschw�er") And skills(#CE_BESCHWOERER,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "basis" And skills(#CE_KEINE_BASISMAGIE,akt_spieler)\gewaehlt = 0
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "erde" And (skills(#CE_ERDMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1)
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "feuer" And (skills(#CE_FEUERMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1)
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "schwarz" And skills(#CE_SCHWARZE_MAGIE,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "druide" And skills(#CE_DRUIDENMAGIE,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "wasser" And (skills(#CE_WASSERMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1)
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "sterne" And skills(#CE_STERNENMAGIE,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "luft" And (skills(#CE_LUFTMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1)
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "weiss" And skills(#CE_WEISSE_MAGIE,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "barde" And skills(#CE_ZAUBERLIEDER,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "illusion" And skills(#CE_ILLUSIONSMAGIE,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "hohe" And skills(#CE_HOHE_MAGIE,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "hexerei" And skills(#CE_HEXEREI,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
         If zauber(i,akt_spieler)\art = "warlock" And skills(#CE_WARLOCK,akt_spieler)\gewaehlt = 1
            nehmen = 1
         EndIf
      EndIf

   ProcedureReturn nehmen

EndProcedure

; -------------------------------------------------------------------------------

Procedure bubblesort()

Shared anz_zauber, akt_zauber_offset2, sprache

   ; Bubblesort
   Global Dim zwischen.s(#ANZ_SPRACHEN)
   For i.w = 1 To anz_zauber - 2
      For j.w = 1 To anz_zauber - 2
         If zauberliste(j+akt_zauber_offset2)\name[1+sprache] > zauberliste(j+akt_zauber_offset2+1)\name[1+sprache]
            For k = 1 To #ANZ_SPRACHEN
               zwischen(k) = zauberliste(j+akt_zauber_offset2)\name[k]
               zauberliste(j+akt_zauber_offset2)\name[k] = zauberliste(j+akt_zauber_offset2+1)\name[k]
               zauberliste(j+akt_zauber_offset2+1)\name[k] = zwischen(k)
            Next
         EndIf
      Next
   Next

EndProcedure

; -------------------------------------------------------------------------------

Procedure erstelle_liste()

Shared akt_spieler, anz_zauber, akt_zauber_offset2, sprache

   ; Liste der besessenen Zauber erstellen
   liste_leeren()
   
   anz_zauber = 1
   For i.w = 1 To #ANZ_ZAUBER
      nehmen.w = zauber_nehmen(i)
      
      ; Durch Scrollore?
      If zauber(i,akt_spieler)\erlernt = 1
         nehmen = 1
      EndIf
      
      If (spieler(akt_spieler)\schule = "frei" And zauber(i,akt_spieler)\erlernt = 1) Or (spieler(akt_spieler)\schule = "beschw�er" And summoning(i) = 1)
      Else
         If spieler(akt_spieler)\schule <> ""
            If zauber(i,akt_spieler)\art <> spieler(akt_spieler)\schule
               nehmen = 0
            EndIf
         EndIf
      EndIf
      
      If nehmen = 1
         For k = 1 To #ANZ_SPRACHEN
            zauberliste(anz_zauber+akt_zauber_offset2)\name[k] = zauber(i,akt_spieler)\name[k]
         Next
         anz_zauber = anz_zauber + 1
      EndIf
   Next
   
   bubblesort()

   For k = 1 To #ANZ_SPRACHEN
      zauberliste(anz_zauber+akt_zauber_offset2)\name[k] = nachricht_text(650,k)
   Next
      
EndProcedure

; -------------------------------------------------------------------------------

Procedure spellweaving()

Shared akt_spieler, no_mouse

   If no_mouse = 0
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mmouse_links   = MouseButton(1)
   EndIf

   ; Links Button
   If mmouse_x > 50 And mmouse_x < 82 And mmouse_y > 365 And mmouse_y < 397
      ClipSprite(#SPRITE_TILESET_ITEMS, 160, 576, 32, 32)
      If mmouse_links = 1
         spieler(akt_spieler)\spellweaving = spieler(akt_spieler)\spellweaving - 1
         If spieler(akt_spieler)\spellweaving < 1
            spieler(akt_spieler)\spellweaving = 1
         EndIf
      EndIf 
   Else
      ClipSprite(#SPRITE_TILESET_ITEMS, 96, 384, 32, 32)
   EndIf 
   DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 50, 365)

   ; Rechts Button
   If mmouse_x > 94 And mmouse_x < 126 And mmouse_y > 365 And mmouse_y < 397
      ClipSprite(#SPRITE_TILESET_ITEMS, 128, 576, 32, 32)
      If mmouse_links = 1
         spieler(akt_spieler)\spellweaving = spieler(akt_spieler)\spellweaving + 1
         If spieler(akt_spieler)\spellweaving > 9
            spieler(akt_spieler)\spellweaving = 9
         EndIf
      EndIf
   Else
      ClipSprite(#SPRITE_TILESET_ITEMS, 64, 384, 32, 32)
   EndIf
   DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 94, 365)
   
   wohin = ScreenOutput()
   StartDrawing(wohin)
   DrawingMode(1)
   FrontColor(RGB(255,255,255))
   DrawText(84,372,Str(spieler(akt_spieler)\spellweaving))
   StopDrawing()
   Delay(40)

EndProcedure


Procedure schulenicons()

Shared akt_spieler, akt_zauber, no_mouse

   If no_mouse = 0
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mouse_links   = MouseButton(1)
      mouse_rechts  = MouseButton(2)
   EndIf

   x.w = #POS_ICON_X
   y.w = #POS_ICON_Y
   ClipSprite(#SPRITE_ICONS, 1*19, 0, 16, 19)
   DisplaySprite(#SPRITE_ICONS, x, y)
   If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
      spieler(akt_spieler)\schule = ""
      erstelle_liste()
      spieler(akt_spieler)\pos_zaubermenue = 0
      akt_zauber = 0
   EndIf
   x = x + 19
   
   If skills(#CE_KEINE_BASISMAGIE,akt_spieler)\gewaehlt = 0
      ClipSprite(#SPRITE_ICONS, 3*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "basis"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_SCROLLORE,akt_spieler)\gewaehlt = 1 Or skills(#CE_FREIE_MAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 15*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "frei"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_STERNENMAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 10*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "sterne"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_ILLUSIONSMAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 9*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "illusion"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_WARLOCK,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 11*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "warlock"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_WEISSE_MAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 13*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "weiss"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_SCHWARZE_MAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 4*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "schwarz"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_FEUERMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 7*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "feuer"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_WASSERMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 12*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "wasser"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_ERDMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 6*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "erde"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_LUFTMAGIE,akt_spieler)\gewaehlt = 1 Or skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 0*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "luft"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_DRUIDENMAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 5*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "druide"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_HEXEREI,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 14*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "hexerei"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_HOHE_MAGIE,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 8*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "hohe"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_ZAUBERLIEDER,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 2*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "barde"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf
   
   If skills(#CE_BESCHWOERER,akt_spieler)\gewaehlt = 1
      ClipSprite(#SPRITE_ICONS, 16*19, 0, 16, 19)
      DisplaySprite(#SPRITE_ICONS, x, y)
      If mouse_links = 1 And mmouse_x >= x And mmouse_x <= x+16 And mmouse_y >= y And mmouse_y <= y+16
         spieler(akt_spieler)\schule = "beschw�er"
         erstelle_liste()
         spieler(akt_spieler)\pos_zaubermenue = 0
         akt_zauber = 0
      EndIf
      x = x + 19
   EndIf

EndProcedure

; -------------------------------------------------------------------------------

Procedure zauber_rahmen()

Shared anz_zauber, akt_zauber, akt_spieler, yplus, yplus2, test, akt_zauber_offset, anzz
Shared sprache, mauszauber

   ; Ueberbleibsel des Labyrinths uebermalen
   wohin = ScreenOutput()
   StartDrawing(wohin)
   FrontColor(RGB(0,0,0))
   Box(365,15,260,449) 
   Box(15,365,335,51)
   StopDrawing()

   ; Rahmen zeichnen
   ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
   DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
   DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
   ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
   DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 464)
   ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
   DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 624, 0)

   ClipSprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 0, 365, 17)
   DisplaySprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 350)
   ClipSprite(#SPRITE_RAHMEN_SCHMAL1, 0, 0, 274, 16)
   DisplaySprite(#SPRITE_RAHMEN_SCHMAL1, 350, 35)
   ClipSprite(#SPRITE_RAHMEN_SCHMAL2, 0, 0, 274, 16)
   DisplaySprite(#SPRITE_RAHMEN_SCHMAL2, 350, 375)
   
   ClipSprite(#SPRITE_RAHMEN_MITTE, 0, 0, 17, 480)
   DisplaySprite(#SPRITE_RAHMEN_MITTE, 350, 0)

   wohin = ScreenOutput()
   StartDrawing(wohin)
      DrawingMode(1)
      FrontColor(RGB(255,255,255))  ; Weiss
      DrawText(440, 18,  nachricht4(100))

      ; In der Mitte wird ausgewaehlt
      FrontColor(RGB(150,150,150))
      Box(365,200+yplus2,260,yplus)

      ; Zauber darstellen
      x = 400
      y = 52
      besch = 0
      mzauber.s = ""
      For i = 1 To anzz
         FrontColor(RGB(255,255,255))  ; Weiss
         If i = mauszauber
            FrontColor(RGB(1,1,255))  ; Blau
            mzauber = zauberliste(i + akt_zauber)\name[2]
         EndIf

         hamwer = 0
         merker = 0
         merker2 = 0
         If zauberliste(i + akt_zauber)\name[2] <> ""
            If schnellzauber(1,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 1
               hamwer = 1
            EndIf
            If schnellzauber(2,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 2
               hamwer = 1
            EndIf
            If schnellzauber(3,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 3
               hamwer = 1
            EndIf
            If schnellzauber(4,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 4
               hamwer = 1
            EndIf
            If schnellzauber(5,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 5
               hamwer = 1
            EndIf
            If schnellzauber(6,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 6
               hamwer = 1
            EndIf
            If schnellzauber(7,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 7
               hamwer = 1
            EndIf
            If schnellzauber(8,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 8
               hamwer = 1
            EndIf
            If schnellzauber(9,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 9
               hamwer = 1
            EndIf
            If schnellzauber(10,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker = 10
               hamwer = 1
            EndIf
            
            If schnellzauber2(1,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 1
               hamwer = 1
            EndIf
            If schnellzauber2(2,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 2
               hamwer = 1
            EndIf
            If schnellzauber2(3,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 3
               hamwer = 1
            EndIf
            If schnellzauber2(4,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 4
               hamwer = 1
            EndIf
            If schnellzauber2(5,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 5
               hamwer = 1
            EndIf
            If schnellzauber2(6,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 6
               hamwer = 1
            EndIf
            If schnellzauber2(7,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 7
               hamwer = 1
            EndIf
            If schnellzauber2(8,akt_spieler) = zauberliste(i + akt_zauber)\name[2]
               merker2 = 8
               hamwer = 1
            EndIf
            If hamwer = 1
               wr_txt(i + akt_zauber,merker,merker2,x,y)
            Else
               wr_txt(i + akt_zauber,0,0,x,y)
            EndIf
         EndIf

         y = y + yplus
      Next
      FrontColor(RGB(255,255,255))  ; Weiss

      ; Beschreibung zu momentanem Zauber
      If mzauber = ""
         For i = 1 To #ANZ_ZAUBER
            If zauber(i,akt_spieler)\name[2] = zauberliste(akt_zauber + akt_zauber_offset)\name[2]
               besch = i
            EndIf
         Next
      Else
         For i = 1 To #ANZ_ZAUBER
            If zauber(i,akt_spieler)\name[2] = mzauber
               besch = i
            EndIf
         Next
      EndIf
      
      
      If besch > 0
         x = 415
         y = 390
         xadd = 150

         DrawText(x,y,nachricht4(61))
         DrawText(x+xadd,y,Str(zauber(besch,akt_spieler)\level))
         
         y = y + yplus
         DrawText(x,y,nachricht4(101))
         DrawText(x+xadd,y,Str(zauber(besch,akt_spieler)\kosten + (spieler(akt_spieler)\spellweaving - 1)))
         
         y = y + yplus
         DrawText(x,y,nachricht4(91))
         DrawText(x+xadd,y,Str(Power(besch)))
         
         y = y + yplus
         DrawText(x,y,nachricht4(102))
         DrawText(x+xadd,y,Str(zauber(besch,akt_spieler)\dauer))
         
         y = y + yplus
         DrawText(x,y,nachricht4(103))
         DrawText(x+xadd,y,Str(zauberchance(besch)))

         DrawText(25,400,zauber(besch,akt_spieler)\besch_1[1+sprache])
         DrawText(25,420,zauber(besch,akt_spieler)\besch_2[1+sprache])
      EndIf


   StopDrawing()
   
   schulenicons()
   If skills(#CE_ZAUBERWEBEN,akt_spieler)\gewaehlt = 1
      spellweaving()
   EndIf

EndProcedure

; ------------------------------------------------------------------------------------------

; Sicherversperrende Felder
Procedure blockiert(x.w,y.w)

Shared akt_spieler

   blocked.w = 0
   
   testfeld.w = labyrinth(x,y)\feld[spieler(akt_spieler)\level]

   If testfeld = #FELD_MAUER Or testfeld = #FELD_MAUER2 Or testfeld = #FELD_MAUER3 Or testfeld = #FELD_MAUER4 Or testfeld = #FELD_MAUER5 Or testfeld = #FELD_GEHEIMGANG Or testfeld = #FELD_TUER2 Or testfeld = #FELD_EIS Or testfeld = #FELD_SUMPF2 Or testfeld = #FELD_GRABSTEIN Or testfeld = #FELD_BAUM_KLEIN Or testfeld = #FELD_FELSBROCKEN Or testfeld = #FELD_MOND Or testfeld = #FELD_HOEHLE2_MAUER Or testfeld = #FELD_LEUCHTER Or testfeld = #FELD_WAND_WEISS Or testfeld = #FELD_FEUER2 Or testfeld = #FELD_HUETTE
      blocked = 1
   EndIf
   
   ProcedureReturn blocked

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure los()

Shared spell_x, spell_y, blocked, akt_spieler

   blocked = 0
   If spell_x = 0 Or spell_y = 0   ; Nur Horizontal oder Vertikal erlaubt
      If spell_x < -1    ; links vom character
         x = spieler(akt_spieler)\character_x + spell_x + 1
         y = spieler(akt_spieler)\character_y
         For i = x To spieler(akt_spieler)\character_x
            If blockiert(x,y) = 1
               blocked = 1
            EndIf
            x = x + 1
         Next
      EndIf
      If spell_x > 1    ; rechts vom character
         x = spieler(akt_spieler)\character_x
         y = spieler(akt_spieler)\character_y
         For i = x To spieler(akt_spieler)\character_x + spell_x - 1
            If blockiert(x,y) = 1
               blocked = 1
            EndIf
            x = x + 1
         Next
      EndIf
      If spell_y < -1    ; oberhalb vom character
         x = spieler(akt_spieler)\character_x
         y = spieler(akt_spieler)\character_y + spell_y + 1
         For i = y To spieler(akt_spieler)\character_y
            If blockiert(x,y) = 1
               blocked = 1
            EndIf
            y = y + 1
         Next
      EndIf
      If spell_y > 1   ; unterhalb vom character
         x = spieler(akt_spieler)\character_x
         y = spieler(akt_spieler)\character_y
         For i = y To spieler(akt_spieler)\character_y + spell_y - 1
            If blockiert(x,y) = 1
               blocked = 1
            EndIf
            y = y + 1
         Next
      EndIf
   Else
      blocked = 1
   EndIf
   
   If habich(#SPELL_TUNNEL) = 1
      blocked = 0
   EndIf

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure monsterschaden(schaden.w)

Shared akt_spieler, spell_x, spell_y, mydelay, sprache
   
   ; Monster ? 
   If istmonster(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1
   
      ; Unsichtbarkeit weg!
      For i = 1 To 15
         If aktive(i,akt_spieler)\nr = #SPELL_UNSICHTBARKEIT And aktive(i,akt_spieler)\dauer <> #UNENDLICH
            aktive(i,akt_spieler)\nr = 0
            aktive(i,akt_spieler)\staerke = 0
            aktive(i,akt_spieler)\dauer = 0
         EndIf
      Next
      
      laby_screen2()
      
      ; Im Sichtfeld?
      If spell_x > -6 And spell_x < 6 And spell_y > -6 And spell_y < 6
         ; Roten Fleck darstellen
         ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 7*32, 32, 32)
         DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+ spell_x*32, 160 + spell_y*32)
         ; Schaden darstellen
         wohin = ScreenOutput()
         StartDrawing(wohin)
            DrawingMode(1)
               ; Verschieben bei groesseren Zahlen
               If schaden < 10: xx=172+ spell_x*32:yy= 168 + spell_y*32: EndIf
               If schaden >= 10: xx=166+ spell_x*32: yy = 168 + spell_y*32: EndIf
               If schaden >= 100: xx=163+ spell_x*32:yy= 168 + spell_y*32: EndIf
            FrontColor(RGB(255,255,255))  ; Weiss
            DrawText(xx,yy,Str(schaden))
         StopDrawing()
      EndIf
   
      ; Ruestung abziehen
      If habich(#SPELL_BRECHER) = 0
         schaden = schaden - Random(monster(labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\objekt[spieler(akt_spieler)\level])  \ruestung)
         If schaden < 1
            schaden = 0
         EndIf
      EndIf

      labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\lebenspunkte[spieler(akt_spieler)\level] = labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\lebenspunkte[spieler(akt_spieler)\level] - schaden
   
      ; Monster tot ?
      If labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\lebenspunkte[spieler(akt_spieler)\level] < 1
      
         explo.w = 0
      
         ; Explodiert?
         If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x,spieler(akt_spieler)\character_y + spell_y,#ME_EXPLODIERT) > 0
            explo = 1
         EndIf
      
         willi.s = monster(labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\objekt[spieler(akt_spieler)\level])\name[1+sprache] + nachricht_text(627,sprache+1)
         nachricht7(willi,#COLOR_ROT)
         
         lernen(spieler(akt_spieler)\character_x + spell_x,spieler(akt_spieler)\character_y + spell_y)
         gott_check()
         
         ; Wassermonster?
         If hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,#ME_WASSER) > 0
            setlaby(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y,spieler(akt_spieler)\level,#FELD_WASSER,0,0,0)
         Else
            hinterlassen(spieler(akt_spieler)\character_x + spell_x,spieler(akt_spieler)\character_y + spell_y)
         EndIf
         
         spieler(akt_spieler)\mks = spieler(akt_spieler)\mks + 1
         
         If explo = 1
            explodiert()
         EndIf
      Else
         ; Status aendern
         If labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\status[spieler(akt_spieler)\level] = #MONSTERSTATUS_NORMAL
            labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\status[spieler(akt_spieler)\level] = #MONSTERSTATUS_ALERT
         EndIf
         If labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\status[spieler(akt_spieler)\level] = #MONSTERSTATUS_SCHLAEFT
            labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\status[spieler(akt_spieler)\level] = #MONSTERSTATUS_NORMAL
         EndIf
         FlipBuffers()
         Delay(mydelay)
      EndIf
   EndIf
   
   laby_screen()

EndProcedure

; ------------------------------------------------------------------------------------------
; Attack Spell

Procedure attack_spell(aussehen.w)

Shared spell_x, spell_y, mydelay4

akt_frame.w = 1
zw_frame.w = 1

      If spell_x > 0
         zielx = 32 * spell_x
      EndIf
      If spell_x < 0
         zielx = -32 * spell_x
      EndIf
      If spell_y > 0
         ziely = 32 * spell_y
      EndIf
      If spell_y < 0
         ziely = -32 * spell_y
      EndIf

      If spell_x > 0
         i = 1
         Repeat
         Fenster()
            laby_screen2()
            If aussehen = 1  ; Funke
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
            EndIf
            If aussehen = 2  ; Lila
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
            EndIf
            If aussehen = 3  ; Feuerschlag
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
            EndIf
            If aussehen = 4 ; Blauer Ball
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
            EndIf
            ; Pfeil
            If aussehen = 5
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            ; Blitz
            If aussehen = 6 
               ClipSprite(#SPRITE_TILESET_ITEMS, 480,384, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160+i, 160)
            EndIf
            If aussehen = 7  ; Dolch
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,0, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
            EndIf
            If aussehen = 8  ; Axt
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,32, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
            EndIf
            If aussehen = 9  ; Speer
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 32,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 96,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 64,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            If aussehen = 10 ; Grosser Gruener Ball
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
            EndIf
            If aussehen = 11  ; Stein
               ClipSprite(#SPRITE_TILESET_ITEMS, 3*32,18*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160+i, 160)
            EndIf
            i = i + mydelay4
            FlipBuffers()
            i = i + 2
         Until i >= zielx
         EndIf
         If spell_x < 0
            i = 1
            Repeat
            Fenster()
            laby_screen2()
            ; Funke
            If aussehen = 1
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
            EndIf
            ; Lila
            If aussehen = 2
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
            EndIf
            ; Feuerschlag
            If aussehen = 3
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
            EndIf
            ; Blauer Ball
            If aussehen = 4
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
            EndIf
            ; Pfeil
            If aussehen = 5
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            ; Blitz
            If aussehen = 6
               ClipSprite(#SPRITE_TILESET_ITEMS, 480,384, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160-i, 160)
            EndIf
            ; Dolch
            If aussehen = 7
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,0, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
            EndIf
            ; Axt
            If aussehen = 8
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,32, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
            EndIf
            ; Speer
            If aussehen = 9  
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 32,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 96,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 64,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            ; Gruen
            If aussehen = 10
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
            EndIf
            ; Stein
            If aussehen = 11
               ClipSprite(#SPRITE_TILESET_ITEMS, 3*32,18*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160-i, 160)
            EndIf
            i = i + mydelay4
            FlipBuffers()
            i = i + 2
         Until i >= zielx
         EndIf
         If spell_y > 0
         i = 1
         Repeat
         Fenster()
            laby_screen2()
            ; Funke
            If aussehen = 1
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
            EndIf
            ; Lila
            If aussehen = 2
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
            EndIf
            ; Feuerschlag
            If aussehen = 3
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
            EndIf
            ; Blau
            If aussehen = 4
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
            EndIf
            ; Pfeil
            If aussehen = 5
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            ; Blitz
            If aussehen = 6
               ClipSprite(#SPRITE_TILESET_ITEMS, 480,384, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160, 160+i)
            EndIf
            ; Dolch
            If aussehen = 7
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,0, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
            EndIf
            ; Axt
            If aussehen = 8
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,32, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
            EndIf
            ; Speer
            If aussehen = 9
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 32,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 96,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 64,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            ; Gruen
            If aussehen = 10
               ClipSprite(#SPRITE_TILESET_ITEMS, 2*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160, 160+i)
            EndIf
            ; Stein
            If aussehen = 11
               ClipSprite(#SPRITE_TILESET_ITEMS, 3*32,18*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160, 160+i)
            EndIf
            i = i + mydelay4
            FlipBuffers()
            i = i + 2
         Until i >= ziely
         EndIf
         If spell_y < 0
         i = 1
         Repeat
         Fenster()
            laby_screen2()
            ; Funke
            If aussehen = 1
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
            EndIf
            ; Lila
            If aussehen = 2
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
            EndIf
            ; Feuerschlag
            If aussehen = 3
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 6*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
            EndIf
            ; Blau
            If aussehen = 4
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
            EndIf
            If aussehen = 5
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 3*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            ; Blitz
            If aussehen = 6
               ClipSprite(#SPRITE_TILESET_ITEMS, 480,384, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160, 160-i)
            EndIf
            ; Dolch
            If aussehen = 7   
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,0, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
            EndIf
            ; Axt
            If aussehen = 8   
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, akt_frame*32-32,32, 32, 32)
               zw_frame = zw_frame + 1
               If zw_frame > 3
                  akt_frame = akt_frame + 1
                  If akt_frame > 4
                     akt_frame = 1
                  EndIf
                  zw_frame = 1
               EndIf
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
            EndIf
            ; Speer
            If aussehen = 9  
               If spell_x > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 32,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+i, 160)
               EndIf
               If spell_x < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 96,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160-i, 160)
               EndIf
               If spell_y > 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 64,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160+i)
               EndIf
               If spell_y < 0
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0,64, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
               EndIf
            EndIf
            ; Gruen
            If aussehen = 10
               ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 4*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160-i)
            EndIf
            ; Stein
            If aussehen = 11
               ClipSprite(#SPRITE_TILESET_ITEMS, 3*32,18*32, 32, 32)
               DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, 160, 160-i)
            EndIf
            i = i + mydelay4
            FlipBuffers()
            i = i + 2
         Until i >= ziely
      EndIf

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure misslungen()

Shared sprache

   If Random(1000) <= 5
      nachricht(738,#COLOR_BLAU)
      spielerschaden(2+Random(spieler(skt_spieler)\level/3), 3, 15)
   Else
      nachricht(48,#COLOR_BLAU)
   EndIf

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure cast_it2()

Shared sprache, anz_zauber, akt_zauber, frame, akt_spieler, spell_x, spell_y, blocked
Shared akt_zauber_offset, schriftrolle, anz_spieler, mydelay, aktion
Shared inhalt, mydelay, karten_typ, xmod, ymod, monsterauge

   XIncludeFile("zaubertest.pbi")

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure cast_it()

Shared akt_spieler, akt_zauber, akt_zauber_offset

   cast_it2()
   If habich(#SPELL_VERDOPPELN) > 0 And zauberliste(akt_zauber + akt_zauber_offset)\name[2] <> "Verdoppeln"
      cast_it2()
   EndIf

EndProcedure

; ------------------------------------------------------------------------------------------
; Zaubermenue

Procedure zaubern()

Shared sprache, anz_zauber, akt_zauber, frame, akt_spieler, spell_x, spell_y, blocked
Shared anzz, yplus, test, mauszauber, akt_zauber_offset, aktion
Shared schriftrolle, akt_zauber_offset2, joystick_used, no_mouse

   erstelle_liste()

   akt_zauber = spieler (akt_spieler)\pos_zaubermenue

   Repeat
        Fenster()
        ClearScreen(RGB(0,0,0))
        draw_screen(0, 0)
        draw_screen3(0, 0)
        draw_screen4(0, 0)
        draw_screen7(0, 0)
        draw_character(spieler(akt_spieler)\face, frame,0)
        show_sight()
        zauber_rahmen()

        ExamineKeyboard()
        jay.w = 0
        jb1.w = 0
        If joystick_used = 1
           ExamineJoystick()
           jay = JoystickAxisY()
           jb1 = JoystickButton(1)
        EndIf
        If no_mouse = 0
            result = ExamineMouse()
            mouse_x = MouseX()
            mouse_y = MouseY()
            mouse_links   = MouseButton(1)
            mouse_rechts  = MouseButton(2)
        EndIf
        
        ; Scroll spellist buttons
        ; Oben
  #POS_BUTTON_HOCH_X = 480
  #POS_BUTTON_HOCH_Y = 211
      If mouse_x >= #POS_BUTTON_SPELLIST_HOCH_X And mouse_x <= #POS_BUTTON_SPELLIST_HOCH_X + 32 And mouse_y >= #POS_BUTTON_SPELLIST_HOCH_Y And mouse_y <= #POS_BUTTON_SPELLIST_HOCH_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 6*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_SPELLIST_HOCH_X, #POS_BUTTON_SPELLIST_HOCH_Y)
         If mouse_links = 1
           If akt_zauber > 0
              akt_zauber = akt_zauber - 1
              Delay(50)
           EndIf
         EndIf 
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 4*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_SPELLIST_HOCH_X, #POS_BUTTON_SPELLIST_HOCH_Y)
      EndIf
      
      ; Unten
      If mouse_x > #POS_BUTTON_SPELLIST_RUNTER_X And mouse_x < #POS_BUTTON_SPELLIST_RUNTER_X + 32 And mouse_y > #POS_BUTTON_SPELLIST_RUNTER_Y And mouse_y < #POS_BUTTON_SPELLIST_RUNTER_Y + 32
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 7*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_SPELLIST_RUNTER_X, #POS_BUTTON_SPELLIST_RUNTER_Y)
         If mouse_links = 1
           If akt_zauber < anz_zauber - 1
              akt_zauber = akt_zauber + 1
              Delay(50)
           EndIf
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS5, 5*32, 0, 31, 31)
         DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS5, #POS_BUTTON_SPELLIST_RUNTER_X, #POS_BUTTON_SPELLIST_RUNTER_Y)
      EndIf

        ; Maus darstellen
        If no_mouse = 0
           ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
           DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mouse_x, mouse_y)
        EndIf

        FlipBuffers()

        If KeyboardPushed(#PB_Key_Down) Or jay = 1
           If akt_zauber < anz_zauber - 1
              akt_zauber = akt_zauber + 1
              Delay(50)
           EndIf
        EndIf
        If KeyboardPushed(#PB_Key_Up) Or jay = -1
           If akt_zauber > 0
              akt_zauber = akt_zauber - 1
              Delay(50)
           EndIf
        EndIf

        ; Mit Maus gezaubert ?
        mauszauber = 0
        y = 52
        aktuell = 1
        If mouse_x > 365 And mouse_x < 574
           For i = 1 To anzz
              If mouse_y >= y And mouse_y <= y + yplus
                 mauszauber = aktuell
              EndIf
              y = y + yplus
              aktuell = aktuell + 1
           Next
        EndIf

        raushier = 0
        If mouse_links = 1 And mauszauber > 0
           raushier = 1
        EndIf

        ; Schnellzauber belegen
        If zauberliste(akt_zauber+akt_zauber_offset)\name[2] <> "Abbrechen"
        If KeyboardPushed(#PB_Key_1)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(1,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_2)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(2,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_3)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(3,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_4)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(4,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_5)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(5,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_6)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(6,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_7)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(7,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_8)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(8,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_9)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(9,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        If KeyboardPushed(#PB_Key_0)
           For i = 1 To 10
              If schnellzauber(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                 schnellzauber(i,akt_spieler) = " "
              EndIf
           Next
           schnellzauber(10,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
        EndIf
        EndIf
        
        If joystick_used = 1
            If JoystickButton(5)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(1,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
            If JoystickButton(6)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(2,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
            If JoystickButton(7)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(3,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
            If JoystickButton(8)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(4,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
            If JoystickButton(9)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(5,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
            If JoystickButton(10)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(6,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
            If JoystickButton(11)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(7,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
            If JoystickButton(12)
               For i = 1 To 8
                  If schnellzauber2(i,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
                     schnellzauber2(i,akt_spieler) = " "
                  EndIf
               Next
               schnellzauber2(8,akt_spieler) = zauberliste(akt_zauber+akt_zauber_offset)\name[2]
            EndIf
        EndIf

   Until raushier = 1 Or mouse_rechts = 1 Or KeyboardPushed(#PB_Key_Return) Or jb1 <> 0

   If KeyboardPushed(#PB_Key_Return) Or jb1 <> 0
      schriftrolle = 0
      cast_it()
   EndIf

   If raushier = 1
      For k = 1 To #ANZ_SPRACHEN
         zauberliste(akt_zauber + akt_zauber_offset)\name[k] = zauberliste(akt_zauber + akt_zauber_offset + mauszauber - 14)\name[k]
      Next
      schriftrolle = 0
      cast_it()
   EndIf
   
   spieler (akt_spieler)\pos_zaubermenue = akt_zauber

EndProcedure
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1982
; FirstLine = 1980
; Folding = --------------------------------------------------------------
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger