Procedure bogenangriff(bogen.w, schleuder.w, angriff.w, schaden.w, kritisch.w, art.w, akt_munition.w)

Shared akt_spieler, spell_x, spell_y, aktion, mydelay, anz_spieler

   ; Pfeil/Stein fliegen lassen
   Sound(#SOUND_BOW)
   if bogen = 1
      schaden.w = (Random(schaden) + 4)
      attack_spell(5)
      okay.w = 0
      ; Explodierend?
      if art = 1
         okay = 1
         Sound(#SOUND_CANNON)
         ; Zielbereich mit Flammen fuellen
         For y=spell_y-1+5 To spell_y+1+5
            For x=spell_x-1+5 To spell_x+1+5
               draw_tile(#FELD_FEUER3, x, y, 1, 1)
            Next
         Next
         flipbuffers()
         delay(mydelay)
      endif
      ; Eispfeile?
      if art = 3
         okay = 1
         Sound(#SOUND_WIND)
         ; Zielbereich mit Schnee fuellen
         if spell_x < 0
            y = 5
            For x=spell_x+5 To -1+5
               draw_tile(#FELD_SCHNEE, x, y, 1, 1)
            Next
         endif
         if spell_x > 0
            y = 5
            For x=6 To spell_x+5
               draw_tile(#FELD_SCHNEE, x, y, 1, 1)
            Next
         endif
         if spell_y < 0
            x = 5
            For y=spell_y+5 To -1+5
               draw_tile(#FELD_SCHNEE, x, y, 1, 1)
            Next
         endif
         if spell_y > 0
            x = 5
            For y=6 To spell_y+5
               draw_tile(#FELD_SCHNEE, x, y, 1, 1)
            Next
         endif
         flipbuffers()
         delay(mydelay)
      endif
   endif
   if schleuder = 1
      ; Schleuder
      schaden.w = (Random(schaden)+1)
      attack_spell(11)
   endif
   
   okay = 0
   ; Explodierend?
   if art = 1
      okay = 1
      ; Schaden
      hydra_zauber(schaden)
      
      ; Alle Spieler angreifen
      save_akt_spieler.w = akt_spieler
      vergl_x.w = spieler(akt_spieler)\character_x+spell_x
      vergl_y.w = spieler(akt_spieler)\character_y+spell_y
      for akt_spieler = 1 to anz_spieler
         if spieler(akt_spieler)\character_x >= vergl_x-1 and spieler(akt_spieler)\character_x <= vergl_x+1 and spieler(akt_spieler)\character_y >= vergl_y-1 and spieler(akt_spieler)\character_y <= vergl_y+1
            spielerschaden(2,1,14)
         endif
      next
      akt_spieler = save_akt_spieler
      
      save_spell_x.w = spell_x
      save_spell_y.w = spell_y
      
      ; Alle Monster angreifen
      for zaehl = 1 to 9
         schaden.w = (Random(schaden) + 4)
         select (zaehl)
            case 1: spell_x = spell_x - 1
                    spell_y = spell_y - 1
            case 2: spell_x = spell_x + 1
            case 3: spell_x = spell_x + 1
            case 4: spell_y = spell_y + 1
                    spell_x = spell_x - 2
            case 5: spell_x = spell_x + 1
            case 6: spell_x = spell_x + 1
            case 7: spell_y = spell_y + 1
                    spell_x = spell_x - 2
            case 8: spell_x = spell_x + 1
            case 9: spell_x = spell_x + 1
         endselect
         feuerschaden(schaden)
      next
      
      spell_x = save_spell_x
      spell_y = save_spell_y
   endif
   ; Eispfeile?
   if art = 3
      okay = 1
      weg.w = 0
      save_x.w = spell_x
      save_y.w = spell_y
      if spell_x < 0 and weg = 0
         weg = 1
         For spell_x = -1 To save_x step -1
            schaden.w = (Random(schaden) + 4)
            eisschaden(schaden)
         Next
      endif
      if spell_x > 0 and weg = 0
         weg = 1
         For spell_x = 1 To save_x
            schaden.w = (Random(schaden) + 4)
            eisschaden(schaden)
         Next
      endif
      if spell_y < 0 and weg = 0
         weg = 1
         For spell_y = -1 To save_y step -1
            schaden.w = (Random(schaden) + 4)
            eisschaden(schaden)
         Next
      endif
      if spell_y > 0 and weg = 0
         weg = 1
         For spell_y=1 To save_y
            schaden.w = (Random(schaden) + 4)
            eisschaden(schaden)
         Next
      endif
   endif
   if okay = 0
      if istmonster(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1 or isthydra(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1
         unsichtbar = 0
         ; Unsichtbares Monster ?
         if hat_eigenschaft2(labyrinth(spieler(akt_spieler)\character_x+spell_x, spieler(akt_spieler)\character_y+spell_y)\objekt[spieler(akt_spieler)\level],#ME_UNSICHTBAR) = 1
            unsichtbar = 1
         endif
         ; Nur mit 20% Kaempfen bei unsichtbar (oder zielsuchende pfeile)!
         if (unsichtbar = 1 and random(100) > 80) or unsichtbar = 0 or habich(#SPELL_UNSICHTBARES_SEHEN) > 0 or art = 2
            ; Angriff
            angriff = angriff + angriff()
            angriff = angriff * 10
            if bogen = 1
               angriff = angriff + spieler(akt_spieler)\bogentreffergegenstand
               if skills(#CE_BOGENSCHIESSEN,akt_spieler)\gewaehlt = 1
                  angriff = angriff + 50
               endif
            endif
            if angriff > 90
               angriff = 90
            endif
            if angriff < 10
               angriff = 10
            endif
            if art = 2
               angriff = 100
            endif
            
            treffer.w = random(100)
            if treffer < angriff
               ; Kritisch?
               kritisch = kritisch + luck() + reflexe()
               if skills(#CE_SCHARFSCHUETZE,akt_spieler)\gewaehlt = 1
                  kritisch = kritisch * 2
                  if kritisch > 45
                     kritisch = 45
                  endif
               else
                  if kritisch > 35
                     kritisch = 35
                  endif
               endif
               if treffer < kritisch
                  hydra_zauber(schaden)
                  ClipSprite(#SPRITE_TILESET_PROJEKTILE, 3*32, 7*32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160+ spell_x*32, 160 + spell_y*32)
                  flipbuffers()
                  delay(mydelay)
                  zerstoert(spell_x,spell_y)
               else
                  hydra_zauber(schaden)
                  monsterschaden(schaden)
                  
                  ; Monster vergiftet?
                  If inventory(akt_munition,akt_spieler)\status = 4 or inventory(akt_munition,akt_spieler)\name = #OBJGRAFIK_PFEIL2
                     art.w = monster(labyrinth(spieler(akt_spieler)\character_x+spell_x,spieler(akt_spieler)\character_y+spell_y)\objekt[spieler(akt_spieler)\level])\art
                     If hat_eigenschaft(spieler(akt_spieler)\character_x+spell_x,spieler(akt_spieler)\character_y+spell_y,#ME_GIFT) = 0 and art <> 3 and art <> 9 and art <> 10
                        labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\status[spieler(akt_spieler)\level] = #MONSTERSTATUS_VERGIFTET+Random(20)+5
                     Else
                        nachricht(456,#COLOR_GRUEN)
                     EndIf
                  EndIf
               EndIf
            else
               nachricht(16,#COLOR_ROT)
            endif
         else
            nachricht(441,#COLOR_ROT)
            spieler(akt_spieler)\Speed = 0
            aktion = 1
         endif ; unsichtbar?
      endif ; monster ?
   endif ; exploding
            
EndProcedure


Procedure bogen()

shared akt_spieler, spell_x, spell_y, aktion, blocked

   akt_munition.w = 0
   bogen.b = 0
   schleuder.b = 0
   pfeile.b = 0
   steine.b = 0
   angriff.w = 0
   schaden.w = 0
   kritisch.w = 0
   spell_x = 0
   spell_y = 0
   feld_waehlen()   ; gibt spell_x und spell_y zurueck
   blocked = 0
   los()            ; gibt blocked zurueck
   If blocked = 0
      ; Bogen/Schleuder benutzt ?
      for i = 1 to #MAX_RUCKSACK
         if inventory(i,akt_spieler)\art = 10 and inventory(i,akt_spieler)\benutzt = 1
            if inventory(i,akt_spieler)\name = #OBJGRAFIK_SCHLEUDER
               schleuder = 1
            else
               bogen = 1
            endif
            angriff  = inventory(i,akt_spieler)\attri2
            angriff  = angriff + spieler(akt_spieler)\bogentreffergegenstand
            schaden  = inventory(i,akt_spieler)\attri3
            schaden  = schaden + spieler(akt_spieler)\bogenschadengegenstand
            kritisch = inventory(i,akt_spieler)\attri4
         endif
      next
      ; Pfeile/Steine benutzt ?
      art.w = 0
      magisch.w = 0
      for i = 1 to #MAX_RUCKSACK
         if inventory(i,akt_spieler)\art = 13 and inventory(i,akt_spieler)\benutzt = 1
            if (inventory(i,akt_spieler)\name = #OBJGRAFIK_STEINE or inventory(i,akt_spieler)\name = #OBJGRAFIK_STAHLKUGELN)
               steine = 1
            else
               if gegenstand(inventory(i,akt_spieler)\name)\magisch = 1
                  magisch = 1
               endif
               pfeile = 1
               ; Explodierend
               if inventory(i,akt_spieler)\name = #OBJGRAFIK_PFEIL1
                  art = 1
               endif
               ; Zielsuchend
               if inventory(i,akt_spieler)\name = #OBJGRAFIK_PFEIL4
                  art = 2
               endif
               ; Durchschlagend
               if inventory(i,akt_spieler)\name = #OBJGRAFIK_PFEIL3
                  art = 3
               endif
            endif
            akt_munition = i
            ; Kostet einen Pfeil!
            inventory(akt_munition,akt_spieler)\attri1 = inventory(akt_munition,akt_spieler)\attri1 - 1
            if inventory(akt_munition,akt_spieler)\attri1 < 1
               leeren(akt_munition)
              if inventory(akt_munition,akt_spieler)\attri1 < 1
                  nachricht(263,#COLOR_WEISS)
               endif
            endif
            angriff = angriff + inventory(i,akt_spieler)\attri2
            schaden = schaden +  inventory(i,akt_spieler)\attri3
            kritisch = kritisch + inventory(i,akt_spieler)\attri4
         endif
      next

      if (bogen = 1 and pfeile = 1) or (schleuder = 1 and steine = 1)
      
         if hat_eigenschaft(spieler(akt_spieler)\character_x+spell_x,spieler(akt_spieler)\character_y+spell_y,#ME_UNVERWUNDBAR) > 0 and (magisch = 0 or skills(#CE_GEISTERJAEGER,akt_spieler) = 1)
            aktion = 1
            attack_spell(5)
            nachricht(736,#COLOR_ROT)
         else
            aktion = 1
            bogenangriff(bogen, schleuder, angriff, schaden, kritisch, art, akt_munition)
            
            ; Wenn nicht tot und zen nochmal schiessen!
            if bogen = 1 and skills(#CE_ZEN_BOGEN,akt_spieler)\gewaehlt = 1 and labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\lebenspunkte[spieler(akt_spieler)\Level] > 0 and istmonster(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1
               bogenangriff(bogen, schleuder, angriff, schaden, kritisch, art, akt_munition)
            endif
         endif
      else  ; Pfeile und Bogen?
         nachricht(14,#COLOR_ROT)
      endif
   endif

EndProcedure



Procedure mystisch()

shared akt_spieler, spell_x, spell_y, aktion, blocked
   
   bogen.b = 0
   pfeil.b = 0
   angriff.w = 0
   schaden.w = 0
   kritisch.w = 0
   spell_x = 0
   spell_y = 0
   feld_waehlen()   ; gibt spell_x und spell_y zurueck
   blocked = 0
   los()            ; gibt blocked zurueck
   If blocked = 0
      if spieler(akt_spieler)\lifepoints > 1
         if istmonster(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1 or isthydra(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1
            aktion = 1
            ; Fleck fliegen lassen
            Sound(#SOUND_BOW)
            attack_spell(2)
            ; Schaden
            angriff = 70
            if random(100) < angriff
               schaden.w = Random(10+level) + 4
               hydra_zauber(schaden)
               monsterschaden(schaden)
            else
               nachricht(16,#COLOR_ROT)
            endif
            spielerschaden(1,3,0)
         else
            nachricht(246,#COLOR_WEISS)
         endif
      else
         nachricht(409,#COLOR_WEISS)
      endif
   endif

EndProcedure


; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger
