; Highscores anzeigen

Procedure init_highscores()

For i = 1 To 30
   hscores(i)\version     = " "
   hscores(i)\name        = " "
   hscores(i)\level       = 0
   hscores(i)\gold        = 0
   hscores(i)\mks         = 0
   hscores(i)\punkte      = 0
   hscores(i)\maennchen   = 0
   hscores(i)\anfangszeit = " "
   hscores(i)\endezeit    = " "
   hscores(i)\MaxLifepoints = 0
   hscores(i)\MaxMana       = 0
   hscores(i)\Attack        = 0
   hscores(i)\Dexterity     = 0
   hscores(i)\Strength      = 0
   hscores(i)\MaxSpeed      = 0
   hscores(i)\Perception    = 0
   hscores(i)\Luck_score    = 0
   hscores(i)\Power_score   = 0
   hscores(i)\Circle        = 0
   hscores(i)\stabteile     = 0
   hscores(i)\moves         = 0
   For j = 1 To #ANZ_SPRACHEN
      hscores(i)\sterbegrund[j] = " "
   Next
   For j = 1 To 30
      hscores(i)\skills[j]      = 0
   Next
Next

EndProcedure


Procedure read_highscores()

If ReadFile(0, "./highscores.dat")
  For i = 1 To 30
     hscores(i)\version       =  ReadString(0)
     hscores(i)\name          =  ReadString(0)
     hscores(i)\level         =  ReadWord(0)
     hscores(i)\gold          =  ReadWord(0)
     hscores(i)\mks           =  ReadWord(0)
     hscores(i)\punkte        =  ReadWord(0)
     hscores(i)\maennchen     =  ReadWord(0)
     hscores(i)\anfangszeit   =  ReadString(0)
     hscores(i)\endezeit      =  ReadString(0)
     hscores(i)\MaxLifepoints =  ReadWord(0)
     hscores(i)\MaxMana       =  ReadWord(0)
     hscores(i)\Attack        =  ReadWord(0)
     hscores(i)\Dexterity     =  ReadWord(0)
     hscores(i)\Strength      =  ReadWord(0)
     hscores(i)\MaxSpeed      =  ReadWord(0)
     hscores(i)\Perception    =  ReadWord(0)
     hscores(i)\Luck_score    =  ReadWord(0)
     hscores(i)\Power_score   =  ReadWord(0)
     hscores(i)\Circle        =  ReadWord(0)
     hscores(i)\stabteile     =  ReadWord(0)
     hscores(i)\moves         =  ReadWord(0)
     For j = 1 To #ANZ_SPRACHEN
        hscores(i)\sterbegrund[j] =  ReadString(0)
     Next
     For j = 1 To 30
        hscores(i)\skills[j]      =  ReadWord(0)
     Next
  Next
  CloseFile(0)
EndIf

EndProcedure


Procedure show_detail(akt_eintrag)

Shared sprache, akt_spieler, joystick_used
   
   Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))
      
      ; Rahmen zeichnen
  ClipSprite(#SPRITE_RAHMEN_OBEN2, 0, 0, 640, 17)
  DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN2, 0, 0)
  ClipSprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 0, 640, 17)
  DisplaySprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 33)
  ClipSprite(#SPRITE_RAHMEN_UNTEN2, 0, 0, 640, 17)
  DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN2, 0, 464)


  ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
  DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
  ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
  DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 624, 0)
   
      ; Maennchen anzeigen
      ClipSprite(#SPRITE_TILESET_CHARACTER, 128, hscores(akt_eintrag)\maennchen*32-32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 50, 100)
      
      wohin = ScreenOutput()
      StartDrawing(wohin)
         FrontColor(RGB(255,255,255))  ; Weiss
         DrawingMode(1)
         xx = 150
         yy = 65

         DrawText(xx, yy,nachricht_text(115,1+sprache))
         DrawText(xx+200, yy,hscores(akt_eintrag)\name)
         
         yy = yy + 15
    
         FrontColor(RGB(154,251,120))
         DrawText(xx, yy,nachricht_text(525,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\level))
         
         yy = yy + 15
    
         FrontColor(RGB(255,255,1))
         DrawText(xx, yy,nachricht_text(156,1+sprache)+":")
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\gold))
         
         yy = yy + 15
   
         FrontColor(RGB(255,255,255))
         DrawText(xx, yy,nachricht_text(155,1+sprache)+":")
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\mks))
         
         yy = yy + 15
     
         DrawText(xx, yy,nachricht_text(93,1+sprache)+":")
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\punkte))
         
         yy = yy + 15
         DrawText(xx, yy,nachricht_text(52,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\attack))
         
         yy = yy + 15

         DrawText(xx, yy,nachricht_text(53,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\dexterity))
         
         yy = yy + 15
         DrawText(xx, yy,nachricht_text(54,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\strength))
         
         yy = yy + 15
         FrontColor(RGB(247,36,61))
         DrawText(xx, yy,nachricht_text(55,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\maxlifepoints))
         
         yy = yy + 15
         FrontColor(RGB(239,131,44))
         DrawText(xx, yy,nachricht_text(56,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\maxspeed))
         
         yy = yy + 15

         FrontColor(RGB(255,255,255))
         DrawText(xx, yy,nachricht_text(57,1+sprache))

         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\perception))
         
         yy = yy + 15
         DrawText(xx, yy,nachricht_text(58,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\luck_score))
         
         yy = yy + 15
         FrontColor(RGB(130,125,250))
         DrawText(xx, yy,nachricht_text(59,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\maxmana))
         
         yy = yy + 15
         DrawText(xx, yy,nachricht_text(60,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\power_score))
         
         yy = yy + 15
         DrawText(xx, yy,nachricht_text(61,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\circle))
         
         yy = yy + 15

         FrontColor(RGB(255,255,255))
         DrawText(xx, yy,nachricht_text(239,1+sprache))

         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\stabteile) + "/9")
         
         yy = yy + 15

         DrawText(xx, yy,nachricht_text(436,1+sprache))
         DrawText(xx+200, yy,Str(hscores(akt_eintrag)\moves))
         
         yy = yy + 15
  
         DrawText(xx, yy,nachricht_text(249,1+sprache))
         DrawText(xx+200, yy,hscores(akt_eintrag)\sterbegrund[1+sprache])
         
         yy = yy + 5
         yy = yy + 15
         ysave = yy

         DrawText(xx-100, yy,nachricht_text(250,1+sprache))
         
         j.w = 1
         For i = 1 To 30
            If hscores(akt_eintrag)\skills[i] > 0
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 1
                  FrontColor(RGB(255,1,1))
               EndIf
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 2
                  FrontColor(RGB(138,11,88))
               EndIf
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 3
                  FrontColor(RGB(255,1,255))
               EndIf
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 4
                  FrontColor(RGB(1,1,255))
               EndIf
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 5
                  FrontColor(RGB(1,255,1))
               EndIf
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 6
                  FrontColor(RGB(1,255,255))
               EndIf
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 7
                  FrontColor(RGB(130,115,30))
               EndIf
               If skills(hscores(akt_eintrag)\skills[i],1)\gruppe = 8
                  FrontColor(RGB(150,150,150))
               EndIf
               DrawText(xx+50, yy,skills(hscores(akt_eintrag)\skills[i],1)\name[1+sprache])
            EndIf
            yy = yy + 15
            j = j + 1
            If j = 9
               xx = xx + 150
               yy = ysave
               j = 1
            EndIf
         Next
         
      StopDrawing()
   
      jax.w = 0
      jay.w = 0
      jb1.w = 0
      jb2.w = 0
      If joystick_used = 1
         ExamineJoystick()
         jax = JoystickAxisX()
         jay = JoystickAxisY()
         jb1 = JoystickButton(1)
         jb2  = JoystickButton(2)
      EndIf
      
      ExamineKeyboard()
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mmouse_links  = MouseButton(1)
      mmouse_rechts = MouseButton(2)
      ; Maus darstellen
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
      FlipBuffers()
      
   Until KeyboardPushed(#PB_Key_Escape) Or KeyboardPushed(#PB_Key_Space) Or mmouse_rechts = 1 Or jb2 = 1

EndProcedure


Procedure upload_box()

Shared yplus, sprache, akt_spieler, joystick_used

   Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))
      laby_rahmen()
      show_logo()
      show_varys()
      show_buttons()

      ClipSprite(#SPRITE_TILESET_FSI1, 1, 1, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_FSI1, 16, 16)
      
      StartDrawing(ScreenOutput())
        DrawingMode(1)
        FrontColor(RGB(255,255,255))
        DrawText(60, 300, nachricht_text(740, 1+sprache))
        DrawText(60, 315, nachricht_text(741, 1+sprache))
        FrontColor(RGB(0,0,0))  ; Schwarz
        DrawText(90, 170, nachricht_text(748,1+sprache))
      StopDrawing()

      jb1.w = 0
      jb2.w = 0
      If joystick_used = 1
         ExamineJoystick()
         jb1 = JoystickButton(1)
         jb2 = JoystickButton(2)
      EndIf
      
     ExamineKeyboard()
     result = ExamineMouse()
     mmouse_x = MouseX()
     mmouse_y = MouseY()
     mmouse_links  = MouseButton(1)
     mmouse_rechts = MouseButton(2)
     
     xx.w = 90
     yy.w = 250
     xxx.w = 190
     yyy.w = 250
     
      ; Okay Button darstellen
      If KeyboardPushed(#PB_Key_Y) Or KeyboardPushed(#PB_Key_Z) Or jb1 = 1
         raus = 1
      EndIf
      If mmouse_x > xx And mmouse_x < xx+90 And mmouse_y > yy And mmouse_y < yy+28
         ClipSprite(#SPRITE_TILESET_BUTTONS2, 0, 0, 87, 32)
         If mmouse_links  = 1
            raus = 1
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS2, 0, 31, 87, 32)
      EndIf
      DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS2, xx, yy)
      
      
      ; Back Button darstellen
      If KeyboardPushed(#PB_Key_N) Or jb2 = 1
         raus = 2
      EndIf
      back_button.w = 0
      If mmouse_x > xxx And mmouse_x < xxx+90 And mmouse_y > yyy And mmouse_y < yyy+28
         ClipSprite(#SPRITE_TILESET_BUTTONS3, 0, 0, 87, 32)
         If mmouse_links  = 1
            raus = 2
         EndIf
      Else
         ClipSprite(#SPRITE_TILESET_BUTTONS3, 0, 31, 87, 32)
      EndIf
      DisplayTransparentSprite(#SPRITE_TILESET_BUTTONS3, xxx, yyy)
     
     ; Maus darstellen
     ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
     DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)

     FlipBuffers()
  Until raus > 0
  If raus = 1
     highscore_upload()
  EndIf

EndProcedure



Procedure new_highscore()

   If CreateFile(0, "./highscores.dat")
      For i = 1 To 30
         WriteStringN(0,hscores(i)\version)
         WriteStringN(0,hscores(i)\name)
         WriteWord(0,hscores(i)\level)
         WriteWord(0,hscores(i)\gold)
         WriteWord(0,hscores(i)\mks)
         WriteWord(0,hscores(i)\punkte)
         WriteWord(0,hscores(i)\maennchen)
         WriteStringN(0,hscores(i)\anfangszeit)
         WriteStringN(0,hscores(i)\endezeit)
         WriteWord(0,hscores(i)\MaxLifepoints)
         WriteWord(0,hscores(i)\MaxMana)
         WriteWord(0,hscores(i)\Attack)
         WriteWord(0,hscores(i)\Dexterity)
         WriteWord(0,hscores(i)\Strength)
         WriteWord(0,hscores(i)\MaxSpeed)
         WriteWord(0,hscores(i)\Perception)
         WriteWord(0,hscores(i)\Luck_score)
         WriteWord(0,hscores(i)\Power_score)
         WriteWord(0,hscores(i)\Circle)
         WriteWord(0,hscores(i)\stabteile)
         WriteWord(0,hscores(i)\moves)
         For j = 1 To #ANZ_SPRACHEN
            WriteStringN(0,hscores(i)\sterbegrund[j])
         Next
         For j = 1 To 30
            WriteWord(0,hscores(i)\skills[j])
         Next
      Next
      CloseFile(0)
   EndIf
   
   If spieler(akt_spieler)\maxlevel>3
   upload_box()
   EndIf

EndProcedure


Procedure show_highscore()

Shared letzter_eintrag, sprache, joystick_used

akt_pos.w = 1

wieder_high:
   akt_eintrag = 0

   ClearScreen(RGB(0,0,0))
   
   ; Rahmen zeichnen
  ClipSprite(#SPRITE_RAHMEN_OBEN2, 0, 0, 640, 17)
  DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN2, 0, 0)
  ClipSprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 0, 640, 17)
  DisplaySprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 33)
  ClipSprite(#SPRITE_RAHMEN_UNTEN2, 0, 0, 640, 17)
  DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN2, 0, 464)


  ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
  DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
  ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
  DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 624, 0)

   wohin = ScreenOutput()
   StartDrawing(wohin)
   DrawingMode(1)
      FrontColor(RGB(1,255,1))  ; Gruen
      DrawText(260,18,"Highscores")
      yy = 75
      DrawText(50, yy,"Nr")
      DrawText(100, yy,nachricht_text(154,1+sprache))
      DrawText(400, yy,"Level")
      DrawText(450, yy,"MKS")
      DrawText(500, yy,nachricht_text(156,1+sprache))
      DrawText(550, yy,nachricht_text(93,1+sprache))
   StopDrawing()

   wohin = ScreenOutput()
   StartDrawing(wohin)
      DrawingMode(1)
      yy = 95
      For i = 1 To 30

         FrontColor(RGB(255,255,255))  ; Weiss
         
         If i = letzter_eintrag
            FrontColor(RGB(255,1,1))  ; Rot
         EndIf
         
         If i = akt_pos 
            FrontColor(RGB(1,1,255))  ; Blau
         EndIf
         
         DrawText(50, yy,Str(i))
         DrawText(100, yy,hscores(i)\name)
         DrawText(400, yy,Str(hscores(i)\level))
         DrawText(450, yy,Str(hscores(i)\mks))
         DrawText(500, yy,Str(hscores(i)\gold))
         DrawText(550, yy,Str(hscores(i)\punkte))
         yy = yy + 12
      Next
   StopDrawing()
   FlipBuffers()
   
   Delay(500)

   Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))
      
      ; Rahmen zeichnen
      ClipSprite(#SPRITE_RAHMEN_OBEN2, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN2, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 0, 640, 17)
      DisplaySprite(#SPRITE_RAHMEN_WAAGRECHT, 0, 33)
      ClipSprite(#SPRITE_RAHMEN_UNTEN2, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN2, 0, 464)


      ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 624, 0)
   
      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)
         FrontColor(RGB(1,255,1))  ; Gruen
         DrawText(260,18,"Highscores")
         yy = 75
         DrawText(50, yy,"Nr")
         DrawText(100, yy,nachricht_text(154,1+sprache))
         DrawText(400, yy,"Level")
         DrawText(450, yy,"MKS")
         DrawText(500, yy,nachricht_text(156,1+sprache))
         DrawText(550, yy,nachricht_text(93,1+sprache))
      StopDrawing()
   
      yy = 95
      For i = 1 To 30
         
         wohin = ScreenOutput()
         StartDrawing(wohin)
         DrawingMode(1)
      
         FrontColor(RGB(255,255,255))  ; Weiss
         
         If i = letzter_eintrag
            FrontColor(RGB(255,1,1))  ; Rot
         EndIf
         
         If i = akt_pos 
            FrontColor(RGB(1,1,255))  ; Blau
         EndIf
         
         If mmouse_y > i*12+85 And mmouse_y < i*12+98
            FrontColor(RGB(100,100,100))  ; Grau
            akt_eintrag = i
         EndIf
         DrawText(50, yy,Str(i))
         DrawText(100, yy,hscores(i)\name)
         DrawText(400, yy,Str(hscores(i)\level))
         DrawText(450, yy,Str(hscores(i)\mks))
         DrawText(500, yy,Str(hscores(i)\gold))
         DrawText(550, yy,Str(hscores(i)\punkte))
         yy = yy + 12
         StopDrawing()
      Next
   
      jax.w = 0
      jay.w = 0
      jb1.w = 0
      jb2.w = 0
      If joystick_used = 1
         ExamineJoystick()
         jax = JoystickAxisX()
         jay = JoystickAxisY()
         jb1 = JoystickButton(1)
         jb2 = JoystickButton(2)
      EndIf
      
      ExamineKeyboard()
      
      
      If KeyboardPushed(#PB_Key_Down) Or jay = 1
         If warten2 > 0
            warten2 = warten2 - 1
         Else
            akt_pos = akt_pos + 1
            If akt_pos > 30
               akt_pos = 30
            EndIf
            warten2 = 10
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Up) Or jay = -1
         If warten2 > 0
            warten2 = warten2 - 1
         Else
            akt_pos = akt_pos - 1
            If akt_pos < 1
               akt_pos = 1
            EndIf
            warten2 = 10
         EndIf
      EndIf
      
      
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mmouse_links  = MouseButton(1)
      mmouse_rechts = MouseButton(2)
      ; Maus darstellen
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
   
      FlipBuffers()
      ret.w = 0
      If KeyboardPushed(#PB_Key_Return) Or jb1 = 1
         ret.w = 1
      EndIf
      spac.w = 0
      If KeyboardPushed(#PB_Key_Space) Or jb2 = 1
         spac.w = 1
      EndIf
   Until mmouse_rechts = 1 Or (mmouse_links = 1 And akt_eintrag > 0) Or ret = 1 Or spac = 1
   
   If mmouse_links = 1
      show_detail(akt_eintrag)
      Goto wieder_high
   EndIf
   
   If ret = 1
      show_detail(akt_pos)
   EndIf
   
   If mmouse_rechts = 1
      letzter_eintrag = 0
   EndIf
   
EndProcedure
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 291
; FirstLine = 311
; Folding = --------
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger
