Procedure explain (was.w, pos.w)

         Select (was)
            Case #ME_FLIEGT:
               nr = 349
            Case #ME_HINTERHALT:
               nr = 350
            Case #ME_GIFT:
               nr = 351
            Case #ME_BESTEHLBAR:
               nr = 352
            Case #ME_FERNKAMPF:
               nr = 353
            Case #ME_VERSTAERKUNG:
               nr = 354
            Case #ME_TROCKEN:
               nr = 355
            Case #ME_ANGST:
               nr = 356
            Case #ME_CHARM:
               nr = 357
            Case #ME_DIEBSTAHL:
               nr = 358
            Case #ME_BRENNT:
               nr = 359
            Case #ME_FEUERFEST:
               nr = 360
            Case #ME_STEINFEST:
               nr = 361
            Case #ME_BLITZE:
               nr = 362
            Case #ME_DISPEL:
               nr = 363
            Case #ME_REGENERATION:
               nr = 364
            Case #ME_UNVERWUNDBAR:
               nr = 365
            Case #ME_EISFEST:
               nr = 366
            Case #ME_UNSICHTBAR:
               nr = 367
            Case #ME_FEUERATEM:
               nr = 368
            Case #ME_GIFTATEM:
               nr = 369
            Case #ME_VERSTEINERN:
               nr = 370
            Case #ME_FROSTATEM:
               nr = 371
            Case #ME_TODESBLICK:
               nr = 372
            Case #ME_BLITZEFEST:
               nr = 373
            Case #ME_HAT_SCHATZ:
               nr = 374
            Case #ME_HAT_MAG_SCHATZ:
               nr = 375
            Case #ME_RES_CRITICAL:
               nr = 376
            Case #ME_SCHLAEFT:
               nr = 481
            Case #ME_WASSER:
               nr = 668
            Case #ME_EINMALIG:
               nr = 669
            Case #ME_SPINNE:
               nr = 670
            Case #ME_GOBLIN:
               nr = 671
            Case #ME_UNTOTER:
               nr = 672
            Case #ME_RATTE:
               nr = 673
            Case #ME_WOLF:
               nr = 674
            Case #ME_FLEDERMAUS:
               nr = 675
            Case #ME_KATZE:
               nr = 676
            Case #ME_WAFFEN_ZERSTOEREN:
               nr = 677
            Case #ME_RUESTUNG_ZERSTOEREN:
               nr = 678
            Case #ME_STEINE_WERFEN:
               nr = 821
            Case #ME_EXPLODIERT:
               nr = 822
            Case #ME_VERMEHREND:
               nr = 823
            Case #ME_ANSTECKEND:
               nr = 824
            Case #ME_WINDFEST:
               nr = 834
         EndSelect
         DrawText(175,pos,nachricht4(nr))
         
EndProcedure
         

Procedure monsterkunde()

Shared sprache, frame, spell_x, spell_y, akt_spieler, monsterauge

   spell_x = 0
   spell_y = 0
   yplus = 20
   feld_waehlen()   ; gibt spell_x und spell_y zurueck

   Repeat
      Fenster()
      ClearScreen(RGB(0,0,0))
      laby_rahmen()
      show_logo()
      show_varys()

      ClipSprite(#SPRITE_TILESET_FSI3, 1, 1, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_FSI3, 16, 16)

      If istmonster(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y) = 1 And hat_eigenschaft(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y, #ME_UNSICHTBAR) = 0
      x = 175
      yn = 30
      wohin = ScreenOutput()
      StartDrawing(wohin)
         DrawingMode(1)
      

         mon.w = labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\objekt[spieler(akt_spieler)\level]
   
         DrawText(x,yn,nachricht5(115,mon))
         If skills(#CE_MONSTERKUNDE,akt_spieler)\gewaehlt = 1 Or monsterauge = 1
            yn = yn + yplus
            tempart.s = ""
      
            Select(monster(mon)\art)
               Case 1: tempart = nachricht_text(118,1+sprache)
               Case 2: tempart = nachricht_text(119,1+sprache)
               Case 3: tempart = nachricht_text(120,1+sprache)
               Case 4: tempart = nachricht_text(121,1+sprache)
               Case 5: tempart = nachricht_text(400,1+sprache)
               Case 7: tempart = nachricht_text(401,1+sprache)
               Case 8: tempart = nachricht_text(402,1+sprache)
               Case 9: tempart = nachricht_text(403,1+sprache)
               Case 10: tempart = nachricht_text(404,1+sprache)
            EndSelect
            
            DrawText(x,yn, nachricht6(116,tempart))
            yn = yn + yplus
            DrawText(x,yn,nachricht6(55,Str(monster(mon)\lebenspunkte)))
            yn = yn + yplus
            DrawText(x,yn,  nachricht6(117,Str(monster(mon)\angriff) + "/" + Str(monster(mon)\abwehr)))
            yn = yn + yplus
            DrawText(x,yn, nachricht6(54,Str(monster(mon)\staerke)))
            yn = yn + yplus
            DrawText(x,yn,  nachricht6(87,Str(monster(mon)\ruestung)))
            
            FrontColor(RGB(255,255,255))
            
            yn = yn + yplus
            explain(monster(mon)\eigenschaft1,yn)
            yn = yn + yplus
            explain(monster(mon)\eigenschaft2,yn)
            yn = yn + yplus
            explain(monster(mon)\eigenschaft3,yn)
            yn = yn + yplus
            explain(monster(mon)\eigenschaft4,yn)
            yn = yn + yplus
            explain(monster(mon)\eigenschaft5,yn)
            yn = yn + yplus
            explain(monster(mon)\eigenschaft6,yn)
            yn = yn + yplus
            explain(monster(mon)\eigenschaft7,yn)
         EndIf
      
      
      StopDrawing()
     EndIf ; Monster?
     
     akt_tile.w = labyrinth(spieler(akt_spieler)\character_x + spell_x, spieler(akt_spieler)\character_y + spell_y)\feld[spieler(akt_spieler)\level]
     If akt_tile <= #ANZ_FELDER
        Select(akt_tile)
            Case #FELD_SCHWARZ: akt_nachricht.w = 752
            Case #FELD_MAUER: akt_nachricht = 753
            Case #FELD_AUSGANG: akt_nachricht = 754
            Case #FELD_EINGANG: akt_nachricht = 755
            Case #FELD_LEER: akt_nachricht = 756
            Case #FELD_SKELETT: akt_nachricht = 757
            Case #FELD_TRUHE: akt_nachricht = 758
            Case #FELD_SANKTUM: akt_nachricht = 759
            Case #FELD_NEXUS: akt_nachricht = 760
            Case #FELD_GOLD: akt_nachricht = 8
            Case #FELD_BUECHER1: akt_nachricht = 761
            Case #FELD_BUECHER2: akt_nachricht = 761
            Case #FELD_LABOR1: akt_nachricht = 762
            Case #FELD_LABOR2: akt_nachricht = 762
            Case #FELD_SCHALTER1: akt_nachricht = 763
            Case #FELD_GEHEIMGANG: akt_nachricht = 756
            Case #FELD_TUER1: akt_nachricht = 764
            Case #FELD_SPEERFALLE1: akt_nachricht = 756
            Case #FELD_PFEILFALLE1: akt_nachricht = 756
            Case #FELD_FALLGRUBE1: akt_nachricht = 756
            Case #FELD_RUNENFALLE_GIFT1: akt_nachricht = 756
            Case #FELD_RUNENFALLE_FEUER1: akt_nachricht = 756
            Case #FELD_RUNENFALLE_EIS1: akt_nachricht = 756
            Case #FELD_MANALEERE1: akt_nachricht = 756
            Case #FELD_AXTFALLE1: akt_nachricht = 756
            Case #FELD_RUNENFALLE_FLUCH1: akt_nachricht = 756
            Case #FELD_SPEERFALLE2: akt_nachricht = 765
            Case #FELD_PFEILFALLE2: akt_nachricht = 766
            Case #FELD_FALLGRUBE2: akt_nachricht = 767
            Case #FELD_RUNENFALLE_GIFT2: akt_nachricht = 768
            Case #FELD_RUNENFALLE_FEUER2: akt_nachricht = 768
            Case #FELD_RUNENFALLE_EIS2: akt_nachricht = 768
            Case #FELD_MANALEERE2: akt_nachricht = 768
            Case #FELD_AXTFALLE2: akt_nachricht = 769
            Case #FELD_RUNENFALLE_FLUCH2: akt_nachricht = 768
            Case #FELD_FEUER1: akt_nachricht = 770
            Case #FELD_FEUER2: akt_nachricht = 770
            Case #FELD_FEUER3: akt_nachricht = 770
            Case #FELD_STERNE1: akt_nachricht = 771
            Case #FELD_STERNE2: akt_nachricht = 771
            Case #FELD_MOND: akt_nachricht = 771
            Case #FELD_WIEDERGAENGER: akt_nachricht = 757
            Case #FELD_FRAGEZEICHEN: akt_nachricht = 772
            Case #FELD_SCHALTER2: akt_nachricht = 763
            Case #FELD_INSEL1: akt_nachricht = 773
            Case #FELD_INSEL2: akt_nachricht = 773
            Case #FELD_INSEL3: akt_nachricht = 773
            Case #FELD_INSEL4: akt_nachricht = 773
            Case #FELD_WASSER: akt_nachricht = 774
            Case #FELD_BRUNNEN: akt_nachricht = 775
            Case #FELD_GRABSTEIN: akt_nachricht = 776
            Case #FELD_BAUM1: akt_nachricht = 777
            Case #FELD_BAUM2: akt_nachricht = 777
            Case #FELD_BAUM3: akt_nachricht = 777
            Case #FELD_BAUM4: akt_nachricht = 777
            Case #FELD_BAUM5: akt_nachricht = 777
            Case #FELD_BAUM6: akt_nachricht = 777
            Case #FELD_BLAUETRUHE1: akt_nachricht = 758
            Case #FELD_BLAUETRUHE2: akt_nachricht = 758
            Case #FELD_HAENDLER1: akt_nachricht = 778
            Case #FELD_LAGERFEUER: akt_nachricht = 770
            Case #FELD_HAENDLER1_1: akt_nachricht = 778
            Case #FELD_GRUENETRUHE1: akt_nachricht = 758
            Case #FELD_GRUENETRUHE2: akt_nachricht = 758
            Case #FELD_VERBORGENER_SCHATZ2: akt_nachricht = 757
            Case #FELD_TUER2: akt_nachricht = 764
            Case #FELD_OFFENE_TUER: akt_nachricht = 764
            Case #FELD_WASSERMONSTER: akt_nachricht = 774
            Case #FELD_SCHACHT: akt_nachricht = 779
            Case #FELD_TELEPORTER: akt_nachricht = 780
            Case #FELD_VERBORGENER_SCHATZ: akt_nachricht = 756
            Case #FELD_THRON: akt_nachricht = 781
            Case #FELD_ALTAR1: akt_nachricht = 782
            Case #FELD_ALTAR2: akt_nachricht = 782
            Case #FELD_EIS: akt_nachricht = 783
            Case #FELD_GIFT: akt_nachricht = 784
            Case #FELD_HAENDLER2: akt_nachricht = 778
            Case #FELD_HAENDLER2_2: akt_nachricht = 778
            Case #FELD_HAENDLER3: akt_nachricht = 778
            Case #FELD_HAENDLER3_3: akt_nachricht = 778
            Case #FELD_HAENDLER4: akt_nachricht = 778
            Case #FELD_HAENDLER4_4: akt_nachricht = 778
            Case #FELD_HOEHLE2_MAUER: akt_nachricht = 753
            Case #FELD_HOEHLE2_LEER: akt_nachricht = 756
            Case #FELD_HOEHLE3_MAUER: akt_nachricht = 753 
            Case #FELD_HOEHLE3_LEER: akt_nachricht = 756
            Case #FELD_GRAS: akt_nachricht = 787
            Case #FELD_GRASSTEIN: akt_nachricht = 787
            Case #FELD_BUSCH: akt_nachricht = 788
            Case #FELD_MIMIC: akt_nachricht = 758
            Case #FELD_SKELETT3: akt_nachricht = 757
            Case #FELD_MAUER2: akt_nachricht = 753
            Case #FELD_MAUER3: akt_nachricht = 753
            Case #FELD_MAUER4: akt_nachricht = 753
            Case #FELD_MAUER5: akt_nachricht = 753
            Case #FELD_BODEN1: akt_nachricht = 756
            Case #FELD_BODEN2: akt_nachricht = 756
            Case #FELD_BODEN3: akt_nachricht = 756
            Case #FELD_BODEN4: akt_nachricht = 756
            Case #FELD_BODEN5: akt_nachricht = 756
            Case #FELD_LAVA: akt_nachricht = 789
            Case #FELD_FELSBROCKEN: akt_nachricht = 790
            Case #FELD_KACHELBODEN1: akt_nachricht = 756
            Case #FELD_KACHELBODEN2: akt_nachricht = 756
            Case #FELD_KACHELBODEN3: akt_nachricht = 756
            Case #FELD_KACHELBODEN4: akt_nachricht = 756
            Case #FELD_STABTEIL: akt_nachricht = 791
            Case #FELD_AMBOSS: akt_nachricht = 792
            Case #FELD_HAENDLER9: akt_nachricht = 778
            Case #FELD_HAENDLER10 : akt_nachricht = 778
            Case #FELD_LEHRER1 : akt_nachricht = 785
            Case #FELD_LEHRER2 : akt_nachricht = 785
            Case #FELD_LEHRER3 : akt_nachricht = 785
            Case #FELD_LEHRER4 : akt_nachricht = 785
            Case #FELD_LEHRER5 : akt_nachricht = 785
            Case #FELD_LEHRER6 : akt_nachricht = 785
            Case #FELD_LEHRER7 : akt_nachricht = 785
            Case #FELD_LEHRER8 : akt_nachricht = 785
            Case #FELD_LEHRER9 : akt_nachricht = 785
            Case #FELD_LEHRER10 : akt_nachricht = 785
            Case #FELD_NETZ : akt_nachricht = 793
            Case #FELD_BAUM_KLEIN : akt_nachricht = 777
            Case #FELD_HYDRA1 : akt_nachricht = 786
            Case #FELD_HYDRA2 : akt_nachricht = 786
            Case #FELD_HYDRA3 : akt_nachricht = 786
            Case #FELD_HYDRA4 : akt_nachricht = 786
            Case #FELD_HYDRA5 : akt_nachricht = 786
            Case #FELD_HYDRA6 : akt_nachricht = 786
            Case #FELD_HYDRA7 : akt_nachricht = 786
            Case #FELD_HYDRA8 : akt_nachricht = 786
            Case #FELD_HYDRA9 : akt_nachricht = 786
            Case #FELD_HYDRA10 : akt_nachricht = 786
            Case #FELD_HYDRA11 : akt_nachricht = 786
            Case #FELD_HYDRA12 : akt_nachricht = 786
            Case #FELD_RUNE1 : akt_nachricht = 794
            Case #FELD_KNOCHEN1 : akt_nachricht = 795
            Case #FELD_KNOCHEN2 : akt_nachricht = 795
            Case #FELD_KNOCHEN3 : akt_nachricht = 795
            Case #FELD_KNOCHEN4 : akt_nachricht = 795
            Case #FELD_KNOCHEN5 : akt_nachricht = 795
            Case #FELD_KNOCHEN6 : akt_nachricht = 795
            Case #FELD_KNOCHEN7 : akt_nachricht = 795
            Case #FELD_KNOCHEN8 : akt_nachricht = 795
            Case #FELD_RUNE2 : akt_nachricht = 794
            Case #FELD_RUNE3 : akt_nachricht = 794
            Case #FELD_WASSER_GOLDSACK : akt_nachricht = 8
            Case #FELD_WASSER_TRUHE : akt_nachricht = 758
            Case #FELD_WASSER_GRUENE_TRUHE : akt_nachricht = 758
            Case #FELD_WASSER_SKELETT : akt_nachricht = 757
            Case #FELD_LEUCHTER : akt_nachricht = 796
            Case #FELD_WAND_WEISS : akt_nachricht = 753
            Case #FELD_TELEPORTER_WALD : akt_nachricht = 780
            Case #FELD_TELEPORTER_LABYRINTH : akt_nachricht = 780
            Case #FELD_TELEPORTER_GOBLINHOEHLE : akt_nachricht = 780
            Case #FELD_TELEPORTER_SPINNENBAU : akt_nachricht = 780
            Case #FELD_TELEPORTER_1 : akt_nachricht = 780
            Case #FELD_TELEPORTER_LAVAKAVERNE : akt_nachricht = 780
            Case #FELD_TELEPORTER_EISKAVERNE : akt_nachricht = 780
            Case #FELD_TELEPORTER_ARCHIPEL : akt_nachricht = 780
            Case #FELD_TELEPORTER_WUESTE : akt_nachricht = 780
            Case #FELD_TELEPORTER_TOTENHALLE : akt_nachricht = 780
            Case #FELD_TELEPORTER_HALLE_ILLUSIONEN : akt_nachricht = 780
            Case #FELD_SAND1 : akt_nachricht = 797
            Case #FELD_SAND_HUEGEL : akt_nachricht = 797
            Case #FELD_SAND2 : akt_nachricht = 797
            Case #FELD_SAND3 : akt_nachricht = 797
            Case #FELD_SAND4 : akt_nachricht = 797
            Case #FELD_PALME1 : akt_nachricht = 798
            Case #FELD_PALME2 : akt_nachricht = 798
            Case #FELD_PALME3 : akt_nachricht = 798
            Case #FELD_PALME4 : akt_nachricht = 798
            Case #FELD_KAKTUS1 : akt_nachricht = 799
            Case #FELD_KAKTUS2 : akt_nachricht = 799
            Case #FELD_TELEPORTER_SUMPF : akt_nachricht = 780
            Case #FELD_TELEPORTER_5 : akt_nachricht = 780
            Case #FELD_TELEPORTER_6 : akt_nachricht = 780
            Case #FELD_WIESE_SKELETT : akt_nachricht = 757
            Case #FELD_WIESE_TRUHE : akt_nachricht = 758
            Case #FELD_WIESE_GRUENETRUHE1 : akt_nachricht = 758
            Case #FELD_WIESE_GRUENETRUHE2 : akt_nachricht = 758
            Case #FELD_TEPPICH1 : akt_nachricht = 800
            Case #FELD_TEPPICH2 : akt_nachricht = 800
            Case #FELD_TEPPICH3 : akt_nachricht = 800
            Case #FELD_SUMPF1 : akt_nachricht = 801
            Case #FELD_SUMPF2 : akt_nachricht = 801
            Case #FELD_PFLANZE : akt_nachricht = 802
            Case #FELD_GIFTIG : akt_nachricht = 784
            Case #FELD_WOUNDED_HERO1 : akt_nachricht = 803
            Case #FELD_WOUNDED_HERO2 : akt_nachricht = 803
            Case #FELD_SCHNEE : akt_nachricht = 804
            Case #FELD_ANKER_ZIEL : akt_nachricht = 780
            Case #FELD_RINNSAAL : akt_nachricht = 774
            Case #FELD_HUETTE : akt_nachricht = 805
            Case #FELD_NAGELGRUBE : akt_nachricht = 836
            Case #FELD_GITTER1 : akt_nachricht = 837
            Case #FELD_GITTER2 : akt_nachricht = 837
        EndSelect
        
        If akt_nachricht > 0
            x = 175
            yn = 30
            wohin = ScreenOutput()
            StartDrawing(wohin)
            DrawingMode(1)
            DrawText(x,yn,nachricht_text(akt_nachricht,1+sprache))
            StopDrawing()
         EndIf
     EndIf

     ExamineKeyboard()
     result = ExamineMouse()
     mmouse_x = MouseX()
     mmouse_y = MouseY()
     mmouse_rechts = MouseButton(2)
     ; Maus darstellen
     ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
     DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)

     FlipBuffers()
  Until KeyboardPushed(#PB_Key_Return) Or mmouse_rechts = 1

EndProcedure


; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 113
; FirstLine = 112
; Folding = --
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger
