Procedure drawcentered(posx.l,posy,obwidth.l,text.s,farbe.l=-1)
  If farbe>-1
    DrawText(posx+obwidth/2-TextWidth(text.s)/2,posy,text.s,farbe)
  Else
    DrawText(posx+obwidth/2-TextWidth(text.s)/2,posy,text.s)
  EndIf
EndProcedure

; Sonstige Routinen
Procedure Fenster(typ=0)
  Shared released, windowsfenster

  If windowsfenster Or typ
    CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
    If WindowEvent()=#PB_Event_CloseWindow
      End
    EndIf
    If Not typ
      x=WindowMouseX(0)
      y=WindowMouseY(0)
      If x<1 Or x>638 Or y<1 Or y>478
        If released=0
          released=1
          ReleaseMouse(1)
        EndIf
      Else
        If released=1
          released=0
          ReleaseMouse(0)
          MouseLocate(x, y)
        EndIf
      EndIf
    EndIf
    CompilerEndSelect
  EndIf


EndProcedure

Procedure creature_lebenspunkte()

Shared akt_spieler

   akt_lp.w = spieler(akt_spieler)\creature_LifePoints
   If habich(#SPELL_VERZAUBERE_KREATUR_1) > 0
      akt_lp = akt_lp + 1
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_2) > 0
      akt_lp = akt_lp + 2
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_3) > 0
      akt_lp = akt_lp + 3
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_4) > 0
      akt_lp = akt_lp + 4
   EndIf
   
   ProcedureReturn akt_lp

EndProcedure


Procedure creature_attacke()

Shared akt_spieler

   akt_attack.w = spieler(akt_spieler)\creature_Attack
   If habich(#SPELL_VERZAUBERE_KREATUR_1) > 0
      akt_attack = akt_attack + 1
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_2) > 0
      akt_attack = akt_attack + 2
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_3) > 0
      akt_attack = akt_attack + 3
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_4) > 0
      akt_attack = akt_attack + 4
   EndIf
   
   ProcedureReturn akt_attack

EndProcedure


Procedure creature_speed()

Shared akt_spieler

   akt_speed.w = spieler(akt_spieler)\creature_MaxSpeed
   If habich(#SPELL_VERZAUBERE_KREATUR_2) > 0
      akt_speed = akt_speed + 1
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_3) > 0
      akt_speed = akt_speed + 2
   EndIf
   
   If habich(#SPELL_VERZAUBERE_KREATUR_4) > 0
      akt_speed = akt_speed + 3
   EndIf
   
   ProcedureReturn akt_speed

EndProcedure


Procedure punkte()

Shared akt_spieler
   
   x1.w = spieler(akt_spieler)\level * 10
   x2.w = gold_anzahl() / 10
   x3.w = spieler(akt_spieler)\mks / 5
   If x2 > x1
      x2 = x1
   EndIf
   If x3 > x1
      x3 = x1
   EndIf
   punkte.w = x1 + x2 + x3
   punkte = punkte + (spieler(akt_spieler)\stabteile * 100)
   
   ProcedureReturn punkte

EndProcedure



Procedure gewicht()

Shared akt_spieler

   gewicht.w = 0
   For i = 1 To #MAX_RUCKSACK
      If inventory(i,akt_spieler)\name <> 0 And gegenstand(inventory(i,akt_spieler)\name)\gewicht > 0 And inventory(i,akt_spieler)\anzahl >= 0 And inventory(i,akt_spieler)\name <= #ANZ_GEGENSTAENDE
         gewicht = gewicht + (gegenstand(inventory(i,akt_spieler)\name)\gewicht * (inventory(i,akt_spieler)\anzahl + 1))
      EndIf
   Next
   
   ProcedureReturn gewicht
   
EndProcedure


Procedure freie_magie()

Shared akt_spieler, yplus, yplus2, akt_zauber_offset2, akt_zauber_offset, anzz, sprache
Shared joystick_used, anz_zauber

   ; Liste der verfuegbaren Zauber erstellen
   liste_leeren()
   
   anz_zauber.w = 1
   For i.w = 1 To #ANZ_ZAUBER
      If zauber(i,akt_spieler)\level <= spieler(akt_spieler)\circle And zauber(i,akt_spieler)\erlernt = 0
         If zauber_nehmen(i) = 0
            For j.w = 1 To #ANZ_SPRACHEN
                zauberliste(anz_zauber+akt_zauber_offset2)\name[j] = zauber(i,akt_spieler)\name[j]
            Next
            anz_zauber = anz_zauber + 1
         EndIf
      EndIf
   Next
   
   bubblesort()
   
   ; Liste zur Auswahl anzeigen
   akt_zauber.w = 1
   Repeat
      Fenster()
      ClearScreen(0)

      ; Rahmen zeichnen
      ClipSprite(#SPRITE_RAHMEN_OBEN, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_OBEN, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_LINKS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_LINKS, 0, 0)
      ClipSprite(#SPRITE_RAHMEN_UNTEN, 0, 0, 640, 17)
      DisplayTransparentSprite(#SPRITE_RAHMEN_UNTEN, 0, 464)
      ClipSprite(#SPRITE_RAHMEN_RECHTS, 0, 0, 17, 480)
      DisplayTransparentSprite(#SPRITE_RAHMEN_RECHTS, 624, 0)
      
      ExamineKeyboard()
      jay.w = 0
      jb1.w = 0
      If joystick_used = 1
         ExamineJoystick()
         jay = JoystickAxisY()
         jb1 = JoystickButton(1)
      EndIf
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mouse_links   = MouseButton(1)
      mouse_rechts  = MouseButton(2)

      If KeyboardPushed(#PB_Key_Down) Or jay = 1
         If akt_zauber < anz_zauber - 1
            akt_zauber = akt_zauber + 1
         EndIf
      EndIf
      If KeyboardPushed(#PB_Key_Up) Or jay = -1
         If akt_zauber > 0
            akt_zauber = akt_zauber - 1
         EndIf
      EndIf

      ; Zauberliste anzeigen
      ; In der Mitte wird ausgewaehlt
      FrontColor(RGB(150,150,150))
      Box(200,200+yplus2,260,yplus)

      wohin = ScreenOutput()
      StartDrawing(wohin)
      DrawingMode(1)
      
      FrontColor(RGB(255,255,255))
      DrawText(250,25,nachricht_text(593,1+sprache))
      
      
      ; Zauber darstellen
      x = 250
      y = 52
      besch = 0
      mzauber.s = ""
      For i = 1 To anzz
         FrontColor(RGB(255,255,255))  ; Weiss
         If i = mauszauber
            FrontColor(RGB(1,1,255))  ; Blau
            mzauber = zauberliste(i + akt_zauber)\name[2]
         EndIf  
         DrawText(x,y,zauberliste(i + akt_zauber)\name[1+sprache])
         y = y + yplus
      Next
      
      ; Beschreibung zu momentanem Zauber
      If mzauber = ""
         For i = 1 To #ANZ_ZAUBER
            If zauber(i,akt_spieler)\name[2] = zauberliste(akt_zauber + akt_zauber_offset)\name[2]
               besch = i
            EndIf
         Next
      Else
         For i = 1 To #ANZ_ZAUBER
            If zauber(i,akt_spieler)\name[2] = mzauber
               besch = i
            EndIf
         Next
      EndIf
      
      
      If besch > 0
         x = 350
         y = 390
         
         FrontColor(RGB(255,255,255))  ; Weiss


         DrawText(x,y,nachricht4(61))

         DrawText(x+100,y,Str(zauber(besch,akt_spieler)\level))
         
         y = y + yplus
         DrawText(x,y,nachricht4(101))
         DrawText(x+100,y,Str(zauber(besch,akt_spieler)\kosten))
         
         y = y + yplus
         DrawText(x,y,nachricht4(91))
         DrawText(x+100,y,Str(Power(besch)))
         
         y = y + yplus
         DrawText(x,y,nachricht4(102))
         DrawText(x+100,y,Str(zauber(besch,akt_spieler)\dauer))
         
         y = y + yplus
         DrawText(x,y,nachricht4(103))
         DrawText(x+100,y,Str(zauber(besch,akt_spieler)\chance))

         DrawText(25,400,zauber(besch,akt_spieler)\besch_1[1+sprache])

         DrawText(25,420,zauber(besch,akt_spieler)\besch_2[1+sprache])

      EndIf
      
      StopDrawing()
      
      ; Maus darstellen
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)

      FlipBuffers()
      Delay(50)

      ; Mit Maus gewaehlt ?
      mauszauber = 0
      y = 52
      aktuell = 1
      If mmouse_x > 250 And mmouse_x < 550
         For i = 1 To anzz
            If mmouse_y >= y And mmouse_y <= y + yplus
               mauszauber = aktuell
            EndIf
            y = y + yplus
            aktuell = aktuell + 1
         Next
      EndIf

      raushier = 0
      If mouse_links = 1 And mauszauber > 0
         raushier = 1
      EndIf
   Until raushier = 1 Or mouse_rechts = 1 Or KeyboardPushed(#PB_Key_Return) Or jb1 <> 0

   If KeyboardPushed(#PB_Key_Return) Or jb1 <> 0
      zauber(besch,akt_spieler)\erlernt = 1
   EndIf

   If raushier = 1
      zauber(besch,akt_spieler)\erlernt = 1
   EndIf
   nachricht(483,#COLOR_WEISS)

EndProcedure


Procedure sound(welchen.w)

Shared sound

If sound = 1
   PlaySound(welchen)
EndIf

EndProcedure


Procedure istmonster(x.w,y.w)

Shared akt_spieler

  If labyrinth(x, y)\feld[spieler(akt_spieler)\level] > #ANZ_FELDER And labyrinth(x,y)\feld[spieler(akt_spieler)\level] <= #ANZ_FELDER+#ANZ_MONSTER
     ProcedureReturn 1
  Else
     ProcedureReturn 0
  EndIf
  
EndProcedure


Procedure isthydra(x.w,y.w)

Shared akt_spieler

  If labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA1 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA2 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA3 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA4 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA5 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA6 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA7 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA8 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA9 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA10 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA11 Or labyrinth(x, y)\feld[spieler(akt_spieler)\level] = #FELD_HYDRA12
     ProcedureReturn 1
  Else
     ProcedureReturn 0
  EndIf
  
EndProcedure



Procedure min(zahl1.w, zahl2.w)

If zahl1 > zahl2
   ProcedureReturn zahl2
EndIf

If zahl1 <= zahl2
   ProcedureReturn zahl1
EndIf

EndProcedure

Procedure max(zahl1.w, zahl2.w)

If zahl1 < zahl2
   ProcedureReturn zahl2
EndIf

If zahl1 >= zahl2
   ProcedureReturn zahl1
EndIf

EndProcedure

; --------------------------------------------------------------------------------

Procedure gold_finden(anzahl.w)

Shared akt_spieler

   If spieler(akt_spieler)\fluch <> #FLUCH_DES_LEPRECHAUN
      
      Sound(#SOUND_SUCCESS)
      nachricht3(6,anzahl,8) 
      If skills(#CE_GOTT_DES_REICHTUMS,akt_spieler)\gewaehlt = 1 And (Random(100) < 600/maxlife())
         spieler(akt_spieler)\maxlifepoints = spieler(akt_spieler)\maxlifepoints + 1
         nachricht(326,#COLOR_GRAU)
      EndIf
                     
      ; Haben wir schon einen Goldsack?
      beutel.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\name = #OBJGRAFIK_BEUTEL
            beutel = i
         EndIf
      Next
      
      ; Wenn nicht neuer Beutel!
      If beutel = 0
         i = 0
         Repeat
            i = i + 1
         Until inventory(i,akt_spieler)\name = 0 Or i > #MAX_RUCKSACK
         If i <= #MAX_RUCKSACK
            ; Goldsack
            inventory(i,akt_spieler)\name = #OBJGRAFIK_BEUTEL
            inventory(i,akt_spieler)\art = gegenstand(#OBJGRAFIK_BEUTEL)\art
            inventory(i,akt_spieler)\attri1 = anzahl
            inventory(i,akt_spieler)\attri2 = gegenstand(#OBJGRAFIK_BEUTEL)\attri2
            inventory(i,akt_spieler)\attri3 = gegenstand(#OBJGRAFIK_BEUTEL)\attri3
            inventory(i,akt_spieler)\attri4 = gegenstand(#OBJGRAFIK_BEUTEL)\attri4
         Else
            nachricht(428,#COLOR_GRAU)
         EndIf
      Else
         ; Wenn ja reinschmeissen!
         If inventory(beutel,akt_spieler)\attri1 + anzahl < 32565
            inventory(beutel,akt_spieler)\attri1 = inventory(beutel,akt_spieler)\attri1 + anzahl
         Else
            inventory(beutel,akt_spieler)\attri1 = 32565
         EndIf
      EndIf
   Else
      nachricht(7,#COLOR_GRAU)
   EndIf

EndProcedure

; --------------------------------------------------------------------------------
; Haendler (Ohne Erfahrungsgewinn bei Gott des Reichtums)
Procedure gold_finden2(anzahl.w)

Shared akt_spieler

   If spieler(akt_spieler)\fluch <> #FLUCH_DES_LEPRECHAUN
      
      Sound(#SOUND_SUCCESS)
                     
      ; Haben wir schon einen Goldsack?
      beutel.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\name = #OBJGRAFIK_BEUTEL
            beutel = i
         EndIf
      Next
      
      ; Wenn nicht neuer Beutel!
      If beutel = 0
         i = 0
         Repeat
            i = i + 1
         Until inventory(i,akt_spieler)\name = 0 Or i > #MAX_RUCKSACK
         If i <= #MAX_RUCKSACK
            ; Goldsack
            inventory(i,akt_spieler)\name = #OBJGRAFIK_BEUTEL
            inventory(i,akt_spieler)\art = gegenstand(#OBJGRAFIK_BEUTEL)\art
            inventory(i,akt_spieler)\attri1 = anzahl
            inventory(i,akt_spieler)\attri2 = gegenstand(#OBJGRAFIK_BEUTEL)\attri2
            inventory(i,akt_spieler)\attri3 = gegenstand(#OBJGRAFIK_BEUTEL)\attri3
            inventory(i,akt_spieler)\attri4 = gegenstand(#OBJGRAFIK_BEUTEL)\attri4
         Else
            nachricht(428,#COLOR_GRAU)
         EndIf
      Else
         ; Wenn ja reinschmeissen!
         inventory(beutel,akt_spieler)\attri1 = inventory(beutel,akt_spieler)\attri1 + anzahl
      EndIf
   Else
      nachricht(7,#COLOR_GRAU)
   EndIf

EndProcedure

; --------------------------------------------------------------------------------

Procedure gold_verlieren(anzahl.w)

Shared akt_spieler

   ; Wo ist der Goldsack?
   beutel.w = 0
   For i = 1 To #MAX_RUCKSACK
      If inventory(i,akt_spieler)\name = #OBJGRAFIK_BEUTEL
         beutel = i
      EndIf
   Next
    
   If beutel > 0
      inventory(beutel,akt_spieler)\attri1 = inventory(beutel,akt_spieler)\attri1 - anzahl
      If inventory(beutel,akt_spieler)\attri1 < 1
         inventory(beutel,akt_spieler)\attri1 = 0
      EndIf
   EndIf  
     

EndProcedure

; --------------------------------------------------------------------------------

Procedure gold_anzahl()

Shared akt_spieler

   ; Haben wir einen Goldsack?
   beutel.w = 0
   For i = 1 To #MAX_RUCKSACK
      If inventory(i,akt_spieler)\name = #OBJGRAFIK_BEUTEL
         beutel = i
      EndIf
   Next
   
   If beutel > 0
      ProcedureReturn(inventory(beutel,akt_spieler)\attri1)
   Else
      ProcedureReturn(0)
   EndIf

EndProcedure

; --------------------------------------------------------------------------------

Procedure gott_check()

Shared skills, spieler, akt_spieler
      
   If skills(#CE_GOTT_DES_KRIEGES,akt_spieler)\gewaehlt = 1
      If Random(100) < (200 / spieler(akt_spieler)\maxlifepoints)
         spieler(akt_spieler)\maxlifepoints = spieler(akt_spieler)\maxlifepoints + 1
         nachricht(321,#COLOR_GELB)
      EndIf
   EndIf
   If skills(#CE_GOTT_DES_TODES,akt_spieler)\gewaehlt = 1
      If Random(100) < (200 / spieler(akt_spieler)\maxmana)
         spieler(akt_spieler)\maxmana = spieler(akt_spieler)\maxmana + 1
         nachricht(322,#COLOR_GELB)
      EndIf
   EndIf

EndProcedure

; --------------------------------------------------------------------------------

Procedure setlaby(x_x.w,y_y.w,ebene.w,was.w,lp.w,typ.w,stat.w)

Shared labyrinth

   labyrinth(x_x,y_y)\feld[ebene] = was
   labyrinth(x_x,y_y)\lebenspunkte[ebene] = lp
   labyrinth(x_x,y_y)\objekt[ebene] = typ
   labyrinth(x_x,y_y)\status[ebene] = stat

EndProcedure

; --------------------------------------------------------------------------------

Procedure zeige_unsichtbare(x_r.w, y_r.w)

Shared labyrinth, spieler, akt_spieler

   xx.w = 0
   yy.w = 0
   ; Unsichtbares Monster darstellen
   If hat_eigenschaft(x_r,y_r,#ME_UNSICHTBAR) = 1
      If x_r > spieler(akt_spieler)\character_x
         xx = 1
      EndIf
      If x_r < spieler(akt_spieler)\character_x
         xx = -1
      EndIf
      If y_r > spieler(akt_spieler)\character_y
         yy = 1
      EndIf
      If y_r < spieler(akt_spieler)\character_y
         yy = -1
      EndIf
      zw = labyrinth(x_r,y_r)\feld[spieler(akt_spieler)\Level] - #ANZ_FELDER
      sprite_x.w = zw
      sprite_y.w = 0
      If sprite_x > 10
         Repeat
            sprite_y = sprite_y + 1
            sprite_x = sprite_x - 10
         Until sprite_x < 11
      EndIf
      ClipSprite(#SPRITE_TILESET_MONSTER, sprite_x*32-32, sprite_y*32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTER, 160+xx*32, 160+yy*32)
   EndIf
   
EndProcedure

; --------------------------------------------------------------------------------

Procedure schaden_min()

Shared akt_spieler

   schaden_min.w = 0
   waffe.w = 0
   For i = 1 To #MAX_RUCKSACK
      If inventory(i,akt_spieler)\art = 1 And inventory(i,akt_spieler)\benutzt = 1
         bonus.w = 0
         If inventory(i,akt_spieler)\status = 0
            bonus = gegenstand(inventory(i,akt_spieler)\name)\attri2
         EndIf
         If inventory(i,akt_spieler)\status = 1
            bonus = gegenstand(inventory(i,akt_spieler)\name)\attri2 / 2
         EndIf
         If inventory(i,akt_spieler)\status = 2
            bonus = 0
         EndIf
         waffe = waffe + bonus
      EndIf
   Next
   
   akt_str.w = staerke()
   If skills(#CE_BERSERKER,akt_spieler)\gewaehlt = 1
      akt_str = akt_str * 2
   EndIf
   
   If waffe > 0
      schaden_min = (akt_str/2) + waffe
   Else
      schaden_min = akt_str/2
   EndIf
   
   schaden_min = schaden_min + habich(#SPELL_LIED_DES_KAMPFES) + habich(#SPELL_STAERKEZAUBER)
   
   ; Blutrausch
   If skills(#CE_BLUTRAUSCH,akt_spieler)\gewaehlt = 1
      okay = 0
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 4)) And okay = 0
         schaden_min = schaden_min * 5
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 3)) And okay = 0
         schaden_min = schaden_min * 4
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 2)) And okay = 0
         schaden_min = schaden_min * 3
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 1.5)) And okay = 0
         schaden_min = schaden_min * 2
         okay = 1
      EndIf
   EndIf
   
   schaden_min = schaden_min + spieler(akt_spieler)\damagegegenstand
      
   ; Kampf mit Schwertern
   If skills(#CE_SCHWERTKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_SCHWERT) = 1
      schaden_min = schaden_min + 2
   EndIf
   
   ; Kampf mit Aexten
   If skills(#CE_AXTKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_AXT) = 1
      schaden_min = schaden_min + 2
   EndIf
   
   ; Kampf mit Speeren
   If skills(#CE_SPEERKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_SPEER) = 1
      schaden_min = schaden_min + 2
   EndIf
   
   ; Kampf mit Haemmern
   If skills(#CE_HAMMERKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_HAMMER) = 1
      schaden_min = schaden_min + 2
   EndIf
   
   ; Waffenloser Kampf
   If skills(#CE_WAFFENLOSER_KAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_WAFFENLOS) = 0
      schaden_min = schaden_min + 3
   EndIf
   
   ; Kampf ohne Waffe
   If ich_trage(#KLASSE_WAFFENLOS) = 0 And skills(#CE_WAFFENLOSER_KAMPF,akt_spieler)\gewaehlt = 0
      schaden_min = schaden_min / 2
   EndIf

   ProcedureReturn schaden_min
   
EndProcedure

; --------------------------------------------------------------------------------

Procedure schaden_max()

Shared akt_spieler

   schaden_max.w = 0
   waffe.w = 0
   For i = 1 To #MAX_RUCKSACK
      If inventory(i,akt_spieler)\art = 1 And inventory(i,akt_spieler)\benutzt = 1
         bonus.w = 0
         If inventory(i,akt_spieler)\status = 0
            bonus = gegenstand(inventory(i,akt_spieler)\name)\attri2
         EndIf
         If inventory(i,akt_spieler)\status = 1
            bonus = gegenstand(inventory(i,akt_spieler)\name)\attri2 / 2
         EndIf
         If inventory(i,akt_spieler)\status = 2
            bonus = 0
         EndIf
         waffe = waffe + bonus
       EndIf
   Next
   
   akt_str.w = staerke()
   If skills(#CE_BERSERKER,akt_spieler)\gewaehlt = 1
      akt_str = akt_str * 2
   EndIf
   
   If waffe > 0
      schaden_max = 2 + akt_str + waffe
   Else
      schaden_max = 2 + akt_str
   EndIf
   
   schaden_max = schaden_max + habich(#SPELL_LIED_DES_KAMPFES) + habich(#SPELL_STAERKEZAUBER)
      
   ; Blutrausch
   If skills(#CE_BLUTRAUSCH,akt_spieler)\gewaehlt = 1
      okay = 0
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 4)) And okay = 0
         schaden_max = schaden_max * 5
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 3)) And okay = 0
         schaden_max = schaden_max * 4
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 2)) And okay = 0
         schaden_max = schaden_max * 3
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 1.5)) And okay = 0
         schaden_max = schaden_max * 2
         okay = 1
      EndIf
   EndIf
   
   schaden_max = schaden_max + spieler(akt_spieler)\damagegegenstand
      
   ; Kampf mit Schwertern
   If skills(#CE_SCHWERTKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_SCHWERT) = 1
      schaden_max = schaden_max + 2
   EndIf
   
   ; Kampf mit Aexten
   If skills(#CE_AXTKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_AXT) = 1
      schaden_max = schaden_max + 2
   EndIf
   
   ; Kampf mit Speeren
   If skills(#CE_SPEERKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_SPEER) = 1
      schaden_max = schaden_max + 2
   EndIf
   
   ; Kampf mit Haemmern
   If skills(#CE_HAMMERKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_HAMMER) = 1
      schaden_max = schaden_max + 2
   EndIf
   
   ; Waffenloser Kampf
   If skills(#CE_WAFFENLOSER_KAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_WAFFENLOS) = 0
      schaden_max = schaden_max + 3
   EndIf
   
   ; Kampf ohne Waffe
   If ich_trage(#KLASSE_WAFFENLOS) = 0 And skills(#CE_WAFFENLOSER_KAMPF,akt_spieler)\gewaehlt = 0
      schaden_max = schaden_max / 2
   EndIf

   ProcedureReturn schaden_max
   
EndProcedure

; --------------------------------------------------------------------------------

Procedure schaden_critical()

Shared akt_spieler, xmod, ymod

   schaden_critical.w = 0
   waffe.w = 0
   For i = 1 To #MAX_RUCKSACK
      If inventory(i,akt_spieler)\art = 1 And inventory(i,akt_spieler)\benutzt = 1
         bonus.w = 0
         If inventory(i,akt_spieler)\status = 0
            bonus = gegenstand(inventory(i,akt_spieler)\name)\attri3
         EndIf
         If inventory(i,akt_spieler)\status = 1
            bonus = gegenstand(inventory(i,akt_spieler)\name)\attri3 / 2
         EndIf
         If inventory(i,akt_spieler)\status = 2
            bonus = 0
         EndIf
         waffe = waffe + bonus
       EndIf
   Next
   
   If waffe > 0
      schaden_critical = waffe
   EndIf
   
   schaden_critical = schaden_critical + (reflexe() + luck())
   
   ; Fighting style?
   If spieler(akt_spieler)\style = 4
      schaden_critical = schaden_critical * 2
   EndIf
   
   ; Assassine ?
   If skills(#CE_ASSASSINE,akt_spieler)\gewaehlt = 1
      schaden_critical = schaden_critical * 2
   EndIf
   
   ; 1000 Klingen
   If habich(#SPELL_1000_KLINGEN) > 0
      schaden_critical = schaden_critical + habich(#SPELL_1000_KLINGEN) * 4
   EndIf
   
   If skills(#CE_ASSASSINE,akt_spieler)\gewaehlt = 1
      If schaden_critical > 45
         schaden_critical = 45
      EndIf
   Else
      If schaden_critical > 30
         schaden_critical = 30
      EndIf
   EndIf

   If hat_eigenschaft(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod,#ME_RES_CRITICAL) = 1
      schaden_critical = 0
   EndIf
   
   ProcedureReturn schaden_critical
   
EndProcedure

; --------------------------------------------------------------------------------

Procedure waffe_attack()

Shared akt_spieler

   waffe_attack.w = 0
   waffe.w = 0
   For i = 1 To #MAX_RUCKSACK
      If inventory(i,akt_spieler)\art = 1 And inventory(i,akt_spieler)\benutzt = 1
         waffe = waffe + gegenstand(inventory(i,akt_spieler)\name)\attri1
      EndIf
   Next
   
   If waffe > 0
      waffe_attack = waffe
   EndIf
   
   ; Kampf mit Schwertern
   If skills(#CE_SCHWERTKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_SCHWERT) = 1
      waffe_attack = waffe_attack + 2
   EndIf
   
   ; Kampf mit Aexten
   If skills(#CE_AXTKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_AXT) = 1
      waffe_attack = waffe_attack + 2
   EndIf
   
   ; Kampf mit Speeren
   If skills(#CE_SPEERKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_SPEER) = 1
      waffe_attack = waffe_attack + 2
   EndIf
   
   ; Kampf mit Haemmern
   If skills(#CE_HAMMERKAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_HAMMER) = 1
      waffe_attack = waffe_attack + 2
   EndIf
   
   ; Waffenloser Kampf
   If skills(#CE_WAFFENLOSER_KAMPF,akt_spieler)\gewaehlt = 1 And ich_trage(#KLASSE_WAFFENLOS) = 0
      waffe_attack = waffe_attack + 3
   EndIf
   
   ; Kampf ohne Waffe
   If ich_trage(#KLASSE_WAFFENLOS) = 0 And skills(#CE_WAFFENLOSER_KAMPF,akt_spieler)\gewaehlt = 0
      waffe_attack = waffe_attack / 2
   EndIf
   

   ProcedureReturn waffe_attack
   
EndProcedure

; --------------------------------------------------------------------------------

Procedure schutz()

Shared akt_spieler, schutz_min, schutz_max, behinderung

   schutz_min = 0
   schutz_max = 0
   behinderung = 0

   ; Andere Gestalt?
   okay.w = 0
   If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN
      okay = 1
      schutz_min = 0
      schutz_max = 1
   EndIf
   If habich(#SPELL_FLEDERMAUSGESTALT) > 0 And okay = 0
      okay = 1
      schutz_min = 0
      schutz_max = 4
   EndIf
   If habich(#SPELL_VOGELGESTALT) > 0 And okay = 0
      okay = 1
      schutz_min = 0
      schutz_max = 5
   EndIf
   If habich(#SPELL_KATZENGESTALT) > 0 And okay = 0
      okay = 1
      schutz_min = 1
      schutz_max = 6
   EndIf
   If habich(#SPELL_WOLFSGESTALT) > 0 And okay = 0
      okay = 1
      schutz_min = 1
      schutz_max = 6
   EndIf
   If habich(#SPELL_DRACHENGESTALT) > 0 And okay = 0
      okay = 1
      schutz_min = 3
      schutz_max = 12
   EndIf
   
   If okay = 0
      ; Helm?
      bonus_min.w = 0
      bonus_max.w = 0
      behinderung.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\art = 6 And inventory(i,akt_spieler)\benutzt = 1
            If inventory(i,akt_spieler)\status = 0
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 1
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2 / 2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3 / 2
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 2
               bonus_min = 0
               bonus_max = 0
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
         EndIf
      Next
      If bonus_max > 0
         schutz_min = schutz_min + bonus_min
         schutz_max = schutz_max + bonus_max
         behinderung = behinderung + behinderung
      EndIf
      ; Handschuhe?
      bonus_min.w = 0
      bonus_max.w = 0
      behinderung.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\art = 7 And inventory(i,akt_spieler)\benutzt = 1
            If inventory(i,akt_spieler)\status = 0
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 1
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2 / 2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3 / 2
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 2
               bonus_min = 0
               bonus_max = 0
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
         EndIf
      Next
      If bonus_max > 0
         schutz_min = schutz_min + bonus_min
         schutz_max = schutz_max + bonus_max
         behinderung = behinderung + behinderung
      EndIf
      ; Stiefel?
      bonus_min.w = 0
      bonus_max.w = 0
      behinderung.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\art = 8 And inventory(i,akt_spieler)\benutzt = 1
            If inventory(i,akt_spieler)\status = 0
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 1
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2 / 2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3 / 2
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 2
               bonus_min = 0
               bonus_max = 0
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
         EndIf
      Next
      If bonus_max > 0
         schutz_min = schutz_min + bonus_min
         schutz_max = schutz_max + bonus_max
         behinderung = behinderung + behinderung
      EndIf
      ; Ruestung?
      bonus_min.w = 0
      bonus_max.w = 0
      behinderung.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\art = 9 And inventory(i,akt_spieler)\benutzt = 1
            If inventory(i,akt_spieler)\status = 0
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 1
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2 / 2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3 / 2
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 2
               bonus_min = 0
               bonus_max = 0
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
         EndIf
      Next
      If bonus_max > 0
         schutz_min = schutz_min + bonus_min
         schutz_max = schutz_max + bonus_max
         behinderung = behinderung + behinderung
      EndIf
      ; Schild?
      bonus_min.w = 0
      bonus_max.w = 0
      behinderung.w = 0
      For i = 1 To #MAX_RUCKSACK
         If inventory(i,akt_spieler)\art = 11 And inventory(i,akt_spieler)\benutzt = 1
            If inventory(i,akt_spieler)\status = 0
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 1
               bonus_min = gegenstand(inventory(i,akt_spieler)\name)\attri2 / 2
               bonus_max = gegenstand(inventory(i,akt_spieler)\name)\attri3 / 2
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
            If inventory(i,akt_spieler)\status = 2
               bonus_min = 0
               bonus_max = 0
               behinderung = gegenstand(inventory(i,akt_spieler)\name)\attri1
            EndIf
         EndIf
      Next
      If bonus_max > 0
         schutz_min = schutz_min + bonus_min
         schutz_max = schutz_max + bonus_max
         behinderung = behinderung + behinderung
      EndIf
   EndIf

EndProcedure

; --------------------------------------------------------------------------------
Procedure luck()

Shared spieler, skills, akt_spieler

   akt_luck.w = spieler(akt_spieler)\Luck_score
   ; Glueckszauber ?
   If habich(#SPELL_GLUECKSZAUBER) > 0
      akt_luck = akt_luck + habich(#SPELL_GLUECKSZAUBER)
   EndIf
   
   akt_luck = akt_luck + spieler(akt_spieler)\gluecksgegenstand
   
   If akt_luck > 15
      akt_luck = 15
   EndIf

ProcedureReturn akt_luck

EndProcedure

; --------------------------------------------------------------------------------

Procedure power(spell.w)

Shared schriftrolle, akt_spieler, anz_spieler

   akt_power.w = spieler(akt_spieler)\Power_score

   ; Arkane Gabe ?
   If spell > 0
      If skills(#CE_ARKANE_GABE,akt_spieler)\gewaehlt = 1
         akt_power = akt_power + zauber(spell,akt_spieler)\level
      EndIf
   EndIf
   ; Blutmagie
   If skills(#CE_BLUTMAGIE,akt_spieler)\gewaehlt = 1
      okay = 0
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 4)) And okay = 0
         akt_power = akt_power * 5
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 3)) And okay = 0
         akt_power = akt_power * 4
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 2)) And okay = 0
         akt_power = akt_power * 3
         okay = 1
      EndIf
      If (spieler(akt_spieler)\lifepoints <= (maxlife() / 1.5)) And okay = 0
         akt_power = akt_power * 2
         okay = 1
      EndIf
   EndIf
   If habich(#SPELL_MACHT) > 0
      akt_power = akt_power * 2
   EndIf
   If spieler(akt_spieler)\fluch = #FLUCH_DER_HEKATE
      akt_power = 1
   EndIf
   If schriftrolle = 1
      akt_power = Random(8)+1
   EndIf
   akt_power = akt_power + spieler(akt_spieler)\powergegenstand
   
   ; Magelord?
   magelord.w = 0
   For i = 1 To anz_spieler
      If skills(#CE_ZAUBERFUERST,i)\gewaehlt = 1
         magelord = 2
      EndIf
   Next
   akt_power = akt_power + magelord
   
   If akt_power > 15
      akt_power = 15
   EndIf

ProcedureReturn akt_power

EndProcedure

; --------------------------------------------------------------------------------
Procedure reflexe()

Shared akt_spieler

   akt_reflexe.w = spieler(akt_spieler)\Dexterity
   akt_reflexe = akt_reflexe + spieler(akt_spieler)\dexteritygegenstand
   okay = 0
   If spieler(akt_spieler)\fluch = #FLUCH_DER_ARTEMIS
      akt_reflexe = 1
      okay = 1
   EndIf
   If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN And okay = 0
      akt_reflexe = 1
      okay = 1
   EndIf
   If habich(#SPELL_FLEDERMAUSGESTALT) > 0 And okay = 0
      akt_reflexe = 6
      okay = 1
   EndIf
   If habich(#SPELL_VOGELGESTALT) > 0 And okay = 0
      akt_reflexe = 6
      okay = 1
   EndIf
   If habich(#SPELL_KATZENGESTALT) > 0 And okay = 0
      akt_reflexe = 10
      okay = 1
   EndIf
   If habich(#SPELL_WOLFSGESTALT) > 0 And okay = 0
      akt_reflexe = 6
      okay = 1
   EndIf
   If habich(#SPELL_DRACHENGESTALT) > 0 And okay = 0
      akt_reflexe = 1
   EndIf

   akt_reflexe = akt_reflexe + habich(#SPELL_CONCENTRATION)
   akt_reflexe = akt_reflexe - spieler(akt_spieler)\krankheit
   
   If akt_reflexe > 15
      akt_reflexe = 15
   EndIf

ProcedureReturn akt_reflexe

EndProcedure

; --------------------------------------------------------------------------------
Procedure maxlife()

Shared akt_spieler

   akt_maxlife.w = spieler(akt_spieler)\MaxLifepoints
   okay = 0
   If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN
      akt_maxlife = 1
      okay = 1
   EndIf
   If habich(#SPELL_FLEDERMAUSGESTALT) > 0 And okay = 0
      akt_maxlife = spieler(akt_spieler)\MaxLifepoints / 3
      okay = 1
   EndIf
   If habich(#SPELL_VOGELGESTALT) > 0 And okay = 0
      akt_maxlife = spieler(akt_spieler)\MaxLifepoints / 3
      okay = 1
   EndIf
   If habich(#SPELL_KATZENGESTALT) > 0 And okay = 0
      akt_maxlife = spieler(akt_spieler)\MaxLifepoints / 2
      okay = 1
   EndIf
   If habich(#SPELL_DRACHENGESTALT) > 0 And okay = 0
      akt_maxlife = spieler(akt_spieler)\MaxLifepoints * 3
   EndIf
   
   akt_maxlife = akt_maxlife + spieler(akt_spieler)\lifepointgegenstand

   If skills(#CE_STAEMMIG,akt_spieler)\gewaehlt = 1
      akt_maxlife = akt_maxlife + (spieler(akt_spieler)\Strength * 2)
   EndIf
   
   If akt_maxlife > 150
      akt_maxlife = 150
   EndIf
   
   If skills(#CE_SCHWACH,akt_spieler)\gewaehlt = 1
      If akt_maxlife > 50
         akt_maxlife = 50
      EndIf
   EndIf

ProcedureReturn akt_maxlife

EndProcedure


; --------------------------------------------------------------------------------
Procedure belastung()

Shared akt_spieler

   ; Gewicht macht langsamer
   belastung.w = 0
   If skills(#CE_TRAEGER,akt_spieler)\gewaehlt = 0
      gewicht.w = gewicht()/10
      If spieler(akt_spieler)\fluch = #FLUCH_MAGNETO
         gewicht = gewicht * 2
      EndIf
      For i = 2 To 9
         If gewicht > i*10
            belastung = belastung + 1
         EndIf
      Next
    EndIf
    
    ProcedureReturn belastung
    
EndProcedure

; --------------------------------------------------------------------------------
Procedure maxspeed()

Shared akt_spieler, anz_spieler

   akt_maxspeed.w = spieler(akt_spieler)\MaxSpeed
   okay = 0
   If habich(#SPELL_FLEDERMAUSGESTALT) > 0 And okay = 0
      akt_maxspeed = 10
      okay = 1
   EndIf
   If habich(#SPELL_VOGELGESTALT) > 0 And okay = 0
      akt_maxspeed = 10
      okay = 1
   EndIf
   If habich(#SPELL_KATZENGESTALT) > 0 And okay = 0
      akt_maxspeed = 10
      okay = 1
   EndIf
   If habich(#SPELL_WOLFSGESTALT) > 0 And okay = 0
      akt_maxspeed = 10
      okay = 1
   EndIf
   If habich(#SPELL_DRACHENGESTALT) > 0 And okay = 0
      akt_maxspeed = 5
   EndIf
   
   ; Rueckenwind?
   akt_maxspeed = akt_maxspeed + habich(#SPELL_RUECKENWIND)
   
   ; Magischer Gegenstand?
   akt_maxspeed = akt_maxspeed + spieler (akt_spieler)\zugweitegegenstand
   
   ; Kundschafter?
   kundschafter.w = 0
   For i = 1 To anz_spieler
      If skills(#CE_KUNDSCHAFTER,i)\gewaehlt = 1
         kundschafter = 2
      EndIf
   Next
   akt_maxspeed = akt_maxspeed + kundschafter
   
   ; Meister der Winde?
   meister.w = 0
   akt_save.w = akt_spieler
   For akt_spieler = 1 To anz_spieler
      If habich(#SPELL_WINDMEISTER) > 0
         meister = 2
      EndIf
   Next
   akt_maxspeed = akt_maxspeed + meister
   akt_spieler = akt_save
   
   ; Schleichen macht langsamer!
   If spieler(akt_spieler)\schleichen > 0
      akt_maxspeed = akt_maxspeed / 2
   EndIf
   
   akt_maxspeed = akt_maxspeed - belastung()

   akt_maxspeed = akt_maxspeed - spieler(akt_spieler)\krankheit
   
   ; Lahm?
   If skills(#CE_LAHM,akt_spieler)\gewaehlt = 1 
      akt_maxspeed = akt_maxspeed / 2
      If akt_maxspeed < 1
         akt_maxspeed = 1
      EndIf
   EndIf
   
   ; Paralyse?
   If spieler(akt_spieler)\fluch = #FLUCH_PARALYSE
      akt_maxspeed = 1
   EndIf
   
   If akt_maxspeed <= 1
      akt_maxspeed = 1
   EndIf
   
   If akt_maxspeed > 25
      akt_maxspeed = 25
   EndIf

ProcedureReturn akt_maxspeed

EndProcedure

; --------------------------------------------------------------------------------
Procedure staerke()

Shared akt_spieler

   akt_strength.w = spieler(akt_spieler)\Strength
   okay = 0
   If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN
      akt_strength = 1
      okay = 1
   EndIf
   If habich(#SPELL_FLEDERMAUSGESTALT) > 0 And okay = 0
      akt_strength = 1
      okay = 1
   EndIf
   If habich(#SPELL_VOGELGESTALT) > 0 And okay = 0
      akt_strength = 1
      okay = 1
   EndIf
   If habich(#SPELL_KATZENGESTALT) > 0 And okay = 0
      akt_strength = 1
      okay = 1
   EndIf
   If habich(#SPELL_WOLFSGESTALT) > 0 And okay = 0
      akt_strength = 5
      okay = 1
   EndIf
   If habich(#SPELL_DRACHENGESTALT) > 0 And okay = 0
      akt_strength = 30
   EndIf
   
   akt_strength = akt_strength + spieler(akt_spieler)\staerkegegenstand
   akt_strength = akt_strength - spieler(akt_spieler)\krankheit
   
   If akt_strength > 15
      akt_strength = 15
   EndIf
   If akt_strength < 1
      akt_strength = 1
   EndIf
   

ProcedureReturn akt_strength

EndProcedure

; --------------------------------------------------------------------------------
Procedure angriff()

Shared akt_spieler, anz_spieler

   akt_angriff.w = spieler(akt_spieler)\Attack
   akt_angriff = akt_angriff + spieler(akt_spieler)\attackgegenstand
   akt_angriff = akt_angriff + habich(#SPELL_PRAEZISION)
   
   ; Anfuehrer?
   anfuehrer.w = 0
   For i = 1 To anz_spieler
      If skills(#CE_ANFUEHRER,i)\gewaehlt = 1
         anfuehrer = 2
      EndIf
   Next
   ; Duelist ?
   If skills(#CE_DUELIST,akt_spieler)\gewaehlt = 1
      akt_angriff = akt_angriff + reflexe() / 2
   EndIf
   ; Kampfeswut ?
   If skills(#CE_KAMPFESWUT,akt_spieler)\gewaehlt = 1
      akt_angriff = akt_angriff + staerke() / 2
   EndIf
   akt_angriff = akt_angriff + anfuehrer
   akt_angriff = akt_angriff - spieler(akt_spieler)\krankheit
   
   ; Fighting styles
   If spieler(akt_spieler)\style = 1
      akt_angriff = akt_angriff + 2
   EndIf
   If spieler(akt_spieler)\style = 2 Or spieler(akt_spieler)\style = 4 Or spieler(akt_spieler)\style = 7 Or spieler(akt_spieler)\style = 9
      akt_angriff = akt_angriff - 2
   EndIf
   If spieler(akt_spieler)\style = 3
      akt_angriff = akt_angriff / 2
   EndIf
   If spieler(akt_spieler)\style = 5
      zw.w = (90 - akt_angriff) / 2
      akt_angriff = akt_angriff + zw
   EndIf

   If akt_angriff < 1
      akt_angriff = 1
   EndIf

ProcedureReturn akt_angriff

EndProcedure

; --------------------------------------------------------------------------------
Procedure maxmana()

Shared akt_spieler

   akt_maxmana.w = spieler(akt_spieler)\maxmana
   
   akt_maxmana = akt_maxmana + spieler(akt_spieler)\managegenstand
   
   If akt_maxmana > 150
      akt_maxmana = 150
   EndIf
   If skills(#CE_GERINGES_MANA,akt_spieler)\gewaehlt = 1
      If akt_maxlife > 50
         akt_maxlife = 50
      EndIf
   EndIf

ProcedureReturn akt_maxmana

EndProcedure


; --------------------------------------------------------------------------------
Procedure wahrnehmung()

Shared akt_spieler

   akt_wahrnehmung.w = spieler(akt_spieler)\perception
   akt_wahrnehmung = akt_wahrnehmung + habich(#SPELL_HEXENSICHT) * 10
   akt_wahrnehmung = akt_wahrnehmung + spieler(akt_spieler)\perceptiongegenstand
   
   If akt_wahrnehmung > 15
      akt_wahrnehmung = 15
   EndIf

ProcedureReturn akt_wahrnehmung

EndProcedure

; --------------------------------------------------------------------------------

Procedure schleichen()

Shared akt_spieler, behinderung, xmod, ymod

   If skills(#CE_SCHLEICHEN,akt_spieler)\gewaehlt = 1
      akt_schleichen = (luck() * 5) + (spieler(akt_spieler)\dexterity * 10) + spieler(akt_spieler)\stealthgegenstand + 25
   Else
      akt_schleichen = (luck() * 5) + (spieler(akt_spieler)\dexterity * 5) + spieler(akt_spieler)\stealthgegenstand
   EndIf
   okay = 0
   If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN
      akt_schleichen = 0
      okay = 1
   EndIf
   If habich(#SPELL_FLEDERMAUSGESTALT) > 0 And okay = 0
      akt_schleichen = 70
      okay = 1
   EndIf
   If habich(#SPELL_VOGELGESTALT) > 0 And okay = 0
      akt_schleichen = 70
      okay = 1
   EndIf
   If habich(#SPELL_KATZENGESTALT) > 0 And okay = 0
      akt_schleichen = 70
      okay = 1
   EndIf
   If habich(#SPELL_DRACHENGESTALT) > 0 And okay = 0
      akt_schleichen = 0
   EndIf
   If habich(#SPELL_UNSICHTBARKEIT) > 0
      akt_schleichen = akt_schleichen + 40
   EndIf
   schutz()
   akt_schleichen = akt_schleichen - behinderung * 10
   akt_schleichen = akt_schleichen - (monster(labyrinth(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod)\objekt[spieler(akt_spieler)\level])\minlevel * 2)
   
   ; Schlafendes Monster?
   If labyrinth(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod)\status[spieler(akt_spieler)\level] = #MONSTERSTATUS_SCHLAEFT
      akt_schleichen = akt_schleichen + 40
   EndIf
   
   ; Alarmiertes Monster?
   If labyrinth(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod)\status[spieler(akt_spieler)\level] = #MONSTERSTATUS_ALERT
      akt_schleichen = 0
   EndIf
   
   If akt_schleichen < 1
      akt_schleichen = 0
   EndIf
   If akt_schleichen > 80
      akt_schleichen = 80
   EndIf
   
   ProcedureReturn akt_schleichen

EndProcedure

; --------------------------------------------------------------------------------

Procedure leeren(feld)

Shared akt_spieler

   If inventory(feld,akt_spieler)\anzahl > 0
      inventory(feld,akt_spieler)\anzahl = inventory(feld,akt_spieler)\anzahl - 1
      ; Anzahl wieder auffuellen
      inventory(feld,akt_spieler)\attri1 = gegenstand(inventory(feld,akt_spieler)\name)\attri1
      ; Status ruecksetzen (Wenn nicht Munition!)
      If gegenstand(inventory(feld,akt_spieler)\name)\art <> 13
         inventory(feld,akt_spieler)\status = 0
      EndIf
   Else
      If inventory(feld,akt_spieler)\name = #OBJGRAFIK_BEUTEL   ; Gold gestohlen?
         inventory(feld,akt_spieler)\attri1 = inventory(feld,akt_spieler)\attri1 - Random(spieler(akt_spieler)\level * 2) + 1
         If inventory(feld,akt_spieler)\attri1 < 1
            inventory(feld,akt_spieler)\attri1 = 0
         EndIf
      Else
         inventory(feld,akt_spieler)\name = 0
         inventory(feld,akt_spieler)\art = 0
         inventory(feld,akt_spieler)\benutzt = 0
         inventory(feld,akt_spieler)\status = 0
         inventory(feld,akt_spieler)\anzahl = 0
         inventory(feld,akt_spieler)\attri1 = 0
         inventory(feld,akt_spieler)\attri2 = 0
         inventory(feld,akt_spieler)\attri3 = 0
         inventory(feld,akt_spieler)\attri4 = 0
         inventory(feld,akt_spieler)\attri5 = 0
      EndIf
   EndIf

EndProcedure

; --------------------------------------------------------------------------------------

Procedure old_message(ausgabe.s, farbe.w)

Shared akt_spieler

   ausgabe = FormatDate("%hh:%ii:%ss", Date()) + "  " + ausgabe
   i = 1
   frei = 0
   Repeat
      If old_messages(i,akt_spieler)\nachricht = " "
         frei = i
      EndIf
      i = i + 1
   Until frei > 0 Or i > 25
   
   If frei > 0
      old_messages(frei,akt_spieler)\nachricht = ausgabe
      old_messages(frei,akt_spieler)\farbe     = farbe
   Else
      ; schieben + eintragen
      For i = 1 To 24
         old_messages(i,akt_spieler)\nachricht = old_messages(i+1,akt_spieler)\nachricht
         old_messages(i,akt_spieler)\farbe     = old_messages(i+1,akt_spieler)\farbe
      Next
      old_messages(25,akt_spieler)\nachricht = ausgabe
      old_messages(25,akt_spieler)\farbe     = farbe
   EndIf

EndProcedure

; --------------------------------------------------------------------------------------

; Eine Nachricht nach unten links schreiben
Procedure nachricht(text.w, farbe.w)

Shared sprache, nachricht_text, mydelay

   wohin = ScreenOutput()
   StartDrawing(wohin)
      DrawingMode(1)
      FrontColor(RGB(0,0,0))
      Box(17,380,330,32)
      Select(farbe)
         Case #COLOR_WEISS: FrontColor(RGB(255,255,255))  ; Weiss
         Case #COLOR_BLAU:  FrontColor(RGB(1,1,255))      ; Blau
         Case #COLOR_ROT:   FrontColor(RGB(255,1,1))      ; Rot
         Case #COLOR_GRUEN: FrontColor(RGB(1,255,1))      ; Gruen
         Case #COLOR_GELB:  FrontColor(RGB(255,255,1))    ; Gelb
         Case #COLOR_GRAU:  FrontColor(RGB(150,150,150))  ; Grau
      EndSelect
      

      ausgabe.s = nachricht_text(text,1+sprache)
      DrawText(25,#NACHRICHTEN_POSY,ausgabe)
      old_message(ausgabe,farbe)
   StopDrawing()
   FlipBuffers()
   Delay(mydelay)

EndProcedure

; --------------------------------------------------------------------------------------

; Finden/Stehlen Gegenstand
Procedure nachricht2(text.w,geg.w)

Shared sprache, nachricht_text, mydelay

   wohin = ScreenOutput()
   StartDrawing(wohin)
      DrawingMode(1)
      FrontColor(RGB(0,0,0))
      Box(17,380,330,32)
      FrontColor(RGB(255,255,1)) ; Gelb

      fertig = 0
      
      ; Trank
      If geg = 998
         fertig = 1
         ausgabe.s = nachricht_text(text,1+sprache) + nachricht_text(734,1+sprache)
      EndIf
      
      ; Schriftrolle
      If geg = 997 Or geg = #OBJGRAFIK_SCHRIFTROLLE
         fertig = 1
         ausgabe = nachricht_text(text,1+sprache) + nachricht_text(658,1+sprache)
      EndIf
      
      If fertig = 0
         If gegenstand(geg)\art = 4  ; Trank
            ausgabe.s = nachricht_text(text,1+sprache) + nachricht_text(734,1+sprache)
         Else
            ausgabe = nachricht_text(text,1+sprache) + gegenstand(geg)\name[1+sprache]
         EndIf
      EndIf
      DrawText(25,#NACHRICHTEN_POSY,ausgabe)
      old_message(ausgabe,#COLOR_GELB)
   StopDrawing()
   FlipBuffers()
   Delay(mydelay)

EndProcedure

; --------------------------------------------------------------------------------------

; Finden Gold
Procedure nachricht3(text1.w,anz.w,text2.w)

Shared sprache, nachricht_text, mydelay

   wohin = ScreenOutput()
   StartDrawing(wohin)
      DrawingMode(1)
      FrontColor(RGB(0,0,0))
      Box(17,380,330,32)
      FrontColor(RGB(255,255,1))  ; Gelb
      ausgabe.s = nachricht_text(text1,1+sprache) + Str(anz) + nachricht_text(text2,1+sprache)
      DrawText(25,#NACHRICHTEN_POSY,ausgabe)
      old_message(ausgabe,#COLOR_GELB)
   StopDrawing()
   FlipBuffers()
   Delay(mydelay)

EndProcedure

; --------------------------------------------------------------------------------------

; Nur Text rausschreiben
Procedure.s nachricht4(text.w)

Shared sprache, nachricht_text

   ausgabe.s = nachricht_text(text,1+sprache)
   ProcedureReturn ausgabe

EndProcedure

; --------------------------------------------------------------------------------------

; Monsterkunde
Procedure.s nachricht5(text.w,mon.w)

Shared sprache, nachricht_text

   ausgabe.s = nachricht_text(text,1+sprache) + monster(mon)\name[1+sprache]
   ProcedureReturn ausgabe

EndProcedure

; --------------------------------------------------------------------------------------

; Variabler Text
Procedure.s nachricht6(text.w, text2.s)

Shared sprache, nachricht_text

   ausgabe.s = nachricht_text(text,1+sprache) + text2
   ProcedureReturn ausgabe

EndProcedure

; --------------------------------------------------------------------------------------

; Eine Nachricht nach unten links schreiben
Procedure nachricht7(text.s,farbe.w)

Shared sprache, nachricht_text, mydelay

   wohin = ScreenOutput()
   StartDrawing(wohin)
      DrawingMode(1)
      FrontColor(RGB(0,0,0))
      Box(17,380,330,32)
      Select(farbe)
         Case #COLOR_WEISS: FrontColor(RGB(255,255,255))  ; Weiss
         Case #COLOR_BLAU:  FrontColor(RGB(1,1,255))      ; Blau
         Case #COLOR_ROT:   FrontColor(RGB(255,1,1))      ; Rot
         Case #COLOR_GRUEN: FrontColor(RGB(1,255,1))      ; Gruen
         Case #COLOR_GELB:  FrontColor(RGB(255,255,1))    ; Gelb
         Case #COLOR_GRAU:  FrontColor(RGB(150,150,150))  ; Grau
      EndSelect
      DrawText(25,#NACHRICHTEN_POSY,text)
      old_message(text,farbe)
   StopDrawing()
   FlipBuffers()
   Delay(mydelay)

EndProcedure

; --------------------------------------------------------------------------------------
; Gegenstand - Klasse
Procedure ich_trage(was.w)

Shared akt_spieler

    jupp = 0
    waffe = 0
    For i = 1 To #MAX_RUCKSACK
       If gegenstand(inventory(i,akt_spieler)\name)\klasse = was And inventory(i,akt_spieler)\benutzt = 1
          jupp = 1
       EndIf
       If gegenstand(inventory(i,akt_spieler)\name)\art = 1 And inventory(i,akt_spieler)\benutzt = 1
          waffe = 1
       EndIf
    Next
    
    If was = #KLASSE_WAFFENLOS And waffe = 1
       jupp = 1
    EndIf
    
    ProcedureReturn jupp

EndProcedure

; --------------------------------------------------------------------------------------
; Gegenstand - Art
Procedure ich_trage3(was.w)

Shared akt_spieler

    jupp = 0
    For i = 1 To #MAX_RUCKSACK
       If inventory(i,akt_spieler)\name = was And inventory(i,akt_spieler)\benutzt = 1
          jupp = 1
       EndIf
    Next
    
    ProcedureReturn jupp

EndProcedure

; --------------------------------------------------------------------------------------

Procedure radius()

Shared akt_spieler, test
  
   ; Andere Gestalt?
   If habich(#SPELL_VOGELGESTALT) > 0 
      sicht = 4
   ElseIf habich(#SPELL_KATZENGESTALT) > 0 
      sicht = 6
   ElseIf habich(#SPELL_WOLFSGESTALT) > 0 
      sicht = 5
   ElseIf habich(#SPELL_DRACHENGESTALT) > 0 
      sicht = 4
   Else
     ; Nachtsicht ?
     nachtsichtw = 0
     If skills(#CE_NACHTSICHT,akt_spieler)\gewaehlt = 1
        nachtsicht = 2
     EndIf
      sicht = spieler(akt_spieler)\light + spieler(akt_spieler)\lichtgegenstand + nachtsicht + habich(#SPELL_LICHT) + habich(#SPELL_LIED_DER_HOFFNUNG)
   EndIf
   
   If sonderlevel(spieler(akt_spieler)\level) = #SL_ARCHIPEL Or sonderlevel(spieler(akt_spieler)\level) = #SL_WUESTE Or sonderlevel(spieler(akt_spieler)\level) = #SL_ZENTAUERWALD Or sonderlevel(spieler(akt_spieler)\level) = #SL_SUMPF
      sicht = 8
   EndIf 
   
    ; Kurzsichtig ?
   If skills(#CE_KURZSICHTIG,akt_spieler)\gewaehlt = 1
      sicht = sicht / 2
   EndIf
   
   ; Magical Darkness?
   If levelmod = #LM_MAGICAL_DARKNESS
      sicht = sicht / 2
   EndIf
   
   If sicht < 1 Or spieler(akt_spieler)\fluch = #FLUCH_BLINDHEIT
      sicht = 1
   EndIf   
   
   ProcedureReturn sicht

EndProcedure


Procedure radius2()

Shared akt_spieler

   sight.w = 0
   Select (spieler(akt_spieler)\creature_typ)
      Case 1: sight = 4 ;Homunkulus
      Case 2: sight = 3 ;Skelett
      Case 3: sight = 3 ;Todesritter
      Case 4: sight = 6 ;Sternenfee
      Case 5: sight = 4 ;Tiger
      Case 6: sight = 3 ;Mumie
      Case 7: sight = 4 ;Daemon
      Case 8: sight = 6 ;Engel
      Case 9: sight = 5 ;Drache
      Case 10: sight = 5 ;Doppelgaenger
      Case 11: sight = 6 ;Vogel
      Case 12: sight = 4 ;Golem
      Case 13: sight = 4 ;Satyr
      Case 14: sight = 6 ;Feuerelementar
      Case 15: sight = 5 ;Wasserelementar
      Case 20: sight = 5 ;Gefaehrte
   EndSelect
   
   ProcedureReturn sight
   
EndProcedure

; --------------------------------------------------------------------------------------

Procedure show_sight()

Shared akt_spieler, test

sicht.w = radius()

Select sicht
   Case 1
      ClipSprite(#SPRITE_TILESET_SIGHT, 1, 1, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
   Case 2
      ClipSprite(#SPRITE_TILESET_SIGHT, 335, 1, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
   Case 3
      ClipSprite(#SPRITE_TILESET_SIGHT, 670, 1, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
   Case 4
      ClipSprite(#SPRITE_TILESET_SIGHT, 1, 335, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
   Case 5
      ClipSprite(#SPRITE_TILESET_SIGHT, 335, 335, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
   Case 6
      ClipSprite(#SPRITE_TILESET_SIGHT, 670, 335, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
   Case 7
      ClipSprite(#SPRITE_TILESET_SIGHT, 1, 670, 335, 335)
      DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
   Default  ; zeige alles
EndSelect

EndProcedure

; --------------------------------------------------------------------------------------

Procedure show_sight2()

Shared spieler, akt_spieler, test, levelmod

   sight.w = radius2()
   
   ; Magical Darkness?
   If levelmod = #LM_MAGICAL_DARKNESS
      sight = sight - 2
      If sight < 2
         sight = 1
      EndIf
   EndIf
   
   
   Select sight
      Case 1
         ClipSprite(#SPRITE_TILESET_SIGHT, 1, 1, 335, 335)
         DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
      Case 2
         ClipSprite(#SPRITE_TILESET_SIGHT, 335, 1, 335, 335)
         DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
      Case 3
         ClipSprite(#SPRITE_TILESET_SIGHT, 670, 1, 335, 335)
         DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
      Case 4
         ClipSprite(#SPRITE_TILESET_SIGHT, 1, 335, 335, 335)
         DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
      Case 5
         ClipSprite(#SPRITE_TILESET_SIGHT, 335, 335, 335, 335)
         DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
      Case 6
         ClipSprite(#SPRITE_TILESET_SIGHT, 670, 335, 335, 335)
         DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
      Case 7
         ClipSprite(#SPRITE_TILESET_SIGHT, 1, 670, 335, 335)
         DisplayTransparentSprite(#SPRITE_TILESET_SIGHT, 16, 15)
      Default  ; zeige alles
   EndSelect


EndProcedure

; -------------------------------------------------------------------------------

Procedure hat_eigenschaft(labyx.w,labyy.w,eigensch.w)

Shared akt_spieler

   fkampf.w = 0
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft1 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft2 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft3 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft4 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft5 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft6 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft7 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft8 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft9 = eigensch
      fkampf = 1
   EndIf
   If monster(labyrinth(labyx,labyy)\objekt[spieler(akt_spieler)\level])\eigenschaft10 = eigensch
      fkampf = 1
   EndIf

ProcedureReturn = fkampf

EndProcedure

; -------------------------------------------------------------------------------

Procedure hat_eigenschaft2(welches.w,eigensch.w)

Shared monster

   gef = 0
   If monster(welches)\eigenschaft1 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft2 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft3 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft4 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft5 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft6 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft7 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft8 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft9 = eigensch
      gef = 1
   EndIf
   If monster(welches)\eigenschaft10 = eigensch
      gef = 1
   EndIf

ProcedureReturn = gef

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure feld_waehlen()

Shared frame, akt_spieler, spell_x, spell_y, joystick_used
Shared mmouse_x, mmouse_y, mmouse_links, mmouse_rechts, selectdelay

result = ExamineMouse()
mouse_x_old.w = MouseX()
mouse_y_old.w = MouseY()

   Repeat
      Fenster()
      ExamineKeyboard()
      jax.w = 0
      jay.w = 0
      jb2.w = 0
      If joystick_used = 1
         ExamineJoystick()
         jax = JoystickAxisX()
         jay = JoystickAxisY()
         jb1 = JoystickButton(1)
      EndIf
      
                  
     
      ADDelayMax(1) = selectdelay
      If KeyboardPushed(#PB_Key_Up)  Or jay = -1
         If autoDelay(1,#AD_WORK, -2)
            autoDelay(1,#AD_SETNEW, -2)
            spell_y = spell_y - 1
         EndIf

      ElseIf KeyboardPushed(#PB_Key_Down) Or jay = 1
         If autoDelay(1,#AD_WORK, -2)
            autoDelay(1,#AD_SETNEW, -2)
            spell_y = spell_y + 1
         EndIf

      ElseIf KeyboardPushed(#PB_Key_Left) Or jax = -1
         If autoDelay(1,#AD_WORK, -2)
            autoDelay(1,#AD_SETNEW, -2)
            spell_x = spell_x - 1
         EndIf

      ElseIf KeyboardPushed(#PB_Key_Right) Or jax = 1
         If autoDelay(1,#AD_WORK, -2)
            autoDelay(1,#AD_SETNEW, -2)
            spell_x = spell_x + 1
         EndIf
      Else
      autoDelay(1,#AD_SETZERO, -2)
      EndIf
      
      
      
      If spell_x > 4
         spell_x = 4
      EndIf
      If spell_y > 4
         spell_y = 4
      EndIf
      If spell_x < -4
         spell_x = -4
      EndIf
      If spell_y < -4
         spell_y = -4
      EndIf

      laby_screen2()

      x = 30
      y = 30
      mouseklick = 0
      For i = 1 To 9
         For j = 1 To 9
            If mmouse_x >= x + i * 32 - 32 And mmouse_x <= x + i * 32 And mmouse_y >=  y + j * 32 - 32 And mmouse_y <= y + j * 32
               If mmouse_x <> mouse_x_old Or mmouse_y <> mouse_y_old
                  mouse_x_old = mmouse_x
                  mouse_y_old = mmouse_y
                  spell_x = i - 5
                  spell_y = j - 5
               EndIf
               If mmouse_links = 1
                  mouseklick = 1
               EndIf
            EndIf
         Next
      Next
   
      ; Auswahlfeld
      ClipSprite(#SPRITE_TILESET_LABYRINTH, 0, 32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_LABYRINTH, 160+spell_x*32, 160+spell_y*32)
   
      ;Maus darstellen
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
   
      FlipBuffers()
   
   Until KeyboardPushed(#PB_Key_Space) Or mouseklick = 1 Or jb1 <> 0
   autoDelay(-1,#AD_DELTEMP,-2) 

EndProcedure
; --------------------------------------------------------------------------------------------

; Mit Flipbuffers!
Procedure laby_screen()

   screen2()
   
   FlipBuffers()

EndProcedure

; --------------------------------------------------------------------------------------------

; Ohne Flipbuffers!
Procedure laby_screen2()

   screen2()

EndProcedure

; --------------------------------------------------------------------------------------------

; Fuer Kreaturen
; Mit flipbuffers
Procedure laby_screen3()

Shared akt_spieler, frame, character_x, character_y, mmouse_x, mmouse_y, mouse_x_old, mouse_y_old
Shared mmouse_links, mmouse_rechts

   ClearScreen(RGB(0,0,0))
   draw_screen2(0,0) ; Alles ausser Mauern + Schaetze
   draw_screen5(0,0) ; Mauern
   draw_screen6(0,0) ; Schaetze
   draw_creature(frame,0)
   laby_rahmen()
   show_logo()
   show_varys2()
   show_sight2()
   show_buttons2()
   ; Maus darstellen
   result = ExamineMouse()
   mmouse_x = MouseX()
   mmouse_y = MouseY()
   mmouse_links  = MouseButton(1)
   mmouse_rechts = MouseButton(2)
   mouse_x_old = mmouse_x
   mouse_y_old = mmouse_y
   
   FlipBuffers()

EndProcedure

; --------------------------------------------------------------------------------------------

; Fuer Kreaturen
; Ohne flipbuffers
Procedure laby_screen4()

Shared akt_spieler, frame, character_x, character_y, mmouse_x, mmouse_y, mouse_x_old, mouse_y_old
Shared mmouse_links, mmouse_rechts

   ClearScreen(RGB(0,0,0))
   draw_screen2(0,0) ; Alles ausser Mauern + Schaetze
   draw_screen5(0,0) ; Mauern
   draw_screen6(0,0) ; Schaetze
   draw_creature(frame,0)
   laby_rahmen()
   show_logo()
   show_varys2()
   show_sight2()
   show_buttons2()
   ; Maus darstellen
   result = ExamineMouse()
   mmouse_x = MouseX()
   mmouse_y = MouseY()
   mmouse_links  = MouseButton(1)
   mmouse_rechts = MouseButton(2)
   mouse_x_old = mmouse_x
   mouse_y_old = mmouse_y

EndProcedure

; --------------------------------------------------------------------------------------

Procedure neuer_level()

Shared akt_spieler, level, test

   spieler(akt_spieler)\level = spieler(akt_spieler)\level + 1
   
   ; Spielende?
   If spieler(akt_spieler)\level > #MAX_EBENEN
      ende()
   EndIf
   
   If spieler(akt_spieler)\level > spieler(akt_spieler)\maxlevel

      spieler(akt_spieler)\maxlevel = spieler(akt_spieler)\level
   
      spieler(akt_spieler)\portal = 1
      spieler(akt_spieler)\teleport = 1
      spieler(akt_spieler)\nexus = 1
      spieler(akt_spieler)\zauberbuch = 1
      spieler(akt_spieler)\kessel = 1
      spieler(akt_spieler)\udjat_ben = 1
      spieler(akt_spieler)\stehlen = 2
      spieler(akt_spieler)\lehrer = 3
      spieler(akt_spieler)\armageddon = 1
      spieler(akt_spieler)\pestilence = 1
      spieler(akt_spieler)\drachenform = 1
      spieler(akt_spieler)\macht = 1
      spieler(akt_spieler)\magic_apple = 2
      spieler(akt_spieler)\refresh = 2
      spieler(akt_spieler)\heal = 3
      
   
      ; Bei Ley Kontakt Aktive Zauber beenden
      If skills(#CE_LEYKONTAKT,akt_spieler)\gewaehlt = 1
         For j = 1 To 15
            If aktive(j,akt_spieler)\dauer > 0 And aktive(j,akt_spieler)\dauer <> #UNENDLICH
               aktive(j,akt_spieler)\nr = 0
               aktive(j,akt_spieler)\staerke = 0
               aktive(j,akt_spieler)\dauer = 0
            EndIf
         Next
      EndIf
      
      ; Leykontakt ?
      If skills(#CE_LEYKONTAKT,akt_spieler)\gewaehlt = 1
         spieler(akt_spieler)\Mana = maxmana()
      EndIf
      
      ; First Aid ?
      If skills(#CE_HEILKUNDE,akt_spieler)\gewaehlt = 1
         spieler(akt_spieler)\Lifepoints = maxlife()
      EndIf
      
      ; Archery ?
      If skills(#CE_BOGENSCHIESSEN,akt_spieler)\gewaehlt = 1
         ; 10 neue Pfeile
         j = 0
         Repeat
            j = j + 1
         Until inventory(j,akt_spieler)\name = 0 Or j > #MAX_RUCKSACK
         
         If j <= #MAX_RUCKSACK
            inventory(j,akt_spieler)\name = #OBJGRAFIK_PFEIL
            inventory(j,akt_spieler)\art = gegenstand(#OBJGRAFIK_PFEIL)\art
            inventory(j,akt_spieler)\attri1 = 10
            inventory(j,akt_spieler)\attri2 = 0
            inventory(j,akt_spieler)\attri3 = 1
            inventory(j,akt_spieler)\attri4 = 5
         EndIf
      EndIf
      
      ; Pfeilmacher ?
      If skills(#CE_PFEILMACHER,akt_spieler)\gewaehlt = 1
         ; 10 neue Spezial Pfeile
         j = 0
         Repeat
            j = j + 1
         Until inventory(j,akt_spieler)\name = 0 Or j > #MAX_RUCKSACK
         
         hugo.w = Random(6)+1
         Select(hugo)
            Case 1: geg.w = #OBJGRAFIK_KOECHER
            Case 2: geg.w = #OBJGRAFIK_PFEILE_SCHWARZ
            Case 3: geg.w = #OBJGRAFIK_ZAUBERPFEIL
            Case 4: geg.w = #OBJGRAFIK_PFEIL1
            Case 5: geg.w = #OBJGRAFIK_PFEIL2
            Case 6: geg.w = #OBJGRAFIK_PFEIL3
            Case 7: geg.w = #OBJGRAFIK_PFEIL4
         EndSelect
         
         If j <= #MAX_RUCKSACK
            inventory(j,akt_spieler)\name = geg
            inventory(j,akt_spieler)\art = gegenstand(geg)\art
            inventory(j,akt_spieler)\attri1 = gegenstand(geg)\attri1
            inventory(j,akt_spieler)\attri2 = gegenstand(geg)\attri2
            inventory(j,akt_spieler)\attri3 = gegenstand(geg)\attri3
            inventory(j,akt_spieler)\attri4 = gegenstand(geg)\attri4
         EndIf
      EndIf
      
      ; Haendler ?
      If skills(#CE_HAENDLER,akt_spieler)\gewaehlt = 1 And Random(100) > 80
         willi.w = Random(4)+1
         Select(willi)
            Case 1: haendler_init1(spieler(akt_spieler)\level)
            Case 2: haendler_init2(spieler(akt_spieler)\level)
            Case 3: haendler_init3(spieler(akt_spieler)\level)
            Case 4: haendler_init4(spieler(akt_spieler)\level)
            Case 5: haendler_init5(spieler(akt_spieler)\level)
         EndSelect
         haendler()
      EndIf
      
      ; Soeldner ?
      If skills(#CE_SOELDNER,akt_spieler)\gewaehlt = 1
         gold_finden2(spieler(akt_spieler)\level*5)
      EndIf
      
      ; Verflucht ?
      If skills(#CE_VERFLUCHT,akt_spieler)\gewaehlt = 1 And Random(100) < min(20+spieler(akt_spieler)\level,90)
         nachricht(29,#COLOR_GRAU)
         If spieler(akt_spieler)\fluch = 0
            spieler(akt_spieler)\fluch = Random(#ANZ_FLUECHE-1) + 1
            If spieler(akt_spieler)\fluch = #FLUCH_CHICKEN
               Sound(#SOUND_CHICKEN)
            Else
               Sound(#SOUND_DARKNESS)
            EndIf
            spieler(akt_spieler)\fluchdauer = Random(6) + 5
            ; Verflucht ?
            If skills(#CE_VERFLUCHT,akt_spieler)\gewaehlt = 1
               spieler(akt_spieler)\fluchdauer = spieler(akt_spieler)\fluchdauer * 2
            EndIf
         Else
            spieler(akt_spieler)\fluchdauer = spieler(akt_spieler)\fluchdauer + Random(6) + 5
            ; Verflucht ?
            If skills(#CE_VERFLUCHT,akt_spieler)\gewaehlt = 1
               spieler(akt_spieler)\fluchdauer = spieler(akt_spieler)\fluchdauer  + Random(6) + 5
            EndIf
         EndIf
      EndIf
   EndIf ; Neuer maxlevel

   ; Schon erschaffen?
   If groesse(spieler(akt_spieler)\level) = 0
      gen_laby(spieler(akt_spieler)\level)
   EndIf

   If sonderlevel(spieler(akt_spieler)\level) > 0
      sonderlevel_text(sonderlevel(spieler(akt_spieler)\level))
   EndIf
   
   If levelmod(spieler(akt_spieler)\level) > 0
      levelmodtext(levelmod(spieler(akt_spieler)\level))
   EndIf
         
   spieler(akt_spieler)\character_x = eingangx(spieler(akt_spieler)\level)
   spieler(akt_spieler)\character_y = eingangy(spieler(akt_spieler)\level)
   spieler(akt_spieler)\Speed = maxspeed()
   spieler(akt_spieler)\creature_x = eingangx(spieler(akt_spieler)\level)
   spieler(akt_spieler)\creature_y = eingangy(spieler(akt_spieler)\level)
      

EndProcedure

; --------------------------------------------------------------------------------

Procedure vorheriger_level()

Shared akt_spieler

   spieler(akt_spieler)\level = spieler(akt_spieler)\level - 1
   
   spieler(akt_spieler)\character_x = ausgangx(spieler(akt_spieler)\level)
   spieler(akt_spieler)\character_y = ausgangy(spieler(akt_spieler)\level)
   spieler(akt_spieler)\Speed = maxspeed()
   spieler(akt_spieler)\creature_x = ausgangx(spieler(akt_spieler)\level)
   spieler(akt_spieler)\creature_y = ausgangy(spieler(akt_spieler)\level)

   If sonderlevel(spieler(akt_spieler)\level) > 0
      sonderlevel_text(sonderlevel(spieler(akt_spieler)\level))
   EndIf
   
   If levelmod(spieler(akt_spieler)\level) > 0
      levelmodtext(levelmod((spieler(akt_spieler)\level)))
   EndIf

EndProcedure

; --------------------------------------------------------------------------------

Procedure naechster()

Shared akt_spieler, xmod, ymod, spieler, anz_spieler

If anz_spieler > 1

 ; gibts noch aktive spieler?
 aktiv = 0
 For i = 1 To anz_spieler
     If spieler(i)\Status = 1 
        aktiv = 1
     EndIf
 Next

 ; Wenn ja weiterschalten auf naechsten aktiven
 If aktiv = 1
   Repeat
      akt_spieler = akt_spieler + 1
      If akt_spieler > anz_spieler
         akt_spieler = 1
      EndIf
   Until spieler(akt_spieler)\Status = 1
 EndIf
 
 xmod = 0
 ymod = 0
 laby_screen()
 Delay(200)
     
EndIf

EndProcedure

; --------------------------------------------------------------------------------------

Procedure spielerschaden(schaden.w, farbe.w, sterbegrund.w)

Shared akt_spieler, frame, sprache, anz_spieler

   inhalt_x.w = inhalt((spieler(akt_spieler)\level))
   inhalt_y.w = 0
   If inhalt_x > 10
      Repeat
         inhalt_y = inhalt_y + 1
         inhalt_x = inhalt_x - 10
      Until inhalt_x < 11
   EndIf
   If inhalt_x = 10
      inhalt_x = 0
      inhalt_y = inhalt_y + 1
   EndIf

   ; Abziehen
   spieler(akt_spieler)\LifePoints = spieler(akt_spieler)\Lifepoints - schaden
   
   laby_screen2()
   ; Fleck darstellen
   If farbe = 1     ; Rot
      ClipSprite(#SPRITE_TILESET_PROJEKTILE, 0*32, 7*32, 32, 32)
   EndIf
   If farbe = 2     ; Gruen
      ClipSprite(#SPRITE_TILESET_PROJEKTILE, 1*32, 7*32, 32, 32)
   EndIf
   If farbe = 3     ; Blau
      ClipSprite(#SPRITE_TILESET_PROJEKTILE, 2*32, 7*32, 32, 32)
   EndIf
   DisplayTransparentSprite(#SPRITE_TILESET_PROJEKTILE, 160, 160)
   Sound(Random(6)+1)
   ; Schaden darstellen
   wohin = ScreenOutput()
   StartDrawing(wohin)
       DrawingMode(1)

       FrontColor(RGB(255,255,255))  ; Weiss
       
       ; verschieben bei groesseren Zahlen
       If schaden < 10: DrawText(172, 168,Str(schaden)): EndIf
       If schaden >= 10:DrawText(166, 168,Str(schaden)): EndIf
       If schaden >= 100: DrawText(163, 168,Str(schaden)): EndIf
        
       
   StopDrawing()
   FlipBuffers()
   Delay(150)

   ; Bei Fallgrube nicht toeten!
   If sterbegrund = 4 And spieler(akt_spieler)\LifePoints < 1
      spieler(akt_spieler)\Lifepoints = 1
   EndIf
   ; Spieler Tot ?
   If spieler(akt_spieler)\LifePoints < 1
      Select(sterbegrund)
          Case 1: ; Speerfalle
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(680,1+sprache)
               Next
          Case 2: ; Axtfalle
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(681,1+sprache)
               Next
          Case 3: ; Pfeilfalle
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(682,1+sprache)
               Next
          Case 4: ; Fallgrube
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(683,1+sprache)
               Next
          Case 5: ; Feuerball
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(684,1+sprache)
               Next
          Case 6: ; Frostball
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(685,1+sprache)
               Next
          Case 7: ; Dunkler Sog
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(686,1+sprache)
               Next
          Case 8: ; Verdursten
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(687,1+sprache)
               Next
          Case 9: ; Verhungern
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(688,1+sprache)
               Next
          Case 10: ; Gift
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(689,1+sprache)
               Next
          Case 11: ; Feuer
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(690,1+sprache)
               Next
          Case 12: ; Wasser
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(691,1+sprache)
               Next
          Case 13: ; Eis
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(692,1+sprache)
               Next
          Case 14: ; Explosion
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(707,1+sprache)
               Next
          Case 15: ; Zauberfehlschlag
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(739,1+sprache)
               Next
          Case 16: ; Nagelgrube
               For i = 1 To #ANZ_SPRACHEN
                  spieler(akt_spieler)\sterbegrund[i] = nachricht_text(830,1+sprache)
               Next
      EndSelect
      tot() 
   EndIf

EndProcedure

; --------------------------------------------------------------------------------------

; Skelett
Procedure aufstehen(nr.w)

Shared akt_spieler, xmod, ymod, frame

     inhalt_x.w = nr
     inhalt_y.w = 0
     If inhalt_x > 10
        Repeat
           inhalt_y = inhalt_y + 1
           inhalt_x = inhalt_x - 10
        Until inhalt_x < 11
     EndIf
     If inhalt_x = 10
        inhalt_x = 0
        inhalt_y = inhalt_y + 1
     EndIf

   For i = 1 To 32
      laby_screen2()
      draw_tile(labyrinth(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod)\feld[spieler(akt_spieler)\Level], 5+xmod, 5+ymod, 0, 0)

      ClipSprite(#SPRITE_TILESET_MONSTER, inhalt_x * 32-32, inhalt_y * 32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTER, 160+xmod*32, 160+ymod*32+(32-i))

      draw_tile(labyrinth(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod+1)\feld[spieler(akt_spieler)\Level], 5+xmod, 5+ymod+1, 0, 0)

      draw_tile(labyrinth(spieler(akt_spieler)\character_x, spieler(akt_spieler)\character_y)\feld[spieler(akt_spieler)\Level], 5, 5, 0, 0)
      draw_character(spieler(akt_spieler)\face, frame,0)

      restaurieren()
      
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
      FlipBuffers()
      Delay(30)

   Next

EndProcedure

; --------------------------------------------------------------------------------------

; Wassermonster
Procedure aufstehen2(nr.w)

Shared akt_spieler, xmod, ymod, frame

   sprite_x.w = nr
   sprite_y.w = 0
   If sprite_x > 10
      Repeat
         sprite_y = sprite_y + 1
         sprite_x = sprite_x - 10
      Until sprite_x < 11
   EndIf

   For i = 1 To 32
      laby_screen2()
      ; Wasser
      draw_tile(labyrinth(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod)\feld[spieler(akt_spieler)\Level], 5+xmod, 5+ymod, 0, 0)
      
      ClipSprite(#SPRITE_TILESET_MONSTER, sprite_x*32-32, sprite_y*32, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTER, 160+xmod*32, 160+ymod*32+(32-i))

      draw_tile(labyrinth(spieler(akt_spieler)\character_x+xmod, spieler(akt_spieler)\character_y+ymod+1)\feld[spieler(akt_spieler)\Level], 5+xmod, 5+ymod+1, 0, 0)

      draw_tile(labyrinth(spieler(akt_spieler)\character_x, spieler(akt_spieler)\character_y)\feld[spieler(akt_spieler)\Level], 5, 5, 0, 0)
      draw_character(spieler(akt_spieler)\face, frame,0)

      restaurieren()
      
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
      
      FlipBuffers()
      Delay(30)
   Next

EndProcedure

; ------------------------------------------------------------------------------------------
; Skelett fuer Kreatur
Procedure aufstehen3(nr.w)

Shared akt_spieler, xmod, ymod, frame


   For i = 1 To 32
      laby_screen4()
      draw_tile(labyrinth(spieler(akt_spieler)\creature_x+xmod, spieler(akt_spieler)\creature_y+ymod)\feld[spieler(akt_spieler)\Level], 5+xmod, 5+ymod, 0, 0)

      ClipSprite(#SPRITE_TILESET_MONSTER, 32, 64, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_MONSTER, 160+xmod*32, 160+ymod*32+(32-i))

      draw_tile(labyrinth(spieler(akt_spieler)\creature_x+xmod, spieler(akt_spieler)\creature_y+ymod+1)\feld[spieler(akt_spieler)\Level], 5+xmod, 5+ymod+1, 0, 0)

      draw_tile(labyrinth(spieler(akt_spieler)\creature_x, spieler(akt_spieler)\creature_y)\feld[spieler(akt_spieler)\Level], 5, 5, 0, 0)
      draw_creature(frame,0)

      restaurieren2()
      
      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
      
      FlipBuffers()
      Delay(30)
   Next

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure aus_schule(spell.w)

Shared akt_spieler

   schule.w = 0
   If zauber(spell,akt_spieler)\art = "basis"
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "sterne" And skills(#CE_STERNENMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "illusion" And skills(#CE_ILLUSIONSMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "weiss" And skills(#CE_WEISSE_MAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "schwarz" And skills(#CE_SCHWARZE_MAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "feuer" And skills(#CE_FEUERMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "wasser" And skills(#CE_WASSERMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "erde" And skills(#CE_ERDMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "luft" And skills(#CE_LUFTMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "druide" And skills(#CE_DRUIDENMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "hexerei" And skills(#CE_HEXEREI,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "hohe" And skills(#CE_HOHE_MAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If zauber(spell,akt_spieler)\art = "barde" And skills(#CE_ZAUBERLIEDER,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   If (zauber(spell,akt_spieler)\art = "erde" Or zauber(spell,akt_spieler)\art = "feuer" Or zauber(spell,akt_spieler)\art = "luft" Or zauber(spell,akt_spieler)\art = "wasser") And skills(#CE_ELEMENTARMAGIE,akt_spieler)\gewaehlt = 1
      schule = 1
   EndIf
   
   ProcedureReturn schule

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure zauberchance(spell.w)

Shared akt_spieler, behinderung

  chance.w = zauber(spell,akt_spieler)\chance
  ; Zauberkunst
  If aus_schule(spell) = 1
     If skills(#CE_ZAUBERKUNST,akt_spieler)\gewaehlt = 1
        chance = 99
     EndIf
  EndIf
  ; Zaubern in Ruestung ?
  If skills(#CE_ZAUBERN_IN_RUESTUNG,akt_spieler)\gewaehlt = 0
     schutz()
     chance = chance - (behinderung * 10)
  EndIf
  ProcedureReturn = chance

EndProcedure

; ------------------------------------------------------------------------------------------

Procedure erfolgreich(spell.w)

Shared akt_spieler, schriftrolle

   okay.w = 0
   If Random(100) < zauberchance(spell) Or schriftrolle = 1
      okay = 1
      If zauber(spell,akt_spieler)\chance < 100
         zauber(spell,akt_spieler)\chance = zauber(spell,akt_spieler)\chance + 5
      EndIf
   EndIf
   
   ProcedureReturn okay
   
EndProcedure

; ------------------------------------------------------------------------------------------

Procedure spieler_angriffswert()

Shared akt_spieler, behinderung

   angriff.w = 20 + (angriff() * 10) + (waffe_attack() * 10) + (habich(#SPELL_LIED_DES_KAMPFES) * 10)
   ; Behinderung durch Ruestung ?
   If skills(#CE_KAMPF_IN_RUESTUNG,akt_spieler)\gewaehlt = 0
      angriff   = angriff - (behinderung * 10)
   EndIf
   If spieler(akt_spieler)\fluch = #FLUCH_DES_ARES
      angriff = 10
   EndIf

   ProcedureReturn = angriff
   
EndProcedure


Procedure autoDelay(ADInput.l,ADWhat.b ,ADDelayMaxInput.l)
Shared ADCount, ADMax
Static TimeOld.l

DelayNull.l = 0

   If ADDelayMaxInput <> -2
      If ADWhat = -1
         If ADDelayMax(ADInput) = 0
            ADDelayMax(ADInput) = ADDelayMaxInput
         EndIf
      Else
         ADDelayMax(ADInput) = ADDelayMaxInput
      EndIf
   EndIf
   
   If ADWhat = 1
      If TimeOld = 0
         TimeOld=ElapsedMilliseconds()
      EndIf
      
      If ADDelay(ADInput) > 0
         ADDelay(ADInput) - (ElapsedMilliseconds()-TimeOld) 
         
         TimeOld=ElapsedMilliseconds()
      
      
         If ADDelay(ADInput) < 0
            ADDelay(ADInput) = 0
         EndIf
      EndIf
   EndIf
   
   If ADWhat = 2
      ADDelay(ADInput) = ADDelayMax(ADInput)
      TimeOld = 0
   EndIf
   
   If ADWhat = 3
      ADDelay(ADInput) = 0
   EndIf
   
   If ADWhat = 5
      For iii = 1 To 10
         ADDelayMax(iii) = 0
         ADDelay(iii) = 0
      Next
   EndIf
   
   If ADDelay(ADInput) <= 0 And ADDelay(ADInput) <> -999
      DelayNull = 1
   Else
      DelayNull = 0
   EndIf



ProcedureReturn DelayNull
   
EndProcedure


Procedure load_room(savename.s,typ.l)
Shared temp_room_x, temp_room_y, temp_room_hgtile, room_cursprite_nr, room_curtext_nr, no_room_intro

warten = mydelay3
write_nr=9 
temp_dir.s = #ROOMDIR + savename + ".rm"
gtext.s = ""
ttext.s = ""

If typ = 1
temp_dir.s = #SLROOMDIR + savename + ".rm"
EndIf

If ReadFile(1, temp_dir + "/" + "roomcontent.rm")
  
  temp_room_hgtile = ReadWord(1)
  temp_room_x = ReadWord(1)
  temp_room_y = ReadWord(1)
  
Global  Dim room_tile(temp_room_x,temp_room_y)
Global  Dim room_monster(temp_room_x,temp_room_y)
Global  Dim room_item(temp_room_x,temp_room_y)
Global  Dim room_tile_lp(temp_room_x,temp_room_y)
Global  Dim room_tile_typ(temp_room_x,temp_room_y)
Global  Dim room_tile_stat(temp_room_x,temp_room_y)


  n = 1
  r = 0
  Repeat
    Repeat
    r = ReadWord(1)

      If r >= 0
        If n= 1
          xxx = r
          yyy = ReadWord(1)
          room_tile(xxx,yyy) = ReadWord(1)
        EndIf
      
        If n= 2
          xxx = r
          yyy = ReadWord(1)
          room_tile_lp(xxx,yyy) = ReadWord(1)
        EndIf
      
        If n= 3
          xxx = r
          yyy = ReadWord(1)
          room_tile_typ(xxx,yyy) = ReadWord(1)
        EndIf
        
        If n= 4
          xxx = r
          yyy = ReadWord(1)
          room_tile_stat(xxx,yyy) = ReadWord(1)
        EndIf
        

        If n= 5
          xxx = r
          yyy = ReadWord(1)
          room_monster(xxx,yyy) = ReadWord(1)
        EndIf
      
;         If n= 6

;         If n= 7
         
;         If n= 8

        If n= 9
          xxx = r
          yyy = ReadWord(1)
          room_item(xxx,yyy) = ReadWord(1)
        EndIf
      
;         If n= 10
;       
;         If n= 11
;         
;         If n= 12

      EndIf
      
    Until r = -1 Or r = -2
  n+1
  Until r = -2
  
    ;Picture in Dir?
  tempV = ReadWord(1)
  If tempV > 0
    If IsSprite(#SPRITE_TILESET_ROOMPICDUMMY)
      FreeSprite(#SPRITE_TILESET_ROOMPICDUMMY)
    EndIf
    room_cursprite_nr = tempV
    CopySprite(room_cursprite_nr, #SPRITE_TILESET_ROOMPICDUMMY)

  ElseIf tempV = -1 Or tempV = -2 
    If IsSprite(#SPRITE_TILESET_ROOMPICDUMMY)
      FreeSprite(#SPRITE_TILESET_ROOMPICDUMMY)
    EndIf
;    If LoadSprite(#SPRITE_TILESET_ROOMPICDUMMY, temp_dir + "/" + "roompic.jpg","0ImageUsed") = 0
   If LoadSprite(#SPRITE_TILESET_ROOMPICDUMMY, temp_dir + "/" + "roompic.jpg") = 0
      CreateSprite(#SPRITE_TILESET_ROOMPICDUMMY, 335,335)
      no_room_intro + 1
    EndIf
  EndIf
  
  ;Text in Dir?
  tempV = ReadWord(1)

  For n2 = 1 To 3
    For n1 = 1 To 4
      nachricht_text(863 + n1,n2) = ""
    Next
  Next

  If tempV >= 0 
  room_curtext_nr = tempV
  ElseIf tempV = -1
      For n2 = 1 To 3
        For n1 = 1 To 4
          ttext.s = ReadString(1)
          nachricht_text(863 + n1,n2) = ttext
          gtext + ttext
        Next
      Next
  EndIf

If gtext = ""
  no_room_intro + 1
EndIf

  CloseFile(1)

Else
EndIf

EndProcedure

Procedure set_room()

   Shared temp_room_x, temp_room_y, temp_room_hgtile
   Shared akt_spieler, xmod, ymod, sprache, mydelay, anz_spieler
   
   xxx=0
   yyy=0

   For yyy = 0 To temp_room_y -1
      For xxx = 0 To temp_room_x -1
      setlaby(raumx(spieler(akt_spieler)\level)+xxx,raumy(spieler(akt_spieler)\level)+yyy,spieler(akt_spieler)\level,room_tile(xxx,yyy),room_tile_lp(xxx,yyy),room_tile_typ(xxx,yyy),room_tile_stat(xxx,yyy))

      If room_monster(xxx,yyy) > 0
      setlaby(raumx(spieler(akt_spieler)\level)+xxx,raumy(spieler(akt_spieler)\level)+yyy,spieler(akt_spieler)\level,monster(room_monster(xxx,yyy))\nr + #ANZ_FELDER,1,1,1)
      EndIf
      
      If room_item(xxx,yyy) > 0
      setlaby(raumx(spieler(akt_spieler)\level)+xxx,raumy(spieler(akt_spieler)\level)+yyy,spieler(akt_spieler)\level,room_item(xxx,yyy) +(#ANZ_FELDER + #ANZ_MONSTER),room_tile_lp(xxx,yyy),room_tile_typ(xxx,yyy),room_tile_stat(xxx,yyy))
      EndIf
      Next
   Next

Global Dim room_tile(0,0)
Global Dim room_monster(0,0)
Global Dim room_item(0,0)
Global Dim room_tile_lp(0,0)
Global Dim room_tile_typ(0,0)
Global Dim room_tile_stat(0,0)
EndProcedure

Procedure count_slrooms()
Shared anz_slraeume
count.l = 0
Nstring.s = ""


ExamineDirectory(0,#SLROOMDIR,"*.rm")
If IsDirectory(0)


N.w = 1
While N
  N = NextDirectoryEntry(0)
  If N
    Nstring = DirectoryEntryName(0)
  EndIf
  If N = 2 And Mid(Nstring,Len(Nstring) - 2,3) = ".rm"
    count + 1
    slraum_name(count) = Mid(Nstring,1,Len(Nstring) - 3)
  EndIf
Wend
EndIf
ProcedureReturn count
EndProcedure

Procedure LogError(beschreibung.s,typ=0)
  If typ
    FirstElement(Fehler())
    InsertElement(Fehler())
  Else
    LastElement(Fehler())
    AddElement(Fehler())
  EndIf
  Fehler()=beschreibung
  If typ=-1
  AddElement(Fehler())
  Fehler()=""
  EndIf
EndProcedure

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows   
Procedure Fehlerverarbeitung()
  ForEach Error()
    If Error()\Zeile=GetErrorLineNR() And Error()\Datei=GetErrorModuleName()
      ProcedureReturn 0
    EndIf
  Next
  AddElement(Error())
  Error()\Zeile=GetErrorLineNR()
  Error()\Datei=GetErrorModuleName()
  
  LogError("---- Fehler "+Str(GetErrorCounter())+" ----")
  LogError("Die Beschreibung lautet: " + GetErrorDescription())
  LogError("Er trat in Zeile "+Str(GetErrorLineNR())+" auf")
  LogError("In der Datei : "+GetFilePart(GetErrorModuleName()))
  LogError("")
EndProcedure
CompilerEndSelect

Procedure Aus()


  Shared Sprache, screenopen
  If screenopen
    CloseScreen()
    If screenopen=2
    CompilerIf #PB_Compiler_OS=#PB_OS_Windows
      CloseWindow(0)
    CompilerEndIf
    EndIf
    Delay(30)
    ReleaseMouse(1)
  EndIf

  If CountList(Fehler())
    Select Sprache
      Case 0
        LogError("",1)
        LogError("when you press the keys CTRL+C",1)
        LogError("The description will be copied into a textfile,",1)
        LogError("Please send this information to a member of the team.",1)
        LogError("While running the programm errors occured.",1)
        Hinweise=5 ; von unten nach oben lesen!
        Zeile.s="Line :"
        title.s="Error warning"
      Case 1
        LogError("",1)
        LogError("wenn sie die Tasten STRG+C drcken",1)
        LogError("Teams mit. Die Beschreibung wird in eine Textdatei kopiert,",1)
        LogError("Bitte teilen sie die Fehler einem Mitarbeiter des",1)
        LogError("W�rend des Programmbetriebs sind Fehler aufgetreten",1)
        Hinweise=5
        Zeile="Zeile :"
        title="Fehler Benachrichtigung"
      Case 2
        LogError("",1)
        LogError(Chr(34)+"error.txt"+Chr(34)+" si se use Strn+C",1)
        LogError("La descripcion del error se copia a un fichero ",1)
        LogError("Por favor digalos a los programadores.",1)
        LogError("Hubo errores durante la execution del programa.",1)
        Hinweise=5
        Zeile="Linea :"
        title="Aviso de errores"
    EndSelect



    CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
    hugo = OpenWindow(0, 0, 0, 640, 480, "Lost Labyrinth "+title,#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered)
    If OpenWindowedScreen(hugo, 0, 0, 640, 480, 1, 0, 0) = 0
    EndIf
    CompilerCase #PB_OS_Linux
    If OpenWindowedScreen(0, 0, 0, 640, 480, 1, 0, 0) = 0
    EndIf
    SDL_WM_SetCaption_("Lost Labyrinth Error Warning", "")
    CompilerEndSelect
  EndIf

  Repeat
    fenster(1)
    ExamineKeyboard()
    FlipBuffers(1)
    ClearScreen(0)

    StartDrawing(ScreenOutput())
    If index> CountList(Fehler())-2
      index=CountList(Fehler())-2
    EndIf
    If index<0
      index=0
    EndIf

    DrawText(20,440,Zeile+Str(index+1)+"   ("+Str(CountList(Fehler()))+")" ,$ffffff,0)
    For a=1 To 20
      num=a+index-1
      SelectElement(Fehler(),num)
      id=@Fehler()
      If id<>idold
        DrawText(20,a*17+20,Fehler(),$ffffff,0)
      EndIf
      idold=id
    Next
    StopDrawing()


    If KeyboardPushed(#PB_Key_Up)
      index=index-1
    ElseIf KeyboardPushed(#PB_Key_Down)
      index=index+1
    EndIf

    If warten<0
      If KeyboardPushed(#PB_Key_LeftControl)|KeyboardPushed(#PB_Key_RightControl) And KeyboardPushed(#PB_Key_C)
        If copied=0
          text.s=""
          FirstElement(Fehler())
          For a=1 To Hinweise-1
            NextElement(Fehler())
          Next
          CreateFile(0,".\error.txt")
          While NextElement(Fehler())
            WriteStringN(0,Fehler())
          Wend
          CloseFile(0)
          copied=1
        EndIf
        RunProgram(".\error.txt")
        warten=90
      EndIf
    Else
      warten-1
    EndIf

    Delay(0)
  Until KeyboardPushed(#PB_Key_Escape)
  End

EndProcedure
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 1895
; FirstLine = 1848
; Folding = -------------------------------------------------------------------------------
; EnableXP
; EnableOnError
; UseMainFile = laby.pb
; Executable = laby.exe
; DisableDebugger